% check signals


OStrans = load('/fml/ag-raetsch/share/projects/genefinding//C_briggsae/exp3/elegansModel/sensors/transacc/output_SVMWDS/pred/contig_1+_all.mat');
NStrans= load('/fml/ag-raetsch/share/projects/genefinding//C_briggsae/exp4/elegansModel/sensors/transacc/output_SVMWDS/pred/contig_1+_all.mat');

OSacc = load('/fml/ag-raetsch/share/projects/genefinding//C_briggsae/exp3/elegansModel/sensors/acc/output_SVMWDS/pred/contig_1+_all.mat');
NSacc= load('/fml/ag-raetsch/share/projects/genefinding//C_briggsae/exp4/elegansModel/sensors/acc/output_SVMWDS/pred/contig_1+_all.mat');

[OSacc.pos ,ii] = sort(OSacc.pos);
OSacc.output = OSacc.output(ii);
OSacc.Conf = OSacc.Conf(ii);
OSacc.Conf_cum = OSacc.Conf_cum(ii);

[NSacc.pos ,ii] = sort(NSacc.pos);
NSacc.output = NSacc.output(ii);
NSacc.Conf = NSacc.Conf(ii);
NSacc.Conf_cum = NSacc.Conf_cum(ii);

[OStrans.pos ,ii] = sort(OStrans.pos);
OStrans.output = OStrans.output(ii);
OStrans.Conf = OStrans.Conf(ii);
OStrans.Conf_cum = OStrans.Conf_cum(ii);

[NStrans.pos ,ii] = sort(NStrans.pos);
NStrans.output = NStrans.output(ii);
NStrans.Conf = NStrans.Conf(ii);
NStrans.Conf_cum = NStrans.Conf_cum(ii);

isequal(OSacc.pos,OStrans.pos)
isequal(NSacc.pos,NStrans.pos)
isequal(OSacc.pos,NSacc.pos)


[tmp,idx1,idx2] = intersect(OSacc.pos,NSacc.pos);
 
figure;
subplot(3,3,1);plot(OSacc.output(idx1),NSacc.output(idx2),'.')
xlabel('old acc output');
ylabel('new acc output');
subplot(3,3,2);plot(OSacc.Conf(idx1),NSacc.Conf(idx2),'.')
xlabel('old acc conf');
ylabel('new acc conf');
subplot(3,3,3);plot(OSacc.Conf_cum(idx1),NSacc.Conf_cum(idx2),'.')
xlabel('old acc confcum');
ylabel('new acc confcum');

subplot(3,3,4);plot(OStrans.output(idx1),NStrans.output(idx2),'.')
xlabel('old trans output');
ylabel('new trans output');
subplot(3,3,5);plot(OStrans.Conf(idx1),NStrans.Conf(idx2),'.')
xlabel('old trans conf');
ylabel('new trans conf');
subplot(3,3,6);plot(OStrans.Conf_cum(idx1),NStrans.Conf_cum(idx2),'.')
xlabel('old trans confcum');
ylabel('new trans confcum');

subplot(3,3,7);plot(OStrans.output(idx1).*OSacc.output(idx1),NStrans.output(idx2).*NSacc.output(idx2),'.')
xlabel('old trans*acc output');
ylabel('new trans*acc output');
subplot(3,3,8);plot(OStrans.Conf(idx1).*OSacc.Conf(idx1),NStrans.Conf(idx2).*NSacc.Conf(idx2),'.')
xlabel('old trans*acc conf');
ylabel('new trans*acc conf');
subplot(3,3,9);plot(OStrans.Conf_cum(idx1).*OSacc.Conf_cum(idx1),NStrans.Conf_cum(idx2).*NSacc.Conf_cum(idx2),'.')
xlabel('old trans*acc confcum');
ylabel('new trans*acc confcum');

%%%
load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp4/elegansModel/lsl/cat-3/predictions/pred_split=1+_cleave6.00.mat','PAR')
load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp4/genome_data/trivial_regions.mat','trivial_regions') 
sig_names = fieldnames(PAR.model.signals);
idx = find(strcmp(sig_names,'trans'));
sig_names(idx) =[];
idx = find(strcmp(sig_names,'stop'));
sig_names{idx} = 'cdsStop';

regn = add_signals2blocks(trivial_regions(1),PAR,sig_names); 
[tmp,idx1,idx2] = intersect(regn.Signals.acc.pos,NSacc.pos);
figure;plot(regn.Signals.acc.Conf_cum(idx1),NSacc.Conf_cum(idx2))
[tmp,idx1,idx2] = intersect(regn.Signals.transacc.pos,NStrans.pos);
figure;plot(regn.Signals.transacc.Conf_cum(idx1),NStrans.Conf_cum(idx2).*NSacc.Conf_cum(idx2))

load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp3/elegansModel/lsl/cat-3_old/predictions/pred_split=1+_cleave6.00.mat','PAR')
load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp3/genome_data/trivial_regions.mat','trivial_regions') 
sig_names = fieldnames(PAR.model.signals);
idx = find(strcmp(sig_names,'trans'));
sig_names(idx) =[];
idx = find(strcmp(sig_names,'stop'));
sig_names{idx} = 'cdsStop';

rego = add_signals2blocks(trivial_regions(1),PAR,sig_names); 
[tmp,idx1,idx2] = intersect(rego.Signals.acc.pos,OSacc.pos);
figure;plot(rego.Signals.acc.Conf_cum(idx1),OSacc.Conf_cum(idx2),'.')
[tmp,idx1,idx2] = intersect(rego.Signals.transacc.pos,OStrans.pos);
figure;plot(rego.Signals.transacc.Conf_cum(idx1),OStrans.Conf_cum(idx2).*OSacc.Conf_cum(idx2),'.')

%%%
% check predictions

Opred = load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp3/elegansModel/lsl/cat-3_old/predictions/blocks_pred/pred_split=_viterbi_block1_cleave=6.00.mat')
Npred = load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp4/elegansModel/lsl/cat-3/predictions/blocks_pred/pred_split=_viterbi_block1_cleave=6.00.mat')
load('~raetsch/svn/projects/genefinding/lsl_paper/PAR_new_signals_new_labels_better_all.mat','PAR')
model=PAR.model;
clear PAR


[seg,idx1,idx2] =intersect(Opred.pred.segments,Npred.pred.segments,'rows');

idx_diff=find(idx1(2:end)-idx1(1:end-1)>1);

for j=idx_diff'
  view_overlapping_predictions(Opred.pred.segments(idx1(j):idx1(j+1),:),Npred.pred.segments(idx2(j):idx2(j+1),:),model)
  pause
end
  
% check blocks 

Oblocks = load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp3/elegansModel/lsl/cat-3_old/predictions/pred_split=1+_cleave6.00.mat')
Nblocks = load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp4/elegansModel/lsl/cat-3/predictions/pred_split=1+_cleave6.00.mat')
% view_overlapping_predictions(Oblocks.blocks(1).prediction.segments,Nblocks.blocks(1).prediction.segments,model,Oblocks.blocks(1).Signals.trans,Nblocks.blocks(1).Signals.trans)
% draw_gene_with_detail(block1.genes)


sig_names = fieldnames(model.signals);
idx = find(strcmp(sig_names,'trans'));
sig_names(idx) =[];
idx = find(strcmp(sig_names,'stop'));
sig_names{idx} = 'cdsStop';
blockso = rmfield(Oblocks.blocks,'Signals')
blocksn = rmfield(Nblocks.blocks,'Signals')
blockso = add_signals2blocks(blockso,Oblocks.PAR,sig_names);
blocksn = add_signals2blocks(blocksn,Nblocks.PAR,sig_names); 

[tmp,idx1,idx2]=intersect(blockso(1).Signals.transacc.pos,blocksn(1).Signals.transacc.pos);
plot(blockso(1).Signals.transacc.Conf_cum(idx1),blocksn(1).Signals.transacc.Conf_cum(idx2),'.')

[tmp,idx1,idx2]=intersect(blockso(1).Signals.acc.pos,blocksn(1).Signals.acc.pos);
plot(blockso(1).Signals.acc.Conf_cum(idx1),blocksn(1).Signals.acc.Conf_cum(idx2),'.')

[tmp,idx1,idx2]=intersect(blockso(1).Signals.acc.pos,Oblocks.blocks(1).Signals.acc.pos);
plot(blockso(1).Signals.acc.Conf_cum(idx1),Oblocks.blocks(1).Signals.acc.Conf_cum(idx2),'.')

blocks = blockso;
for b = 1:length(blocks) 
  % trans = score of transc_vs_acc times score of acc_vs_nonacc
  blocks(b).Signals.trans = blocks(b).Signals.transacc;
  blocks(b).Signals.trans.Conf_cum = blocks(b).Signals.transacc.Conf_cum.* blocks(b).Signals.acc.Conf_cum ;
  % transacc = score of acc_vs_nonacc 
  blocks(b).Signals.transacc = blocks(b).Signals.acc;  
  blocks(b).Signals.stop = blocks(b).Signals.cdsStop; 
end   
blockso = blocks;

[tmp,idx1,idx2]=intersect(blockso(1).Signals.trans.pos,Oblocks.blocks(1).Signals.trans.pos);
plot(blockso(1).Signals.trans.Conf_cum(idx1),Oblocks.blocks(1).Signals.trans.Conf_cum(idx2),'.')

blocks = blocksn;
for b = 1:length(blocks) 
  % trans = score of transc_vs_acc times score of acc_vs_nonacc
  blocks(b).Signals.trans = blocks(b).Signals.transacc;
  blocks(b).Signals.trans.Conf_cum = blocks(b).Signals.transacc.Conf_cum.* blocks(b).Signals.acc.Conf_cum ;
  % transacc = score of acc_vs_nonacc 
  blocks(b).Signals.transacc = blocks(b).Signals.acc;  
  blocks(b).Signals.stop = blocks(b).Signals.cdsStop; 
end   
blocksn = blocks; 
isequal(blocksn(1).Signals.trans,Nblocks.blocks(1).Signals.trans)
[tmp,idx1,idx2] = intersect(blockso(1).Signals.trans.pos,Oblocks.blocks(1).Signals.trans.pos);
isequal(blockso(1).Signals.trans.Conf_cum(idx1),Oblocks.blocks(1).Signals.trans.Conf_cum(idx2))
[tmp,idx1,idx2] = intersect(blockso(1).Signals.trans.pos,blockso(1).Signals.trans.pos);
plot(blockso(1).Signals.trans.Conf_cum(idx1),blocksn(1).Signals.trans.Conf_cum(idx2),'.')



[tmp,idx1,idx2] = intersect(blockso(1).Signals.acc.pos,OSacc.pos);
figure;plot(blockso(1).Signals.acc.Conf_cum(idx1),OSacc.Conf_cum(idx2)','.')
[tmp,idx1,idx2] = intersect(blockso(1).Signals.transacc.pos,OStrans.pos);
figure;plot(blockso(1).Signals.transacc.Conf_cum(idx1),OStrans.Conf_cum(idx2).*OSacc.Conf_cum(idx2),'.')

[tmp,idx1,idx2] = intersect(blocksn(1).Signals.acc.pos,NSacc.pos);
figure;plot(blocksn(1).Signals.acc.Conf_cum(idx1),NSacc.Conf_cum(idx2)','.')
[tmp,idx1,idx2] = intersect(blocksn(1).Signals.transacc.pos,NStrans.pos);
figure;plot(blocksn(1).Signals.trans.Conf_cum(idx1),NStrans.Conf_cum(idx2).*NSacc.Conf_cum(idx2).^2,'.')
isequal(blocksn(1).details.score.trans,blocksn(1).Signals.trans.Conf_cum)  

% check genes
Og = load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp3/elegansModel/lsl/cat-3_old/predictions/pred_split=genes_cleave6.00_final.mat');
Ng = load('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp4/elegansModel/lsl/cat-3/predictions/pred_split=genes_cleave6.00_final.mat');

draw_gene_with_signals(gene,which_signal,local)

genome_info=init_genome('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp4/orig_data/genome.config')
for i=1:length(Ng.genes)
  Ng.genes(i).transcript_status=1;
end
evaluate_predictions(N.trivial_regions,Ng.genes,Og.genes,genome_info,0,0)
 
  