
dir =  '/fml/ag-raetsch/share/projects/genefinding/C_elegans/';
unix(sprintf('mkdir %s',dir))
unix(sprintf('mkdir %s/WS160',dir))
unix(sprintf('mkdir %s/WS160/orig_data',dir))

%% make genome.config file

PAR.FN.input.fn_genome_config = sprintf('%sWS160/orig_data/genome.config',dir);
PAR.organism.name = 'C_elegans';

test_regions = init_regions(PAR);
save([dir 'WS160/orig_data/test_regions.mat'],'test_regions')
training_regions=test_regions(1);
training_regions.stop = 0;
training_regions.start = 0;
save([dir 'WS160/orig_data/training_regions.mat'],'training_regions')

%%%%%%%%%%%%%%%
organism = 'C_elegans';
sensor = 'acc';
method = 'SVM_WDS'
Exp = 'exp_C_elegans_WS160'
PAR = masterscript_data(organism,sensor,method,1,Exp)

%%%%%%%

PAR = exp_C_elegans_WS160;
PAR.organism.name = 'C_elegans';

PAR.RPROC.collect_jobs = 1 ;

PAR = Nematodes_acc_SVM_WDS(PAR);
[PAR, jobinfo_acc] = masterscript_sensors(PAR)
jobinfo_acc = rproc_resubmit(jobinfo_acc) ;

PAR = Nematodes_don_SVM_WDS(PAR);
[PAR, jobinfo_don] = masterscript_sensors(PAR)
jobinfo_don = rproc_resubmit(jobinfo_don) ;

PAR = Nematodes_cdsStop_SVM_COMBINED(PAR);
[PAR, jobinfo_cdsStop] = masterscript_sensors(PAR)
jobinfo_cdsStop = rproc_resubmit(jobinfo_cdsStop) ;

PAR = Nematodes_tis_SVM_COMBINED(PAR);
[PAR, jobinfo_tis] = masterscript_sensors(PAR)
jobinfo_tis = rproc_resubmit(jobinfo_tis) ;

PAR = Nematodes_trans_SVM_WDS(PAR);
[PAR, jobinfo_trans] = masterscript_sensors(PAR)
jobinfo_trans = rproc_resubmit(jobinfo_trans) ;

PAR.RPROC.MEMREQ = 20000 ;

PAR = Nematodes_cleave_SVM_SPWDSP(PAR);
[PAR, jobinfo_cleave] = masterscript_sensors(PAR)
jobinfo_cleave = rproc_resubmit(jobinfo_cleave) ;

PAR = Nematodes_tss_SVM_SPWDSP(PAR);
[PAR, jobinfo_tss] = masterscript_sensors(PAR)
jobinfo_tss = rproc_resubmit(jobinfo_tss) ;

PAR = Nematodes_polya_SVM_COMBINED(PAR);
[PAR, jobinfo_polya] = masterscript_sensors(PAR)
jobinfo_polya = rproc_resubmit(jobinfo_polya) ;

jobinfo = [jobinfo_acc jobinfo_don jobinfo_trans jobinfo_tss ...
           jobinfo_cleave jobinfo_tis jobinfo_cdsStop jobinfo_polya] ;

jobinfo = rproc_wait(jobinfo, 10)

%%%%%%%%%%%%

PAR = exp_nematodes;
PAR = exp_lsl_cat1(PAR);
PAR = Nematodes_lsl(PAR);

prepare_blocks(PAR)



%%%%%%
clear all
fn = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS160/exp2/lsl/cat-1/predictions/GS-07-12-2007/test_blocks'
blocks=[];
for i=1:6
  for j='+-'
    L=load(sprintf('%s%i%s.mat',fn,i,j));
    blocks = [blocks, L.blocks];
  end
end
load('~raetsch/svn/projects/genefinding/lsl_paper/PAR_new_signals_new_labels_better_all.mat','PAR')
PAR.cleave_offset = 6;
PAR.submit=1;
PAR.fn_pred = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS160/exp2/lsl/cat-1/predictions/GS-07-12-2007/pred_';

% genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS160/orig_data/genome.config') ;

predict_blocks(PAR,blocks) ;

if isfield(PAR, 'cleave_offset')
    fname = [PAR.fn_pred sprintf('_cleave%1.2f.mat', cleave_offset)];
else
    fname = PAR.fn_pred ;
end ;
tmp = load(fname);
test_blocks = tmp.blocks;

predict_blocks(PAR)
