
dir =  '/fml/ag-raetsch/share/projects/genefinding/C_elegans/';
unix(sprintf('mkdir %s',dir))
unix(sprintf('mkdir %s/WS180',dir))
unix(sprintf('mkdir %s/WS180/orig_data',dir))

%% make genome.config file

PAR.FN.input.fn_genome_config = sprintf('%sWS180/orig_data/genome.config',dir);
PAR.organism.name = 'C_elegans';

test_regions = init_regions(PAR);
save([dir 'WS180/orig_data/test_regions.mat'],'test_regions')
training_regions=test_regions(1);
training_regions.stop = 0;
training_regions.start = 0;
save([dir 'WS180/orig_data/training_regions.mat'],'training_regions')

%%%%%%%%%%%%%%%
organism = 'C_elegans';
sensor = 'acc';
method = 'SVM_WDS'
Exp = 'exp_C_elegans_WS180'
PAR = masterscript_data(organism,sensor,method,1,Exp)

%%%%%%%

PAR = exp_C_elegans_WS180;
PAR.organism.name = 'C_elegans';

PAR.RPROC.collect_jobs = 1 ;

PAR = Nematodes_acc_SVM_WDS(PAR);
[PAR, jobinfo_acc] = masterscript_sensors(PAR)
jobinfo_acc = rproc_resubmit(jobinfo_acc) ;

PAR = Nematodes_don_SVM_WDS(PAR);
[PAR, jobinfo_don] = masterscript_sensors(PAR)
jobinfo_don = rproc_resubmit(jobinfo_don) ;

PAR = Nematodes_cdsStop_SVM_COMBINED(PAR);
[PAR, jobinfo_cdsStop] = masterscript_sensors(PAR)
jobinfo_cdsStop = rproc_resubmit(jobinfo_cdsStop) ;

PAR = Nematodes_tis_SVM_COMBINED(PAR);
[PAR, jobinfo_tis] = masterscript_sensors(PAR)
jobinfo_tis = rproc_resubmit(jobinfo_tis) ;

PAR = Nematodes_trans_SVM_WDS(PAR);
[PAR, jobinfo_trans] = masterscript_sensors(PAR)
jobinfo_trans = rproc_resubmit(jobinfo_trans) ;


PAR.RPROC.MEMREQ = 20000 ;

PAR = Nematodes_cleave_SVM_SPWDSP(PAR);
[PAR, jobinfo_cleave] = masterscript_sensors(PAR)
jobinfo_cleave = rproc_resubmit(jobinfo_cleave) ;

PAR = Nematodes_tss_SVM_SPWDSP(PAR);
[PAR, jobinfo_tss] = masterscript_sensors(PAR)
jobinfo_tss = rproc_resubmit(jobinfo_tss) ;

PAR = Nematodes_polya_SVM_COMBINED(PAR);
[PAR, jobinfo_polya] = masterscript_sensors(PAR)
jobinfo_polya = rproc_resubmit(jobinfo_polya) ;

jobinfo = [jobinfo_acc jobinfo_don jobinfo_trans jobinfo_tss ...
           jobinfo_cleave jobinfo_tis jobinfo_cdsStop jobinfo_polya] ;

jobinfo = rproc_wait(jobinfo, 10)

%%%%%%%%%%%%

PAR = exp_C_elegans_WS180;
PAR = exp_lsl_cat3(PAR);
PAR = Nematodes_lsl(PAR);
prepare_blocks(PAR)


clear all
fn = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/lsl/cat-3/data/test_blocks'
blocks=[];
for i=1:6
  for j='+-'
    L=load(sprintf('%s%i%s.mat',fn,i,j));
    blocks = [blocks, L.blocks];
  end
end
load('~raetsch/svn/projects/genefinding/lsl_paper/PAR_new_signals_new_labels_better_all.mat','PAR')
PAR.cleave_offset = 6;
PAR.submit=1;
PAR.fn_pred = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/lsl/cat-3/predictions/GS-07-12-2007/pred_';

PAR.regions.offset = 1000;
PAR.RPROC.MEMREQ = 5000;
PAR.exm_per_batch = 1;
genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/orig_data/genome.config') ;

%%create signal mask for cat 3 (done by gunnar)
% cd /fml/ag-raetsch/share/projects/genomes/Caenorhabditis_elegans_WS180
% 
% cd ~/svn/projects/splicing/gff/read_sequences/
% read_confirmed_sequences
% addpath ~/svn/projects/genefinding/data_processing_lsl/signal_masks/
% gen_signal_masks(genome_info)
%%%


signal_masks = load_struct('/fml/ag-raetsch/share/projects/genomes/Caenorhabditis_elegans_WS180/signal_masks.mat', 'signal_masks') ;

predict_blocks(PAR,blocks,genome_info, signal_masks) ;


%%%%

fn_blocks  = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/lsl/cat-3/data/test_blocks'
fn_preds = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/lsl/' ...
            'cat-3/predictions/GS-07-12-2007/pred__viterbi_block']
fn_config = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/orig_data/genome.config';
genome_info = init_genome(fn_config);

fn_save = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/lsl/'...                
             'cat-3/predictions/GS-07-12-2007/pred']      

fn_trivial_regions = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/genome_data/trivial_regions.mat';
fn_anno='/fml/ag-raetsch/share/databases/genomes/elegans_WS180/anno_WS180_final.mat';

for i = 1:6
  for s = '+-'
    L = load(sprintf('%s%i%s.mat',fn_blocks,i,s),'blocks','model');
    for k = [L.blocks.id]
      load(sprintf('%s%i_cleave=6.00.mat',fn_preds,k),'pred')
      idx = find([L.blocks.id]==k);
      L.blocks(idx).prediction = pred; 
    end
    blocks = convertblocks2newtype(L.blocks,fn_config,'C_elegnas');
    blocks = reconcatinate_blocks_new(blocks,L.model,genome_info,1000);
    save(sprintf('%s_blocks%i%s_cleave=6.00.mat',fn_save,i,s),'blocks')
    genes = blocks2genes(blocks,L.model,'prediction',genome_info);
    save(sprintf('%s_genes%i%s_cleave=6.00.mat',fn_save,i,s),'genes')
    write_gff3(genes,sprintf('%s_%i%s_cleave=6.00.gff3',fn_save,i,s),'mGENE','predicted')
  end
end


load(fn_trivial_regions,'trivial_regions');
load(fn_anno,'genes');
anno_genes=genes;
genes=[];
for i = 1:6
  for s = '+-'
    L=load(sprintf('%s_genes%i%s_cleave=6.00.mat',fn_save,i,s),'genes');
    genes = [genes L.genes];
  end
end

for i=1:length(genes)
  genes(i).id = i;
  genes(i).name = sprintf('mGene_pred_%i',i);
end

write_gff3(genes,'/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/lsl/cat-3/predictions/GS-07-12-2007/mGene_C_elegansWS180.gff3',...
           'mGENE','predicted') 

for i=1:length(anno_genes)
  anno_genes(i).id = i;
end

res_genome = evaluate_predictions(trivial_regions,anno_genes,genes, genome_info, 0,0);
                


%%% redo blocks2genes include operons, transacc, polya

fn_blocks  = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/lsl/cat-3/data/test_blocks'
fn_preds = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/lsl/' ...
            'cat-3/predictions/GS-07-12-2007/pred__viterbi_block']
fn_config = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/orig_data/genome.config';
genome_info = init_genome(fn_config);

fn_save = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/lsl/'...                
             'cat-3/predictions/GS-07-12-2007/pred']      

L = load(sprintf('%s1+.mat',fn_blocks),'model');
genes = [];
operons = [];
for i = 1:6
  for s = '+-'
    load(sprintf('%s_blocks%i%s_cleave=6.00.mat',fn_save,i,s),'blocks')
    [genes_,operons_] = blocks2genes(blocks,L.model,'prediction',genome_info,'nematode');
    genes = [genes genes_];
    operons = [operons operons_];
  end
end
save(sprintf('%s_genes_cleave=6.00_new.mat',fn_save),'genes','operons')