
dir =  '/fml/ag-raetsch/share/projects/genefinding/C_elegans/';
unix(sprintf('mkdir %s',dir))
unix(sprintf('mkdir %s/nGASP15',dir))
unix(sprintf('mkdir %s/nGASP15/orig_data',dir))

cd /fml/ag-raetsch/share/projects/genefinding/C_elegans/nGASP15/orig_data
unix(sprintf('ln -s ~/svn/projects/nGASP/data/genome.config .'))
cd ~/svn/projects/genefinding

%% generate test and training regions

genome_info=init_genome('/fml/ag-raetsch/share/projects/genefinding/C_elegans/nGASP15/orig_data/genome.config')

PAR.organism.name = 'C_elegans';
L1=load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_CNEW_complete.mat') 
L2=load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase2_confirmed_isoforms_CNEW.mat') 

map = compute_colocation_map(L1.genes,L2.genes,genome_info); 
maps =[];
for j=1:length(map)
  maps = [maps map{j}];
end
idx= setdiff([1:length(L1.genes)],maps);
add_training_genes = L1.genes(idx);
genes=add_training_genes([add_training_genes.strand]=='+');
load('/fml/ag-raetsch/share/projects/nGASP/test_regions.mat')
add_training_regions =[];
for j=1:length(test_regions)
  reg = test_regions(j);
  idx = find(str({genes.chr},reg.chr)&[genes.start]<reg.stop &[genes.stop]>reg.start)
  if isempty(idx)
    add_training_regions = [add_training_regions j];
  end
end
test_regions = init_regions(PAR);
save([dir 'nGASP15/orig_data/test_regions.mat'],'test_regions')
training_regions=test_regions(1);
training_regions.stop = 0;
training_regions.start = 0;
save([dir 'nGASP15/orig_data/training_regions.mat'],'training_regions')

%%%%%%%%%%%%%%%
organism = 'C_elegans';
sensor = 'acc';
method = 'SVM_WDS'
Exp = 'exp_C_elegans_nGASP15'
PAR = masterscript_data(organism,sensor,method,1,Exp)

%%%%%%%

PAR = exp_C_elegans_nGASP15;
PAR.organism.name = 'C_elegans';

PAR = Nematodes_acc_SVM_WDS(PAR);
[PAR, jobinfo_acc] = masterscript_sensors(PAR)
jobinfo_acc = rproc_resubmit(jobinfo_acc) ;

PAR = Nematodes_don_SVM_WDS(PAR);
[PAR, jobinfo_don] = masterscript_sensors(PAR)
jobinfo_don = rproc_resubmit(jobinfo_don) ;

PAR = Nematodes_cdsStop_SVM_COMBINED(PAR);
[PAR, jobinfo_cdsStop] = masterscript_sensors(PAR)
jobinfo_cdsStop = rproc_resubmit(jobinfo_cdsStop) ;

PAR = Nematodes_tis_SVM_COMBINED(PAR);
[PAR, jobinfo_tis] = masterscript_sensors(PAR)
jobinfo_tis = rproc_resubmit(jobinfo_tis) ;

PAR = Nematodes_trans_SVM_WDS(PAR);
[PAR, jobinfo_trans] = masterscript_sensors(PAR)
jobinfo_trans = rproc_resubmit(jobinfo_trans) ;


PAR.RPROC.MEMREQ = 5000 ;

PAR = Nematodes_cleave_SVM_SPWDSP(PAR);
[PAR, jobinfo_cleave] = masterscript_sensors(PAR)
jobinfo_cleave = rproc_resubmit(jobinfo_cleave) ;

PAR = Nematodes_tss_SVM_SPWDSP(PAR);
[PAR, jobinfo_tss] = masterscript_sensors(PAR)
jobinfo_tss = rproc_resubmit(jobinfo_tss) ;

PAR = Nematodes_polya_SVM_COMBINED(PAR);
[PAR, jobinfo_polya] = masterscript_sensors(PAR)
jobinfo_polya = rproc_resubmit(jobinfo_polya) ;

jobinfo = [jobinfo_acc jobinfo_don jobinfo_trans jobinf_tss ...
           jobinfo_cleave jobinfo_tis jobinfo_cdsStop jobinfo_polya] ;

rproc_wait(jobinfo, 60)

%%%%%%%%%%%%


Exp = 'exp_C_elegans_nGASP15';
PAR = feval(Exp);
PAR.organism.name = 'C_elegans';
PAR = C_elegans_lsl(PAR);
PAR = masterscript_lsl(PAR)
