function C_elegans_nGASP_prep(PAR)

  addpath ~/svn/projects/genefinding/experiments/nGASP/
% link to config file
if ~fexist(PAR.FN.input.fn_genome_config)
  unix(sprintf('ln -s %s %s',PAR.FN.genome.fn_genome_config,PAR.FN.input.fn_genome_config));
end
genome_info = init_genome(PAR.FN.input.fn_genome_config);

% link to confirmed file
if ~fexist(PAR.FN.input.fn_genes_conf_orig)&fexist(PAR.FN.genome.fn_confirmed_sequences)
  unix(sprintf('ln -s %s %s',PAR.FN.genome.fn_confirmed_sequences,PAR.FN.input.fn_genes_conf_orig));
end

if fexist(PAR.FN.input.fn_genes_conf_orig)&~fexist(PAR.FN.output.fn_genes_conf)
  load(PAR.FN.input.fn_genes_conf_orig)
  genes = prepare_confirmed(genes,PAR);
  save(PAR.FN.output.fn_genes_conf,'genes');
end
  
  
% link to annotation 
%-----------------------------------------------------------

anno_file = sprintf('%s/%s/%s/annotation/conf_unconf.mat',PAR.FN.genome_dir,PAR.organism.name,PAR.organism.release);
if  ~fexist(anno_file)
  genes=[];
  for j=1:length(genome_info.annotation_fnames)
    gff_file = genome_info.annotation_fnames{j}; 
    anno_file1 = [gff_file(1:end-5) '.mat']
    if ~fexist(anno_file1)&fexist(gff_file)
      source = 'Coding_transcript'; run_locally=1; by_contig=0;
      genome_info2 = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS160/orig_data/genome.config')  
      L.genes = read_genes_from_gff3(gff_file,anno_file1,genome_info2,source,by_contig,run_locally);
    else
      L = load(anno_file1);
    end
    genes = [genes L.genes];
  end
  save(anno_file,'genes')
end
if  ~fexist(PAR.FN.input.fn_genes_anno_orig)
  unix(sprintf('ln -s %s %s',anno_file,PAR.FN.input.fn_genes_anno_orig));
end

if ~fexist(PAR.FN.output.fn_genes_anno)&fexist(PAR.FN.input.fn_genes_anno_orig)
  clear genes
  L = load(PAR.FN.input.fn_genes_anno_orig,'genes');
  cont2chrom;
  for i=1:length(L.genes)
    genes(i) = L.genes(i);
    contig = find(strcmp({cont.chr},L.genes(i).chr)&[cont.start]<L.genes(i).start&[cont.stop]>L.genes(i).stop);
    genes(i).chr = cont(contig).name;
    genes(i).chr_num = contig;
    genes(i).start = L.genes(i).start-cont(contig).start+1;
    genes(i).stop = L.genes(i).stop-cont(contig).start+1;
    genes(i).tis =  genes(i).tis-cont(contig).start+1;
    genes(i).cdsStop = genes(i).cdsStop-cont(contig).start+1;      
    for j=1:length(genes(i).exons)
      genes(i).exons{j}(:,1:2) = genes(i).exons{j}(:,1:2)-cont(contig).start+1;
    end
    for j=1:length(genes(i).cds_exons)
      genes(i).cds_exons{j}(:,1:2) = genes(i).cds_exons{j}(:,1:2)-cont(contig).start+1;
    end
  end
  build_splice_graph
  genes = infer_splice_graph_caller(genes);
  fprintf('Sorting exons...\n');
  for i=1:length(genes)
    [dummy,exon_order] = sort(genes(i).splicegraph{1}(1,:),2,'ascend');
    genes(i).splicegraph{1} = genes(i).splicegraph{1}(:,exon_order);
    genes(i).splicegraph{2} = genes(i).splicegraph{2}(exon_order,exon_order);
  end
  genes = alt_const(genes);
  genes = prepare_anno(genes,PAR);
  save(PAR.FN.output.fn_genes_anno,'genes');
  
  if 0 
  load(PAR.FN.input.fn_genes_anno_orig,'all_genes')
  % genes = replace_contignames(genes,PAR.FN.genome.fn_name_to_contig_mapping,genome_info2,1);
  cont2chrom;
  genes=init_genes;
  for i=1:length(all_genes)
    contig = find(strcmp({cont.chr},all_genes(i).chr)&[cont.start]<all_genes(i).start&[cont.stop]>all_genes(i).stop);
    genes(i).name = all_genes(i).name;
    genes(i).transcripts = all_genes(i).transcripts;
    genes(i).exons = all_genes(i).exons;
    genes(i).strand = all_genes(i).strands(1);
    genes(i).chr = cont(contig).name;
    genes(i).chr_num = contig;
    genes(i).start = all_genes(i).start-cont(contig).start+1;
    genes(i).stop = all_genes(i).stop-cont(contig).start+1;
    genes(i).cds_exons = all_genes(i).cds_exons;
    genes(i).tis =  all_genes(i).tis_pos;
    genes(i).cdsStop = all_genes(i).stop_pos;
    genes(i).tis =  genes(i).tis-cont(contig).start+1;
    genes(i).cdsStop = genes(i).cdsStop-cont(contig).start+1;      
    if genes(i).strand=='+'
      for j=1:length(genes(i).exons)
        genes(i).exons{j}(:,1:2) = genes(i).exons{j}(:,1:2)-cont(contig).start+1;
        genes(i).exons{j}(1:end-1,2) = genes(i).exons{j}(1:end-1,2)+1;
      end
      for j=1:length(genes(i).cds_exons)
        genes(i).cds_exons{j}(:,1:2) = genes(i).cds_exons{j}(:,1:2)-cont(contig).start+1;
        genes(i).cds_exons{j}(:,2) = genes(i).cds_exons{j}(:,2)+1;
      end
      genes(i).cdsStop = genes(i).cdsStop+1;      
    else
      % keyboard
      for j=1:length(genes(i).exons)
        genes(i).exons{j}(:,1:2) = genes(i).exons{j}(:,1:2)-cont(contig).start+1;
        genes(i).exons{j}(2:end,1) = genes(i).exons{j}(2:end,1)-1;
      end
      for j=1:length(genes(i).cds_exons)
        genes(i).cds_exons{j}(:,1:2) = genes(i).cds_exons{j}(:,1:2)-cont(contig).start+1;
        genes(i).cds_exons{j}(:,1) = genes(i).cds_exons{j}(:,1)-1;
      end
      genes(i).cdsStop = genes(i).cdsStop-1;   
    end
  end
  build_splice_graph
  genes = infer_splice_graph_caller(genes)
  fprintf('Sorting exons...\n');
  for i=1:length(genes)
    [dummy,exon_order] = sort(genes(i).splicegraph{1}(1,:),2,'ascend');
    genes(i).splicegraph{1} = genes(i).splicegraph{1}(:,exon_order);
    genes(i).splicegraph{2} = genes(i).splicegraph{2}(exon_order,exon_order);
  end
  genes = alt_const(genes);
  genes = prepare_anno(genes,PAR);
  save(PAR.FN.output.fn_genes_anno,'genes');
  end
end

% create trainings region (empty or Ns) if not train_on
trivial_regions = init_regions(PAR);
if ~exist(PAR.FN.input.fn_trainings_regions)|~exist(PAR.FN.input.fn_test_regions)
  training_regions = trivial_regions(1:20);
  test_regions = trivial_regions(21:40);
  save(PAR.FN.input.fn_trainings_regions,'training_regions')
  save(PAR.FN.input.fn_test_regions,'test_regions')
end


