function Nematodes_prep(PAR)
  
% --------------condense contigs---------------------%
if 0
  keyboard
  config_file1 =  sprintf('%s/%s/%s/genebuild/genome.config',PAR.FN.genome_dir,PAR.organism.name,PAR.organism.release);
  genome_info = init_genome(config_file1);
  target_dir = sprintf('%s/%s/%s/genebuild_condensed',PAR.FN.genome_dir,PAR.organism.name,PAR.organism.release);
  
  if ~fexist(sprintf('%s/genome.config',target_dir)) & length(genome_info.contig_names)>100
    condense_contigs(config_file1,target_dir);
    return
    %--------------genebuild---------------------%
  end
  clear config_file1 target_dir 
end
% keyboard
 
% link to config file
if ~fexist(PAR.FN.input.fn_genome_config)
  unix(sprintf('ln -s %s %s',PAR.FN.genome.fn_genome_config,PAR.FN.input.fn_genome_config));
end
genome_info = init_genome(PAR.FN.input.fn_genome_config);

% link to confirmed file
if ~fexist(PAR.FN.input.fn_genes_conf_orig)&fexist(PAR.FN.genome.fn_confirmed_sequences)
  unix(sprintf('ln -s %s %s',PAR.FN.genome.fn_confirmed_sequences,PAR.FN.input.fn_genes_conf_orig));
end
%prepare confirmed_sequences for genefinding
if fexist(PAR.FN.input.fn_genes_conf_orig)&~fexist(PAR.FN.output.fn_genes_conf)
  load(PAR.FN.input.fn_genes_conf_orig)
  genes = prepare_confirmed(genes,PAR);
  save(PAR.FN.output.fn_genes_conf,'genes');
end

% link to N_map file
N_file1 =  sprintf('%s/%s/%s/%s/N_map.gff3',PAR.FN.genome_dir,PAR.organism.name,PAR.organism.release,PAR.organism.genebuilt);
N_file2 =  sprintf('%s/%s/%s/orig_data/N_map.gff3',PAR.FN.input_dir,PAR.organism.name,PAR.dir_name);
if ~exist(N_file2)& fexist(N_file1)
  unix(sprintf('ln -s %s %s',N_file1,N_file2));
end
  
% keyboard
% link to annotation 
%-----------------------------------------------------------
anno_file = sprintf('%s/%s/%s/annotation/annotated_genes.mat',PAR.FN.genome_dir,PAR.organism.name,PAR.organism.release);
if 0 % ~fexist(PAR.FN.input.fn_genes_anno_orig)
  unix(sprintf('ln -s %s %s',anno_file,PAR.FN.input.fn_genes_anno_orig));
end
if 0% ~fexist(anno_file)&~isempty(genome_info.annotation_fnames);
  gff_file = genome_info.annotation_fnames{1}; 
  % no filtering according to second column (source column) of gff-file
  source = 'Coding_transcript'; run_locally=0; by_contig=0;
  genes = read_genes_from_gff3(gff_file,anno_file,genome_info,source,by_contig,run_locally);
  clear g_idx save_file gff_file 
end
if 0%  ~fexist(PAR.FN.output.fn_genes_anno)&fexist(PAR.FN.input.fn_genes_anno_orig)
  load(PAR.FN.input.fn_genes_anno_orig)
  genes = prepare_anno(genes,PAR);
  save(PAR.FN.output.fn_genes_anno,'genes');
end

% create trainings region (empty or Ns) if not train_on
trivial_regions = init_regions(PAR);
if ~exist(PAR.FN.input.fn_trainings_regions)|~exist(PAR.FN.input.fn_test_regions)
  if ~PAR.tasks.train_on
    if fexist(N_file2)
      training_regions = build_regions_from_file(N_file2,PAR.FN.input.fn_genome_config,PAR.organism.name)
    else
      training_regions = trivial_regions(1);
      training_regions.stop = 0;
      training_regions.start = 0;
    end
    save(PAR.FN.input.fn_trainings_regions,'training_regions')
    % create test regions (whole genome or complement of Ns)
    if fexist(N_file2)
      test_regions = setdiff_regions(trivial_regions,training_regions);
    else
      test_regions = trivial_regions;
    end
    save(PAR.FN.input.fn_test_regions,'test_regions')
    training_regions = assert_noRegionOverlap(test_regions,training_regions);
  else 
    %train AND test (!!) genomewide on all known EST genes
    load(PAR.FN.output.fn_genes_conf,'genes');
    for i=1:length(genes)
      genes(i).start = max(genes(i).start-2000,1);
      genes(i).stop = genes(i).stop+2000;
      genes(i).exons{1} = [];
      genes(i).exons{1}(1,1) = genes(i).start;
      genes(i).exons{1}(1,2) = genes(i).stop;
      if genes(i).strand =='+'
        genes(i).offset = genes(i).start - 1;
      else
        genes(i).offset = genes(i).stop + 1;
      end
      genes(i).cds_exons=genes(i).exons;
    end
    %merge overlapping genes
    genes = merge_transcripts_by_colocation(genes,genome_info)
    %convert genes structure to regions structure
    training_regions = init_regions;
    training_regions = convert_struct(training_regions,genes);
    for i=1:length(training_regions)
      training_regions(i).organism = PAR.organism.name ;
      training_regions(i).config = PAR.FN.input.fn_genome_config;
    end
    save(PAR.FN.input.fn_trainings_regions,'training_regions')
    test_regions = trivial_regions;
    save(PAR.FN.input.fn_test_regions,'test_regions')
  end
else
  load(PAR.FN.input.fn_trainings_regions,'training_regions')
  load(PAR.FN.input.fn_test_regions,'test_regions')
end
