

if 0
  addpath ~/svn/projects/genefinding/lsl_paper/
  PAR.exp_name = 'cat-1'
  PAR.dir = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/' PAR.exp_name ,'/'];
  PAR.fn_blocks = [PAR.dir '/data/blocks_new_signals_new_labels_trans_corrected_better.mat'] ;     
  
  blocks = load_struct(PAR.fn_blocks, 'blocks') ;
  
  C_elegans_new_training_config
  
  
  PAR.min_dist = 1000;
  PAR.num_splits = 5 ; 
  
  L=load(PAR.fn_polya_signals,'consensus') ;
  PAR.polya_sixmers = L.consensus ;
  
  model = make_model(PAR);
end

%% get SL1/SL2 info from annotated genes
gff_fname = '/fml/ag-raetsch/share/databases/genomes/C_elegans/elegans_WS160/annotation/elegansWS160.gff';
OP_fname = '/fml/ag-raetsch/share/databases/genomes/C_elegans/elegans_WS160/annotation/elegansWS160_operons.mat';
SL1_fname = '/fml/ag-raetsch/share/databases/genomes/C_elegans/elegans_WS160/annotation/elegansWS160_SL1.mat';
SL2_fname = '/fml/ag-raetsch/share/databases/genomes/C_elegans/elegans_WS160/annotation/elegansWS160_SL2.mat';

operons = parse_gff3_fortype(gff_fname, OP_fname,'operon');
SL1 = parse_gff3_fortype(gff_fname, SL1_fname,'SL1_acceptor_site');
SL2 = parse_gff3_fortype(gff_fname, SL2_fname,'SL2_acceptor_site');

blocks_ = map_SLandoperons2blocks(blocks,SL1,SL2,operons)
 

%% regenerate truth according to new model

blocks_new = rmfield(blocks,'truth');
blocks_new = gen_truth(blocks_new, model)

% compare old and new
cnt =0;cnt_trans=0;cnt_outrons=0;cnt_operons=0;
outrons=[];operons=[];
for i=1:length(blocks)
  if ~all(blocks(i). has_valid_transcript)|any(blocks(i).overlaps_with_prev)|~all(blocks(i).gene_complete)
    cnt=cnt+1;
    continue
  end
  for j=1:length(blocks(i).truth)
    pos_old =  blocks(i).truth(j).pos(blocks(i).truth(j).path~=model.state_ids.intergenic_long);
    pos_new =  blocks_new(i).truth(j).pos(blocks_new(i).truth(j).path~=model.state_ids.intergenic_long);
    path_old =  blocks(i).truth(j).path(blocks(i).truth(j).path~=model.state_ids.intergenic_long);
    path_new =  blocks_new(i).truth(j).path(blocks_new(i).truth(j).path~=model.state_ids.intergenic_long);
    
    idx=find(ismember(path_new, model.state_ids.trans));
    if ~isempty(idx)
      cnt_trans=cnt_trans+length(idx);
      % keyboard
      cnt_outrons=cnt_outrons+sum(path_new(idx-1)== model.state_ids.tss);
      for k=idx
        if path_new(k-1)== model.state_ids.tss
          outrons=[outrons;  pos_new(k)-pos_new(k-1)];
        end
      end
      cnt_operons=cnt_operons+sum(path_new(idx-1)== model.state_ids.cleave);
      for k=idx
        if path_new(k-1)== model.state_ids.cleave
          operons=[operons;  pos_new(k)-pos_new(k-1)];
        end
      end
    end
    
    if ~isequal(path_old,path_new)|~isequal(pos_old,pos_new)
      if isequal(pos_new(path_new~=model.state_ids.tss),pos_old(path_old~=model.state_ids.tss))&...
            isequal(path_new(path_new~=model.state_ids.tss),path_old(path_old~=model.state_ids.tss))
        continue
        %%tss was sometimes not annotated
      end
      
      if isequal(pos_old,pos_new)
        path_new(path_new==model.state_ids.tis(2))=model.state_ids.tis(1);
        path_old(path_old==model.state_ids.tis(2))=model.state_ids.tis(1);
        if isequal(path_old,path_new)
          continue
          %%tis(2) was handeld wrongly
        end
      end
      keyboard
    end
    
  end
end

blocks=blocks_new
something_wrong=[];
for i=1:length(blocks)
  if ~all(blocks(i). has_valid_transcript)|any(blocks(i).overlaps_with_prev)|~all(blocks(i).gene_complete)
    cnt=cnt+1;
    continue
  end
  for j=1:length(blocks(i).truth)
    SEG = blocks(i).truth(j);
    [path,pos_idx,pos,ok1]=segmentation2path(SEG, blocks(i), model,0);
    if ok1
      assert(isequal(SEG.pos,pos)&isequal(SEG.pos_idx,pos_idx))
      if ~isequal(SEG.path,path)
        keyboard
      end
    end
    % 
    % keyboard
    [N.segments, N.genes, ok2] = path2segmentation(path,pos_idx, blocks(i),model,0) ;
    if ok1==0&ok2==0;
      % something_wrong=[something_wrong i];
      continue
    end
    if (~isequal(N.segments,SEG.segments))
      something_wrong=[something_wrong i];
      if length(N.segments)==length(SEG.segments)
        [ii1,ii2] = find(N.segments~=SEG.segments);
        
        if all(all(N.segments(ii1,ii2))==model.segments.intergenic)&&all(all(SEG.segments(ii1,ii2)==model.segments.intercistronic))&...
              all(N.segments(ii1+1,3)==model.segments.transexon)&&all(N.segments(ii1+1,1)~=N.segments(ii1+1,3))
          % in gen_truth; anything is annotated as operon that has
          % trans; however if there is a tss, than the transition
            % cleave -> tss is intergenic and not intercistronic 
          continue
        end
        keyboard
      else
        setdiff(N.segments,SEG.segments,'rows')
        setdiff(SEG.segments,N.segments,'rows')
        keyboard
      end
    end
  end
end
  