function galaxy_signal_train(Exp,signal)

fprintf(1,'\n\nstart training for sensor %s\n\n',signal);

fid = fopen('/tmp/log12','w');

save('~/tmp/galaxy_workspace2');
% fprintf(fid,'organism: %s  signal: %s method: %s genome_config: %s fn_wiggle: %s dir_: %s svm_dir: %s \n',organism, signal,'SVMWDS', genome_config, fn_wiggle, dir_ , dir_)

% dir_ =  '/tmp/';
% fprintf(fid,'mkdir -p %s/%s/genome_data',dir_,organism);


PAR = create_PAR(Exp);
create_directories(PAR.FN,PAR.organism) ;

genome_config = PAR.FN.input.fn_genome_config;
organism = PAR.organism.name;

fprintf(fid,'init_regions\n')
training_regions = init_regions(PAR);
save(PAR.FN.input.fn_trainings_regions,'training_regions');

test_regions=training_regions(1);
test_regions.stop = 0;
test_regions.start = 0;
save(PAR.FN.input.fn_test_regions, 'test_regions');

trivial_regions = training_regions;
save(PAR.FN.output.fn_trivial_regions,'trivial_regions');
clear trivial_regions

blocks=training_regions([]) ;
block_length=1000 ;
for i=1:length(training_regions)
  for p=1:block_length:training_regions(i).stop,
    blocks(end+1).start = p ;
    blocks(end).stop = min(training_regions(i).stop, p+block_length) ;
    blocks(end).chr = training_regions(i).chr ;
    blocks(end).chr_num = training_regions(i).chr_num ;
    blocks(end).strand = training_regions(i).strand ;
    blocks(end).id = length(blocks) ;
    if blocks(end).strand=='+',
      blocks(end).offset = blocks(end).start - 1 ;
    else
      blocks(end).offset = blocks(end).stop + 1 ;
    end ;
    blocks(end).config = genome_config ;
    blocks(end).organism = organism ;
  end ;
end ;
sp = ceil(rand(1,length(blocks))*PAR.SETs.num_splits) ;
split = struct ;
for i=1:PAR.SETs.num_splits,
  split.(sprintf('split_%i', i)) = find(sp==i) ;
end ;

%blocks = training_regions;
save(PAR.FN.output.fn_training_blocks, 'blocks', 'PAR', 'split');

genome_info =  init_genome(genome_config) ;

for i=1:length(genome_info.contig_names),
  for s='+-',
    str=load_genomic(i,s,1,inf, genome_info) ;
    pos = strfind(str, 'ag')+2 ;
    pos(pos<PAR.Signals.(signal).lwin_big+10 | pos>=length(str)-PAR.Signals.(signal).rwin_big-10) = [] ;
    pos2= strfind(str, 'agag')+4 ;
    label = -ones(1,length(pos)) ;
    [tmp,idx1, idx2]=intersect(pos, pos2) ;
    label(idx1) = 1 ;
    
    save(sprintf('%s/contig_%i%c.mat', PAR.FN.input_sig.(signal).fn_candsites, i, s), 'pos', 'label') ;
    
  end ;
end 


PAR.Signal_name = signal ;


[PAR, jobinfo, all_done] = masterscript_sensors(PAR, 1) ;

% fprintf(fid,'rm -r %s/%s/ \n',dir_,organism)

% keyboard



return
