function galaxy_starter(organism, signal, genome_config, fn_wiggle, strand, dir_ ,svm_dir)

fprintf(1,'\n\nstart prediction on %sstrand\n\n',strand)

fid = fopen('/tmp/log11','w');
svm_file = [svm_dir organism '_' signal '.mat'];

save('/tmp/galaxy_workspace2')
fprintf(fid,'organism: %s  signal: %s method: %s genome_config: %s fn_wiggle: %s dir_: %s svm_dir: %s \n',organism, signal,'SVMWDS', genome_config, fn_wiggle, dir_ ,svm_dir)

%dir_ =  '/tmp/';
fprintf(fid,'mkdir -p %s/%s/genome_data',dir_,organism);

unix(sprintf('mkdir -p %s/%s/genome_data',dir_,organism));
unix(sprintf('mkdir -p %s/%s/orig_data',dir_,organism));
unix(sprintf('mkdir -p %s/%s/sensors/tis/',dir_,organism));
unix(sprintf('mkdir -p %s/%s/sensors/tss/',dir_,organism));
unix(sprintf('mkdir -p %s/%s/sensors/cleave/',dir_,organism));
unix(sprintf('mkdir -p %s/%s/sensors/cdsStop/',dir_,organism));
unix(sprintf('mkdir -p %s/%s/sensors/polya/',dir_,organism));
unix(sprintf('mkdir -p %s/%s///sensors/%s/output_SVMWDS/MS/',dir_,organism,signal));

Exp = sprintf('exp_galaxy_%s',organism);
PAR = create_PAR(Exp)
PAR.organism.name = organism;

PAR.FN.input_dir=dir_;
PAR.FN.output_dir=dir_;

input_fns = fieldnames(PAR.FN.input);
for i=1:length(input_fns)
  PAR.FN.input.(input_fns{i}) = ...
      strrepX(PAR.FN.input.(input_fns{i}), '/fml/ag-raetsch/share/projects/genefinding/', dir_) ;
end ;

input_sig_fns = fieldnames(PAR.FN.input_sig.(signal));
for i=1:length(input_sig_fns)
  PAR.FN.input_sig.(signal).(input_sig_fns{i}) = ...
      strrepX(PAR.FN.input_sig.(signal).(input_sig_fns{i}), '/fml/ag-raetsch/share/projects/genefinding/', dir_) ;
end ;

output_fns = fieldnames(PAR.FN.output);
for i=1:length(output_fns)
  PAR.FN.output.(output_fns{i}) = ...
      strrepX(PAR.FN.output.(output_fns{i}), '/fml/ag-raetsch/share/projects/genefinding/', dir_) ;
end ;

output_sig_fns = fieldnames(PAR.FN.output_sig.(signal));
for i=1:length(output_sig_fns)
  PAR.FN.output_sig.(signal).(output_sig_fns{i}) = ...
      strrepX(PAR.FN.output_sig.(signal).(output_sig_fns{i}), '/fml/ag-raetsch/share/projects/genefinding/', dir_) ;
end ;

%config_file = sprintf('%s_%s_%s',organism, signal,method);
%fprintf(fid,'feval %s',config_file)
%PAR=feval(config_file,PAR,1);


PAR.FN.input.fn_genome_config = genome_config;%'/tmp/genome.config';
%PAR.SETs.which_pred_svm = 1;

fn_svm = [PAR.FN.output_sig.(signal).fn_SVMs '/best_partition=1.mat'];

fprintf(fid,'cp %s %s',svm_file, fn_svm)
unix(sprintf('cp %s %s',svm_file, fn_svm));

fprintf(fid,'init_regions\n')
test_regions = init_regions(PAR);
%if strand=='+'
%  test_regions = test_regions(1);
%else
%  test_regions = test_regions(2);
%end
save(PAR.FN.input.fn_test_regions,'test_regions')
training_regions=test_regions(1);
training_regions.stop = 0;
training_regions.start = 0;
save(PAR.FN.input.fn_trainings_regions,'training_regions')

trivial_regions = test_regions;
save(PAR.FN.output.fn_trivial_regions,'trivial_regions')
clear trivial_regions
blocks = test_regions;
save(PAR.FN.output.fn_blocks,'blocks','PAR')
create_directories(PAR);

PAR.Signal_name = signal ;
[PAR] = masterscript_sensors(PAR) ;

fprintf(fid,'rm -r %s/%s/ \n',dir_,organism)

keyboard


unix(sprintf('gunzip %s/%s/sensors/%s/output_SVMWDS/pred/contig_1%s_Conf_cum.wiggle.gz',dir_,organism,signal,'*'));

%unix(sprintf('gunzip %s/%s/sensors/%s/output_SVMWD/pred/contig_1-_Conf_cum.wiggle.gz',dir_,organism,signal));
%unix(sprintf('cp %s/%s/sensors/%s/output_SVMWDS/pred/contig_1%s_Conf_cum.wiggle %s',dir_,organism,signal,strand,fn_wiggle));
%unix(sprintf('cp %s/%s/sensors/%s/output_SVMWD/pred/contig_1-_Conf_cum.wiggle %s',dir_,organism,signal,fn_wiggle2));

write_signal_gff(wiggle_fn, signal, genome_config_fn, gff_fn);

unix(sprintf('rm -r %s/%s/sensors',dir_,organism));
unix(sprintf('rm -r %s/%s/current_predictions',dir_,organism));
unix(sprintf('rm -r %s/%s/genome_data',dir_,organism));
unix(sprintf('rm -r %s/%s/orig_data',dir_,organism));

fclose(fid)

return
