

lpenv=cplex_license(0,8) ;  

addpath ~/svn/projects/genefinding/data_processing_lsl
addpath ~/svn/projects/genefinding/lsl_paper
addpath ~/svn/projects/genefinding/utils
addpath ~/svn/projects/genefinding/viz
addpath ~/svn/projects/genefinding/eval_lsl
%addpath /fml/ag-raetsch/share/software/matlab_tools/shogun
addpath ~/projects/shogun/src
%addpath ~/projects/shogun_matlab-7.0/src

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%% Layer 1: Signal Training
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%% Layer 1: Signal Prediction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%% Layer 1: Content Training
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%% Layer2: modelselection on path
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

C_elegans_new_training_config


PAR.min_dist = 1000;
PAR.num_splits = 5 ; 

L=load(PAR.fn_polya_signals,'consensus') ;
PAR.polya_sixmers = L.consensus ;

PAR.model = make_model(PAR);

PAR.use_annotation = 1;


%%% train models

unix(sprintf('mkdir -p %s/result', PAR.dir)) ;

PAR.opt_step = 1000 ;
PAR.max_neg = 2 ;
PAR.margin = 1 ;
PAR.RPROC.MEMREQ = 1000;
PAR.RPROC.options = [];
PAR.RPROC.options.arch = 64 ;
PAR.RPROC.options.express = 0 ;

PAR.INF = 1e20;

PAR.max_num_iterations = 100;

PAR.fn_init =  sprintf('%strain/%s-%s/init.mat',PAR.dir,PAR.user,PAR.dt);
PAR.fn_train = sprintf('%strain/%s-%s/train',PAR.dir,PAR.user,PAR.dt);
PAR.fn_pred = sprintf('%spredictions/%s-%s/pred_split=%i',PAR.dir,PAR.user,PAR.dt,PAR.pred_split_idx);
PAR.fn_log = sprintf('%slog_files/%s_%s_log_',PAR.dir,PAR.user,PAR.dt);

unix(sprintf('mkdir -p %strain/%s-%s', PAR.dir,PAR.user,PAR.dt)) ;
unix(sprintf('mkdir -p %spredictions/%s-%s', PAR.dir,PAR.user,PAR.dt)) ;


%train_path(PAR) ;
new_model = 1;
O = load('~raetsch/svn/projects/genefinding/lsl_paper/PAR_new_signals_new_labels_better_all.mat','PAR');
PAR_old = O.PAR;
use_xis = 0;
TRAIN = retrain_path(PAR, PAR_old, use_xis, new_model)
return

pred_path(PAR) ;

%PAR.pred_split_idx = 1:4 ;
%PAR.fn_pred = sprintf('%spredictions/%s_%s_pred%i:%i.mat',PAR.dir,PAR.user,PAR.dt,PAR.pred_split_idx(1),PAR.pred_split_idx(end));
%pred_path(PAR) ;

% test error
tmp = load(PAR.fn_pred);
test_blocks = tmp.blocks;
evaluate_block_predictions(test_blocks, 2, 'confirmed');
evaluate_block_predictions(test_blocks, 2);


id=1 ;
draw_pred(test_blocks(id).truth, test_blocks(id).pred, PAR.model) 


PAR.pred_split_idx=5 ;
PAR.fn_pred = sprintf('%spredictions/%s_%s_pred_cheat%i:%i.mat',PAR.dir,PAR.user,PAR.dt,PAR.pred_split_idx(1),PAR.pred_split_idx(end));
pred_path_cheat(PAR) ;


PAR.cleave_offset = 3.5 ;
pred_path_cleave(PAR) ;
L=load([PAR.fn_pred sprintf('_cleave%1.2f.mat', PAR.cleave_offset)], 'blocks', 'PAR', 'P') ;
evaluate_block_predictions(L.blocks);



cleave_offsets=-2.5:0.5:5%[-3:0.5:3] ;
for cleave_offset=cleave_offsets
  PAR.cleave_offset = cleave_offset ;
  pred_path_cleave(PAR) ;
end ;

%cleave_offsets=0:0.5:5%[0:10] ;
for cleave_offset=cleave_offsets
  PAR.cleave_offset = cleave_offset ;
  cleave_offset
  L=load([PAR.fn_pred sprintf('_cleave%1.2f.mat', PAR.cleave_offset)], 'blocks', 'PAR', 'P') ;
  evaluate_block_predictions(L.blocks, 2, 'confirmed');
end ;

