function Nematodes_starter(Exp,status,sensors,contents,verb)
  
%  Nematodes_starter(org_name,status,sensors,verb)
%
% Exp = 'exp_C_briggsae';
% Exp = 'exp_C_remanei';
% Exp = 'exp_C_brenneri';
% Exp = 'exp_C_elegans_WS180';
% Exp = 'exp_C_japonica';
% Exp = 'exp_C_elegans';
% status ='prep', 'layer1','layer2','final'  
% sensors={'acc','don','cdsStop','tis','tss','cleave','polya','trans'};  
% 
% ! unix(['cp ~raetsch/svn/projects/genefinding/lsl_paper/PAR_new_signals_new_labels_better_all.mat'...
%         '/fml/ag-raetsch/share/projects/genefinding/C_elegans/PAR_new_signals_new_labels_better_all.mat'])
%
%--------------genebuild---------------------%
%
% cd /fml/ag-raetsch/share/databases/genomes/C_remanei/wustl-15.0.1/scripts/
% ./scripts.sh
% basedir = '/fml/ag-raetsch/share/databases/genomes//C_remanei/wustl-15.0.1/' 
% min_prot_id = [30 50 70]
% [best_prot_id,Nums] = select_protein_ident(basedir,min_prot_id)

 dbstop error
  
  
if nargin<2
  status ='layer1';
end    
if nargin<3 
  sensors={'acc','don','cdsStop','tis','tss','cleave','polya','transacc'};
end
if nargin<4 
  contents={'intergenic','utr5exon','cds_exon','frame0','utr3exon','intron'};
end
if nargin<5
  verb=0;
end    
if ~iscell(sensors)
  sensors={sensors};
end

check_files = 0 ;

addpath genefinding
paths

PAR = create_PAR(Exp,verb);
create_directories(PAR,verb) 

%----------------PREPARE REGIONS AND BLOCKS----------------%

if isequal(status,'prep')  
  if isequal(PAR.dir_name,'nGASP')
    C_elegans_nGASP_prep(PAR)
  else
    Nematodes_prep(PAR)
  end
  PAR = masterscript_data(PAR);
  status = 'layer1';
end

if isequal(status,'prep2')  
  % keyboard
  PAR = masterscript_data(PAR,2);
  status = 'layer1';
  sensors = {'transacc'}
end

%--------------------PREDICT ALL SIGNALS-------------------%

PAR.tasks.run_locally = 1;
PAR.RPROC.options.express = 0;
% PAR.RPROC.numjunks = 10;
% PAR.RPROC.divide4pred = 1 ; 

all_predictions_done = 0 ; 
if isequal(status,'layer1')    
  while ~all_predictions_done
    JOBINFO = [];ALL_DONE=[];
    fprintf('\nstart layer 1 predictions\n')
    for i=1:length(sensors)
      sensor = sensors{i};
      PAR.Signal_name = sensor;
      [PAR, jobinfo.(sensor),all_done.(sensor)] = masterscript_sensors(PAR,check_files,verb);
      if ~isempty(jobinfo.(sensor))
        jobinfo.(sensor) = rproc_resubmit(jobinfo.(sensor));
        JOBINFO = [JOBINFO jobinfo.(sensor)];
      end
      ALL_DONE = [ALL_DONE all_done.(sensor)];
    end      
    rproc_wait(JOBINFO, 30);  
    all_predictions_done = all(ALL_DONE);
    if all(all_predictions_done)
      fprintf('\nSIGNALS COMPLETE n')
    end
  end
  status = 'prep_blocks';
end

return

%--------------------Layer 1 done-------------------%
cd ~/svn/projects/genefinding/lsl_paper





%--------------------PREPARE BLOCKS FOR LAYER 2-------------------%
addpath ~/svn/projects/genefinding/lsl_paper
rmpath /fml/ag-raetsch/home/schweike/svn/projects/genefinding/lsl/
rmpath /fml/ag-raetsch/home/schweike/svn/projects/genefinding/lsl_new

if isequal(status,'prep_blocks')
  fprintf('\nstart layer 2 predictions\n')
  % signal_masks = gen_signal_masks(genome_info);
  jobinfo = prepare_blocks(PAR);
  
  jobinfo = rproc_resubmit(jobinfo) ;
  rproc_wait(jobinfo, 30);
end

%--------------------PREDICT ALL CONTENTS-------------------%
PAR.tasks.run_locally = 1;
PAR.RPROC.options.express = 0;
% PAR.RPROC.numjunks = 10;
% PAR.RPROC.divide4pred = 1 ; 

all_predictions_done = 0 ; 
if isequal(status,'contents')    
  while ~all_predictions_done
    JOBINFO = [];ALL_DONE=[];
    fprintf('\nstart layer 1 predictions\n')
    for i=1:length(contents)
      content = contents{i};
      PAR.Content_name = content;
      [PAR, jobinfo.(content),all_done.(content)] = masterscript_contents(PAR,check_files,verb);
      [PAR, jobinfo.(content),all_done.(content)] = masterscript_contents(PAR,check_files,verb);
      if ~isempty(jobinfo.(content))
        jobinfo.(content) = rproc_resubmit(jobinfo.(content));
        JOBINFO = [JOBINFO jobinfo.(content)];
      end
      ALL_DONE = [ALL_DONE all_done.(content)];
    end      
    rproc_wait(JOBINFO, 30);  
    all_predictions_done = all(ALL_DONE);
    if all(all_predictions_done)
      fprintf('\nCONTENTS COMPLETE n')
    end
  end
  status = 'layer2';
end





%--------------------PREDICT LAYER 2-------------------%
if isequal(status,'layer2')
  last_job = 0;
  
  cd ~/svn/projects/genefinding/lsl_paper
  for i=1:length(genome_info.contig_names)
    for j='+-'
      blocks = load_struct(sprintf('%s%i%s.mat',PAR.FN.input_lsl.fn_test_blocks,i,j), 'blocks') ;
      jobinfo = predict_blocks(PAR,blocks,genome_info,signal_masks) ;
      JOBS(last_job+[1:length(jobinfo)]) = jobinfo ;
      last_job = length(JOBS); 
    end
  end
  rproc_wait(JOBS, 60)
end
keyboard  
collect_predictions(PAR)

map_genes=1;
replace_contignames=1;

final_stuff(PAR,map_genes,replace_contignames)

return













%%%%%%%%%%%%%%%%

%---------------------------------------------------------------
% Evaluate
%---------------------------------------------------------------

prediction_quality_controll(PAR);


gff_fname = '/fml/ag-raetsch/share/databases/genomes/C_briggsae/briggsae_cb3_WS180/annotation/briggsae_WS180.gff';
save_fname = '~/tmp.mat'

genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp3/orig_data/genome.config')  ;
fn = '/fml/ag-raetsch/share/databases/genomes/C_briggsae/briggsae_cb3_WS180/sequences/contigs/name_to_contig_mapping';
[tmp,genome_info] = replace_contignames([],fn,genome_info); 
anno_genes = read_genes_from_gff3(gff_fname,save_fname,genome_info,'curated',0,1,1);



load(PAR.FN.input.fn_trivial_regions,'trivial_regions');


for i=1:length(anno_genes)
  anno_genes(i).id = i;
end
genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp3/orig_data/genome.config')  ;
res_genome = evaluate_predictions(trivial_regions,anno_genes,genes, genome_info, 0,0);
                



%---------------------------------------------------------------
%--------------------CHECK cat1 -------------------%
cd ~/svn/projects/genefinding/
paths
PAR = exp_C_briggsae;
PAR = exp_lsl_cat1(PAR);
PAR = Nematodes_lsl(PAR);

genome_info = init_genome(PAR.FN.input.fn_genome_config);
O = load('~raetsch/svn/projects/genefinding/lsl_paper/PAR_new_signals_new_labels_better_all.mat','PAR')

O.PAR.cleave_offset = PAR.method.par_ms.cleave_offset ;
O.PAR.submit=1;
O.PAR.fn_pred = PAR.FN.output_lsl.fn_pred;
O.PAR.regions.offset = PAR.regions.offset;
O.PAR.RPROC.MEMREQ = 7000;
O.PAR.exm_per_batch = 1;

rmpath /fml/ag-raetsch/home/schweike/svn/projects/genefinding/lsl/
rmpath /fml/ag-raetsch/home/schweike/svn/projects/genefinding/lsl_new
addpath ~/svn/projects/genefinding/lsl_paper

last_job=0;
cd ~/svn/projects/genefinding/lsl_paper
for i=1:length(genome_info.contig_names)
  for j='+-'
    blocks = load_struct(sprintf('%s%i%s_seq.mat',PAR.FN.input_lsl.fn_test_blocks,i,j), 'blocks') ;
    jobinfo = predict_blocks(O.PAR,blocks) ;
    JOBS(last_job+[1:length(jobinfo)]) = jobinfo ;
    last_job = length(JOBS); 
  end
end
rproc_wait(JOBS, 60)

collect_predictions(PAR)
PAR.model = O.PAR.model;
PAR.FN.input.fn_name_to_contig_mapping = '/fml/ag-raetsch/share/databases/genomes/C_briggsae/briggsae_cb3_WS180/sequences/contigs/name_to_contig_mapping';
final_stuff(PAR)

%---------------------------------------------------------------
%--------------------CHECK cat3 prot id 80 -------------------%

cd ~/svn/projects/genefinding/
paths
PAR = exp_C_briggsae;
PAR = exp_lsl_cat3_80(PAR);
PAR = Nematodes_lsl(PAR);

PAR.FN.input.fn_genome_config = '/fml/ag-raetsch/share/databases/genomes//C_briggsae/briggsae_cb3_WS180/genebuild80minprotcov/genome.config'

genome_info = init_genome(PAR.FN.input.fn_genome_config);

addpath ~/svn/projects/genefinding/data_processing_lsl/signal_masks/

signal_masks = gen_signal_masks(genome_info)


O = load('~raetsch/svn/projects/genefinding/lsl_paper/PAR_new_signals_new_labels_better_all.mat','PAR')

O.PAR.cleave_offset = PAR.method.par_ms.cleave_offset ;
O.PAR.submit=1;
O.PAR.fn_pred = PAR.FN.output_lsl.fn_pred;
O.PAR.regions.offset = PAR.regions.offset;
O.PAR.RPROC.MEMREQ = 30000;
O.PAR.exm_per_batch = 1;

rmpath /fml/ag-raetsch/home/schweike/svn/projects/genefinding/lsl/
rmpath /fml/ag-raetsch/home/schweike/svn/projects/genefinding/lsl_new
addpath ~/svn/projects/genefinding/lsl_paper

last_job=0;
cd ~/svn/projects/genefinding/lsl_paper
for i=3:length(genome_info.contig_names)
  for j='+-'
    blocks = load_struct(sprintf('%s%i%s_seq.mat',PAR.FN.input_lsl.fn_test_blocks,i,j), 'blocks') ;
    jobinfo = predict_blocks(O.PAR,blocks) ;
    JOBS(last_job+[1:length(jobinfo)]) = jobinfo ;
    last_job = length(JOBS); 
  end
end
rproc_wait(JOBS, 60)


collect_predictions(PAR)
PAR.model = O.PAR.model;
PAR.FN.input.fn_name_to_contig_mapping = '/fml/ag-raetsch/share/databases/genomes/C_briggsae/briggsae_cb3_WS180/sequences/contigs/name_to_contig_mapping';
final_stuff(PAR)







