function blocks = map_SLandoperons2blocks(blocks,SL1,SL2,operons)
  

unused_sl1 = [];
unused_sl2 = [];
for i=1:length(blocks)
  op = operons(find(strcmp({operons.chr},blocks(i).chr)&strcmp({operons.strand},blocks(i).strand)));
  sl1 = SL1(find(strcmp({SL1.chr},blocks(i).chr)&strcmp({SL1.strand},blocks(i).strand)));
  sl2 = SL2(find(strcmp({SL2.chr},blocks(i).chr)&strcmp({SL2.strand},blocks(i).strand)));

  if blocks(i).strand=='+'
    op = op(find([op.start]<blocks(i).block_end& [op.stop]>blocks(i).block_start));
    sl1 = sl1(find([sl1.start]<blocks(i).block_end& [sl1.stop]>blocks(i).block_start));
    sl2 = sl2(find([sl2.start]<blocks(i).block_end& [sl2.stop]>blocks(i).block_start));
    sl1_pos = [sl1.stop]-blocks(i).offset;
    sl2_pos = [sl2.stop]-blocks(i).offset;
    blocks(i).trans_info = cell(size(blocks(i).trans));
    sl1_used=[];
    sl2_used=[];
    for j=1:length(blocks(i).gene_ids)
      
      blocks(i).trans_info{j} = zeros(size(blocks(i).trans{j}));
      % assert(length(blocks(i).trans{j})==1);
      for k=1:length(blocks(i).trans{j})
        if ~isnan(blocks(i).trans{j}(k))
          idx1 = find(blocks(i).trans{j}(k)==sl1_pos);
          idx2 = find(blocks(i).trans{j}(k)==sl2_pos);
          if ~isempty(idx2)
            blocks(i).trans_info{j}(k) = 2;
            sl2_used=[sl2_used sl2_pos(idx2)];
          end
          if ~isempty(idx1)
            if ~isempty(idx2)
              warning('sl1 and sl2')
            end
            blocks(i).trans_info{j}(k) = 1;
            sl1_used=[sl1_used sl1_pos(idx1)];
          end
          
        else
          idx1 = find(blocks(i).tss{j}(k)==sl1_pos);
          idx2 = find(blocks(i).tss{j}(k)==sl2_pos);
          if isempty(idx1)&isempty(idx2)
            idx1 = find(blocks(i).anno_tss{j}(k)==sl1_pos);
            idx2 = find(blocks(i).anno_tss{j}(k)==sl2_pos);
          end
          if isempty(idx1)&isempty(idx2)
            idx1 = find(abs(blocks(i).tss{j}(k)-sl1_pos)<5);
            idx2 = find(abs(blocks(i).tss{j}(k)-sl2_pos)<5);
          end
          if ~isempty(idx2)
            blocks(i).trans{j}(k) = blocks(i).tss{j}(k);
            blocks(i).trans_info{j}(k) = 2;
            sl2_used=[sl2_used sl2_pos(idx2)];
          end
          if ~isempty(idx1)
            if ~isempty(idx2)
              warning('sl1 and sl2')
            end
            blocks(i).trans{j}(k) = blocks(i).tss{j}(k);
            blocks(i).trans_info{j}(k) = 1;
            sl1_used=[sl1_used sl1_pos(idx1)];
          end
        end %if 
      end %loop over transacc 
      if ~all(blocks(i).trans_info{j})
        idx = find([blocks(i).trans_info{j}]==0);
        if any(~isnan([blocks(i).trans{j}(idx)]))
          warning('trans not found in annotation !')
          % keyboard
        end
      end
      
      % blocks(i).inoperon = cell(size(blocks(i).trans));
      
    end % loop over genes in block
    if ~isempty(setdiff(sl1_pos,sl1_used))
      warning('not all SL1 used')
      % keyboard
    end
    if ~isempty(setdiff(sl2_pos,sl2_used))
      warning('not all SL2 used')
      % keyboard
    end
  else
  end
end
