
% prepare test blocks with signal masks
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%load('/fml/ag-raetsch/share/databases/genomes/C_elegans/nGASP/genebuildnGASPCat3/signal_masks.mat', 'signal_masks') ;
%load('/fml/ag-raetsch/share/databases/genomes/C_elegans/nGASP/genebuildnGASPCat3_minESTcov50/signal_masks.mat', 'signal_masks') ;
% load('/fml/ag-raetsch/share/databases/genomes/C_elegans/nGASP/genebuildnGASPCat3_minESTProtcov25+/signal_masks.mat', 'signal_masks') ;
load('/fml/ag-raetsch/share/databases/genomes/C_elegans/nGASP/genebuildnGASPCat3_minESTProtcov25+/signal_masks_withends.mat', 'signal_masks') ;
blocks = load_struct(PAR.FN.input_lsl.fn_test_blocks, 'blocks') ;
for i=1:length(blocks),
  i
  block = blocks(i) ;
  % some coordinate magic
  block.chr_num = 10+floor((i+1)/2) ;
  if block.strand == '+',
    block.block_start = 1 ;
    block.offset = 0 ;
    block.block_end = 1000000 ;
  else
    block.block_start = 1000000 ;
    block.offset = 1000001 ;
    block.block_end = 1 ;
  end ;
  block=apply_signal_mask(block, signal_masks)
  block.block_start = blocks(i).block_start ;
  block.offset = blocks(i).offset ;
  block.block_end = blocks(i).block_end ;
  [block.seq,block.pos]=gen_seq(block, PAR.model) ;
  blocks(i) = rmfield(block, 'chr_num') ;
end 
save_struct([PAR.FN.input_lsl.fn_test_blocks '-with-signalmasks_withends.mat'], blocks, 'blocks') ;

if 0,
  PAR.fn_blocks = [PAR.FN.input_lsl.fn_test_blocks '-with-signalmasks_withends.mat'] ;
  if isfield(PAR,'fn_splits')
    PAR=rmfield(PAR, 'fn_splits') ;
  end
  PAR.RPROC.MEMREQ=4000 ;
  jobinfo = rproc_empty(0) ;
  options = [] ;
  options.addpaths=separate(path, ':') ;
  pred={} ;
  offsets=[3:0.5:5.5]; 
  for offset=offsets,
    PAR.cleave_offset = offset ;
    pred{end+1}=pred_path_cleave(PAR) ;
    %jobinfo(end+1) = rproc('pred_path_cleave', PAR, 8000, options, 30) ;
  end ;

  genes_anno=[] ; res_cat1={} ; genes_pred={} ; operons_pred={} ;
  for j=1:length(pred),
    blocks=pred{j} ;
    genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding//C_elegans/WS160/orig_data/genome.config');%PAR.FN.input.fn_genome_config) ;
    L=load('/fml/ag-raetsch/share/projects/nGASP/test_regions.mat');
    regions=L.test_regions; clear L
    
    [genes_pred{end+1},operons_pred{end+1}] = blocks2genes(blocks, PAR.model, 'prediction', genome_info, 'nematode');
    
    L=load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_CNEW_complete.mat')
    genes_anno = L.genes ;
    
    offsets(j) 
    res_cat1{end+1} = evaluate_predictions(regions,genes_anno,genes_pred{end},genome_info,0);
  end ;
end ;

% prepare train blocks with signal masks
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%load('/fml/ag-raetsch/share/databases/genomes/C_elegans/nGASP/genebuildnGASPCat3/signal_masks.mat', 'signal_masks') ;
%load('/fml/ag-raetsch/share/databases/genomes/C_elegans/nGASP/genebuildnGASPCat3_minESTcov50/signal_masks.mat', 'signal_masks') ;
load('/fml/ag-raetsch/share/databases/genomes/C_elegans/nGASP/genebuildnGASPCat3_minESTProtcov25+/signal_masks_withends.mat', 'signal_masks') ;
blocks = load_struct(PAR.FN.input_lsl.fn_training_blocks, 'blocks') ;
cont2chrom
for i=1:length(blocks),
  i

  contig = [] ;
  for j=1:length(cont),
    if isequal(cont(j).chr, blocks(i).chr) && cont(j).start<= ...
          blocks(i).block_start && cont(j).stop>=blocks(i).block_end,
      contig = j ;
    end ;
  end 
  assert(~isempty(contig)) ;
  
  block = blocks(i) ;
  % some coordinate magic
  block.chr_num = contig ;
  if block.strand == '+',
    block.block_start = block.block_start-cont(contig).start+1 ;
    block.offset = block.offset-cont(contig).start+1 ;
    block.block_end = block.block_end-cont(contig).start+1 ;
  else
    block.block_start = block.block_start - cont(contig).start+1 ;
    block.offset = block.offset - cont(contig).start+1 ;
    block.block_end = block.block_end - cont(contig).start+1 ;
  end ;
  block=apply_signal_mask(block, signal_masks);
  block.block_start = blocks(i).block_start ;
  block.offset = blocks(i).offset ;
  block.block_end = blocks(i).block_end ;
  [block.seq,block.pos]=gen_seq(block, PAR.model) ;
  blocks(i) = rmfield(block, 'chr_num') ;
end 
save_struct([PAR.FN.input_lsl.fn_training_blocks '-with-signalmasks.mat'], blocks, 'blocks') ;

if 0,
  PAR.fn_blocks = [PAR.FN.input_lsl.fn_training_blocks '-with-signalmasks.mat'] ;
  PAR.fn_split = PAR.FN.input_lsl.fn_training_split;
  PAR.RPROC.MEMREQ=1000 ;
  
  jobinfo = rproc_empty(0) ;
  options = [] ;
  options.addpaths=separate(path, ':') ;
  pred={} ;
  offsets=[3:0.5:5.5]
  for offset=offsets,
    PAR.cleave_offset = offset ;
    pred{end+1}=pred_path_cleave(PAR) ;
    %jobinfo(end+1) = rproc('pred_path_cleave', PAR, 8000, options, 30) ;
  end ;
  
  genes_anno=[] ; res_cat1={} ; genes_pred={} ; operons_pred={} ;
  for j=1:length(pred),
    blocks=pred{j} ;
    genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding//C_elegans/WS160/orig_data/genome.config');%PAR.FN.input.fn_genome_config) ;
    L=load('/fml/ag-raetsch/share/projects/nGASP/training_regions.mat');
    regions=L.training_regions; clear L
    
    [genes_pred{end+1},operons_pred{end+1}] = blocks2genes(blocks, PAR.model, 'prediction', genome_info, 'nematode');
    
    if isempty(genes_anno),
      for i=1:length(blocks),
        blocks(i).my_truth = blocks(i).truth(1) ; 
      end ;
      [genes_anno,operons_anno] = blocks2genes(blocks, PAR.model, 'my_truth', genome_info, 'nematode');
    end ;
    offsets(j)
    res_cat1{end+1} = evaluate_predictions(regions,genes_anno,genes_pred{end},genome_info,0);
  end 
  
  res_cat1{:}
end ;