function PAR=Nematodes_cdsStop_SVM_COMBINED(PAR,create_dir)

if nargin<1
  PAR=init_PAR;
elseif nargin<2
  create_dir=0;
end

PAR = Nematodes(PAR);
PAR = cdsStop(PAR);
PAR = SVM_COMBINED(PAR);


PAR = create_filenames(PAR);

E = load(['/fml/ag-raetsch/share/projects/genefinding/C_elegans/sensors/' ...
          'cdsStop/output_SVMSPWDSSP/SVM_best_partition=1.mat'],'PAR');

assert(isequal(E.PAR.Signal_name,PAR.Signal_name));

%%remove stuff which is only needed for label generation and training
PAR = rmfield(PAR,'label_source');
PAR = rmfield(PAR,'label_source_par');

num_splits = PAR.SETs.num_splits;

PAR = rmfield(PAR,'SETs');
if num_splits >E.PAR.SETs.num_splits;
  keyboard
else
  PAR.SETs.num_splits= num_splits;
end

%----FN---

input_sig.fn_pos = PAR.FN.input_sig.(PAR.Signal_name).fn_pos;
PAR.FN.input_sig.(PAR.Signal_name) = input_sig;

output.fn_trivial_regions = PAR.FN.output.fn_trivial_regions ;
output.fn_blocks= PAR.FN.output.fn_blocks;
output.fn_training_blocks= PAR.FN.output.fn_training_blocks;
output.fn_test_blocks= PAR.FN.output.fn_test_blocks;

PAR.FN.output = output;

output_sig.fn_pred = PAR.FN.output_sig.(PAR.Signal_name).fn_pred;
output_sig.fn_SVMs = E.PAR.FN.output_sig.(PAR.Signal_name).fn_SVMs;
PAR.FN.output_sig.(PAR.Signal_name) = output_sig;

%assert(isequal(PAR.Signals.(PAR.Signal_name),E.PAR.Signals.(PAR.Signal_name)))
%assert(isequal(PAR.method,E.PAR.method))

PAR.Signals.(PAR.Signal_name) = E.PAR.Signals.(PAR.Signal_name);
PAR.method = E.PAR.method;


if create_dir
  create_directories(PAR);
end