function blocks=add_intensities2blocks(blocks,fn_data,percentile)
% blocks=add_intensities2blocks(blocks,fn_data)
% 
% fn_data: mat-file with variables 'probe_PM_I','probe_id' containing intensities and positions
% blocks: required fields: chr_num, start, stop, strand
% 
% example: D-series, Quantile normalized, rich_regression:=sequence normalized
% load /fml/ag-raetsch/share/projects/tiling_arrays/array_data_mat/D_QN_RR.mat
%
% probe_PM_I: Intensities of Perfect Match probes
load(fn_data,'probe_PM_I','probe_id')

chr_num = fix(probe_id./1e8);
pos = mod(probe_id,1e8);
clear probe_id

chr_nums = unique([blocks.chr_num]);
for chr=chr_nums
  chr_block_ids = find([blocks.chr_num]==chr);
  pos_ids = find(chr_num==chr);
  chr_pos = pos(pos_ids);
  chr_probe_PM_I = probe_PM_I(:,pos_ids);
  for b=chr_block_ids
    which = find(chr_pos>blocks(b).start&chr_pos<blocks(b).stop);
    blocks(b).intensities = chr_probe_PM_I(:,which);
    blocks(b).intensities = my_prctile(blocks(b).intensities,percentile);
    if blocks(b).strand=='+'
      blocks(b).probe_local_pos = chr_pos(which)-blocks(b).start+1;
    else
      blocks(b).probe_local_pos = blocks(b).stop-chr_pos(which)+1;
      blocks(b).probe_local_pos =blocks(b).probe_local_pos(end:-1:1);
      blocks(b).intensities =blocks(b).intensities(end:-1:1);
    end
    assert(issorted(blocks(b).probe_local_pos))
  end
end

