function attach_content_sensors_to_blocks()
  
results_dir = '/fml/ag-raetsch/share/projects/nGASP/content/';
%%%%% SET THIS:
results_dir = [results_dir 'RESULTS_2006-12-22_17h27/'];

% load parameters
param_file = [results_dir 'global_parameters.mat'];
load(param_file, 'PAR');

% load blocks that will be used for label sequence learning
load(PAR.block_file);

binary_hist = 1;
cons_binary_hist = 0;

contents = [blocks(:).content];
subset_ids = [contents(:).subset_id];
content_svm_w = cell(1,length(PAR.orders));
for i=1:PAR.SETs.num_splits,
  test_subset = 1+mod(i+PAR.SETs.num_splits-2,PAR.SETs.num_splits);
  
  content = [];
  content.subset_id = test_subset;
  fprintf('\n');
  for o=PAR.orders, % orders of spectrum kernels
    order_idx = find(PAR.orders==o);
    
    for t=1:PAR.num_types,
      % load content SVMs for intergenic segments
      file_name = [PAR.svm_file_prefix '_' PAR.type_abbrs{t} ...
                   '_split' num2str(i) '_order' num2str(o) ...
                   '_binHist' num2str(binary_hist)];
      load(file_name);
      fprintf('Loaded SVM from %s\n', file_name);
      assert(SVM.PARAM.test_set_id == test_subset);      
      
      content_SVMs{order_idx}.order = o;
      content_SVMs{order_idx}.type{t,i} = PAR.type_descrs{t};
      content_SVMs{order_idx}.subset(t,i) = test_subset;
      content_SVMs{order_idx}.w(t,i,:) = SVM.w;
      
      if PAR.use_conservation,
        file_name = [PAR.svm_file_prefix '_' PAR.type_abbrs{t} ...
                     '_conservation_only_split' num2str(i) ...
                     '_order' num2str(o) '_binHist' num2str(cons_binary_hist)];
        tmp = load(file_name);
        SVM2 = tmp.SVM;
        clear tmp
        fprintf('Loaded SVM from %s\n', file_name);
        assert(SVM2.PARAM.test_set_id == test_subset);      

        cons_content_SVMs{order_idx}.order = o;
        cons_content_SVMs{order_idx}.type{t,i} = PAR.type_descrs{t};
        cons_content_SVMs{order_idx}.subset(t,i) = test_subset;
        cons_content_SVMs{order_idx}.w(t,i,:) = SVM2.w;
      end;
    end;
  end;
      
  % determine blocks in corresponding test set
  block_idx = find(subset_ids==test_subset);
  
  % attach content struct to blocks
  for b=block_idx,
    blocks(b).content = content;
  end;
end;

keyboard

% save results
content_blocks = blocks;
save(PAR.content_block_file, 'content_blocks', 'content_SVMs');
fprintf('\nsaved content blocks and SVMs to %s\n', ...
        PAR.content_block_file);  

% save results for conservation content SVMs
if PAR.use_conservation,
  fname = PAR.content_block_file;
  if fname(end-3:end)=='.mat',
    fname = fname(1:end-4);
  end
  fname = [fname '_conserv.mat'];
  save(fname, 'content_blocks', 'cons_content_SVMs');
  fprintf('\nsaved content blocks and conservation SVMs to %s\n', fname);  
end;

