function attach_frame_sensors_to_blocks()
  
dir = '/fml/ag-raetsch/share/projects/nGASP/content/';
content_block_file = [dir 'RESULTS_FOR_2nd_LAYER/content_blocks.mat'];
%%%%% SET THIS:
results_dir = [dir 'RESULTS_2006-12-22_16h34_conserv/'];

% load parameters
param_file = [results_dir 'global_parameters.mat'];
load(param_file, 'PAR');
load(PAR.frame_block_file, 'frame_SVMs');

% load content blocks that will be used for label sequence learning
load(content_block_file);

frame_orders = [];
for i=1:length(frame_SVMs),  
  frame_orders = [frame_orders frame_SVMs{i}.order];
end

for o=1:length(content_SVMs),
  order_idx = [];
  order_idx = find(frame_orders==content_SVMs{o}.order);
  if ~isempty(order_idx),
    assert(all(content_SVMs{o}.subset(1,:)==frame_SVMs{order_idx}.subset));
    assert(content_SVMs{o}.order==frame_SVMs{order_idx}.order);
    % HACK triple information for frame svm (yes there is only one,
    % but we still save 3 for the LSL)
    for f=1:3,
      content_SVMs{o}.subset = [content_SVMs{o}.subset; ...
                          frame_SVMs{order_idx}.subset];
      content_SVMs{o}.type(5+f,:) = repmat({['cds_frame' num2str(f-1)]},1,5);
      content_SVMs{o}.w(5+f,:,:) = frame_SVMs{order_idx}.w;
    end
  end
end

save(content_block_file, 'content_blocks', 'content_SVMs');
fprintf('\nsaved content blocks and content+frame SVMs to %s\n', content_block_file);    

if PAR.use_conservation,
  clear content_blocks content_SVMs conten_block_file frame_SVMs frame_orders
  content_block_file = [dir 'RESULTS_FOR_2nd_LAYER/content_blocks_conserv.mat'];
  load(content_block_file, 'content_blocks', 'cons_content_SVMs');
  
  frame_block_file = PAR.frame_block_file;
  if frame_block_file(end-3:end)=='.mat',
    frame_block_file = frame_block_file(1:end-4);
  end
  frame_block_file = [frame_block_file '_conserv.mat'];
  load(frame_block_file, 'cons_frame_SVMs');
  
  frame_orders = [];
  for i=1:length(cons_frame_SVMs),  
    frame_orders = [frame_orders cons_frame_SVMs{i}.order];
  end

  for o=1:length(cons_content_SVMs),
    order_idx = [];
    order_idx = find(frame_orders==cons_content_SVMs{o}.order);
    if ~isempty(order_idx),
      assert(all(cons_content_SVMs{o}.subset(1,:)==cons_frame_SVMs{order_idx}.subset));
      assert(cons_content_SVMs{o}.order==cons_frame_SVMs{order_idx}.order);
      % HACK triple information for frame svm (yes there is only one,
      % but we still save 3 for the LSL)
      for f=1:3,
        cons_content_SVMs{o}.subset = [cons_content_SVMs{o}.subset; ...
                            cons_frame_SVMs{order_idx}.subset];
        cons_content_SVMs{o}.type(5+f,:) = repmat({['cds_frame' num2str(f-1)]},1,5);
        cons_content_SVMs{o}.w(5+f,:,:) = cons_frame_SVMs{order_idx}.w;
      end
      fprintf('attached frame SVMs order %i\n', frame_orders(order_idx));
      cons_content_SVMs{o}
    end
  end
  
  content_SVMs = cons_content_SVMs;
  save(content_block_file, 'content_blocks', 'content_SVMs');
  fprintf('\nsaved conservation content blocks and content+frame SVMs to %s\n', content_block_file);    
end

