function DATA = collect_frame_examples(blocks, PAR)

cnt = 0;
for b=1:length(blocks),
  for g=1:length(blocks(b).frame.exons)
    cds_coords = blocks(b).frame.exons{g};
    if blocks(b).frame.skip(g),
      continue;
    end;
  
    too_small = find(cds_coords(:,2)-cds_coords(:,1)+1 < PAR.min_segment_len);
    cds_coords(too_small,:) = [];
    
    if ~isempty(cds_coords),
      % "allocate memory"
      % create 3 examples (1 pos. + 2 neg.) from every CDS exon
      DATA.cds{cnt+size(cds_coords,1)*3} = [];
      if PAR.use_conservation,
        DATA.conservation{cnt+size(cds_coords,1)*3} = [];            
      end;
      % collect sequences
      for i=1:size(cds_coords,1),
        for j=0:2,
          DATA.cds{cnt+(i-1)*3+j+1} = blocks(b).genestr(cds_coords(i,1)+j:cds_coords(i,2));
          DATA.frame(cnt+(i-1)*3+j+1) = mod(cds_coords(i,3)+j,3);
          if PAR.use_conservation,
            DATA.conservation{cnt+(i-1)*3+j+1} = ...
                blocks(b).conservation(cds_coords(i,1)+j:cds_coords(i,2));        
            assert(size(DATA.conservation{cnt+(i-1)*3+j+1})==size(DATA.cds{cnt+(i-1)*3+j+1}));
          end;
        end;
      end;
      cnt = length(DATA.cds);
    end;
  end;
end;

r_idx = randperm(length(DATA.cds));
DATA.cds = {DATA.cds{r_idx}};
if PAR.use_conservation,
  DATA.conservation = {DATA.conservation{r_idx}};
end;
DATA.frame = DATA.frame(r_idx);


