function load_content_and_predict(PAR, Test_Data)

paths 

if strcmp(PAR.Content_name,'frame0')
  use_frame=1;
else
  use_frame=0;
end

fn_blocks = PAR.FN.output.fn_training_blocks;
[pos_examples neg_examples]=load_blocks_and_gen_segments(fn_blocks,PAR.FN.input.fn_genome_config, PAR.SETs.which_contents, PAR.SETs.which_val,PAR.method.kernels{1}.order,use_frame);


if use_frame
  for j=1:length(pos_examples)
    has_atg(j) = strcmp(pos_examples{j}(1:3),'ATG');
    len = length(pos_examples{j}); 
    pos_examples{j} = pos_examples{j}(4:end);
    assert(mod(length(pos_examples{j}),3)==0)
  end
  fprintf('%i of %i do not start with AGT (they will be removed from training set)\n',sum(has_atg==0),length(pos_examples))
  pos_examples(find(has_atg==0))=[];
  neg_examples = make_frame_neg_examples(pos_examples);
end

% concat examples and generate labels
%----------------------------------------------------------------
XT_cell = {pos_examples{:}, neg_examples{:}};
LT = [ones(1,length(pos_examples)), -ones(1,length(neg_examples))];

% generate feature vectors
%----------------------------------------------------------------
XT = zeros(4^PAR.method.kernels{1}.order,length(XT_cell));
if use_frame
  stepping = 3;
  offset = mod(3-mod(PAR.method.kernels{1}.order,3),3);
else
  stepping = 1;
  offset = 0;
end
for j=1:length(XT_cell)
  [mask hist] = compute_mers(XT_cell{j}, PAR.method.kernels{1}.order, stepping, offset);
  XT(:,j) = hist';
end

predict_content(XT,PAR.fn_SVMs,PAR.fn_eval,LT)

