function load_intensities_and_train(PAR,Train_Data)

paths

fn_blocks = PAR.FN.output.fn_blocks;

% load blocks and generate cell arrays of sequences corresponding to the segments
%----------------------------------------------------------------
[pos_examples neg_examples pos_block_ids neg_block_ids pos_segments neg_segments blocks]=...
      load_blocks_and_gen_segments(fn_blocks,PAR.FN.input.fn_genome_config, PAR.SETs.which_contents, PAR.SETs.which_train,'train');
assert(length(pos_examples)==length(pos_block_ids))
assert(length(neg_examples)==length(neg_block_ids))
assert(size(neg_segments,1)==length(neg_block_ids))
assert(size(pos_segments,1)==length(pos_block_ids))


% load_intensities
%----------------------------------------------------------------
blocks = add_intensities2blocks(blocks,'/fml/ag-raetsch/share/projects/tiling_arrays/array_data_mat/D_QN_RR.mat')

% calc summarising statistics of intensities of different experiments
%----------------------------------------------------------------
for b=1:length(blocks)
  blocks(b).intensities=quantile(blocks(b).intensities,0.8);
end

bins=30;
limits = linspace(3,18,bins);

% calc features
%----------------------------------------------------------------
pos_feat = calc_tiling_features(blocks,pos_segments,pos_block_ids,limits);
neg_feat = calc_tiling_features(blocks,neg_segments,neg_block_ids,limits);

% concat examples and generate labels
%----------------------------------------------------------------
XT = [pos_feat neg_feat];
LT = [ones(1,length(pos_examples)), -ones(1,length(neg_examples))];
perm = randperm(length(LT));
XT = XT(:,perm);
LT = LT(perm);


%train_content(XT,LT,PAR.method.par_ms.C, PAR.fn_SVMs);


% simple test to check performance
%----------------------------------------------------------------

l = floor(length(LT)/4*3);
train_content(XT(:,1:l),LT(1:l),PAR.method.par_ms.C, PAR.fn_SVMs);
outfile = '/tmp/schrott2';

predict_content(XT(:,l+1:end),PAR.fn_SVMs,outfile);
load(outfile, 'output')
roc = calcrocscore(output,LT(l+1:end))
rfc = calcrfcscore(output,LT(l+1:end))
keyboard



return

function intensities=get_intensities(block,start,stop)
  idx = find(block.probe_local_pos>start&block.probe_local_pos<stop);
  intensities = block.intensities(idx);
return
