function main_content_training(PAR)

%%% CHECK STRUKT %%%%%%%%%%%%
assert(isfield(PAR.Contents,'combine_UTRs'))
assert(isfield(PAR.Contents,'max_intercistronic_len'))
assert(isfield(PAR.Contents,'num_types'))
assert(isfield(PAR.Contents,'type_descrs'))
assert(isfield(PAR.Contents,'type_abbrs'))
assert(length(PAR.Contents.type_descrs)==length(PAR.Contents.type_abbrs))
assert(length(PAR.Contents.type_descrs)==PAR.Contents.num_types)
assert(isfield(PAR,'Content_name'))
assert(isfield(PAR.FN.input_cont.(PAR.Content_name),'fn_training_tracks'))
assert(isfield(PAR.FN.output_cont.(PAR.Content_name),'fn_SVMs'))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%PAR.training_seq_file = '/fml/ag-raetsch/share/projects/nGASP/training_regions.mat';

%PAR.training_signals_file = '/fml/ag-raetsch/share/projects/nGASP/training_signals.mat';

%PAR.LSL_block_file = '/fml/ag-raetsch/share/projects/nGASP/LSL/data/blocks_2006-12-18.mat';

%PAR.block_file             = [PAR.results_dir 'blocks.mat'];
%PAR.data_split_file_prefix = [PAR.results_dir 'content_data_split'];
%PAR.content_block_file     = [PAR.results_dir 'content_blocks.mat'];


%if PAR.Contents.combine_UTRs,
%  if PAR.Contents.max_intercistronic_len > 0,
%    PAR.num_types = 5;
%    PAR.type_descrs = { 'intergenic', 'utr_exon', 'cds_exon', ...
%                   'intron', 'intercistronic' };    
%    PAR.type_abbrs = { 'ige' 'utr' 'cex' 'ino' 'ics' };
%  else
%    PAR.num_types = 4;
%    PAR.type_descrs = { 'intergenic', 'utr_exon', 'cds_exon', 'intron' };
%    PAR.type_abbrs = { 'ige' 'utr' 'cex' 'ino' };
%  end;
%else
%  if PAR.Contents.max_intercistronic_len > 0,
%    PAR.num_types = 6;
%    PAR.type_descrs = { 'intergenic', 'utr5exon','cds_exon', ...
%                   'intron', 'utr3exon', 'intercistronic' };    
%    PAR.type_abbrs = { 'ige' 'u5p' 'cex' 'ino' 'u3p' 'ics' };
%  else
%    PAR.num_types = 5;  
%    PAR.type_descrs = { 'intergenic', 'utr5exon', 'cds_exon', ...
%                   'intron', 'utr3exon' };
%    PAR.type_abbrs = { 'ige' 'u5p' 'cex' 'ino' 'u3p' };
%  end;
%end;


if ~fexist(PAR.FN.input_cont.(PAR.Content_name).fn_training_tracks),
  gen_annotation_tracks(PAR.FN.output.fn_genes_contents, PAR.FN.input.fn_genome_config,...
                         PAR.FN.output.fn_training_blocks, PAR.FN.input_cont.(PAR.Content_name).fn_training_tracks, ...
                         PAR.content.info_type);
end;
load(PAR.FN.input_cont.(PAR.Content_name).fn_training_tracks, 'training_tracks', 'type_info')
keyboard
PAR.track_info = type_info; 
clear type_info;

if ~fexist(),
% welche files ????  
  partition_annotation_tracks(fn_blocks, fn_training_blocks, fn_tracks, fn_out, PAR.SETs.num_splits);
else
  load(PAR.block_file);  
end;

JOB_INFO = [];
job_cnt = 1;
for i=1:PAR.SETs.num_splits,
  %% one procedure for all contents 
  % prepare train, test, and crossvalidation data
  file_name = [PAR.data_split_file_prefix num2str(i) '.mat'];
  
  if fexist(file_name),
    load(file_name);
    fprintf('Loaded data from %s\n', file_name);
  else
    [TRAIN, TEST, test_set_id] = segment_tracks(PAR, i);
    save(file_name, 'TRAIN', 'TEST', 'test_set_id');
  end;

  SVM_PARAM = PAR;
  % subset_id of blocks in the test set
  SVM_PARAM.test_set_id = test_set_id;
  
  %%now contents are treated separatly, remove loop over t
  for t=1:PAR.num_types,
    % balance the length distribution of pos and negative example segments
    [XTR_pos XTR_neg] = balance_length(t, TRAIN, PAR);
    [XTE_pos XTE_neg] = balance_length(t, TEST,  PAR);
    
    % combine pos and neg examples again
    XTR = {XTR_pos{:} XTR_neg{:}};
    LTR = [ones(1,length(XTR_pos))  -1*ones(1,length(XTR_neg))];
    XTE = {XTE_pos{:} XTE_neg{:}};
    LTE = [ones(1,length(XTE_pos))  -1*ones(1,length(XTE_neg))];
    
    %now we should be done with example generation; save examples XT, LT
    %start ms_gf_starter
    for order=PAR.orders,
      SVM_PARAM.order = order;
      SVM.PARAM = SVM_PARAM;
      SVM.PARAM.binary_hist = 1; % to be set in PAR.method (SVM_SP.m) 
      SVM.PARAM.svm_file = [PAR.FN.output_cont.(PAR.Content_name).fn_SVMs '_' PAR.type_abbrs{t} ...
                          '_split' num2str(i) '_order' num2str(order) ...
                          '_binHist' num2str(SVM.PARAM.binary_hist)];

      r_idx1 = randperm(length(LTR));
      SVM.XTR = {XTR{r_idx1}};
      SVM.LTR = LTR(r_idx1);
      r_idx2 = randperm(length(LTE));
      SVM.XTE = {XTE{r_idx2}};
      SVM.LTE = LTE(r_idx2);

      
      % combined parameters for script run in rproc
      RPROC_PAR.SVM            = SVM;
      % rproc parameters and options
      RPROC_MEMREQ             = 3000;
      RPROC_OPT.express        = 0;
      RPROC_OPT.immediately_bg = 0;
      RPROC_OPT.immediately    = 0;
      RPROC_OPT.arch           = 64; % take only 64 bit nodes others
                                     % seem to have problems with shogun
      RPROC_OPT.identifier     = ['GZ_train_content_' PAR.type_abbrs{t} ...
                          '_split' num2str(i) '_order' num2str(order) '_'];
      
      RPROC_TIME               = 10; % mins
      
%%%%% for debugging...
%     SVM = train_content_svm_RPROC(RPROC_PAR);
%     fprintf('\n\nPerformance evaluation of content SVM for %s, order %i, subset %i:\n', ...
%             upper(PAR.type_descrs{t}), order, i);
%     fprintf('ROC score on test set: %2.2f.\n\n', SVM.ROC_score);
%%%%%

      JOB_INFO{job_cnt} = rproc('train_content_svm_RPROC', ...
                                RPROC_PAR, RPROC_MEMREQ, RPROC_OPT, RPROC_TIME);
      fprintf('\nSubmitted job %i\n\n', job_cnt);
      job_cnt = job_cnt + 1;

      RPROC_PAR.SVM = [];
      clear SVM
    end;
  end;
end;

param_file = [PAR.results_dir 'global_parameters.mat'];
save(param_file, 'PAR');


%%%%% FOR THIS TO RUN THROUGH ALL JOBS HAVE TO BE FINISHED FIRST...
% attach w vector of content SVMs to blocks for label sequence learning
% attach_content_sensors_to_blocks();

%%%%% FOR EVALUATION
% evaluate_content();
