function [TRAIN TEST test_set_id] = prepare_frame_data(PAR, permutation)

train_subsets = 1+mod(permutation+[-1:PAR.SETs.num_splits-3],PAR.SETs.num_splits);
dummy = '';
for i=train_subsets(1:end-1),
  dummy = [dummy num2str(i) ', '];
end;
dummy = [dummy num2str(train_subsets(end))];
fprintf('\nTraining on subsets %s\n', dummy);       
test_subset = 1+mod(permutation+PAR.SETs.num_splits-2,PAR.SETs.num_splits);
fprintf('Testing  on subset  %i\n', test_subset);       

% load blocks
load(PAR.frame_block_file,'blocks');

frame_data = [blocks(:).frame];
subset_ids = [frame_data(:).subset_id];

% split blocks in training and test set
train_block_idx = [];
for i=train_subsets,
  train_block_idx = [train_block_idx find(subset_ids==i)];
end;
test_block_idx = find(subset_ids==test_subset);
  
fprintf('\nCollecting training examples for frame sensor...\n');
TRAIN = collect_frame_examples(blocks(train_block_idx), PAR);
  
fprintf('\nCollecting test examples for frame sensor...\n');       
TEST  = collect_frame_examples(blocks(test_block_idx),  PAR);

test_set_id = test_subset;
