function [TRAIN TEST test_set_id] = segment_tracks(PAR, permutation)

%  [TRAIN TEST test_set_id] = segment_tracks(PAR, permutation)
% generate (positive) examples for all types (we want to keep this!!)
% generate DATA for each split (1:5), instead of explicit TRAIN/TEST
  
  
  train_subsets = 1+mod(permutation+[-1:PAR.SETs.num_splits-3],PAR.SETs.num_splits);
dummy = '';
for i=train_subsets(1:end-1),
  dummy = [dummy num2str(i) ', '];
end;
dummy = [dummy num2str(train_subsets(end))];
fprintf('\nTraining on subsets %s\n', dummy);       
test_subset = 1+mod(permutation+PAR.SETs.num_splits-2,PAR.SETs.num_splits);
fprintf('Testing  on subset  %i\n', test_subset);       

% load blocks
load(PAR.block_file,'blocks');

contents = [blocks(:).content];
subset_ids = [contents(:).subset_id];
% split blocks in training and test set
train_block_idx = [];
for i=train_subsets,
  train_block_idx = [train_block_idx find(subset_ids==i)];
end;
test_block_idx = find(subset_ids==test_subset);


fprintf('\nCollecting training segments...\n');       
TRAIN = collect_content_examples(blocks(train_block_idx), PAR);

fprintf('\nCollecting test segments...\n');       
TEST  = collect_content_examples(blocks(test_block_idx), PAR);

test_set_id = test_subset;
