function train_content(XT,LT,C,svm_file)

fprintf('Training SVM on %i pos. and %i neg. examples...\n', ...
        sum(LT>0), sum(LT<0));
fprintf('size of training features: (%i,%i)\n',size(XT,1),size(XT,2))

sg('send_command', 'use_linadd 1');
sg('set_features', 'TRAIN', XT) ;
sg('set_labels', 'TRAIN', LT) ;

cache_size=10;
sg('send_command', sprintf('set_kernel LINEAR REAL %i 1.0', cache_size));
sg('send_command', 'new_svm LIGHT') ;
sg('send_command', 'init_kernel TRAIN');
sg('send_command', sprintf( 'c %1.2e', C));
sg('send_command', 'svm_train' );
sg_ver=sg('get_version');


% save SVM parameters

[b, alphas] = sg('get_svm');
Train.alphas = alphas;
Train.b = b;
sup_vec_idx = alphas(:,2)+1;
Train.XT = XT(:,sup_vec_idx);
Train.LT = LT(sup_vec_idx);
Train.sg_ver = sg_ver;

% using this command w was empty
%w = sg('get_kernel_optimization');

w = zeros(size(Train.XT,1),1);
for a=1:length(Train.LT)
  w = w+Train.alphas(a,1).*Train.XT(:,a);
end
Train.w = w;


fprintf('save svm to: %s\n',svm_file)

save(svm_file,'Train','C');
