function new_blocks = convertblocks2oldtype(blocks,config,organism)

if nargin<3
  organism=[];
end
genome_info = init_genome(config);
new_blocks(length(blocks)) = init_regions;
sig_names = fieldnames(blocks(1).details.pos);

for i=1:length(blocks)
  new_blocks(i).organism = organism;
  new_blocks(i).config = config;
  new_blocks(i).id = blocks(i).id;
  new_blocks(i).chr_num = strmatch(blocks(i).chr,genome_info.contig_names,'exact');
  new_blocks(i).chr = blocks(i).chr;
  new_blocks(i).strand = blocks(i).strand;
  new_blocks(i).offset = blocks(i).offset;
  if blocks(i).strand =='+'
    new_blocks(i).stop = blocks(i).block_end ;
    new_blocks(i).start = blocks(i).block_start;
  else
    new_blocks(i).start = blocks(i).block_end;
    new_blocks(i).stop = blocks(i).block_start;
  end
  new_blocks(i).seq = blocks(i).genestr ;  
  new_blocks(i).split = blocks(i).content.subset_id ;
  if isfield(blocks(i),'seq')&&~isempty(blocks(i).seq)
    new_blocks(i).features = blocks(i).seq;
  end
  if isfield(blocks(i),'pos')&&~isempty(blocks(i).pos)
    new_blocks(i).all_pos = blocks(i).pos;
  end
  if isfield(blocks(i),'details')&& ~isempty(blocks(i).details)
    for j=1:length(sig_names)
      new_blocks(i).Signals.(sig_names{j}).pos = blocks(i).details.pos.(sig_names{j}); 
      new_blocks(i).Signals.(sig_names{j}).Conf_cum = blocks(i).details.score.(sig_names{j}) ;
    end
  end
  if isfield(blocks(i),'prediction')&& ~isempty(blocks(i).prediction)
    new_blocks(i).prediction = blocks(i).prediction;
  end
end

