function old_blocks = convertblocks2oldtype(blocks, rm_old)

if nargin<2
  rm_old=0;
end
  
old_blocks(length(blocks)) = blocks(length(blocks));  
old_blocks(length(blocks)).id = [];
old_blocks(length(blocks)).reg = [];
old_blocks(length(blocks)).chr = [];
old_blocks(length(blocks)).strand = [];
old_blocks(length(blocks)).block_end = [];
old_blocks(length(blocks)).offset = [];
old_blocks(length(blocks)).block_start = [];
old_blocks(length(blocks)).genestr = [];
old_blocks(length(blocks)).details = [];
old_blocks(length(blocks)).content = [];
old_blocks(length(blocks)).seq = [];
old_blocks(length(blocks)).pos = [];
old_blocks(length(blocks)).split = [];

sig_names = fieldnames(blocks(1).Signals);

names =fieldnames(blocks);
for i=1:length(blocks)
  for j=1:length(names)
    old_blocks(i).(names{j}) = blocks(i).(names{j});
  end
  old_blocks(i).id = blocks(i).id;
  old_blocks(i).reg =  blocks(i).chr_num;
  old_blocks(i).chr = blocks(i).chr;
  old_blocks(i).strand = blocks(i).strand;
  if blocks(i).strand =='+'
    old_blocks(i).block_end = blocks(i).stop ;
    old_blocks(i).offset = blocks(i).start-1 ;
    old_blocks(i).block_start = blocks(i).start;
  else
    old_blocks(i).block_end = blocks(i).start;
    old_blocks(i).offset = blocks(i).stop + 1;
    old_blocks(i).block_start = blocks(i).stop;
  end
  if isfield(blocks,'seq')
    old_blocks(i).genestr = blocks(i).seq ;  
  end
  if isfield(blocks,'split')
    old_blocks(i).content.subset_id = blocks(i).split;
  end
  % old_blocks(i).split = blocks(i).split;
  if isfield(blocks(i),'features')&&~isempty(blocks(i).features)
    old_blocks(i).seq = blocks(i).features;
  else
    old_blocks(i).seq = [];
  end
  if isfield(blocks(i),'all_pos')&&~isempty(blocks(i).all_pos)
    old_blocks(i).pos = blocks(i).all_pos;
  end
  for j=1:length(sig_names)
    old_blocks(i).details.pos.(sig_names{j})  = blocks(i).Signals.(sig_names{j}).pos; 
    old_blocks(i).details.score.(sig_names{j})  = blocks(i).Signals.(sig_names{j}).Conf_cum;
  end
end

if rm_old
  old_blocks = rmfield(old_blocks,'features');
  old_blocks = rmfield(old_blocks,'all_pos');
  old_blocks = rmfield(old_blocks,'start');
  old_blocks = rmfield(old_blocks,'stop');
  old_blocks = rmfield(old_blocks,'chr_num');
  old_blocks = rmfield(old_blocks,'Signals');
end
