function blocks_split = gen_block_splits(blocks,PAR)
  
  

has_transcript = [];
overlaps = [];
for i = 1:length(blocks)
  has_no_transcript(i) = sum(blocks(i).has_valid_transcript==0);
  has_overlaps(i) = sum(blocks(i).overlaps_with_prev==1) ;
end

good_idx = find(~has_no_transcript&~has_overlaps);

good_idx(good_idx==50) = [] ;%splicing in trans exon!!!
good_idx(good_idx==118) = [] ;%splicing in trans exon!!!
good_idx(good_idx==250) = [] ;%splicing in trans exon!!!
good_idx(good_idx==354) = [] ;%splicing in trans exon!!!
good_idx(good_idx==399) = [] ;%splicing in trans exon!!!
good_idx(good_idx==425) = [] ;%splicing in trans exon!!!
good_idx(good_idx==509) = [] ;%splicing in trans exon!!!
good_idx(good_idx==599) = [] ;%splicing in trans exon!!!
good_idx(good_idx==679) = [] ;%splicing in trans exon!!!
good_idx(good_idx==802) = [] ;%splicing in trans exon!!!

rand('seed', 12324) ;
idx = randperm(length(good_idx));
split_length = floor(length(good_idx)/PAR.num_splits);
for i=1:PAR.num_splits
  if i~=PAR.num_splits
    blocks_split{i} = good_idx(idx((i-1)*split_length+1:(i)*split_length)) ; 
  else
    blocks_split{i} = good_idx(idx((i-1)*split_length+1:end)) 
  end
end

save(PAR.fn_splits,'blocks_split')


