function blocks = make_prediction_blocks(PAR, blocks, model)

% load sequence
%-------------------------------------------------------------
if ~isfield(blocks, 'seq')
  blocks = load_sequence(blocks);
end
% add signals to blocks
%-------------------------------------------------------------
fprintf(1,'load signals and append to blocks \n')

if isfield(PAR.LSL.method, 'model_name')&&strcmp(PAR.LSL.method.model_name, 'onlyorf')

  fprintf(1,'load signals for acc, don, tis, cdsStop only \n and make up some dummy positions with zero values for the other signals \n')
  blocks = add_signals2blocks(blocks,PAR,{'acc','don','tis','cdsStop'},'pred_dir',1); 
  for b = 1:length(blocks)
    len = length(blocks(b).seq);
    additional_pos = (PAR.regions.offset+1:10:blocks(b).stop-blocks(b).start-PAR.regions.offset-1);
    blocks(b).Signals.tss.pos = blocks(b).Signals.tis.pos-1;
    idx = find(blocks(b).Signals.tis.pos<=1);
    blocks(b).Signals.tss.pos(idx)=[];
    assert(all(blocks(b).Signals.tss.pos<=len))
    blocks(b).Signals.tss.Conf_cum = zeros(length(blocks(b).Signals.tis.pos),1);
    blocks(b).Signals.cleave.pos = unique([blocks(b).Signals.cdsStop.pos+4; additional_pos']);
    idx = find(blocks(b).Signals.cleave.pos>=len);
    blocks(b).Signals.cleave.pos(idx)=[];
    blocks(b).Signals.cleave.Conf_cum = zeros(length(blocks(b).Signals.cleave.pos),1);
    blocks(b).Signals.polya.pos = [];
    blocks(b).Signals.polya.Conf_cum = [];
  end
else
  blocks = add_signals2blocks(blocks,PAR,{'acc','don','tss','tis','cdsStop','polya','cleave'},'pred_dir',1000);
end

% generate feature matrix states x pos x features 
%-------------------------------------------------------------
fprintf(1,'generate feature matrix for blocks \n')
blocks = gen_features(blocks,model);


