function jobinfo = prepare_blocks(PAR)
% prepare_blocks(PAR)

paths
jobinfo = rproc_empty(0) ;
options = PAR.RPROC.options;
options.ncpus = 1;
cd  '~/svn/projects/genefinding/data_processing_lsl/'
options.identifier = sprintf('%sconf%s_%s',upper(PAR.organism.name(1:4)),PAR.Signal_name,PAR.method.name) ;
MEMREQ = PAR.RPROC.MEMREQ;
if ~isfield(PAR.tasks,'run_locally')
  PAR.tasks.run_locally=0;
end
fid=1;q=0;

if PAR.tasks.train_on ||PAR.tasks.modelsel_on
  fprintf(1,'preparing training blocks\n')
  % load(PAR.FN.input_lsl.fn_genes,'genes') ;
  % genes = gen_truth(genes, model);
  load(PAR.FN.output.fn_training_blocks,'blocks','split'); 
  % blocks = add_truth2blocks(blocks,genes,model);
  fn = PAR.FN.input_lsl.fn_training_blocks;
else
  fprintf(1,'preparing test blocks\n')
  load(PAR.FN.output.fn_test_blocks,'blocks','split') 
  % LL = load(PAR.FN.output_lsl.fn_train,'PAR');
  % model = LL.PAR.model; clear LL
  fn = PAR.FN.input_lsl.fn_test_blocks;
end

genome_info = init_genome(PAR.FN.input.fn_genome_config);

for i=1:length(genome_info.contig_names)
  for j='+-'
    fprintf('contig %i%s\r',i,j);
    PAR.fn_save = sprintf('%s%i%s.mat',fn,i,j);
    if fexist(PAR.fn_save)
      L=load_struct(PAR.fn_save,'blocks');
      if isfield(L,'details')
        continue
      end
    else
      idx = find([blocks.strand]==j&[blocks.chr_num]==i);
      c_blocks = blocks(idx);
      PAR.fn_save = sprintf('%s%i%s.mat',fn,i,j);
      save_struct(PAR.fn_save, c_blocks,'blocks');
      save(PAR.fn_save,'-append','PAR');
    end  
    q=q+1; 
    if ~PAR.tasks.run_locally
      if isfield(PAR.RPROC, 'collect_jobs') && PAR.RPROC.collect_jobs 
        jobinfo(q) = rproc_create('prepare_blocks_helper', PAR, PAR.RPROC.MEMREQ,options,10*60) ;
      else
        jobinfo(q) = rproc('prepare_blocks_helper', PAR, MEMREQ,options, 2*60);
      end
    else
      prepare_blocks_helper(PAR)
    end
  end
end



