function maps = read_map(fn_map,genome_info1,genome_info2,type);
  
%  maps = read_maps(fn_map,genome_info1,genome_info2);
 
if nargin<4
  type = 'NSPACER';
end

CHR =   genome_info1.contig_names;

maps(length(CHR)).chr_num1 = [];
maps(length(CHR)).chr1 = {};
maps(length(CHR)).start1 = [];
maps(length(CHR)).stop1 = [];
maps(length(CHR)).chr_num2 = [];
maps(length(CHR)).chr2 = {};
maps(length(CHR)).start2 = [];
maps(length(CHR)).stop2 = [];

tmp_fname = tempname;
unix(sprintf('grep -v %s %s > %s', type, fn_map, tmp_fname));

for i=1:length(CHR)
  tmp_fname1 = tempname;
  unix(sprintf('grep %s %s > %s', CHR{i},tmp_fname , tmp_fname1));
  fd1 = fopen(tmp_fname1,'r');
  maps(i).chr1 = {};
  maps(i).chr2 = {};         
  while ~feof(fd1),
    Line = fgetl(fd1);
    if isempty(Line),continue, end
    elems = separate(Line);
    
    if ~isequal(elems{1},CHR{i}), continue; end
    maps(i).chr_num1 = [maps(i).chr_num1 find(strcmp(genome_info1.contig_names,elems{1}))];
    maps(i).chr1 = {maps(i).chr1{:} elems{1}};
    maps(i).start1 = [maps(i).start1 str2num(elems{2})];
    maps(i).stop1 = [maps(i).stop1 str2num(elems{3})];
    
    maps(i).chr_num2 = [maps(i).chr_num2 find(strcmp(genome_info2.contig_names,elems{4}))];
    maps(i).chr2 = {maps(i).chr2{:} elems{4}};
    maps(i).start2 = [maps(i).start2 str2num(elems{5})];
    maps(i).stop2 = [maps(i).stop2 str2num(elems{6})];
    
  end
  unix(sprintf('rm %s',tmp_fname1));
  fclose(fd1);
end

unix(sprintf('rm %s',tmp_fname));