function block=apply_signal_mask(block, signal_masks)
% block=apply_signal_mask(block, signal_masks)

offset=1000; 
verbose=1 ;

if ~isempty(block.details.score.tis)
  assert(min(block.details.score.tis)>=0) ;
  assert(max(block.details.score.tis)<=1) ;
end
if ~isempty(block.details.score.stop)
  assert(min(block.details.score.stop)>=0) ;
  assert(max(block.details.score.stop)<=1) ;
end

pot_not = 12 ;
pot_likely = 1/6 ;
pot_good = 1/8 ;
pot_sure = 1/12 ;

signal_mask = signal_masks(1+(block.strand=='-'), block.chr_num) ;
  
if block.strand=='+',
  acc_pos = block.details.pos.acc+block.offset ;
  don_pos = block.details.pos.don+block.offset-1 ;
  tis_pos = block.details.pos.tis+block.offset ;
  stop_pos = block.details.pos.stop+block.offset ;
  tss_pos = block.details.pos.tss+block.offset ;
  cleave_pos = block.details.pos.cleave+block.offset ;  
  polya_pos = block.details.pos.polya+block.offset ;  
  
else
  acc_pos = block.offset-block.details.pos.acc ;
  don_pos = block.offset-(block.details.pos.don-1) ;
  tis_pos = block.offset-block.details.pos.tis ;
  stop_pos = block.offset-block.details.pos.stop ;
  tss_pos = block.offset-block.details.pos.tss ;
  cleave_pos = block.offset-block.details.pos.cleave ;
  polya_pos = block.offset-block.details.pos.polya ;

end ;

%acceptor mask
idx=find(signal_mask.no_ss(acc_pos) & ~signal_mask.likely_acc(acc_pos) & ~signal_mask.sure_acc(acc_pos)) ;
mean_neg.acc = mean(block.details.score.acc(idx)) ;
block.details.score.acc(idx) = block.details.score.acc(idx).^pot_not ;
idx=find(signal_mask.likely_acc(acc_pos)) ;
mean_like.acc = mean(block.details.score.acc(idx)) ;
block.details.score.acc(idx) = block.details.score.acc(idx).^pot_likely ;
idx = find(signal_mask.sure_acc(acc_pos)) ;
idx_ = find(signal_mask.sure_acc(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('acc not found') ; end ;
mean_pos.acc = mean(block.details.score.acc(idx)) ;
block.details.score.acc(idx) = block.details.score.acc(idx).^pot_sure ;

% donor masks
idx=find(signal_mask.no_ss(don_pos) & ~signal_mask.likely_don(don_pos) & ~signal_mask.sure_don(don_pos)) ;
mean_neg.don = mean(block.details.score.don(idx)) ;
block.details.score.don(idx) = block.details.score.don(idx).^pot_not ;
idx=find(signal_mask.likely_don(don_pos)) ;
mean_like.don = mean(block.details.score.don(idx)) ;
block.details.score.don(idx) = block.details.score.don(idx).^pot_likely ;
idx=find(signal_mask.sure_don(don_pos)) ;
idx_=find(signal_mask.sure_don(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('don not found') ; end ;
mean_pos.don = mean(block.details.score.don(idx)) ;
block.details.score.don(idx) = block.details.score.don(idx).^pot_sure ;
    
% tis masks
idx=find(signal_mask.no_tis(tis_pos) & ~signal_mask.likely_tis(tis_pos)) ;
mean_neg.tis = mean(block.details.score.tis(idx)) ;
block.details.score.tis(idx) = block.details.score.tis(idx).^pot_not ;
idx=find(signal_mask.likely_tis(tis_pos)) ;
idx_=find(signal_mask.likely_tis(block.block_start+offset:block.block_end-offset)) ;
% if ~(length(idx)==length(idx_)) && verbose, disp('tis not found'); end ;
mean_pos.tis = mean(block.details.score.tis(idx)) ;
block.details.score.tis(idx) = block.details.score.tis(idx).^pot_likely ;
    
% stop masks
idx=find(signal_mask.no_stop(stop_pos) & ~signal_mask.likely_stop(stop_pos)) ;
mean_neg.stop = mean(block.details.score.stop(idx)) ;
block.details.score.stop(idx) = block.details.score.stop(idx).^pot_not ;
idx=find(signal_mask.likely_stop(stop_pos)) ;
idx_=find(signal_mask.likely_stop(block.block_start+offset:block.block_end-offset)) ;
% if ~(length(idx)==length(idx_)) && verbose, disp('stop codon not found') ; end ;
mean_pos.stop = mean(block.details.score.stop(idx)) ;
block.details.score.stop(idx) = block.details.score.stop(idx).^pot_likely ;

% tss masks
idx = find(signal_mask.no_tss(tss_pos) & ~signal_mask.likely_tss(tss_pos)) ;
mean_neg.tss = mean(block.details.score.tss(idx)) ;
block.details.score.tss(idx) = block.details.score.tss(idx).^pot_not ;
idx=find(signal_mask.likely_tss(tss_pos)) ;
idx_=find(signal_mask.likely_tss(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('tss not found'); end ;
mean_like.tss = mean(block.details.score.tss(idx)) ;
block.details.score.tss(idx) = block.details.score.tss(idx).^pot_likely ;
idx = find(signal_mask.good_tss(tss_pos)) ;
idx_ = find(signal_mask.good_tss(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('tss not found') ; end ;
mean_pos.tss = mean(block.details.score.tss(idx)) ;
block.details.score.tss(idx) = block.details.score.tss(idx).^pot_good ;
  
% trans masks
idx = find(signal_mask.no_tss(acc_pos) & ~signal_mask.likely_tss(acc_pos)) ;
mean_neg.trans = mean(block.details.score.trans(idx)) ;
block.details.score.trans(idx) = block.details.score.trans(idx).^pot_not ;
idx=find(signal_mask.likely_tss(acc_pos)) ;
idx_=find(signal_mask.likely_tss(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('trans not found'); end ;
mean_like.trans = mean(block.details.score.trans(idx)) ;
block.details.score.trans(idx) = block.details.score.trans(idx).^pot_likely ;
idx = find(signal_mask.good_tss(acc_pos)) ;
idx_ = find(signal_mask.good_tss(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('trans not found') ; end ;
mean_pos.trans = mean(block.details.score.trans(idx)) ;
block.details.score.trans(idx) = block.details.score.trans(idx).^pot_good ;   

% cleave masks
idx=find(signal_mask.no_cleave(cleave_pos) & ~signal_mask.likely_cleave(cleave_pos)) ;
mean_neg.cleave = mean(block.details.score.cleave(idx)) ;
block.details.score.cleave(idx) = block.details.score.cleave(idx).^pot_not ;
idx=find(signal_mask.likely_cleave(cleave_pos)) ;
idx_=find(signal_mask.likely_cleave(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('cleave codon not found') ; end ;
mean_like.cleave = mean(block.details.score.cleave(idx)) ;
block.details.score.cleave(idx) = block.details.score.cleave(idx).^pot_likely ;

idx = find(signal_mask.good_cleave(cleave_pos)) ;
idx_ = find(signal_mask.good_cleave(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('cleave not found') ; end ;
mean_pos.cleave = mean(block.details.score.cleave(idx)) ;
block.details.score.cleave(idx) = block.details.score.cleave(idx).^pot_good ;

  
    
% polya masks
idx=find(signal_mask.no_cleave(polya_pos) & ~signal_mask.likely_cleave(polya_pos)) ;
mean_neg.polya = mean(block.details.score.polya(idx)) ;
block.details.score.polya(idx) = block.details.score.polya(idx).^pot_not ;
idx=find(signal_mask.likely_cleave(polya_pos)) ;
idx_=find(signal_mask.likely_cleave(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('polya codon not found') ; end ;
mean_like.polya = mean(block.details.score.polya(idx)) ;
block.details.score.polya(idx) = block.details.score.polya(idx).^pot_likely ;

idx = find(signal_mask.good_cleave(polya_pos)) ;
idx_ = find(signal_mask.good_cleave(block.block_start+offset:block.block_end-offset)) ;
if ~(length(idx)==length(idx_)) && verbose, disp('polya not found') ; end ;
mean_pos.polya = mean(block.details.score.polya(idx)) ;
block.details.score.polya(idx) = block.details.score.polya(idx).^pot_good ;

mean_pos
mean_like
mean_neg  