function signal_masks=check_ss_masks(genome_info)
% signal_masks=gen_signal_masks(genome_info)

%genome_info = init_genome('genome.config') ;
genes=load_struct(sprintf('%s/confirmed_sequences_transform.mat', genome_info.basedir), 'genes') ;

sets = { 'PR-', 'PR-BP:',    'PR-ENS',   'PR-FLY',    'PR-RP:',    'PR-SGD',    'PR-SW:',    'PR-TR:',    'PR-WP:'} ;

frac_pos = [] ;
frac_acc = [] ;
frac_don = [] ;
frac_lacc = [] ;
frac_ldon = [] ;

tol = 20 ;
tol2 = 5 ;

for s=1:length(sets),

num_acc_errors = 0 ; num_acc = 0 ;
num_don_errors = 0 ; num_don = 0 ;
num_pos = 0 ;
num_no_ss_pos = 0 ; 
num_likely_acc_pos = 0 ;
num_likely_don_pos = 0 ;

for i=1:length(genes)
  donors = [] ;
  acceptors = [] ;

  est_idx = [] ;
  for k=1:length(genes(i).transcripts)
    if isequal(genes(i).transcripts{k}(1:4), 'EST-') || isequal(genes(i).transcripts{k}(1:3), 'GR-')
      est_idx(end+1) = k ;
      donors    = [donors; genes(i).exons{k}(1:end-1,2)] ;
      acceptors = [acceptors; genes(i).exons{k}(2:end,1)] ;
    end ;
  end ;

  no_ss_mask = zeros(1,length(genes(i).genestr));
  likely_acc_mask = zeros(1,length(genes(i).genestr));
  likely_don_mask = zeros(1,length(genes(i).genestr));
  for k=1:length(genes(i).transcripts)
    if isequal(genes(i).transcripts{k}(1:length(sets{s})), sets{s})
      for q=1:size(genes(i).exons{k},1)
        no_ss_mask(genes(i).exons{k}(q,1)+tol:genes(i).exons{k}(q,2)-tol) = 1 ;
      end ;
      for q=1:size(genes(i).exons{k},1)-1
        no_ss_mask(genes(i).exons{k}(q,2)+tol:genes(i).exons{k}(q+1,1)-tol) = 1 ;
        likely_don_mask(genes(i).exons{k}(q,2)-tol2:genes(i).exons{k}(q,2)+tol2) = 1 ;
        likely_acc_mask(genes(i).exons{k}(q+1,1)-tol2:genes(i).exons{k}(q+1,1)+tol2) = 1 ;
      end ;
    end ;
  end ;

  if 1,
    gene = genes(i) ;
    gene.transcripts(est_idx) = [] ;
    gene.exons(est_idx) = [] ;
    if ~isempty(gene.exons),
      gene = build_splice_graph_caller(gene) ;
      gene = infer_splice_graph_caller(gene) ;
      
      [dummy,exon_order] = sort(gene.splicegraph{1}(1,:),2,'ascend');
      gene.splicegraph{1} = gene.splicegraph{1}(:,exon_order);
      gene.splicegraph{2} = gene.splicegraph{2}(exon_order,exon_order);
      gene = alt_const(gene) ;
      
      regions = detectaltregions(gene)  ;
      if ~isempty(regions), 
        for k=1:size(regions,2)
          no_ss_mask(regions(1,k)-tol:regions(2,k)+tol) = 0 ;
          likely_don_mask(regions(1,k)-tol:regions(2,k)+tol) = 0 ;
          likely_acc_mask(regions(1,k)-tol:regions(2,k)+tol) = 0 ;
        end ;
      end ;
    end ;
  end ;

  donors = unique(donors) ;
  num_don = num_don + length(donors) ;
  num_don_errors = num_don_errors + sum(no_ss_mask(donors)) ;

  acceptors = unique(acceptors) ;
  num_acc = num_acc + length(acceptors) ;
  num_acc_errors = num_acc_errors + sum(no_ss_mask(acceptors)) ;

  num_pos = num_pos + genes(i).splicegraph{1}(2,end) - genes(i).splicegraph{1}(1,1) ;
  num_no_ss_pos = num_no_ss_pos + sum(no_ss_mask)  ;
  num_likely_acc_pos = num_likely_acc_pos + sum(likely_acc_mask)  ;
  num_likely_don_pos = num_likely_don_pos + sum(likely_don_mask)  ;
end ;

frac_don(s) = num_don_errors/num_don
frac_acc(s) = num_acc_errors/num_acc

frac_ldon(s) = num_likely_don_pos/num_pos
frac_lacc(s) = num_likely_acc_pos/num_pos 

frac_pos(s) = num_no_ss_pos/num_pos 

end ;

keyboard