function genes= addPredTransacc2genes(genes,PAR)
   
% genes= addPredTransacc2genes(genes,PAR)

which_pos.contig = 1;
which_pos.local = 0;

strands='+-';
num_regions = 0;
regions(length(genes)).chr_num = [];
regions(length(genes)).strand = '';
regions(length(genes)).start = [] ;
regions(length(genes)).stop = [];
regions(length(genes)).genes_id = [];

transgenes_idx=[];
fprintf('looking for transsplice sites in window +- %i bd from potential gene start (gene.start)\n',...
        PAR.label_source_par.transacc.win_pred)
fprintf('if gene has tss, it is used as gene start, else gene.start is used \n')
fprintf('transsplice site is forced to be between gene start and tis \n')
fprintf('beginning of cDNAs or confirmed annotation are used as tis \n')
fprintf('threshold for included splicesites: conf_cum > %.2f\n', PAR.label_source_par.transacc.threshold_pred);
fprintf('ignoring genes without cDNA or (partially) confirmed annotation\n')
for s = strands;
  contig_genes_idx = find([genes.strand]==s) ;
  for g_idx = contig_genes_idx
    gene = genes(g_idx);
    if ~any(gene.transcript_info==PAR.info_genes.transcript.cDNA|...
            (gene.transcript_info==PAR.info_genes.transcript.anno& gene.transcript_status>-1))
      continue
    end
    % keyboard
    cdna_idx = find(gene.transcript_info==PAR.info_genes.transcript.cDNA|...
                    (gene.transcript_info==PAR.info_genes.transcript.anno& gene.transcript_status==1));
    cdsstart = [];
    if s=='+'
      if ~isempty(gene.tss)
        gene_start = min(gene.tss);
      else
        gene_start = gene.start;
      end
      for i=cdna_idx
        cdsstart = [cdsstart gene.exons{i}(1,1)] ;
      end
      cdsstart = min([cdsstart,gene_start+PAR.label_source_par.transacc.win_pred]);
      gene_start = gene_start-PAR.label_source_par.transacc.win_pred;
      if gene_start>cdsstart 
        continue
      end
      num_regions = num_regions+1;
      regions(num_regions).start = gene_start;
      regions(num_regions).stop = cdsstart;
    else
      if ~isempty(gene.tss)
        gene_start = max(gene.tss);
      else
        gene_start = gene.stop;
      end
      for i=cdna_idx
        cdsstart = [cdsstart gene.exons{i}(end,2)] ;
      end
      cdsstart = max([cdsstart,gene_start-PAR.label_source_par.transacc.win_pred]);
      gene_start+PAR.label_source_par.transacc.win_pred;
      if cdsstart>gene_start
        continue
      end
      num_regions = num_regions+1;
      regions(num_regions).start = cdsstart ;
      regions(num_regions).stop = gene_start;
    end
    transgenes_idx = [transgenes_idx g_idx];
    regions(num_regions).chr_num = gene.chr_num; 
    regions(num_regions).strand = gene.strand;
    regions(num_regions).genes_id = gene.id;
  end
end
regions = regions(1:num_regions);
regions(1).config = PAR.FN.input.fn_genome_config;
regions = retrieve_signals(regions,PAR.FN.output_sig.acc.fn_pred,'acc',{'Conf_cum'},which_pos);
assert(length(regions)==length(transgenes_idx));
num_trans = length(regions)*10;
TRANSACC(num_trans).name = {};
TRANSACC(num_trans).pos = 0;
TRANSACC(num_trans).confLevel = 0;
TRANSACC(num_trans).strand = '';
TRANSACC(num_trans).chr_num = '';
TRANSACC(num_trans).confirmed_genes = '';
num_regions = 0;
num_trans = 0;
num_trans_genes = 0;
for g_idx=transgenes_idx
  fprintf('%i\r',g_idx);
  num_regions = num_regions+1;
  pos = regions(num_regions).Signals.acc.contig_pos;
  conf = regions(num_regions).Signals.acc.Conf_cum;
  idx = find(conf>PAR.label_source_par.transacc.threshold_pred);
  pos=pos(idx);
  conf=conf(idx);
  if isempty(pos)
    continue
  end
  num_trans_genes=num_trans_genes+1;
  genes(g_idx).transacc = [genes(g_idx).transacc; pos];  
  genes(g_idx).transacc_info = [genes(g_idx).transacc_info; repmat(PAR.info_genes.transacc.pred,length(pos),1)]; 
  genes(g_idx).transacc_conf = [genes(g_idx).transacc_conf; conf]; 
  assert(genes(g_idx).id==regions(num_regions).genes_id);
  % TRANSACC(num_trans).name =
  for i=1:length(pos)
    num_trans = num_trans+1;
    TRANSACC(num_trans).pos = pos(i);
    TRANSACC(num_trans).confLevel = regions(num_regions).Signals.acc.Conf_cum(i);
    TRANSACC(num_trans).strand = regions(num_regions).strand;
    TRANSACC(num_trans).chr_num = regions(num_regions).chr_num;
    TRANSACC(num_trans).confirmed_genes = g_idx;
  end
end
fprintf('number of predicted transacc sites: %i\n',num_trans);
fprintf('number of genes with predicted transacc sites: %i\n',num_trans_genes);

TRANSACC = TRANSACC(1:num_trans);
save(PAR.FN.input_sig.transacc.fn_pred,'TRANSACC');