function genes1 = add_pos_field(genes1,genes2,field) ;

% genes1 = add_pos_field(genes1,genes2,field) ;

CHR1 = [genes1.chr_num]; 
CHR2 = [genes2.chr_num]; 
STR1 = [genes1.strand]; 
STR2 = [genes2.strand]; 

chr = unique(CHR1);
str = unique(STR1);
assert(isempty(setdiff(chr,unique(CHR2))))
assert(isempty(setdiff(unique(CHR2),chr)))

map = cell(length(genes1),1) ;

idx_2_covered=[];
not_found = 0;

for c = chr
  fprintf(1,'chromosome %i\r',c)
  for s = str
    idx1 = find(CHR1==c & STR1==s) ;
    idx2 = find(CHR2==c & STR2==s) ;
    for gene1_idx = idx1
      gene1 = genes1(gene1_idx);
      match_idx2 = idx2(find([genes2(idx2).start]<gene1.stop&[genes2(idx2).stop]>gene1.start));
      if isempty(match_idx2)
        not_found = not_found+1 ;
        gene1 = setfield(gene1,field,-1);
      else
        map{gene1_idx} = match_idx2;
        pos = [];
        for j=match_idx2
          pos = [pos getfield(genes2(j),field)];
        end
        gene1 = setfield(gene1,field,pos);
       
        idx_2_covered = [idx_2_covered match_idx2];
      end
      genes1(gene1_idx) = gene1 ;
    end
  end
end

idx2_unused = setdiff([1:length(genes2)],idx_2_covered);
fprintf(1,'\nnumber of genes without coverage: %i\n ',not_found )
fprintf(1,'\nnumber of uncovered hits: %i\n ',length(idx2_unused))
