function check_and_plot_splits(trivial_regions,training_regions,test_regions,genes,blocks,train, test)
  
  
for i=1:length(trivial_regions)
  reg = trivial_regions(i);
  figure; hold on, grid on
  plot([reg.start reg.stop],[0 0 ],'k-'); 
  axis([reg.start reg.stop 0 5 ])
  title(sprintf('contig %i%s',reg.chr_num,reg.strand));
  % plot genes
  cnt = 1;
  if ~isempty(genes)
    cnt = plot_segments(reg,genes,1,'k','genes');
    cnt = plot_segments(reg,blocks,cnt+0.5,'k','blocks');
  end
  % plot training regions and blocks
  cnt = plot_segments(reg,training_regions,cnt+0.5,'r','training regions');
  cnt = plot_segments(reg,train.blocks,cnt+0.5,'r','training blocks');
  
  % plot training and test blocks
  cnt = plot_segments(reg,test_regions,cnt+0.5,'b','test regions');
  cnt = plot_segments(reg,test.blocks,cnt+0.5,'b','test blocks');

  axis([reg.start reg.stop 0 cnt+0.5])
  hold off

end
    
 
function y_value = plot_segments(reg1,reg2,y_value,color,add_text)
  
if ~isempty(reg2)
  idx = find([reg2.chr_num] == reg1.chr_num&...
             [reg2.strand] == reg1.strand);
  
  reg = reg2(idx);
else
  reg=[];
end

cnt=0;
for j=1:length(reg)
  plot([reg(j).start reg(j).stop],[y_value+cnt y_value+cnt],sprintf('-+%s',color),'LineWidth',2)
  cnt=cnt+0.04;
end
y_value = y_value +cnt;
add_text = sprintf('%s : %i',add_text,length(reg));

text(min(reg1.start+1000,reg1.stop-1000), y_value+0.1,add_text)
  