function cluster_EST_matches(PAR)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% cluster_EST_matches_tss.m
% May 2007

% Calls cluster_EST_matches_tss_chrwise.m for each chromosome and save putative TSS sites
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

which.tss = PAR.label_source.tss.est_clusters;
which.cleave = PAR.label_source.cleave.est_clusters;
PAR.debug = 1;
if length(PAR.FN.input.fn_ESTs_matches)==1
  PAR.fn_in_ests = PAR.FN.input.fn_ESTs_matches{1};
  if which.tss &~fexist(PAR.FN.input_sig.tss.fn_est_cluster)&PAR.add_signals.tss
    fprintf(1,'\t Clustering ESTs for tss\n');
    fprintf(1,'\t Using %s\n', PAR.FN.input.fn_ESTs_matches{1});
    PAR.fn_out = PAR.FN.input_sig.tss.fn_est_cluster;
    cluster_EST_matches_tss_chrwise(PAR);
  elseif fexist(PAR.FN.input_sig.tss.fn_est_cluster)
    fprintf(1,'\t tss file already exists\n');
  else
    fprintf(1,'\t no tss generation from EST clusters performed \n');
  end
  if which.cleave &~fexist(PAR.FN.input_sig.cleave.fn_est_cluster)&PAR.add_signals.cleave
    fprintf(1,'\t Clustering ESTs for cleave\n');
    fprintf(1,'\t Using %s\n', PAR.FN.input.fn_ESTs_matches{1});
    PAR.fn_out = PAR.FN.input_sig.cleave.fn_est_cluster;
    cluster_EST_matches_cleave_chrwise(PAR);
  elseif fexist(PAR.FN.input_sig.cleave.fn_est_cluster)
    fprintf(1,'\t cleave file already exists\n');
  else
    fprintf(1,'\t no cleave generation from EST clusters performed \n');
  end
else
  jobinfo = rproc_empty(1) ;
  cnt = 0;
  for i = 1:length(PAR.FN.input.fn_ESTs_matches)
    PAR.fn_in_ests = PAR.FN.input.fn_ESTs_matches{i};
    if which.tss&PAR.add_signals.tss
      fprintf(1,'/t Using %s\n', PAR.FN.input.fn_ESTs_matches{i});
      cnt = cnt+1;
      PAR.fn_out = sprintf('%s_%i.mat',PAR.FN.input_sig.tss.fn_est_cluster,i);
      jobinfo(cnt) = rproc('cluster_EST_matches_tss_chrwise',PAR,3500 , [], 10*60);
    end
    if which.cleave&PAR.add_signals.cleave
      fprintf(1,'/t Using %s\n', PAR.FN.input.fn_ESTs_matches{i});
      cnt = cnt+1;
      PAR.fn_out = sprintf('%s_%i.mat',PAR.FN.input_sig.cleave.fn_est_cluster,i);
      jobinfo(cnt) = rproc('cluster_EST_matches_cleave_chrwise',PAR,3500 , [], 10*60);
    end
  end;
  [jobinfo,num_crashed] = rproc_wait(jobinfo);
  TSS = [];CLEAVE=[];
  for i = 1:length(PAR.FN.input.fn_ESTs_matches)
    if which.tss&PAR.add_signals.tss
      PAR.fn_out = sprintf('%s_%i.mat',PAR.FN.input_sig.tss.fn_est_cluster,i);
      T = load(PAR.fn_out)
      TSS = [TSS, T.TSS];
    end;
    if which.cleave&PAR.add_signals.cleave
      PAR.fn_out = sprintf('%s_%i.mat',PAR.FN.input_sig.cleave.fn_est_cluster,i);
      T = load(PAR.fn_out)
      CLEAVE = [CLEAVE, T.CLEAVE];
    end;
  end
  PAR = rmfield(PAR,'fn_out');
  PAR = rmfield(PAR,'debug');
  save(PAR.FN.input_sig.tss.fn_est_cluster,'TSS','PAR');
  save(PAR.FN.input_sig.cleave.fn_est_cluster,'CLEAVE','PAR');
end


