function genes2  = convert_struct(genes1, genes2)
%
% genes2  = convert_struct(genes1, genes2)
%
% removes fields from genes2 which are not in genes1; adds fields to
% genes2; which are missing compared to genes1.
% genes2 is returned, with same fields as genes1.  
  
fields_1 = fieldnames(genes1);
fields_2 = fieldnames(genes2);
fields_x1 = setdiff(fields_1,fields_2);
fields_x2 = setdiff(fields_2,fields_1); 

if ~isempty(fields_x2)
  fprintf('fields are removed\n')
  disp(fields_x2)
  for f = 1:length(fields_x2)
    genes2 = rmfield(genes2,fields_x2{f});
  end
end
if ~isempty(fields_x1)
  fprintf('fields are added empty\n')
  disp(fields_x1)
  for f = 1:length(fields_x1)
    cl = class(genes1(1).(fields_x1{f}));
    genes2(1).(fields_x1{f})=[];
    if isequal(cl,'cell')
      for j=1:length(genes2)
        genes2(j).(fields_x1{f})={};
      end
    end
  end
end

genes2 = orderfields(genes2, genes1);
