function find_all_polyas(PAR)
%  find_all_polyas(PAR)
 
polya_par = PAR.label_source_par.polya;
polya_par.fn_genome_config = PAR.FN.input.fn_genome_config;

unix(sprintf('mkdir -p %s', polya_par.logdir));
 
%genome_config = init_genome(PAR.FN.input.fn_genome_config);

%%% LEARN DISTRIBUTION of PAS signals from high confidence cleave sites
cleave = [];
cleave_highconf = [];
if fexist(PAR.FN.input_sig.cleave.fn_est_cluster)&&PAR.label_source.cleave.est_clusters
  L = load(PAR.FN.input_sig.cleave.fn_est_cluster,'CLEAVE');
  cleave = [cleave L.CLEAVE];
  polya_par.cleave_estidx = [1 length(cleave)];
  idx = find([cleave.confLevel] ==3);
  cleave_highconf = [cleave_highconf  cleave(idx)];
  %% cleave.confLevel = [1 2 3]
end

if PAR.label_source.cleave.anno
  if fexist(PAR.FN.input_sig.cleave.fn_anno)
    L = load(PAR.FN.input_sig.cleave.fn_anno,'CLEAVE');
  else
    clear L
    load(PAR.FN.output.fn_genes_anno,'genes');
    
    num=0;
    for i=1:length(genes)
      for j=1:length(genes(i).cleave)
        num=num+1;
        CLEAVE(num).name = genes(i).name;
        CLEAVE(num).pos = genes(i).cleave(j);
        CLEAVE(num).confLevel = genes(i).transcript_status(j);
        CLEAVE(num).strand = genes(i).strand;
        CLEAVE(num).chr_num = genes(i).chr_num;
        CLEAVE(num).anno_genes = genes(i).anno_id;
      end
    end
    L.CLEAVE=CLEAVE;
    save(PAR.FN.input_sig.cleave.fn_anno,'CLEAVE');
  end
  %% cleave.confLevel ?
  idx = find([L.CLEAVE.confLevel] == 1);
  polya_par.cleave_annoidx = [length(cleave)+1 length(cleave)+length(idx)];
  cleave = [cleave L.CLEAVE];
  cleave_highconf = [cleave_highconf L.CLEAVE(idx)];
end


if 0 % fexist(PAR.FN.input_sig.cleave.fn_fulllength)&&PAR.label_source.cleave.fulllength
  L = load(PAR.FN.input_sig.cleave.fn_fulllength,'CLEAVE');
  idx = find([L.cleave.confLevel <= 3]);
  polya_par.cleave_flidx = [length(cleave)+1 length(cleave)+length(idx)];
  cleave = [cleave L.cleave];
  cleave_highconf = [cleave_highconf L.cleave(idx)];
  
  %_all.mat cleave.confLevel >0 (terminal info)
end

if 0 % fexist(PAR.FN.input_sig.cleave.fn_db)&&PAR.label_source.cleave.db
  L = load(PAR.FN.input_sig.cleave.fn_db,'CLEAVE');
  %% cleave.confLevel ?
  %% idx = find([L.cleave.confLevel == 0]);
  polya_par.cleave_dbidx = [length(cleave)+1 length(cleave)+length(idx)];
  cleave = [cleave L.cleave];
  cleave_highconf = [cleave_highconf L.cleave(idx)];
end


polya_par.cleavedata = cleave;
polya_par.cleavedata_highconf = cleave_highconf;

consensus = find_polya_covsixmers(polya_par);
% here we are able to hard-code consensus sequences
% arabidopsis test consensus fuer wl=1
%consensus = {    'aataaa'    'aataat'    'aatata'    'aattta'    'attaat'    'aatgaa'    'tatata'    'aatatt' ...
%                 'aatcaa'    'ataaaa'    'tataat'    'aaataa'    'aatatc'    'aattat'    'aatatg'    'aattga' ...
%                'tttaaa'     'aattaa'    'cataat'    'aagaat'    'aagtaa'    'attata'    'aaccaa'    'aataag'...
%                 'actaac'    'aattca'    'catgaa'    'aatgca'    'atttaa'    'aaagaa'    'tatgaa'    'cattaa' ...  
%                 'aactaa'};


save(PAR.FN.input_sig.polya.fn_polya,'consensus','PAR');

polya_par.consensus = consensus;
polya = generate_polya(polya_par);

save(PAR.FN.input_sig.polya.fn_polya,'-append', 'polya','consensus','PAR');
