function paths=find_all_paths(a_mat)
% adjacency matrix a_mat 
% consider only transitions in upper triangle

% find all initial exons
inner_exons = [];
for j=1:size(a_mat,1)
  a_mat(j,1:j)=zeros(1,j);
  inner_exons = [inner_exons find(a_mat(j,:))];
end
initial_exons = setdiff(1:size(a_mat,1),inner_exons);

% initialize paths with initial exons
paths = {initial_exons(1)};
for j=2:length(initial_exons)
  paths = {paths{:},initial_exons(j)};
end
all_done=0;
while ~all_done
  all_done=1;
  for j=1:length(paths)
    path = paths{j};
    idx = find(a_mat(path(end),:));
    if isempty(idx), continue; end
    all_done=0;
    paths{j} = [path idx(1)];
    for k=2:length(idx)
      paths{end+1}= [path idx(k)];
    end
  end 
end

