function [len tis cdsStop] = find_tis_and_stop(gene,path,unspliced_seq,exons)

if nargin<4
  exons = gene.splicegraph{1};
end


nuc = [];
don = [];
acc = [];
for j=1:length(path)
  nuc = [nuc exons(1,path(j)):(exons(2,path(j))-1)];
  if j>1
    acc = [acc ;(exons(1,path(j))-2):(exons(1,path(j))-1)];
  end
  if j<length(path)
    don = [don ;exons(2,path(j)):(exons(2,path(j))+1)];
  end
end

%transform to local coordinates
if gene.strand=='+'
  nuc = nuc-gene.start+1;
  don = don-gene.start+1;
  acc = acc-gene.start+1;
else
  nuc = gene.stop-nuc+1;
  tmp = acc;
  if length(acc)>0
    acc = gene.stop-don(:,[2 1]);% little hacky: switch don and acc on neg strand
    don = gene.stop-tmp(:,[2 1]);
  end
  nuc = nuc(end:-1:1);
end


assert(issorted(nuc))
seq = unspliced_seq(nuc);
don = unspliced_seq(don);
acc = unspliced_seq(acc);
for j=1:size(acc,1)
  assert(isequal(acc(j,:),'AG'))
  assert(ismember(don(j,:),{'GC','GT'}))
end

[len, start, stop] = maxorf(seq);

if start==0 && stop == 0
  warning('no orf found')
  tis = -1;
  cdsStop = -1;
  len = -1;
else
  tis = nuc(start);
  cdsStop = nuc(stop);
end
