function genes=mergePredAnnoTransacc(genes,PAR)
% genes = mergePredAnnoTransacc(genes,PAR)
%
  
num_genes_pred = zeros(1,length(genes));
num_genes_anno = zeros(1,length(genes));

num_trans_offset = zeros(1,length(genes));
num_trans_both = zeros(1,length(genes));

for g_idx=1:length(genes)
  gene = genes(g_idx);
  idx_pred = find(gene.transacc_info==PAR.info_genes.transacc.pred); 
  num_genes_pred(g_idx) = length(idx_pred);
  idx_anno = find(gene.transacc_info==PAR.info_genes.transacc.anno_SL1|...
                  gene.transacc_info==PAR.info_genes.transacc.anno_SL2); 
  num_genes_anno(g_idx) = length(idx_anno);
  for offset=[-2:2]
    [tmp,idx1,idx2] = intersect(gene.transacc(idx_pred),gene.transacc(idx_anno)+offset);
    if ~isempty(tmp)
      num_trans_offset(g_idx) =num_trans_offset(g_idx)+length(tmp);
      gene.transacc(idx_anno(idx2))=gene.transacc(idx_pred(idx1));
    end
  end
  [tmp,idx1,idx2] = intersect(gene.transacc(idx_pred),gene.transacc(idx_anno));
  num_trans_both(g_idx) = length(tmp);
  genes(g_idx)=gene;
end
fprintf('nb of genes %i\n',length(genes))
fprintf('nb of genes with annotated trans site (nb of annotated sites): %i(%i)\n',sum(num_genes_anno>0),sum(num_genes_anno));
fprintf('nb of genes with predicted trans site (nb of pred sites): %i(%i)\n',sum(num_genes_pred>0),sum(num_genes_pred));
fprintf('nb of genes with annotated and predicted trans acceptor site: %i(%i)\n',sum(num_trans_both>0),sum(num_trans_both));
fprintf('nb of shifted (+-2) annotated trans acceptor site: %i\n',sum(num_trans_offset));

