function genes = merge_utr_cds(genes) 
% genes = merge_utr_cds(genes) 


for i=1:length(genes)
  genes(i).id = i;
  genes(i).tis = [] ;
  genes(i).cdsStop = [] ;
  % genes(i).cds_exons = {} ;
  gene = genes(i) ;
  for j=1:length(gene.transcripts)
    
    exons = gene.exons{j} ;
    [exons(:,1),idx] = sort(exons(:,1)) ;
    exons(:,2:3) = exons(idx,2:3) ;
    % gene.cds_exons{j} = exons(find(exons(:,3)==3),:) ;
    if gene.strand=='+',
      gene.tss(j) = exons(1,1);
      gene.cleave(j) = exons(end,2);
      % assert(any(exons(1,3)==[2 3])) ;
      % assert(any(exons(end,3)==[3 4])) ;
      if exons(1,3)==2, %% 'five_prime_utr' 
        idx2 = find(exons(:,3)==2,1,'last') ;
        idx3 = find(exons(:,3)==3,1,'first') ;
        tis = exons(idx3,1) ;
        if exons(idx2,2)+1==exons(idx3,1)
          exons_ = exons(1:idx2,:) ;
          exons_(idx2,2:3)=[exons(idx3,2) 3];
          exons_=[exons_; exons(idx3+1:end,:)] ;
          exons=exons_ ;
        end ;
      else
        tis=exons(1,1) ;
      end ;
      if exons(end,3)==4, %% three_prime_utr 
        idx3=find(exons(:,3)==3,1,'last') ; %% 'coding_exon' type=3 ;
        idx4=find(exons(:,3)==4,1,'first') ; 
        cdsStop = exons(idx3,2) ;
        if exons(idx3,2)+1==exons(idx4,1),
          exons_ = exons(1:idx3,:) ;
          exons_(idx3,2)=exons(idx4,2) ;
          exons_=[exons_; exons(idx4+1:end,:)] ;
          exons=exons_ ;
        end ;
      else
        cdsStop=exons(end,2) ;
      end ;
    else
      gene.tss(j) = exons(end,2);
      gene.cleave(j) = exons(1,1);
      % assert(any(exons(end,3)==[2 3])) ;
      % assert(any(exons(1,3)==[3 4])) ;
      if exons(1,3)==4,%% three_prime_utr 
        idx4=find(exons(:,3)==4,1,'last') ;
        idx3=find(exons(:,3)==3,1,'first') ;
        cdsStop = exons(idx3,1) ;
        if exons(idx4,2)+1==exons(idx3,1),
          exons_ = exons(1:idx4,:) ;
          exons_(idx4,2:3)=[exons(idx3,2) 3] ;
          exons_=[exons_; exons(idx3+1:end,:)] ;
          exons=exons_ ;
        end ;
      else
        cdsStop=exons(1,1) ;
      end ;
      if exons(end,3)==2,%% five_prime_utr 
        idx3=find(exons(:,3)==3,1,'last') ;
        idx2=find(exons(:,3)==2,1,'first') ;
        tis = exons(idx3,2) ;
        if exons(idx3,2)+1==exons(idx2,1),
          exons_ = exons(1:idx3,:) ;
          exons_(idx3,2)=exons(idx2,2) ;
          exons_=[exons_; exons(idx2+1:end,:)] ;
          exons=exons_ ;
        end ;
      else
        tis=exons(end,2) ;
      end ;
    end ;
    exons(:,3)=[] ;
    gene.exons{j}=exons ;
    if ~isempty(tis)
      gene.tis(end+1)=tis ;
    end
    if ~isempty(cdsStop)
      gene.cdsStop(end+1)=cdsStop ;
    end
  end ;
  genes(i)=gene ;
end ;