function mk_cds(PAR)
  
load(PAR.FN.output.fn_genes_anno,'genes') ;
for i=1:length(genes),
  assert(genes(i).start>0)
  genes(i).strands=genes(i).strand*ones(1,length(genes(i).transcripts)) ;
end ;
anno_genes = genes ;

load(PAR.FN.input.fn_genes_conf_orig,'genes') ;

genome_info = init_genome(PAR.FN.genome.fn_genome_config);

colmap21 = compute_colocation_map(genes, anno_genes, genome_info) ;

TIS = [] ; STOP = [] ;
for i=1:length(anno_genes),
  assert(PAR.label_source_par.tis.anno_useonlycDNA == PAR.label_source_par.cdsStop.anno_useonlycDNA)
  if PAR.label_source_par.tis.anno_useonlycDNA
    cond = length(colmap21{i})==1 && genes(colmap21{i}).has_cDNA;
  else
    cond = length(colmap21{i})==1 ;
  end
  if cond & ~isempty(anno_genes(i).cds_exons)
    TIS(end+1).name = anno_genes(i).name ;
    TIS(end).pos = [] ;
    TIS(end).confLevel=1 ;
    TIS(end).strand = anno_genes(i).strand ;
    TIS(end).chr_num = anno_genes(i).chr_num ;
    TIS(end).confirmed_genes = colmap21{i} ;
    TIS(end).start = genes(colmap21{i}).start ;
    TIS(end).stop = genes(colmap21{i}).stop ;
    if length(STOP)==0, 
      STOP=TIS ;
    else
      STOP(end+1) = TIS(end) ;
    end ;
    if anno_genes(i).strand=='+',
      TIS(end).pos = anno_genes(i).cds_exons{1}(1,1) ;
      STOP(end).pos = anno_genes(i).cds_exons{1}(end,2)-3 ;% point to the start of the consensus
    else
      TIS(end).pos = anno_genes(i).cds_exons{1}(end,2) ; 
      STOP(end).pos = anno_genes(i).cds_exons{1}(1,1)+3 ; % point to the start of the consensus
    end ;
  end ;
end ;

save(PAR.FN.input_sig.tis.fn_anno,'TIS');
save(PAR.FN.input_sig.cdsStop.fn_anno,'STOP');
