function parse_sl_from_anno_wormbase(PAR)
addpath( '/fml/ag-raetsch/share/software/matlab_tools/utils/' );

genome_info =  init_genome(PAR.FN.input.fn_genome_config) ;
fname = genome_info.annotation_fnames{1};
idx = strfind(fname,'/');
% release = fname(idx(end-1)+1:idx(end)-1);
% basedir = '/fml/ag-raetsch/share/projects/transcription/tss/';
% savedir = sprintf('%s%s/', basedir, release);

% if(~exist(savedir,'dir'))
%   success = mkdir(basedir, par.release);
%   assert(success);
%   status = system(sprintf('chmod g+w %s', savedir));
% end;

tmpfname = tempname;

type ={'SL1', 'SL2'};
for t=1:length(type)
  unix(sprintf('grep ''%s_acceptor_site'' %s > %s',type{t},fname,tmpfname));

  % keyboard
  transacc = [];
  transacc(1).name = {};
  transacc(1).pos = 0;
  transacc(1).confLevel = 0;
  transacc(1).strand = '';
  transacc(1).chr = '';
  transacc(1).type = 0;
  
  fd = fopen(tmpfname, 'r+') ;
  
  cnt = 1;
  fprintf('start parsing trans acc from annotation\n')
  while ~feof(fd),
    line = fgetl(fd) ; 
    if ~ischar(line),  break; end ;
    if length(line)>10000, keyboard; end ;
    elems = separate(line) ;
    
    assert(elems{7}=='+' || elems{7}=='-') ;
    strand = char(elems{7});
    if (strand == '+')
      pos = str2num(elems{5}) ;
    else
      pos = str2num(elems{4});
    end;
    
    chr = elems{1};
    ii = strfind(elems{9},'WB');
    sn = elems{9}(ii:end-1);
    
    fi = find(pos==[transacc.pos]);
    assert(length(fi)==1 || isempty(fi));
    if(~isempty(fi))
      transacc(fi).name{end+1} = sn;
      continue;
    end;
    
    transacc(cnt).name = {sn};
    transacc(cnt).pos = pos;
    transacc(cnt).confLevel=1;
    transacc(cnt).strand = strand;
    transacc(cnt).chr_num = strmatch(chr,genome_info.contig_names,'exact');
    transacc(cnt).type = elems{2};
    cnt = cnt + 1; 
    if (mod(length(transacc),10)==0) fprintf(1,'%i\r',length(transacc)); end;
    
  end ;
  
  fclose(fd) ;
  disp(length(transacc));

  chromosomes = unique([transacc.chr_num]);
  
  % transacc_all = transacc;
  % for i=1:length(chromosomes)
  %   TRANSACC = transacc_all([transacc_all.chr_num]==chromosomes(i));
  %   outfile = sprintf('%s_%d.mat', PAR.FN.input_sig.transacc.fn_anno, i);
  %   save(outfile,'TRANSACC');
  % end;
  TRANSACC=transacc;
  if isequal(type{t},'SL1')
    save(sprintf('%s.mat',PAR.FN.input_sig.transacc.fn_anno_SL1),'TRANSACC')
  else
    save(sprintf('%s.mat',PAR.FN.input_sig.transacc.fn_anno_SL2),'TRANSACC')
  end
end