function dataout = cutout(datain, c);
% cut out sequences containing character or sequence c('n' or 'N'
% or 'ttttt' for ex.)
% Petra Philips

dd = [];
if length(c) == 1
  if sum(sum(datain == c)) ~= 0
    a = sum(datain == c);
    [b bi] = sort(a); 
    [ bu bm bn] = unique(b);
    if bu(1) == 0
      dd = datain(:,bi(1:bm(1)));
    end;
    dataout = dd;
  else 
    dataout = datain;
  end;
else
  order = length(c);
  L = size(datain,1);
  l1 = size(datain,2);
  
  s1 = acgt2int(datain);
  s1_xm = zeros(L-order+1,l1);
  
  cn = 1;
  for i=1:order
    cs(order - i+1) = cn;
    cn = cn*4;
  end;

  % convert xmer into one number 
  for j=1:L-order+1;
    s1_xm(j,:) = cs * s1(j:j+order-1,:);
  end; % for j  

  cstr = [];
  for k=1:order
    cstr = [cstr; acgt2int(c(k))];   
  end;
  cnum = cs*cstr;
  
  % cut out
  if sum(sum(s1_xm == cnum)) ~= 0
    a = sum(s1_xm == cnum);
    [b bi] = sort(a); 
    [ bu bm bn] = unique(b);
    if bu(1) == 0
      dd = datain(:,bi(1:bm(1)));
    end;
    dataout = dd;
  else 
    dataout = datain;
  end;
end;
return;