function POLYALIST = generate_polya(POLYAPAR);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parameters
%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
addpath polya_utils/ ;
%addpath ~/svn/tools/genomes/ ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set genomic info for loadin the sequences
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
genome_config = init_genome(POLYAPAR.fn_genome_config);

wl = POLYAPAR.wl;
POSconstr = POLYAPAR.POSconstr;
cleave = POLYAPAR.cleavedata_highconf;
POLYACONSENSUS = POLYAPAR.consensus;

% first build a model for the occurences of all significant high confidence 
% PAS 6mers (estimate mean and variance of their positions)

counterrepr = 0;
counter = 1;

for i=1:length(cleave)
  % if confidence is one of the input parameters take it for
  % foreground model
  cleaveposition = cleave(i).pos;
  if strcmp(cleave(i).strand, '+')
    strand = 1;
  else 
    strand = 0;
  end; 
  counterrepr = counterrepr +1;
   
    % cut out -100, +100 around putative polyA site
    % cut out -50*wl +50*wl around putative polyA site1
    bs = cleaveposition-50*wl;
    es = cleaveposition+50*wl;

    clear sequ;
    sequ = lower(load_genomic(genome_config.contig_names{cleave(i).chr_num}, cleave(i).strand, bs, es,genome_config));
    if es < 5,
      break;
    end;
    
    FGDATA(:,counter) = sequ;
    counter = counter + 1;    
end; % for i=1:lrepr

noSequ= counter - 1;
FGDATA = FGDATA(:,1:noSequ);

FGDATA = cutout(FGDATA, 'n');
% build an array with all the sixmers of the foregroundground sequences
FGXMER = acgt2intXmer(FGDATA,6);

PASlocationVec = [];
for ii=1:length(POLYACONSENSUS)
	% consider this sequence 
        xmersequ = POLYACONSENSUS{ii};
        xmer = acgt2intXmer(xmersequ',6);
        lvtmp = sum(FGXMER' == xmer);
        for i=1:size(FGXMER,1)
          PASlocationVec= [PASlocationVec i*ones(1,lvtmp(i))];
        end;
end;
[posmutotal, possigmatotal] = mynormfit(PASlocationVec);
PASlocation = [];
PASlocation.posmutotal = posmutotal;
PASlocation.possigmatotal = possigmatotal;

% print nice figure
%PASlocationVec= PASlocationVec - 50*wl -1;
% h= figure; hold on;
%hist(PASlocationVec,wl*25+1);
%xlabel('Location relative to putative ESTs'); 

POLYAPAR.distribution = PASlocation;

POLYALIST = create_polya(POLYAPAR);

return;
