function save_splits2bed(blocks,split,fn_out,PAR)
%  save_splits2bed(PAR)
  
genome_info = init_genome(PAR.FN.input.fn_genome_config);
contig_names = genome_info.contig_names;

if isempty(split)
  fprintf('split empty')
  return
end
if isempty(blocks)
  fprintf('blocks empty')
  return
end


split_names = fieldnames(split);
num_splits = length(split_names);
start_pos = [];
stop_pos = [];
contigs = [];
strand = [];
split_num = [];

for s = 1:length(split_names) 
  idx = split.(split_names{s});
  start_pos = [start_pos [blocks(idx).start]];
  stop_pos = [stop_pos [blocks(idx).stop]]; 
  contigs = [contigs [blocks(idx).chr_num]];
  strand = [strand [blocks(idx).strand]];
  split_num = [split_num repmat(s*100,1,length(idx))];
end
start_pos = start_pos+ PAR.regions.offset;
stop_pos = stop_pos- PAR.regions.offset;

for s='+-'
  fn_out1=sprintf('%s%s.bed',fn_out, s);
  
  if fexist(fn_out1)
    fprintf('warning file %s already exists',fn_out1);
    continue
  else
    fprintf('save as %s\n',fn_out1);
    [fd msg] = fopen(fn_out1, 'w+');
    fprintf(fd,'track name=blocks description="blocks" useScore=1\n');
    fprintf(fd,'browser position chrI:1-2,673,945\n');
    fprintf(fd,'browser hide all\n');
    fprintf(fd,'browser pack WormBase Genes\n');
    fprintf(fd,'browser full altGraph\n');
  end
  disp(msg)
  for c=unique(contigs)
    contig_name = sprintf('chr%s',contig_names{c}); 
    idx = find(contigs==c&strand==s);
    start_pos1 = start_pos(idx);
    stop_pos1 = stop_pos(idx);
    split_num1 = split_num(idx);
    [temp,idx] = sort(start_pos1);
    for p=idx
      fprintf(fd,'%s\t%i\t%i\t%s\t%i\t%s\n ',contig_name, start_pos1(p), stop_pos1(p), 'region', split_num1(p), s);
    end
  end  
  fclose(fd);
end
