function regions2 = setdiff_regions(trivial_regions,regions1)

% region = setdiff(regions1,regions2)
%   
% function finds the region complement of regions1 on trivial_regions; 
% 
%   
% INPUT  -trivial_regions: region struct according to init_regions 
%                          (chr strand) should be unique.   
%        -regions1: region struct according to init_regions
% 
% SEE ALSO : init_regions

  

CHR = [trivial_regions.chr_num];
STR = [trivial_regions.strand];
STR = STR=='+';
assert(size([CHR; STR]',1) == size(unique([CHR; STR]','rows'),1))

regions2 = init_regions;
num_regs = 0;
for i=1:length(trivial_regions)
  reg = trivial_regions(i);
  idx = find([regions1.strand] == reg.strand & [regions1.chr_num] == reg.chr_num);
  starts = [regions1(idx).start];
  stops = [regions1(idx).stop];
  [tmp,idx1] = sort(starts) ; 
  regs1 = regions1(idx(idx1));
  if regs1(1).start>1
    num_regs = num_regs+1;
    regions2(num_regs) = reg ;
    regions2(num_regs).start = 1 ;
    regions2(num_regs).stop = regs1(1).start-1; 
  end
  for j=1:length(regs1)-1
    num_regs = num_regs+1;
    regions2(num_regs) = reg ;
    regions2(num_regs).start = regs1(j).stop+1;
    regions2(num_regs).stop = regs1(j+1).start-1;
  end
  if regs1(end).stop<reg.stop
    num_regs = num_regs+1;
    regions2(num_regs) = reg ;
    regions2(num_regs).start = regs1(end).stop+1;
    regions2(num_regs).stop = reg.stop; 
  end
end

  
for i=1:length(regions2)
  switch regions2(i).strand
   case '+',
    regions2(i).offset = regions2(i).start - 1;
   case '-',
    regions2(i).offset = regions2(i).stop + 1;
  end
end
  
  
  
  
  