function [new_reg,split] = sort_regions(reg)
      
  
reg_chr = [reg.chr_num];

CHR = unique(reg_chr);

taken = [];
rm_idx =[];
for i=1:length(CHR)
  tmp1 = find(reg_chr==CHR(i));
  reg_str = [reg(tmp1).strand];
  STR = unique(reg_str);
  for j=1:length(STR)
    tmp2 = find(reg_str==STR(j));
    reg_starts = [reg(tmp1(tmp2)).start];
    reg_stops = [reg(tmp1(tmp2)).stop];
    [reg_starts,tmp3]= sort(reg_starts);
    reg_stops = reg_stops(tmp3);
    idx_new = tmp1(tmp2(tmp3));
    assert(all([reg(idx_new).strand]==STR(j)))
    assert(all([reg(idx_new).chr_num]==CHR(i)))
    assert(isempty(intersect(taken,idx_new)));
    taken = [taken, idx_new];
    
    reg_tmp = reg(tmp1(tmp2(tmp3)));
    ends = [reg_starts; reg_stops]';
    if size(unique(ends,'rows'),1)<size(ends,1)
      [tmp,idx1,idx2] = unique(ends,'rows');
      for k=1:size(ends,1)
        if sum(idx2==k)>1
          idx3 = find(idx2==k);
          if any([reg_tmp(idx3).num_fragments])>1
            keyboard
          end
          reg_tmp(idx3(1)).paralogs = unique([reg_tmp(idx3).paralogs]) ;
          reg_tmp(idx3(1)).gene_ids = unique([reg_tmp(idx3).gene_ids]) ;
          reg_tmp(idx3(1)).old_id = unique([reg_tmp(idx3).old_id]) ;
          rm_idx = [rm_idx idx3(2:end)+length(new_reg)];
        end
      end
    end
    
    if ~exist('new_reg')
      new_reg = reg_tmp;
    else
      new_reg(end+[1:length(tmp3)]) = reg_tmp;
    end
    
  end
end
ends = [[new_reg(rm_idx).chr_num]; [[new_reg(rm_idx).strand]=='+']; [new_reg(rm_idx).start]; [new_reg(rm_idx).stop]]';
new_reg(rm_idx)=[];
ends_  = [[new_reg.chr_num]; [[new_reg.strand]=='+']; [new_reg.start]; [new_reg.stop]]'; 
assert(all(ismember(ends,ends_,'rows')));

fprintf(1,'removed %i identical regions\n',length(rm_idx));
for i=1:length(new_reg)
  new_reg(i).old_id2 = new_reg(i).id;
  new_reg(i).id = i;
  paralogs =  new_reg(j).paralogs;
  if ~isempty(paralogs)
    idx = find(ismember([new_reg.old_id2],paralogs));
    new_reg(j).paralogs = idx;
  end
end
new_reg = rmfield(new_reg,'old_id2') ;

assert(length(taken)==length(unique(taken)))
assert(all(ismember([1:length(reg)],taken)))
assert(length(taken)==length(reg))

if ~exist('new_reg')
  assert(isempty(reg))
  new_reg=reg;
end

if isfield(new_reg,'split')
  SPLITS = unique([new_reg.split]);
  for s=SPLITS
    split.(sprintf('split_%i',s)) = find([new_reg.split]==s);
  end
else
  split = struct; 
end