function [regions,map] = split_regions_helper(regions,REG,GENES,PAR,map)
 
  
  
  
  
new_tr=1;
g=0;
contigstart = REG.start;
contigstop = REG.stop;

if PAR.regions.merge_confirmed
  min_genes_per_region = 1;
  fpritnf('putting only 1 gene in region; regions will be merged later with only complete genes')
else 
  min_genes_per_region = PAR.regions.min_genes_per_region;
end




if ~isempty(GENES)
  idx =  find(REG.chr_num==[GENES.chr_num]&[GENES.strand]==REG.strand& ...
              REG.start<=[GENES.start]& ...
              REG.stop>=[GENES.stop]);
  idx_overlap = find(REG.chr_num==[GENES.chr_num]&[GENES.strand]==REG.strand& ...
                     REG.start>=[GENES.start]& ...
                     REG.start<=[GENES.stop]);
  assert(isempty(idx_overlap))
  idx_overlap = find(REG.chr_num==[GENES.chr_num]&[GENES.strand]==REG.strand& ...
                     REG.stop>=[GENES.start]& ...
                     REG.stop<=[GENES.stop]);
  assert(isempty(idx_overlap))
else 
  idx=[];
end

fprintf(1,'split region %s%s, num of genes found: %i\r',REG.chr,REG.strand, length(idx)) 
if ~isempty(idx)
  genes = GENES(idx);
  [tmp pos] = sort([genes.start]);
  genes = genes(pos);
  clear pos idx start_pos
else
  block_length = REG.stop-REG.start;
  if ~isfield(PAR.regions,'max_length')|isempty(PAR.regions.max_length)
    num_blocks = 1;
  else
    num_blocks = ceil(block_length/PAR.regions.max_length);
    block_length = ceil(block_length/num_blocks);
  end
  start = REG.start+2*PAR.regions.minCutDist;
  genes = [];
  for j=1:num_blocks
    stop = min(start+block_length,REG.stop);
    genes(j).id = [];
    genes(j).transcript_status =[];
    genes(j).is_complete = [];
    genes(j).start = start+2*PAR.regions.minCutDist+10;
    genes(j).stop = stop-2*PAR.regions.minCutDist-10;
    start = stop;
  end
end






while g<size(genes,2)
  region = [];
  region.organism = REG.organism;
  region.chr = REG.chr;
  region.chr_num  = REG.chr_num;
  region.strand  = REG.strand;
  region.id = length(regions)+1;
  region.TR_idx = REG.TR_idx ;
  region.num_fragments = 1;
  region.config = REG.config;
  region.paralogs = [];
  r_genes = [];
  region.gene_ids=[];
  region.gene_status=[];
  region.gene_complete=[];
  genedist_too_short=0;
  if new_tr
    region.start = REG.start;
    region.stop = REG.start;
    new_tr=0;
  else
    region.start = region_end_stop;
  end
  %add genes to region as long as min gene num is not achieved, genedist is too short or more if you are at 
  %the end of the contig and last region would be to short
  while  g<size(genes,2)&...
        (length(r_genes)<min_genes_per_region|...
         g+min_genes_per_region>size(genes,2)|...
         genedist_too_short |...
         (length(r_genes)>0&...
          (region.stop+PAR.regions.offset>contigstop|region.stop-PAR.regions.offset<1))) 
    % is this the last gene of the contig?
    % enough genes for this region collected?
    % still enough genes to fill another region?
    % next gene closer than 2*minCutDist?
    g=g+1;
    r_genes = [r_genes genes(g)];
    region.gene_ids = [region.gene_ids genes(g).id];
    region.gene_status = [region.gene_status max(genes(g).transcript_status)];
    region.gene_complete = [region.gene_complete max(genes(g).is_complete)];
    map(genes(g).id) = region.id;
    gene_stop = max([r_genes.stop]);
    if g==size(genes,2)
      region.stop = REG.stop;
    else
      genedist = genes(g+1).start-gene_stop-1;
      rand_num = ceil(rand*(genedist-2*PAR.regions.minCutDist));
      region.stop = gene_stop+PAR.regions.minCutDist+rand_num;
      genedist_too_short = (genedist<=2*PAR.regions.minCutDist+1);
    end
  end%while add genes
  region.left_dist = min([r_genes.start])- region.start;
  region.right_dist = region.stop - gene_stop;
  %   assert(length(region.gene_ids)>=min_genes_per_region)
  region_end_stop = region.stop+1;
  
  if ~isempty(GENES)
    check_block_gene_ids(region, GENES);
  end

  region.reg_no_overlap(1) = max([contigstart+PAR.regions.offset region.start]);
  region.reg_no_overlap(2) = min([contigstop-PAR.regions.offset region.stop]);
  region.start = max([contigstart region.start-PAR.regions.offset]);
  region.stop = min([contigstop region.stop+PAR.regions.offset]);
  region.reg_no_overlap = region.reg_no_overlap-region.start+1;
 
  switch region.strand
   case '+',
    region.offset = region.start - 1;
   case '-',
    region.offset = region.stop + 1;
  end
  % keyboard
  regions = [regions region];
end % loop over genes in contig
