function split_idx_genes = splits_by_paralogs(genes,num_splits)

  
rand('seed',1234)  
cluster = {};  
covered = [];
for gene_id = 1:length(genes)
  fprintf('%i\r',gene_id)
  if isempty(genes(gene_id).paralogs)
    cluster{end+1} = gene_id;
    covered = [covered, gene_id];
    genes(gene_id).paralog_cluster = length(cluster);
  elseif ~ismember(gene_id,covered)
    cluster{end+1} = [genes(gene_id).paralogs];
    covered = [covered, genes(gene_id).paralogs] ;
    genes(gene_id).paralog_cluster = length(cluster);
    [genes(genes(gene_id).paralogs).paralog_cluster] = deal(length(cluster));
  else
    assert(all(ismember(genes(gene_id).paralogs,cluster{genes(gene_id).paralog_cluster})))
  end
end
assert(isequal(sort(covered),[1:gene_id]))

if length(cluster)<num_splits
  error('number of paralog clusters < number of splits')
end

for c=1:length(cluster)
  cluster_length(c) = length(cluster{c});
end
assert(sum(cluster_length)==length(genes))

fprintf('\n numer of paralog clusters %i',length(cluster))
fprintf('\n maximum number of genes per cluster %i',max(cluster_length))
fprintf('\n mean number of genes per cluster %.2f\n',mean(cluster_length))


% [cluster_length,idx] =sort(cluster_length);
% cumsum(cluster_length)/sum(cluster_length);

[cluster_length,idx] =sort(cluster_length,'descend');
cluster= cluster(idx);
idx = find(cluster_length==1);
idx = idx(randperm(length(idx))) ;
cluster = [cluster(cluster_length>1) cluster(idx)];

idx=1:length(cluster);

split_idx_cluster ={};
nb_clusters=[];
nb_genes=[];
for i=1:num_splits
  split_idx_cluster{i} = idx([i:num_splits*2:length(idx)]);
  split_idx_cluster{i} = sort([split_idx_cluster{i} idx([num_splits*2-i+1:num_splits*2:length(idx)])]);
  nb_clusters(i)=length(split_idx_cluster{i});
  split_idx_genes{i} = [cluster{split_idx_cluster{i}}];
  nb_genes(i)=length(split_idx_genes{i});
end

assert(length(unique( [split_idx_cluster{:}]))==length(idx))
if 0
for i=1:num_splits,
  yy(i,:) = hist(cluster_length(split_idx_cluster{i}),[1:10:500]);
  leg{i} = sprintf('split %i; nb of genes %i',i,nb_genes(i));
end

figure;plot([1:10:500],yy),grid on
xlabel('number of genes per cluster')
ylabel(sprintf('number of clusters (total %.1f per split)',mean(nb_clusters)))
legend(leg)
end
assert(length(unique( [split_idx_genes{:}]))==length(genes))