function dist = transsplice_statistics(genes,PAR,type)
  
dist.anno_tis = -10000*ones(1,length(genes));
dist.anno_tss = -10000*ones(1,length(genes));
dist.anno_start = -10000*ones(1,length(genes));
dist.gene_idx = zeros(1,length(genes));
num = 0;
for g_idx=1:length(genes)
  gene = genes(g_idx);
  idx = find(gene.transacc_info==PAR.info_genes.transacc.(type));
  cdna_idx = find(gene.transcript_info == PAR.info_genes.transcript.cDNA);
  if ~isempty(cdna_idx)
    tis =  [];
    if gene.strand=='+'
      for i=cdna_idx
        tis = [tis gene.exons{i}(1,1)] ;
      end
      tis = min(tis);
      dist.anno_tis(num+[1:length(idx)]) = gene.transacc(idx) - tis;
      dist.gene_idx(num+[1:length(idx)]) = g_idx;
    else
      for i=cdna_idx
        tis = [tis gene.exons{i}(end,2)] ;
      end
      tis = max(tis);    
      dist.anno_tis(num+[1:length(idx)]) = -(gene.transacc(idx) - tis);
      dist.gene_idx(num+[1:length(idx)]) = g_idx;
    end
  end
  if ~isempty(gene.tss)
    if gene.strand=='+'
      dist.anno_tss(num+[1:length(idx)]) = gene.transacc(idx) - max(gene.tss);
    else
      dist.anno_tss(num+[1:length(idx)]) = -(gene.transacc(idx) - min(gene.tss));
    end
    dist.gene_idx(num+[1:length(idx)]) = g_idx;
  end
  if gene.start=='+'
    dist.anno_start(num+[1:length(idx)]) = gene.transacc(idx) - gene.start;
  else
    dist.anno_start(num+[1:length(idx)]) = -(gene.transacc(idx) - gene.stop);
  end
  dist.gene_idx(num+[1:length(idx)]) = g_idx;
  num = num+length(idx);
end

dist.anno_tis(num+1:end) = [];
dist.anno_tss(num+1:end) = [];
dist.anno_start(num+1:end) = [];
dist.gene_idx(num+1:end) = [];

[y,x] = hist(dist.anno_start,1000);
figure; plot(x,y/num*100)
[xx,idx] = sort(abs(x));grid on
xlabel('trans-gene.start')
figure;plot(xx,cumsum(y(idx))./sum(y))

[y,x] = hist(dist.anno_tss,1000);
figure; plot(x,y/num*100)
[xx,idx] = sort(abs(x));
xlabel('trans-gene.tss')
figure;plot(xx,cumsum(y(idx))./sum(y))

[y,x] = hist(dist.anno_tis,1000);
figure; plot(x,y/num*100)
[xx,idx] = sort(abs(x));
xlabel('trans-cdna start')
figure;plot(xx,cumsum(y(idx))./sum(y))



A2=load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/sensors/transacc/transacc_anno_SL2.mat')
A1=load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/sensors/transacc/transacc_anno_SL1.mat')
P=load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/sensors/transacc/transacc_pred.mat')
confs_a1=[];
confs_p =[];
confs_a2=[];

for j=unique([A1.TRANSACC.chr_num]),
  for s='+-',
    a1_idx = find([A1.TRANSACC.strand]==s&[A1.TRANSACC.chr_num]==j);
    a2_idx = find([A2.TRANSACC.strand]==s&[A2.TRANSACC.chr_num]==j);
    p_idx =  find([P.TRANSACC.strand]==s&[P.TRANSACC.chr]==j);
    
    [tmp,idx1,idx2]=intersect([A1.TRANSACC(a1_idx).pos],[P.TRANSACC(p_idx).pos]);
    confs_a1 = [confs_a1 P.TRANSACC(p_idx(idx2)).confLevel]; 
    
    [tmp,idx1,idx2]=intersect([A2.TRANSACC(a2_idx).pos],[P.TRANSACC(p_idx).pos]);
    confs_a2 = [confs_a2 P.TRANSACC(p_idx(idx2)).confLevel]; 
    
    [tmp,idx1]=setdiff([P.TRANSACC(p_idx).pos],[A2.TRANSACC(a2_idx).pos]);
    [tmp,idx2]=setdiff([P.TRANSACC(p_idx(idx1)).pos],[A2.TRANSACC(a2_idx).pos]);
    confs_p = [confs_a2 P.TRANSACC(p_idx(idx1(idx2))).confLevel]; 
  end,
end,

confs = [confs_a1 confs_a2];
[ya,x] = hist(confs,100);
plot(x,ya);
hold on;
[yp,x] = hist(confs_p,100);
plot(x,yp,'r');