addpath '~/svn/tools/genomes/'
addpath '/fml/ag-raetsch/share/software/matlab_tools/utils'
addpath '~/svn/projects/splicing/splicegraphs'
addpath '../data_processing_sensors'


compute_on_cluster=1;
cleave_offsets=[3.0, 6.0, 9.0, 10.5, 12.0, 15]
%cleave_offsets=[3.0]

matdir = '/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/predictions/gr_loss_C=1_final_sol10_cor-02-09-2007/'
genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/orig_data/genome.config_500');


%to save uncompressed files: save filename -v6

blocks_cleave=[]

%iterate over cleaves
%for i=1:length(cleave_offsets)
if (0)

  cleave_offset=cleave_offsets(i) ;
  blocks=[] ;
  blocks_cleave(i).cleave_offset = cleave_offset ;

  %iterate over blocks

  %for j=181:997
  for j=3:997
  %for j=3:4

    %filenames are of the form: pred_genome_997_cleave=10.5_cleave10.50.mat
    fname = sprintf('pred_genome_%i_cleave=%1.1f_viterbi_block%i.mat', j, cleave_offset, j)
    fname_blocks = sprintf('pred_genome_%i.mat', j);

    %load data  
    L1 = load([matdir fname_blocks], 'blocks', 'PAR');
    L2 = load([matdir fname], 'pred');

    %keyboard

    %set predictions
    L1.blocks.prediction=L2.pred;

    %remove 
    L1.blocks=rmfield(L1.blocks, {'content', 'pred', 'genestr', 'seq', 'pos'} );

    blocks = [blocks L1.blocks];
    PAR = L1.PAR;

    clear L1,L2

  end

  %convert blocks to genes
  genes = blocks2genes(blocks, PAR.model, 'prediction', genome_info) ; 

  %keyboard

  %save genes to file
  fname_genes = sprintf('~/genes_cleave=%1.1f.mat', cleave_offset)
  %save fname_genes 'genes' 'PAR' -v7.3
  save(fname_genes,'genes','PAR','-v7.3')

  clear blocks

end

%keyboard


save_path='~/'

jobinfo = rproc_empty(1) ;
q = 0;
for p = 1:PAR.SETs.num_partitions
  fprintf(1,'\n\n-----------\n');
  fprintf(1,'PARTITION %i\n',p);
  fprintf(1,'-----------\n');
  fn_best_SVM = sprintf('%s%s_partition=%i.mat', PAR.FN.output_sig.(PAR.Signal_name).fn_SVMs,PAR.Signal_name,p);
  fn_motifs = sprintf('%s%s_%i.mat',PAR.FN.output_sig.(PAR.Signal_name).fn_motifs,PAR.Signal_name,p);
  if ~fexist(fn_motifs)
    D.motifsFileName=fn_motifs;
    D.svmFileName=fn_best_SVM;
    PAR.RPROC.options.identifier=sprintf('motifs_%s_%s',PAR.organism.name,PAR.Signal_name);
    PAR.RPROC.options.ncpus=1;
    q=q+1;
    jobinfo(q) = rproc('find_svm_motifs', D, PAR.RPROC.MEMREQ,PAR.RPROC.options, 60);
    %find_svm_motifs(fn_best_SVM, fn_motifs)
  end
end %% loop over partitions

[jobinfo,num_crashed] = rproc_wait(jobinfo,5);


jobinfo = rproc_empty(1) ;
q=0;

%iterate over cleaves
for i=1:length(cleave_offsets)-1

  fname_left=sprintf('~/genes_cleave=%1.1f.mat', cleave_offsets(i))
  fname_right=sprintf('~/genes_cleave=%1.1f.mat', cleave_offsets(i+1))

  if (i==1)
    %load genes with lower cleave
    left=load(fname_left)

    for j=1:length(left.genes)
      left.genes(j).transcript_status=-1;
    end

  else
    left=right
  end



  %load genes with higher cleave
  right=load(fname_right)
  
  for j=1:length(right.genes)
    right.genes(j).transcript_status=-1;
  end

 
  %get trivial regions
  left.PAR.FN.input.fn_genome_config='/fml/ag-raetsch/share/projects/genefinding/P_pacificus/orig_data/genome.config_500'
  left.PAR.organism.name='pacificus'
  regions=init_regions(left.PAR)

  q=q+1;
  
 #nice 


  PAR.RPROC.options.nicetohave = 1;
 
  if (compute_on_cluster)
    jobinfo(q) = rproc('find_svm_motifs', D, PAR.RPROC.MEMREQ,PAR.RPROC.options, 60);
  else
    [res,map] = evaluate_predictions(regions,left.genes,right.genes,genome_info,0);
  end

  keyboard

  save(sprintf('~/res_cleave=%1.1f.mat', cleave_offsets(i)), 'res', 'map')
end ;

