
cleave = 6

base_dir = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1//test_predictions/'...
            'new_signals_new_labels_better_all-17-11-2007/'];

fn_out_target_genome_genes = sprintf('%sgenome_genes_shiftedWS180_cleave%1.2f.mat',base_dir, cleave);
fn_out_orig_genome_genes = sprintf('%sgenome_genes_cleave%1.2f.mat',base_dir, cleave);

target_config = '/fml/ag-raetsch/share/databases/genomes/elegans_WS180/genome.config' ;
orig_config = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/orig_data/genome.config'

target_genome_info = init_genome(target_config);
orig_genome_info = init_genome(orig_config);

% change names: assumes that chromosomes are in the same order
target_genome_info.contig_names=orig_genome_info.contig_names ;

O = load(fn_out_orig_genome_genes);
T = load(fn_out_target_genome_genes);

LL=load('/fml/ag-raetsch/share/projects/NematodeAlignments/chr_map_elegans_remanei_briggsae.mat')


%% CONSERVATION OF ORF

CONS(length(O.genes)).cds =[]; 
for i=1:length(O.genes)
  gene=O.genes(i);
  cds = gene.cds_exons{1};
  CONS(i).cds = [];
  for j=1:size(cds,1)
    CONS(i).cds = [CONS(i).cds LL.chr_maps{gene.chr_num}(:,cds(j,1):cds(j,2))];
  end
  CONS(i).cds_brigsae = mean(CONS(i).cds(6,:));
  CONS(i).cds_remanei = mean(CONS(i).cds(3,:));
  CONS(i).cds_both =  mean([CONS(i).cds_brigsae CONS(i).cds_remanei]);
end
% [dy,dx] = hist([CONS.cds_both],50)
[dyb,dx] = hist([CONS.cds_brigsae],50);
[dyr,dx] = hist([CONS.cds_remanei],dx);


%% CONSERVATION OF ORF


figure; hold on
plot(dx,dyr,'r')
plot(dx,dyb,'k')
legend('remanei (3)','briggsae (6)')
ylabel('number of genes')
xlabel('mean conservation of cds')

CONS_P(length(O.genes(O.idx_pseudo))).cds =[]; 
for i=O.idx_pseudo
  gene=O.genes(i);
  cds = gene.cds_exons{1};
  CONS_P(i).cds = [];
  for j=1:size(cds,1)
    CONS_P(i).cds = [CONS_P(i).cds LL.chr_maps{gene.chr_num}(:,cds(j,1):cds(j,2))];
  end
  CONS_P(i).cds_brigsae = mean(CONS_P(i).cds(6,:));
  CONS_P(i).cds_remanei = mean(CONS_P(i).cds(3,:));
  CONS_P(i).cds_both =  mean([CONS(i).cds_brigsae CONS(i).cds_remanei]);  
end
[dyP,dx] = hist([CONS_P.cds_brigsae],dx);

figure;
hold on
plot(dx,dyb/(sum(dyb)),'k') 
plot(dx,dyP/(sum(dyP)),'r') 
legend('all predicted genes', 'predicted genes overlapping with pseudogenes')
ylabel('number of genes')
xlabel('mean conservation of cds')

%% Pseudogenes

L = load('/fml/ag-raetsch/share/databases/genomes/elegans_WS180/pseudogenes.mat') ;
pseudo_genes = L.genes ;
for j=1:length(pseudo_genes)
  pseudo_genes(j).id=j;
end

colmap = compute_colocation_map(pseudo_genes, T.genes, target_genome_info) ;

map = zeros(1,length(colmap)) ;
for i=1:length(colmap),
  map(i) = ~isempty(colmap{i}) ;
end 
idx_pseudo = find(map) ;


colmap = compute_colocation_map(T.genes,pseudo_genes, target_genome_info) ;

map = zeros(1,length(colmap)) ;
for i=1:length(colmap),
  map(i) = ~isempty(colmap{i}) ;
end 
idx_pseudo = find(map) ;