function blocks = cutOutRegions(fn_in,fn_out,fn_nGASP_test)
  


%-----------------------------

tmp = load(fn_nGASP_test, 'blocks');
nGASP_blocks = tmp.blocks;

is_replaced = zeros(1,length(nGASP_blocks));

for f=1:length(fn_in),
  fprintf('loading predictions from %s...\n', fn_in{f});
  load(fn_in{f}, 'blocks');
  segments = blocks.prediction.segments;
  
  % cut out nGASP test blocks and convert to coordinates
  for b=1:length(nGASP_blocks),
    part_segments =[];
    if isequal(nGASP_blocks(b).chr, blocks.chr) ...
          & isequal(nGASP_blocks(b).strand, blocks.strand),
      
      if blocks.strand=='+'
        start = nGASP_blocks(b).block_start;
        stop  = nGASP_blocks(b).block_end;
      else
        start = length(blocks.genestr)-nGASP_blocks(b).block_start+1;
        stop  = length(blocks.genestr)-nGASP_blocks(b).block_end+1;
      end
      % assert(isequal(blocks.genestr(start:stop),nGASP_blocks(b).genestr));

      s_idx = find(segments(:,1)>start & segments(:,2)<stop);
      part_segments = segments(s_idx,:);
      if blocks.strand=='+'
        part_segments(:,1:2) = part_segments(:,1:2) - start+1; 
      else
        part_segments(:,1:2) = part_segments(:,1:2) - start;       
      end
      if part_segments(1,3)~=0
        part_segments = [[1 part_segments(1,1) 0];part_segments];
      else
        part_segments(1,1)=1;
      end
      if part_segments(end,3)~=0
        part_segments = [part_segments; [part_segments(end,2)  length(nGASP_blocks(b).genestr) 0]];
      else
        part_segments(end,2) = length(nGASP_blocks(b).genestr);
      end
      assert(all(all(part_segments(:,1:2)>0&part_segments(:,1:2)<=length(nGASP_blocks(b).genestr))))
      nGASP_blocks(b).prediction.segments = part_segments;
      assert(is_replaced(b)==0);
      is_replaced(b) = 1;
      
    end
  end
end

assert(all(is_replaced==1));
blocks = nGASP_blocks;
save(fn_out,'blocks')