function draw_figures(res,SN,SP,sources,idx_ref,idx_other,type_names,fname)

  
% CDS_nucleotides, CDS_exons.CDS_transcript, CDS_genes  

% SN=SN./100;
% SP=SP./100;

segments = {'cds_nucleotides','cds_exons','cds_transcripts','genes'};  


num = find(strcmp(type_names,segments{1}));
nuc = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];

num = find(strcmp(type_names,segments{2}));
exon = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];

num = find(strcmp(type_names,segments{3}));
trans = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];

num = find(strcmp(type_names,segments{4}));
gene = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];


figure(1)
subplot(2,2,1)
avg = mean(nuc')';
bar([nuc avg])
h=gca;
title('cds nucleotides');grid on
data = [nuc exon];
a=axis; a(3)= min(data(:))-1.5;a(4)=max(data(:))+0.5;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);

% keyboard
subplot(2,2,2)
avg = mean(exon')';
bar([exon,avg])
h=gca;
title('cds exons');grid on
a=axis; a(3)= min(data(:))-1.5;a(4)=max(data(:))+0.5;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);

subplot(2,2,3)
avg = mean(trans')';
bar([trans avg])
h=gca;
title('cds transcript');grid on
data = [trans gene];
a=axis; a(3)= min(data(:))-1.5;a(4)=max(data(:))+0.5;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);

subplot(2,2,4)
avg = mean(gene')';
bar([gene avg])
title('cds genes');grid on
h=gca;
a=axis; a(3)= min(data(:))-1.5;a(4)=max(data(:))+0.5;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);


if nargin>6
  print( '-depsc2',[fname 'performance.eps']); 
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%TIS, STOP, TSS CLEAVE 

signals={'acc','don','tis','cdsStop','tss','cleave'};
num = find(strcmp(type_names,signals{1}));
acc = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];
num = find(strcmp(type_names,signals{2}));
don = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];
num = find(strcmp(type_names,signals{3}));
tis = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];
num = find(strcmp(type_names,signals{4}));
stop = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];
num = find(strcmp(type_names,signals{5}));
tss = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];
num = find(strcmp(type_names,signals{6}));
cleave = [SN(idx_ref,num)-SN(idx_other,num) SP(idx_ref,num)-SP(idx_other,num)];


figure(2),
subplot(3,2,1)
avg = mean(acc')';
bar([acc avg])
h=gca;
title('Acc');grid on
data = [acc don];
a=axis; a(3)= min(data(:))-2;a(4)=max(data(:))+1;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);

% keyboard
subplot(3,2,2)
avg = mean(don')';
bar([don avg])
h=gca;
title('Don');grid on
a=axis; a(3)= min(data(:))-2;a(4)=max(data(:))+1;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);


subplot(3,2,3)
avg = mean(tis')';
bar([tis avg])
h=gca;
title('tis');grid on
data = [tis stop];
a=axis; a(3)= min(data(:))-2;a(4)=max(data(:))+1;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);

% keyboard
subplot(3,2,4)
avg = mean(stop')';
bar([stop avg])
h=gca;
title('stop');grid on
a=axis; a(3)= min(data(:))-2;a(4)=max(data(:))+1;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);

subplot(3,2,5)
avg = mean(tss')';
bar([tss avg])
h=gca;
title('tss 20');grid on
data = [tss cleave];
a=axis; a(3)= min(data(:))-2;a(4)=max(data(:))+1;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);

subplot(3,2,6)
avg = mean(cleave')';
bar([cleave avg])
h=gca;
title('cleave 20');grid on
a=axis; a(3)= min(data(:))-2;a(4)=max(data(:))+1;axis(a)
text([idx_other]-0.3,ones(1,length(idx_other))*min(data(:))-0.7,'Sn','FontSize', 6);
text([idx_other]-0.07,ones(1,length(idx_other))*min(data(:))-0.7,'Sp','FontSize', 6);
text([idx_other]+0.13,ones(1,length(idx_other))*min(data(:))-0.7,'Avg','FontSize', 6);
set(h,'xTickLABEL',sources([idx_other]),'FontSize', 6);


if nargin>6
  print( '-depsc2',[fname 'end_performance.eps']); 
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%DIST

color={'b-','c-','y-','r-','k-'};
figure(4); subplot(1,2,1); hold on
[y(idx_ref,:),x(idx_ref,:)] = hist(res(idx_ref).tss.dist,[-200:10:200]);
for i=idx_other
  [y(i,:),x(i,:)] = hist(res(i).tss.dist,x(idx_ref,:));
  plot(x(i,2:end-1)',y(i,2:end-1)',color{i})
end
plot(x(idx_ref,2:end-1)',y(idx_ref,2:end-1)',color{5});
hold off
subplot(1,2,1);axis([-200 200 0 200]); grid on
clear x y
title('distance to confirmed tss')

subplot(1,2,2); hold on
[y(idx_ref,:),x(idx_ref,:)] = hist(res(idx_ref).cleave.dist,[-200:10:200]);
for i=idx_other
  [y(i,:),x(i,:)] = hist(res(i).cleave.dist,x(idx_ref,:));
  plot(x(i,2:end-1)',y(i,2:end-1)',color{i});hold on
end
plot(x(idx_ref,2:end-1)',y(idx_ref,2:end-1)',color{5});
hold off
axis([-200 200 0 200]); grid on
title('distance to confirmed cleave')
clear x y
legend({sources{[idx_other idx_ref]}})
if nargin>6
  print( '-depsc2',[fname 'dist.eps']);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

