
PAR.dir = ['/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/'];
PAR.fn_blocks_pre = [PAR.dir '/data/genome_blocks.mat'] ;

if ~exist('blocks_pre', 'var'),
  %load(PAR.fn_blocks_pre) ;
  load /tmp/genome_blocks.mat
  
  blocks_pre = blocks ;
end ;

genome_info=init_genome('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/orig_data/genome.config_500');            

if ~exist('genes', 'var'),
  % load confirmed sequences and reduce to 500 contigs 
  load /fml/ag-raetsch/share/projects/genefinding/P_pacificus/orig_data/confirmed_sequences.mat
  take = zeros(1,length(genes)) ;
  for i=1:length(genes),
    idx = find(ismember(genome_info.contig_names, genes(i).chr)) ;
    if length(idx)==1, 
      if genes(i).strands(1) == '+',
        take(i) = 1 ; 
      else
        take(i) = -1 ;
      end ;
    end ;
    genes(i).chr_idx = idx ;
  end ;
  genes_neg = genes(take==-1) ;
  genes(take<=0)=[] ;
  
  for i=1:length(genes),
    is_SL = zeros(1,length(genes(i).transcripts)) ;
    for j=1:length(genes(i).transcripts),
      idx=strfind(genes(i).transcripts{j}, 'ioAGSL') ;
      if ~isempty(idx),
        is_SL(j) = 1 ;
      end ;
    end
    genes(i).is_SL=is_SL ;
  end ;
end ;


num_preds = [0 0 0 0 0 0 0] ;
len_preds = [0 0 0 0 0 0 0] ;
num_starts = [0 0 0 0 0 0 0] ;
num_start_found = [0 0 0 0 0 0 0] ;
num_start_middle = [0 0 0 0 0 0 0] ;
num_negs = [0 0 0 0 0 0 0] ;
num_neg_found = [0 0 0 0 0 0 0] ;
num_intergenic_found = [0 0 0 0 0 0 0] ;
num_genes = [0 0 0 0 0 0 0] ;

n=0 ;
for block_num=1:998,
  fname105=sprintf('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/predictions/gr_loss_C=1_final_sol10_cor-02-09-2007/pred_genome_%i_cleave=10.5_viterbi_block%i.mat', block_num, block_num) ;
  L=load(fname105);
  n=n+length(L.pred.genes) ;
end ;

for block_num=1:998,
  block_num

  %fn_blocks = sprintf('%s/data/genome_blocks_final_%i.mat', '/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1', block_num) ;
  %load(fn_blocks)
  blocks = blocks_pre(block_num) ;
  if blocks.strand=='-', continue ; end ;

  fname15=sprintf('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/predictions/gr_loss_C=1_final_sol10_cor-02-09-2007/pred_genome_%i_cleave=15.0_viterbi_block%i.mat', block_num, block_num) ;
  fname12=sprintf('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/predictions/gr_loss_C=1_final_sol10_cor-02-09-2007/pred_genome_%i_cleave=12.0_viterbi_block%i.mat', block_num, block_num) ;
  fname105=sprintf('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/predictions/gr_loss_C=1_final_sol10_cor-02-09-2007/pred_genome_%i_cleave=10.5_viterbi_block%i.mat', block_num, block_num) ;
  fname9=sprintf('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/predictions/gr_loss_C=1_final_sol10_cor-02-09-2007/pred_genome_%i_cleave=9.0_viterbi_block%i.mat', block_num, block_num) ;
  fname6=sprintf('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/predictions/gr_loss_C=1_final_sol10_cor-02-09-2007/pred_genome_%i_cleave=6.0_viterbi_block%i.mat', block_num, block_num) ;
  fname3=sprintf('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/predictions/gr_loss_C=1_final_sol10_cor-02-09-2007/pred_genome_%i_cleave=3.0_viterbi_block%i.mat', block_num, block_num) ;
  fname0=sprintf('/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/cat-1/predictions/gr_loss_C=1_final_sol10_cor-02-09-2007/pred_genome_%i_viterbi_block%i.mat', block_num, block_num) ;

  if ~fexist(fname105),%~fexist(fname9) || ~fexist(fname105) ||
                       %~fexist(fname15) || ~fexist(fname12) ||
                       %~fexist(fname9) || ~fexist(fname6) ||
                       %~fexist(fname3) || ~fexist(fname0), 
    continue ; end ;

  for cleave=10.5%[0,3,6,9,10.5,12,15],
    if cleave==0, 
      load(fname0,'pred') ; 
      CC=1 ;
    elseif cleave==3,
      load(fname3,'pred') ;
      CC=2 ;
    elseif cleave==6,
      load(fname6,'pred') ;
      CC=3 ;
    elseif cleave==9,
      load(fname9,'pred') ;
      CC=4 ;
    elseif cleave==10.5,
      load(fname105,'pred') ;
      CC=5 ;
    elseif cleave==12,
      load(fname12,'pred') ;
      CC=6 ;
    elseif cleave==15,
      load(fname15,'pred') ;
      CC=7 ;
    else
      error('haeh?') ;
    end ;
    if isempty(pred.genes{1}), continue; end ;
    blocks.prediction = pred ;

    [block_num, cleave]

    idx=find(ismember({genes_neg(:).chr}, blocks.chr)) ;
    gene_neg_coords = [[genes_neg(idx).start]' [genes_neg(idx).stop]'] ;

    idx=find(ismember({genes(:).chr}, blocks.chr)) ;
    gene_pos_coords = [[genes(idx).start]' [genes(idx).stop]'] ;
    gene_coords = [] ;
    for i=idx,
      if sum(genes(i).is_SL)>1, continue ; end ;
      j=find(genes(i).is_SL,1,'first') ;
      if isempty(j), continue ; end ;
      gene_coords(end+1,:) = [genes(i).exons{j}(1,1) genes(i).exons{j}(end,2) i] ;
    end ;

    pred_coords = [] ;
    for i=1:length(blocks.prediction.genes)
      if isempty(blocks.prediction.genes{i}), break ; end ;
      pred_coords(i,:) = [blocks.prediction.genes{i}(1,1) blocks.prediction.genes{i}(end,2)] ;
      %pred_coords(i,:) = [length(blocks.genestr)-blocks.prediction.genes{i}(end,2) length(blocks.genestr)-blocks.prediction.genes{i}(end,2)] ;
    end 
    num_preds(CC) = num_preds(CC) + size(pred_coords,1) ;
    if ~isempty(pred_coords),
      len_preds(CC) = len_preds(CC) + sum(pred_coords(:,2)-pred_coords(:,1));
    end ;

    num_starts(CC) = num_starts(CC) + size(gene_coords,1) ;
    if ~isempty(pred_coords)
      for i=1:size(gene_coords,1),
        k=find(abs(pred_coords(:,1)-gene_coords(i,1))<100) ;
        if ~isempty(k), num_start_found(CC)=num_start_found(CC)+1 ; end ;
      end 
    end ;

    map = zeros(1,length(blocks.genestr)) ;
    
    for i=1:size(pred_coords,1),
      map(pred_coords(i,1):pred_coords(i,2)) = i ;
    end 
    
    for i=1:size(gene_coords,1),
      if all(map(gene_coords(i,1)-100:gene_coords(i,1)+100)>0)
        num_start_middle(CC) = num_start_middle(CC) + 1 ;
      end ;
    end 
    
    num_negs(CC) = num_negs(CC) + size(gene_neg_coords,1) ;
    for i=1:size(gene_neg_coords,1),
      if any(map(gene_neg_coords(i,1):gene_neg_coords(i,2))>0)
        num_neg_found(CC) = num_neg_found(CC) + 1 ;
      end ;
    end ;

    num_genes(CC) = num_genes(CC) + size(gene_pos_coords,1) ;
    for i=1:size(gene_pos_coords,1),
      if mean(map(gene_pos_coords(i,1):gene_pos_coords(i,2))==0)>0.5
        num_intergenic_found(CC) = num_intergenic_found(CC) + 1 ;
        %keyboard
      end ;
    end ;

  end ;

  num_preds
  len_preds./num_preds
  num_starts
  num_start_found
  num_start_middle
  num_negs
  num_neg_found
  num_genes
  num_intergenic_found
end 

num_preds

disp('len_preds./num_preds')
len_preds./num_preds

disp('num_start_found./num_starts')
num_start_found./num_starts

disp('num_start_middle./num_starts')
num_start_middle./num_starts

disp('num_neg_found./num_negs') 
num_neg_found./num_negs

disp('num_intergenic_found./num_genes')
num_intergenic_found./num_genes

close all
subplot(2,2,1)
plot([0,3,6,9,10.5,12,15], num_start_found./num_starts)
title('num\_start\_found./num\_starts') ;

subplot(2,2,2)
plot([0,3,6,9,10.5,12,15], num_start_middle./num_starts)
title('num\_start\_middle./num\_starts') ;

subplot(2,2,3)
plot([0,3,6,9,10.5,12,15], num_neg_found./num_negs)
title('num\_neg\_found./num\_negs') ;

subplot(2,2,4)
plot([0,3,6,9,10.5,12,15], num_intergenic_found./num_genes)
title('num\_intergenic\_found./num\_genes') ;


if 0,
num_found = 0 ;
for i=1:size(gene_coords,1),
  if any(map(gene_coords(i,1):gene_coords(i,2))>0)
    num_found = num_found + 1 ;

    found_idx = setdiff(unique(map(gene_coords(i,1):gene_coords(i,2))),0) ;
    gene=genes(gene_coords(i,3)) ;
    gene.transcripts{end+1} = 'pred' ;
    exons = blocks.prediction.genes{found_idx} ;
    gene.exons{end+1} = exons(exons(:,3)==3,:) ;

    close all; viewsplicegraph(gene); drawnow ; print -depsc2 ~/Desktop/gene.eps
    pause
  end ;
end 

end

