addpath ~/svn/projects/genefinding/data_processing_sensors/
addpath ~/svn/tools/genomes/
addpath ~/svn/projects/splicing/utils
addpath ~/svn/projects/splicing/splicegraphs/
addpath ~/svn/projects/splicing/splicegraphs/detect_altsplice/


cleave = 6

%base_dir = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1//test_predictions/'...
%            'gr_all_new_loss_C=1_range-28-08-2007/'];
base_dir = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1//test_predictions/'...
            'new_signals_new_labels_better_all-17-11-2007/'];
for i=1:12,
  fn_in{i} = sprintf('%spred_contig_corrected%i_cleave%1.2f.mat', base_dir,i, cleave);
  fn_out1{i} = sprintf('%sconcat_contig%i_cleave%1.2f.mat',base_dir,i, cleave);
  fn_out1g{i} = sprintf('%sgenes_contig%i_cleave%1.2f.mat',base_dir,i, cleave); 
  fn_out2{i} = sprintf('%sshiftedWS160_contig%i_cleave%1.2f.mat',base_dir,i, cleave);
  fn_out2g{i} = sprintf('%sgenes_shiftedWS160_contig%i_cleave%1.2f.mat',base_dir,i, cleave);
end

fn_nGASP_test = ['/fml/ag-raetsch/share/projects/nGASP/LSL/cat-1/' ...
                 'test_data/blocks_2006-12-30-final.mat'];
fn_out_nGASP_genes = sprintf('%snGASP_genes_cleave%1.2f.mat',base_dir, cleave);
fn_out_nGASP = sprintf('%snGASP_cleave%1.2f.mat',base_dir, cleave);
fn_out_genome_genes = sprintf('%sgenome_genes_cleave%1.2f.mat',base_dir, cleave);

old_config = '~/svn/projects/nGASP/eval/genome.config' ;
new_config = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/orig_data/genome.config'

old_genome_info = init_genome(old_config);
new_genome_info = init_genome(new_config);

%load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/train/gr_all_new_loss_C=1_range-28-08-2007/train.mat','PAR')
load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/train/new_signals_new_labels_better_all-17-11-2007/train.mat', 'PAR') ;
model = PAR.model; clear PAR                     

%%%

reconcatinate_blocks(fn_in,fn_out1,model,new_genome_info);
for j=1:length(fn_out1)
  load(fn_out1{j},'blocks');
  genes = blocks2genes(blocks,model,'prediction',new_genome_info);
  save(fn_out1g{j},'genes');
end
map_predictionsToDifferentAnno(fn_out1,fn_out2,old_genome_info,new_genome_info);
for j=1:length(fn_out2)
  load(fn_out2{j},'blocks');
  genes = blocks2genes(blocks,model,'prediction',old_genome_info);
  save(fn_out2g{j},'genes')
end

blocks = cutOutRegions(fn_out2,fn_out_nGASP,fn_nGASP_test)
genes = blocks2genes(blocks,model,'prediction',old_genome_info);
save(fn_out_nGASP_genes,'genes')                     


%% EVALUATE ON NGASP

load('/fml/ag-raetsch/share/projects/nGASP/test_regions.mat')
regions=test_regions;

L=load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_C_new_complete_new.mat')
res = evaluate_predictions(regions,L.genes,genes,old_genome_info,0);
save(fn_out_nGASP_genes,'-append','res')     

% lookfor res.wrong_ids


%% EVALUATE ON GENOME

load(['/fml/ag-raetsch/share/projects/genefinding/C_elegans/' ...
      'genome_data/trivial_regions.mat'],'trivial_regions')
L_anno=load('~raetsch/anno_WS171_final.mat')
for j=1:length(L_anno.genes)
  L_anno.genes(j).id=j;
end

for j=1:length(trivial_regions)
  L=load(fn_out1g{j},'genes');
  if j==1, 
    genes = L.genes ;
  else
    genes = [L.genes genes] ;
  end ;
end ;
for j=1:length(genes)
  genes(j).id=j;
end
save_struct(fn_out_genome_genes, genes, 'genes') ;

for j=1:length(trivial_regions)
  fprintf('%s %c\n', trivial_regions(j).chr, trivial_regions(j).strand) ;
  pred_genes = genes(ismember({genes.chr}, trivial_regions(j).chr) & [genes.strand]==trivial_regions(j).strand) ;
  anno_genes = L_anno.genes(ismember({L_anno.genes.chr}, trivial_regions(j).chr) & [L_anno.genes.strand]==trivial_regions(j).strand) ;
  res_genome(j) = evaluate_predictions(trivial_regions(j),anno_genes,pred_genes,new_genome_info,0);
end

new_genes_idx = [] ;
for i=1:length(res_genome)
  new_genes_idx = [new_genes_idx res_genome(i).genes.wrong_ids] ;
end ;

missing_genes_idx = [] ;
missing_genes_num= [] ;
for i=1:length(res_genome)
  missing_genes_idx = [missing_genes_idx res_genome(i).genes.missing_ids] ;
  missing_genes_num = [missing_genes_num; res_genome(i).genes.missing_conf res_genome(i).genes.missing_partconf res_genome(i).genes.missing_unconf] ;
end ;

save(fn_out_genome_genes,'-append','res_genome','new_genes_idx')     








% look for pseudo genes

load(['/fml/ag-raetsch/share/projects/genefinding/C_elegans/' ...
      'genome_data/trivial_regions.mat'],'trivial_regions')
L_anno=load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/orig_data/pseudogenes.mat') ;
%L_anno=load('~raetsch/anno_WS171_final.mat')
for j=1:length(L_anno.genes)
  L_anno.genes(j).id=j;
end

for j=1:length(trivial_regions)
  L=load(fn_out1g{j},'genes');
  if j==1, 
    genes = L.genes ;
  else
    genes = [L.genes genes] ;
  end ;
end ;
for j=1:length(genes)
  genes(j).id=j;
end
save_struct(fn_out_genome_genes, genes, 'genes') ;

for j=1:length(trivial_regions)
  fprintf('%s %c\n', trivial_regions(j).chr, trivial_regions(j).strand) ;
  pred_genes = genes(ismember({genes.chr}, trivial_regions(j).chr) & [genes.strand]==trivial_regions(j).strand) ;
  anno_genes = L_anno.genes(ismember({L_anno.genes.chr}, trivial_regions(j).chr) & [L_anno.genes.strand]==trivial_regions(j).strand) ;
  res_genome_pseudo(j) = evaluate_predictions(trivial_regions(j),anno_genes,pred_genes,new_genome_info,0);
end

non_pseudo_genes_idx = [] ;
for i=1:length(res_genome)
  non_pseudo_genes_idx = [non_pseudo_genes_idx res_genome_pseudo(i).genes.wrong_ids] ;
end ;

save(fn_out_genome_genes,'-append','res_genome_pseudo','pseudo_genes_idx')     

fname='/fml/ag-raetsch/share/databases/elegans_WS170/elegansWS171.gff3_RNA' ;
ncgenes = parse_gff3_RNA(fname, '~/tmp.mat') ;

colmap = compute_colocation_map(ncgenes,genes,new_genome_info) ;
map = zeros(1,length(colmap)) ;
for i=1:length(colmap),
  map(i) = ~isempty(colmap{i}) ;
end 
idx_nc = find(map) ;
