paths

dir =  '/fml/ag-raetsch/share/projects/genefinding/';
ext2 = '/lsl/cat-3_newmodel/predictions/'

fn_new = {[dir 'C_remanei/50contig_2/elegansModel/' ext2]...
          [dir 'C_briggsae/exp4/elegansModel/' ext2],...
          [dir 'C_brenneri/50contig/elegansModel' ext2],...
          [dir 'B_malayi/elegansModel/exp1a' ext2],...
          [dir 'C_japonica/50contig/elegansModel' ext2],...
          [dir 'C_elegans/WS180/exp1/' ext2]};

num=6;


load([fn_new{num} 'pred_1+_cleave6.00.mat'],'PAR');
%%%%%%%%%%%%%%%%%%%%%%%%%
% quality controll
%%%%%%%%%%%%%%%%%%%%%%%%%

GF ={'mGene new','augustus','fgenesh','jigsaw','mgene'};

organism = PAR.organism.name(3:end);
if isequal(organism,'malayi')
  organism = 'brugia'
end

%%%%%%%%%%%%%%%%
%% ALL OLD ESTs
%%%%%%%%%%%%%%%%
fn_est = [PAR.FN.input.fn_genes_conf_orig(1:end-4) 'ests_only.mat'];
if fexist(fn_est)
  Old_all = load(fn_est);
  genome_info = Old_all.genome_info;
end
%%%%%%%%%%%%%%%%
%% ALL NEW ESTs
%%%%%%%%%%%%%%%%

fn_est = [PAR.FN.input.fn_genes_conf_orig(1:end-4) '_new_ests_only.mat'];
if fexist(fn_est)
  New_all  = load(fn_est);
  genome_info = New_all.genome_info;
end

%%%%%%%%%%%%%%%%
%% find new genes
%%%%%%%%%%%%%%%%
if exist('New_all') & isfield(New_all,'genes_est')&exist('Old_all') & isfield(Old_all,'genes_est')
  colmap = compute_colocation_map(Old_all.genes_est, New_all.genes_est, genome_info,0) ;
  ii=find(cellfun('isempty',colmap));
  New.genes_est = New_all.genes_est(ii);
  ii2 = setdiff([1:length(New_all.genes_est)],ii);
  Old.genes_est = New_all.genes_est(ii2);
elseif exist('New_all') & isfield(New_all,'genes_est')
  New = New_all;
  clear New_all
elseif exist('Old_all') & isfield(Old_all,'genes_est')
  Old.genes_est = Old_all.genes_est;
end

%%%%%%%%%%%%%%%%
%%%Annotation
%%%%%%%%%%%%%%%%
fn_anno=['/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/' ...
        'orig_data/annotated_genes.mat'];
if fexist(fn_anno)
  Anno=load(fn_anno);
  load(PAR.FN.input.fn_test_regions);
end

for i=1:length(Anno.genes)
  if isempty(Anno.genes(i).transcript_status)
    Anno.genes(i).status = -1;
    keyboard
  else
    Anno.genes(i).status = max(Anno.genes(i).transcript_status);
  end
  Anno.genes(i).id = i;
end

%%%%%%%%%%%%%%%%
%%%Predictions
%%%%%%%%%%%%%%%%

for i=1:length(GF)
  if i==1
    fn_gf = sprintf('%s/pred_genes_cleave%1.2f_final.mat',PAR.FN.output_lsl.fn_pred,PAR.method.par_ms.cleave_offset )
  else
    fn_gf = sprintf('%s%s/current_predictions/wormbase/%s.%s.mat',PAR.FN.input_dir,PAR.organism.name,organism,GF{i})
  end
  P(i) = load(fn_gf,'genes');
end


for i=1:length(GF)
  for j=1:length(P(i).genes); P(i).genes(j).is_valid=1;end
  if 0
  if exist('New_all')
    res_all(i) = prediction_quality_controll(New_all.genes_est,P(i).genes,genome_info)
  end
  if exist('New')
    res_new(i) = prediction_quality_controll(New.genes_est,P(i).genes,genome_info)
  end
  if exist('Old')
    res_old(i) = prediction_quality_controll(Old.genes_est,P(i).genes,genome_info)
  end
  end
  % keyboard
  if exist('Anno')
    N(i).name = GF{i};
    N(i).colmap_P = compute_colocation_map(Anno.genes, P(i).genes, genome_info,0)  ;
    N(i).idx_new = find(cellfun('isempty',N(i).colmap_P));
    for j=setdiff([1:length(GF)],i)
      N(i).(['colmap_' strrep(GF{j}, ' ', '')]) = compute_colocation_map(P(j).genes, P(i).genes(N(i).idx_new), genome_info,0)  ;
      N(i).COL(j,:) = ~cellfun('isempty', N(i).(['colmap_' strrep(GF{j},' ', '')]));
    end
    [N(i).coverage(2,:) N(i).coverage(1,:)] = hist(sum(N(i).COL(1:4,:)),[0:4]);
    
    M(i).idx_conf = find([Anno.genes.status]==1);
    M(i).colmap_conf = compute_colocation_map(P(i).genes, Anno.genes(M(i).idx_conf), genome_info,0)  ;
    M(i).idx_missed_conf = find(cellfun('isempty',M(i).colmap_conf));
    
    M(i).idx_partconf = find([Anno.genes.status]==0);
    M(i).colmap_part = compute_colocation_map(P(i).genes, Anno.genes(M(i).idx_partconf), genome_info,0)  ;
    M(i).idx_missed_part = find(cellfun('isempty',M(i).colmap_part));

    M(i).idx_unconf = find([Anno.genes.status]==-1);
    M(i).colmap_unconf = compute_colocation_map(P(i).genes, Anno.genes(M(i).idx_unconf), genome_info,0)  ;
    M(i).idx_missed_unconf = find(cellfun('isempty',M(i).colmap_unconf));
   
    % res_anno(i) = evaluate_predictions(test_regions,Anno.genes,P(i).genes,genome_info,0);
  end
end
for i=[2 3 4 1]
  fprintf('%i (%.1f\\%%) & %i (%.1f\\%%) & %i (%.1f\\%%) & %i (%.1f\\%%) \n',...
          length(M(i).idx_missed_conf), length(M(i).idx_missed_conf)/length(M(i).idx_conf)*100, ...
          length(M(i).idx_missed_part), length(M(i).idx_missed_part)/length(M(i).idx_partconf)*100, ...
          length(M(i).idx_missed_unconf), length(M(i).idx_missed_unconf)/length(M(i).idx_unconf)*100, ...
          sum([length(M(i).idx_missed_conf) length(M(i).idx_missed_part) length(M(i).idx_missed_unconf)]),...
          sum([length(M(i).idx_missed_conf) length(M(i).idx_missed_part) length(M(i).idx_missed_unconf)])/sum([length(M(i).idx_conf) length(M(i).idx_partconf) length(M(i).idx_unconf)])*100)
end

for i=[2 3 4 1]
  fprintf('%i (%.1f\\%%) & %i (%.1f\\%%) & %i (%.1f\\%%) & %i (%.1f\\%%) & %i \n',...
          N(i).coverage(2,1),N(i).coverage(2,1)/sum(N(i).coverage(2,:))*100,...
          N(i).coverage(2,2),N(i).coverage(2,2)/sum(N(i).coverage(2,:))*100,...
          N(i).coverage(2,3),N(i).coverage(2,3)/sum(N(i).coverage(2,:))*100,...
          N(i).coverage(2,4),N(i).coverage(2,4)/sum(N(i).coverage(2,:))*100,...
          sum(N(i).coverage(2,:)))
end



for i=[2 3 4 1]
  fprintf('%i & %i & %i & %i & %i \n',N(i).coverage(2,1),N(i).coverage(2,2),N(i).coverage(2,3),N(i).coverage(2,4),sum(N(i).coverage(2,:)))
end


fn_result = sprintf('%s%s/current_predictions/wormbase/results.mat',PAR.FN.input_dir,PAR.organism.name)
save(fn_result,'res_all','res_new','res_old','res_anno');

idx = [3 2 4 1];
idx=[1 2]
print_result_quality_controll(res_all,GF,idx,genome_info)
print_result_quality_controll(res_new,GF,idx,genome_info)
print_result_quality_controll(res_old,GF,idx,genome_info)

colmap = compute_colocation_map(Anno.genes, P.genes, genome_info,0)  

%%%%%%%%%%%
plot_quality_controll(res);






%%% C elegans


A=load(['/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/' ...
        'orig_data/annotated_genes.mat'])

for i=1:length(A.genes);A.genes(i).is_valid=1;end
r = prediction_quality_controll(Old.genes_est,A.genes,genome_info)

for i=1:length(GF)
  if i==1
    fn_gf = sprintf('%s/pred_genes_cleave%1.2f_final.mat',PAR.FN.output_lsl.fn_pred,PAR.method.par_ms.cleave_offset );
  else
    fn_gf = sprintf('%s%s/current_predictions/wormbase/%s.%s.mat',PAR.FN.input_dir,PAR.organism.name,organism,GF{i})
  end
  P = load(fn_gf,'genes');
  
  res_cat3_comp(i) = evaluate_predictions(test_regions,A.genes,genes_pred,genome_info,0);
  res_cat3_conf(i) = evaluate_predictions(test_regions,genes_anno_confirmed,genes_pred,genome_info,0);
end

%%%%%%%%%%%%%

evaluate_predictions(regions,genes_anno,genes_pred,genome_info,end_tol,run_local,fn);