
% --- organism
organismName = 'C_elegans';
nofContigs = 12;
version = '180';
maxOperonLength = 1e6;

% --- version
base_dir = [ '/fml/ag-raetsch/share/projects/genefinding/', organismName, '/WS', version ];
gff_dir  = [ '/fml/ag-raetsch/share/databases/genomes/',    organismName, '/elegans_WS', version ];
switch( version )
 case '170'
  cleave = 6;
  fn_par  = [ base_dir, '/lsl/cat-1/train/new_signals_new_labels_better_all-17-11-2007/train.mat' ];
  out_dir = [ base_dir, '/lsl/cat-1/test_predictions/new_signals_new_labels_better_all-17-11-2007' ];
 case '180'
  fn_par  = [ base_dir, '/exp1/lsl/cat-3/predictions/PAR.mat' ];
  %out_dir = [ base_dir, '/exp1/lsl/cat-3/predictions/GS-07-12-2007' ];
  out_dir = [ base_dir, '/exp1/lsl/cat-3/predictions/old' ];
  gff_dir = [ gff_dir, '/annotation' ];
  chrMapKeys = { 'contig0', 'contig1', 'contig2', 'contig3', 'contig4', 'contig5' };
  chrMapVals = { 'I', 'II', 'III', 'IV', 'V', 'X' };
 otherwise
  error( 'unknown genome annotation version' );
end;

% --- files & dirs
mGene = 'mGene';
assert( organismName(2) == '_' );
annot = sprintf( '%sWS%s', organismName(3:end), version );
suffix = 'gff3';
tmp_dir = [ 'data_processing_lsl/operons/', annot ];
fn_gff = sprintf( '%s/%s.%s', gff_dir, annot, suffix );
fn_triv = [ base_dir, '/genome_data/trivial_regions.mat' ];
fn_conf = [ base_dir, '/orig_data/annotated_genes.mat' ];


