
%%ON NGASP
file_results='/fml/ag-raetsch/share/projects/nGASP/nGASP_Predictions_curated/evaluation_results.mat'
load(file_results,'res_cat1','sources_cat1')

load('/fml/ag-raetsch/share/projects/nGASP/test_regions.mat')
regions=test_regions;
load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_CNEW_complete.mat')
genes_anno = genes;

config = '~/svn/projects/nGASP/eval/genome.config' ;

genome_info = init_genome(config);


%%%
cleaves = 6.0;
base_dir = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/test_predictions/'...
            'new_signals_new_labels_better_all-17-11-2007/NEWnGASP_genes_cleave']
load(sprintf('%s%1.2f.mat',base_dir,cleaves),'genes')
genes_pred = genes;
sources_cat1 = {sources_cat1{:}, sprintf('cleave %1.1f',cleaves)}
res_cat1(end+1) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);

%%%%%%
cleaves = [5.5, 6.0 6.5];
base_dir = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/test_predictions/'...
            'new_signals_new_labels_better_all-17-11-2007/NEWnGASP_genes_cleave']
for i=1:length(cleaves)
  load(sprintf('%s%1.2f.mat',base_dir,cleaves(i)),'genes')
  genes_pred = genes;
  sources_cat1 = {sources_cat1{:}, sprintf('New all cleave %1.1f',cleaves(i))}
  res_cat1(end+1) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
end

%%%

cleaves = [5.5, 6.0 6.5];
base_dir = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/test_predictions/'...
            'new_signals_new_labels_better-17-11-2007/NEWnGASP_genes_cleave']
for i=1:length(cleaves)
  load(sprintf('%s%1.2f.mat',base_dir,cleaves(i)),'genes')
  genes_pred = genes;
  sources_cat1 = {sources_cat1{:}, sprintf('New all cleave%1.1f',cleaves(i))}
  res_cat1(end+1) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
end


%%%%%%%%%%

type_names={'cds_nucleotides','nucleotides','cds_exons','exons', ...
            'cds_transcripts','transcripts','genes','tis','stop','tss50','tss250','tss1000','cleave50','cleave250','cleave1000'};


for i=1:length(sources_cat1)
  for j=1:9
    MC1(i,j) = res_cat1(i).(type_names{j}).mean_SNSP ;
  end
  MC1(i,10) = res_cat1(i).tss.mean_SNSP50;
  MC1(i,11) = res_cat1(i).tss.mean_SNSP250;
  MC1(i,12) = res_cat1(i).tss.mean_SNSP1000;
  MC1(i,13) = res_cat1(i).cleave.mean_SNSP50;
  MC1(i,14) = res_cat1(i).cleave.mean_SNSP250;
  MC1(i,15) = res_cat1(i).cleave.mean_SNSP1000;
  missing(i,1) =res_cat1(i).genes.missing ;
  missing(i,2) =res_cat1(i).genes.missing_conf./res_cat1(i).genes.missing ;
  missing(i,3) =res_cat1(i).genes.missing_partconf./res_cat1(i).genes.missing;
  missing(i,4) =res_cat1(i).genes.missing_unconf./res_cat1(i).genes.missing ;
  wrong(i) = res_cat1(i).genes.wrong ;
end



[tmp,idx] = sort(MC1(:,3),'descend');
MC1 = MC1(idx(1:8),:);
missing = missing(idx(1:8),:);
wrong = wrong(idx(1:8));
sources = sources_cat1(idx(1:8));


%%%CDS 
idx_cds=[1 3 5];               
figure(1); grid on
bar(MC1(:,idx_cds)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
legend(sources,'Location','BestOutside')
h=gca;
a=axis; a(3)=0;a(4)=1;axis(a);grid on
set(h,'xTickLABEL',{type_names{[idx_cds]}});



%%% mRNA
idx_all=[2 4];   
figure(3); grid on
bar(MC1(:,idx_all)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_all}});;grid on

%%%START STOP
idx_starts=[8:9];
figure(4); grid on
bar(MC1(:,idx_starts)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a);grid on
set(h,'xTickLABEL',{type_names{idx_starts}});
title('A');

%%%TSS CLEAVE 50
idx_starts=[10,13];
figure(5)
bar(MC1(:,idx_starts)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_starts}});
title('B');


%%%TSS CLEAVE 250
idx_starts=[11 14];
figure(6)
bar(MC1(:,idx_starts)')
%title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_starts}});
title('C');

%%%TSS CLEAVE 1000
idx_starts=[12 15];
figure(7)
bar(MC1(:,idx_starts)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_starts}});
title('D');

