function evaluate_predictions4paper

%max_tss_dist=100;
%max_cleave_dist =100;
file_results='/fml/ag-raetsch/share/projects/nGASP/nGASP_Predictions_curated/evaluation_results_new.mat'
if 0% fexist(file_results)
  load(file_results,'res_cat1','sources_cat1')
else
  load('/fml/ag-raetsch/share/projects/nGASP/test_regions.mat')
  regions=test_regions;
  load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_C_complete.mat')
  genes_anno = genes;
  
  genome_info = init_genome('~/svn/projects/nGASP/eval/genome.config') ;
  
  dir = '/fml/ag-raetsch/share/projects/nGASP/nGASP_Predictions_curated/';
  files_cat1 = {'MGENE/G3A_cat1_ver1'};
  file_mgene_new_cleave6 = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/test_predictions/gr_old_all_loss_C=1-28-08-2007/genes_cleave6.mat';
  file_mgene_new_new = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/test_predictions/gr_all_new_loss_C=1_range-28-08-2007/genes_pred_nGASP_shiftedWS160_cleave12.70.mat'
  sources_cat1 = {'MGENE','MGENE NEW','MGENE NewSigUncorr747'};
  
  for i=1: length(files_cat1)
    load(sprintf('%s%s_complete.mat',dir,files_cat1{i}))
    genes_pred=genes;
    fprintf('\n\n%s\n',sources_cat1{i})
    res_cat1(i) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
  end
  load(file_mgene_new_cleave6)
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat1{i+1})
  res_cat1(i+1) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
  
  load(file_mgene_new_cleave12)
  genes_pred=genes;
  load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_C_new_complete_new.mat')
  genes_anno = genes;
  fprintf('\n\n%s\n',sources_cat1{i+2})
  res_cat1(i+2) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
  save(file_results,'res_cat1','sources_cat1')
end

type_names={'cds_nucleotides','nucleotides','cds_exons','exons', ...
            'cds_transcripts','transcripts','genes','tis','stop','tss50','tss250','tss1000','cleave50','cleave250','cleave1000'};
%

for i=1:length(sources_cat1)
  for j=1:9
    MC1(i,j) = res_cat1(i).(type_names{j}).mean_SNSP ;
  end
  MC1(i,10) = res_cat1(i).tss.mean_SNSP50;
  MC1(i,11) = res_cat1(i).tss.mean_SNSP250;
  MC1(i,12) = res_cat1(i).tss.mean_SNSP1000;
  MC1(i,13) = res_cat1(i).cleave.mean_SNSP50;
  MC1(i,14) = res_cat1(i).cleave.mean_SNSP250;
  MC1(i,15) = res_cat1(i).cleave.mean_SNSP1000;
  missing(i,1) =res_cat1(i).genes.missing ;
  missing(i,2) =res_cat1(i).genes.missing_conf./res_cat1(i).genes.missing ;
  missing(i,3) =res_cat1(i).genes.missing_partconf./res_cat1(i).genes.missing;
  missing(i,4) =res_cat1(i).genes.missing_unconf./res_cat1(i).genes.missing ;
  wrong(i) = res_cat1(i).genes.wrong ;
end



[tmp,idx] = sort(MC1(:,3),'descend');
MC1 = MC1(idx,:);
missing = missing(idx,:);
wrong = wrong(idx);
sources = sources_cat1(idx);

idx_cds=[1 3 5];               
figure(1)
bar(MC1(:,idx_cds)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
legend(sources,'Location','BestOutside')
h=gca;
a=axis; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{[idx_cds]}});

idx_cds=[1 3 5];               
figure(2)
bar(MC1(:,idx_cds)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
%legend(sources,'Location','BestOutside')
h=gca;
a=axis; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{[idx_cds]}});
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_cds1.eps');

if 0
idx_cds=[1 3 5 7];               
figure(2)
bar(MC1(:,idx_cds)')
title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;a=axis; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_cds}});
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_cds2.eps');
end

idx_all=[2 4];   
figure(3)
bar(MC1(:,idx_all)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_all}});
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_all.eps');

idx_starts=[8:9];
figure(4)
bar(MC1(:,idx_starts)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_starts}});
title('A');
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_ends_1.eps');

idx_starts=[10,13];
figure(5)
bar(MC1(:,idx_starts)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_starts}});
title('B');
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_ends_2.eps');


idx_starts=[11 14];
figure(6)
bar(MC1(:,idx_starts)')
%title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_starts}});
title('C');
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_ends_3.eps');

idx_starts=[12 15];
figure(7)
bar(MC1(:,idx_starts)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_starts}});
title('D');
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_ends_4.eps');

if 0
figure(7)
bar(missing)
% title('CAT 1 all');
ylabel('nb of missing genes/ nb of wrong genes');
% legend(sources,'Location','BestOutside')
h=gca;
set(h,'xTickLABEL');
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_missing.eps');
end

keyboard
return
%%%% CAT 2 LOOK ON ALL GENES FIRST

files_cat2 = {'EUGENE/EuGene_cat2_ver1','MGENE/G3A_cat2_ver1a','MGENE/G3A_cat2_ver2a',...
              'SGP2/SGP2'};%NSCAN 

sources_cat2 = {'EUGENE','MGENE 2.1a','MGENE 2.2a',...
              'SGP2'};%NSCAN 

for i=1:length(files_cat2)
  load(sprintf('%s%s_complete.mat',dir,files_cat2{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat2{i})
  res2(i) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
end
%%%%
for i=1:length(sources_cat2)
  for j=1:length(type_names)
    MC2(i,j) = [mean([res2(i).(type_names{j}).SN,res2(i).(type_names{j}).SP]) ];
  end
end

[tmp,idx] = sort(MC2(:,3),'descend');
MC2 = MC2(idx,:);
sources = sources_cat2(idx);

figure(2)
bar(MC2(:,[1 3 5])')
title('CAT 2 all');
ylabel('mean(sensitivity,specificity)');
legend(sources,'Location','BestOutside')
h=gca;
set(h,'xTickLABEL',type_names([1 3 5]));
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/CAT_2.eps');

%%%% CAT 3 LOOK ON ALL GENES FIRST

for i=1:length(files_cat3)
  load(sprintf('%s%s_complete.mat',dir,files_cat3{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat3{i})
  res3(i) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
end
%%%%
for i=1:length(sources_cat3)
  for j=1:length(type_names)
    MC3(i,j) = [mean([res3(i).(type_names{j}).SN,res3(i).(type_names{j}).SP]) ];
  end
end

[tmp,idx] = sort(MC3(:,1),'descend');
MC3 = MC3(idx,:);
sources = sources_cat3(idx);

figure(3)
bar(MC3(:,[1 3 5])')
title('CAT 3 all');
ylabel('mean(sensitivity,specificity)');
legend(sources,'Location','BestOutside')
h=gca;
set(h,'xTickLABEL',type_names([1 3 5]));
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/CAT_3.eps');


return














%%%% LOOK ON CONFIRMED GENES
[tmp,idx1,idx2] = intersect({genes_anno.name},{genes_conf.name});
assert(length(idx2)==length(genes_conf))
genes_anno2 = genes_anno;
for j=idx1
  genes_anno2(j)=genes_conf(idx2(idx1==j));
  assert(all(genes_anno2(j).transcript_status))
end
for j=1:length(genes_anno2)
  if ismember(j,idx1)
    genes_anno2(j).mask_on=0;
  else
    genes_anno2(j).mask_on=1;
  end
end
for i=1:length(files_cat1)
  load(sprintf('%s%s_complete.mat',dir,files_cat1{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat1{i})
  res2(i) = evaluate_predictions(regions,genes_anno2,genes_pred,genome_info);
end

for i=1:length(files_cat1)
  for j=1:length(type_names)
    MC2(i,j) = [mean([res2(i).(type_names{j}).SN,res2(i).(type_names{j}).SP]) ];
  end
end
[tmp,idx] = sort(MC2(:,1),'descend');
MC2 = MC2(idx,:);
sources = sources_cat1 (idx);

figure(2)
bar(MC2')
title('CAT 1 confirmed');
ylabel('mean(sensitivity,specificity)');
legend(sources)
h=gca;
set(h,'xTickLABEL',type_names);


%%%% LOOK ON PARTIALLY CONFIRMED GENES
[tmp,idx1,idx2] = intersect({genes_anno.name},{genes_part.name});
assert(length(idx2)==length(genes_part))
genes_anno3 = genes_anno;
for j=idx1
  genes_anno3(j)=genes_part(idx2(idx1==j));
end
for j=1:length(genes_anno3)
  if ismember(j,idx1)
    genes_anno3(j).mask_on=0;
  else
    genes_anno3(j).mask_on=1;
  end
end
for i=1:length(files_cat1)
  load(sprintf('%s%s_complete.mat',dir,files_cat1{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat1{i})
  res3(i) = evaluate_predictions(regions,genes_anno3,genes_pred,genome_info);
end

for i=1:length(files_cat1)
  for j=1:length(type_names)
    MC3(i,j) = [mean([res3(i).(type_names{j}).SN,res3(i).(type_names{j}).SP]) ];
  end
end
[tmp,idx] = sort(MC3(:,1),'descend');
MC3 = MC3(idx,:);
sources = sources_cat1 (idx);

figure(3)
bar(MC3')
title('CAT 1 partially confirmed');
ylabel('mean(sensitivity,specificity)');
legend(sources)
h=gca;
set(h,'xTickLABEL',type_names);

%%%% LOOK ON UNCONFIRMED GENES
[tmp,idx1,idx2] = intersect({genes_anno.name},{genes_part.name});
assert(length(idx2)==length(genes_part))
[tmp,idx3,idx4] = intersect({genes_anno.name},{genes_conf.name});
assert(length(idx4)==length(genes_conf))

genes_anno4 = genes_anno;

for j=1:length(genes_anno4)
  if ismember(j,[idx1 idx4])
    genes_anno4(j).mask_on=1;
  else
    genes_anno4(j).mask_on=0;
  end
end

for i=1:length(files_cat1)
  load(sprintf('%s%s_complete.mat',dir,files_cat1{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat1{i})    
  res4(i) = evaluate_predictions(regions,genes_anno4,genes_pred,genome_info);
end

for i=1:length(files_cat1)
  for j=1:length(type_names)
    MC4(i,j) = [mean([res4(i).(type_names{j}).SN,res4(i).(type_names{j}).SP]) ];
  end
end
[tmp,idx] = sort(MC4(:,1),'descend');
MC4 = MC4(idx,:);
sources = sources_cat1 (idx);

figure(4)
bar(MC4')
title('CAT 1 unconfirmed');
ylabel('mean(sensitivity,specificity)');
legend(sources)
h=gca;
set(h,'xTickLABEL',type_names);

figure(5)
bar(MC2'-MC4')
title('CAT 1 diff: conf - unconf');
ylabel('mean(sensitivity,specificity)');
legend(sources_cat1)
h=gca;
set(h,'xTickLABEL',type_names);



%%%%%%%%%% CHECK REPEATS

repeat_chr = [genes.chr_num];

overlap=[];overlap_genes=[];
for i=1:length(genes)
  gene=genes(i);
  rep=repeats(repeat_chr==gene.chr_num);
  rep = rep([rep.start]<=gene.stop &[rep.stop]>=gene.start);
  overlap=[overlap [rep.id]];
  if ~isempty(rep)
    overlap_genes=[overlap_genes i];
    viewsplicegraph(gene);hold on
    for j=1:length(rep)
      plot([rep(j).start rep(j).stop],[1 1])
    end
    keyboard
  end
end