function evaluate_predictions4paper

%max_tss_dist=100;
%max_cleave_dist =100;
file_results='/fml/ag-raetsch/share/projects/nGASP/nGASP_Predictions_curated/evaluation_results.mat'
load(file_results,'res_cat1','sources_cat1')

load('/fml/ag-raetsch/share/projects/nGASP/test_regions.mat')
regions=test_regions;
load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_C_new_complete_new.mat')
genes_anno = genes;
load(['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/test_predictions/'...
      'new_signals_new_labels_better_all-17-11-2007/nGASP_genes_cleave6.00.mat'],'genes')
genes_pred = genes;
genome_info = init_genome('~/svn/projects/nGASP/eval/genome.config') ;
sources_cat1 ={sources_cat1{:},'MGENE ALL'};

res_cat1(end+1) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
type_names={'cds_nucleotides','nucleotides','cds_exons','exons', ...
            'cds_transcripts','transcripts','genes','tis','stop','tss50','tss250','tss1000','cleave50','cleave250','cleave1000'};
%

for i=1:length(sources_cat1)
  for j=1:9
    MC1(i,j) = res_cat1(i).(type_names{j}).mean_SNSP ;
  end
  MC1(i,10) = res_cat1(i).tss.mean_SNSP50;
  MC1(i,11) = res_cat1(i).tss.mean_SNSP250;
  MC1(i,12) = res_cat1(i).tss.mean_SNSP1000;
  MC1(i,13) = res_cat1(i).cleave.mean_SNSP50;
  MC1(i,14) = res_cat1(i).cleave.mean_SNSP250;
  MC1(i,15) = res_cat1(i).cleave.mean_SNSP1000;
  missing(i,1) =res_cat1(i).genes.missing ;
  missing(i,2) =res_cat1(i).genes.missing_conf./res_cat1(i).genes.missing ;
  missing(i,3) =res_cat1(i).genes.missing_partconf./res_cat1(i).genes.missing;
  missing(i,4) =res_cat1(i).genes.missing_unconf./res_cat1(i).genes.missing ;
  wrong(i) = res_cat1(i).genes.wrong ;
end



[tmp,idx] = sort(MC1(:,3),'descend');
MC1 = MC1(idx,:);
missing = missing(idx,:);
wrong = wrong(idx);
sources = sources_cat1(idx);

idx_cds=[1 3 5];               
figure(1)
bar(MC1(:,idx_cds)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
legend(sources,'Location','BestOutside')
h=gca;
a=axis; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{[idx_cds]}});

idx_cds=[1 3 5];               
figure(2)
bar(MC1(:,idx_cds)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
%legend(sources,'Location','BestOutside')
h=gca;
a=axis; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{[idx_cds]}});
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_cds1.eps');

if 0
idx_cds=[1 3 5 7];               
figure(2)
bar(MC1(:,idx_cds)')
title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;a=axis; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_cds}});
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_cds2.eps');
end

idx_all=[2 4];   
figure(3)
bar(MC1(:,idx_all)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_all}});
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_all.eps');

idx_starts=[8:9];
figure(4)
bar(MC1(:,idx_starts)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_starts}});
