


load('/fml/ag-raetsch/share/projects/nGASP/test_regions.mat')
regions=test_regions;
load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_C_complete.mat')
genes_anno = genes;
load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_A_complete.mat')
genes_conf = genes;
load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_B_complete.mat')
genes_part = genes;
genome_info = init_genome('~/svn/projects/nGASP/eval/genome.config') ;

file_repeats ='/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/data/repeats_test.mat';
load(file_repeats,'repeats')

dir = '/fml/ag-raetsch/share/projects/nGASP/nGASP_Predictions_curated/'
files_cat1 = {'AGENE/AGENE','AUGUSTUS/AUGUSTUS_cat1_ver1','AUGUSTUS/AUGUSTUS_cat1_ver2',...
              'CRAIG/CRAIG','EUGENE/EuGene_cat1_ver1','EXONHUNTER/exonhunter_cat1_ver1',...
              'FGENESH/Fgenesh','GENEID/geneid_v1.3','GENEMARKHMM/GENEMARKHMM',...
              'GLIMMERHMM/GLIMMERHMM','MGENE/G3A_cat1_ver0','MGENE/G3A_cat1_ver1',...
              'MGENE/G3A_cat1_ver2','SNAP/SNAP'};
file_mgene_new_cleave6 = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/test_predictions/gr_old_all_loss_C=1-28-08-2007/genes_cleave6.mat';
file_mgene_new_cleave_corr = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/test_predictions/gr_old_all_loss_C=1_cleave_corr-28-08-2007/genes_cleave0.mat';

files_cat2 = {'EUGENE/EuGene_cat2_ver1','MGENE/G3A_cat2_ver1a','MGENE/G3A_cat2_ver2a',...
              'SGP2/SGP2'};%NSCAN 
files_cat3 = {'AUGUSTUS/AUGUSTUS_cat3_ver1','EUGENE/EuGene_cat3_ver1',...
              'EXONHUNTER/exonhunter_cat3_ver1','EXONHUNTER/exonhunter_cat3_ver2'...
              'FGENESH++/Fgenesh_plus','MAKER/maker_cat3_ver1','MAKER/maker_cat3_ver2'...
              'MGENE/G3A_cat3_ver1','MGENE/G3A_cat3_ver2',...
              'MGENE/G3A_cat3_ver3'};%'EUGENE/EuGene_cat3_ver2' ENSEMBLE

sources_cat1 = {'AGENE','AUGUSTUS 1','AUGUSTUS 2',...
              'CRAIG','EUGENE 1','EXONHUNTER',...
              'FGENESH','GENEID','GENEMARKHMM',...
              'GLIMMERHMM','MGENE 1','MGENE 2',...
              'MGENE 3','SNAP','MGENE NEW','MGENE NEW CLEAVE'};

sources_cat2 = {'EUGENE','MGENE 2.1a','MGENE 2.2a',...
              'SGP2'};%NSCAN 

sources_cat3 = {'AUGUSTUS 3.1','EUGENE 3.1',...
              'EXONHUNTER 3.1','EXONHUNTER 3.2'...
              'FGENESH++','MAKER 3.1','MAKER 3.2'...
              'MGENE 3.1','MGENE 3.2',...
              'MGENE 3.3'};%'EUGENE/EuGene_cat3_ver2' ENSEMBLE

type_names={'cds_nucleotides','nucleotides','cds_exons','exons','cds_transcripts','transcripts','genes','tis','stop','tss','cleave'}


%%%% LOOK ON ALL GENES FIRST
for i=1: length(files_cat1)
  load(sprintf('%s%s_complete.mat',dir,files_cat1{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat1{i})
  res1(i) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
end
load(file_mgene_new_cleave6)
genes_pred=genes;
fprintf('\n\n%s\n',sources_cat1{i+1})
res1(i+1) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);

load(file_mgene_new_cleave_corr)
genes_pred=genes;
fprintf('\n\n%s\n',sources_cat1{i+2})
res1(i+2) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);

if 0
%%%%%%%%%% CHECK REPEATS
repeat_chr = [genes.chr_num];

overlap=[];overlap_genes=[];
for j=1:length(genes)
  gene=genes(j);
  rep=repeats(repeat_chr==gene.chr_num);
  rep = rep([rep.start]<=gene.stop &[rep.stop]>=gene.start);
  overlap=[overlap [rep.id]];
  if ~isempty(rep)
    for k=1:size(gene.exons{1},1)
      if any([rep.start]<=gene.exons{1}(k,2) &[rep.stop]>=gene.exons{1}(k,1));
        overlap_genes=[overlap_genes j];
      end
    end
    
    % viewsplicegraph(gene);hold on
    % for j=1:length(rep)
    %   plot([rep(j).start rep(j).stop],[1 1])
    %end
    % keyboard
  end
end
genes_pred(overlap_genes)=[];
fprintf('\n\n%s\n',sources_cat1{i+2})
res1(i+2) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
end
%%%%

for i=1:length(sources_cat1)
  for j=1:length(type_names)
    MC1(i,j) = [mean([res1(i).(type_names{j}).SN,res1(i).(type_names{j}).SP]) ];
  end
end

[tmp,idx] = sort(MC1(:,3),'descend');
MC1 = MC1(idx,:);
sources = sources_cat1(idx);

figure(1)
bar(MC1')
title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
set(h,'xTickLABEL',type_names);
print( '-dpsc','-loose', '~/svn/projects/genefinding/eval_lsl/CAT_1.ps');



%%%% CAT 2 LOOK ON ALL GENES FIRST

for i=1:length(files_cat2)
  load(sprintf('%s%s_complete.mat',dir,files_cat2{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat2{i})
  res2(i) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
end
%%%%
for i=1:length(sources_cat2)
  for j=1:length(type_names)
    MC2(i,j) = [mean([res2(i).(type_names{j}).SN,res2(i).(type_names{j}).SP]) ];
  end
end

[tmp,idx] = sort(MC2(:,3),'descend');
MC2 = MC2(idx,:);
sources = sources_cat2(idx);

figure(2)
bar(MC2(:,[1 3 5])')
title('CAT 2 all');
ylabel('mean(sensitivity,specificity)');
legend(sources,'Location','BestOutside')
h=gca;
set(h,'xTickLABEL',type_names([1 3 5]));
print( '-dpsc', '~/svn/projects/genefinding/eval_lsl/CAT_2.ps');

%%%% CAT 3 LOOK ON ALL GENES FIRST

for i=1:length(files_cat3)
  load(sprintf('%s%s_complete.mat',dir,files_cat3{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat3{i})
  res3(i) = evaluate_predictions(regions,genes_anno,genes_pred,genome_info,0);
end
%%%%
for i=1:length(sources_cat3)
  for j=1:length(type_names)
    MC3(i,j) = [mean([res3(i).(type_names{j}).SN,res3(i).(type_names{j}).SP]) ];
  end
end

[tmp,idx] = sort(MC3(:,1),'descend');
MC3 = MC3(idx,:);
sources = sources_cat3(idx);

figure(3)
bar(MC3(:,[1 3 5])')
title('CAT 3 all');
ylabel('mean(sensitivity,specificity)');
legend(sources,'Location','BestOutside')
h=gca;
set(h,'xTickLABEL',type_names([1 3 5]));
print( '-dpsc', '~/svn/projects/genefinding/eval_lsl/CAT_3.ps');


return














%%%% LOOK ON CONFIRMED GENES
[tmp,idx1,idx2] = intersect({genes_anno.name},{genes_conf.name});
assert(length(idx2)==length(genes_conf))
genes_anno2 = genes_anno;
for j=idx1
  genes_anno2(j)=genes_conf(idx2(idx1==j));
  assert(all(genes_anno2(j).transcript_status))
end
for j=1:length(genes_anno2)
  if ismember(j,idx1)
    genes_anno2(j).mask_on=0;
  else
    genes_anno2(j).mask_on=1;
  end
end
for i=1:length(files_cat1)
  load(sprintf('%s%s_complete.mat',dir,files_cat1{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat1{i})
  res2(i) = evaluate_predictions(regions,genes_anno2,genes_pred,genome_info);
end

for i=1:length(files_cat1)
  for j=1:length(type_names)
    MC2(i,j) = [mean([res2(i).(type_names{j}).SN,res2(i).(type_names{j}).SP]) ];
  end
end
[tmp,idx] = sort(MC2(:,1),'descend');
MC2 = MC2(idx,:);
sources = sources_cat1 (idx);

figure(2)
bar(MC2')
title('CAT 1 confirmed');
ylabel('mean(sensitivity,specificity)');
legend(sources)
h=gca;
set(h,'xTickLABEL',type_names);


%%%% LOOK ON PARTIALLY CONFIRMED GENES
[tmp,idx1,idx2] = intersect({genes_anno.name},{genes_part.name});
assert(length(idx2)==length(genes_part))
genes_anno3 = genes_anno;
for j=idx1
  genes_anno3(j)=genes_part(idx2(idx1==j));
end
for j=1:length(genes_anno3)
  if ismember(j,idx1)
    genes_anno3(j).mask_on=0;
  else
    genes_anno3(j).mask_on=1;
  end
end
for i=1:length(files_cat1)
  load(sprintf('%s%s_complete.mat',dir,files_cat1{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat1{i})
  res3(i) = evaluate_predictions(regions,genes_anno3,genes_pred,genome_info);
end

for i=1:length(files_cat1)
  for j=1:length(type_names)
    MC3(i,j) = [mean([res3(i).(type_names{j}).SN,res3(i).(type_names{j}).SP]) ];
  end
end
[tmp,idx] = sort(MC3(:,1),'descend');
MC3 = MC3(idx,:);
sources = sources_cat1 (idx);

figure(3)
bar(MC3')
title('CAT 1 partially confirmed');
ylabel('mean(sensitivity,specificity)');
legend(sources)
h=gca;
set(h,'xTickLABEL',type_names);

%%%% LOOK ON UNCONFIRMED GENES
[tmp,idx1,idx2] = intersect({genes_anno.name},{genes_part.name});
assert(length(idx2)==length(genes_part))
[tmp,idx3,idx4] = intersect({genes_anno.name},{genes_conf.name});
assert(length(idx4)==length(genes_conf))

genes_anno4 = genes_anno;

for j=1:length(genes_anno4)
  if ismember(j,[idx1 idx4])
    genes_anno4(j).mask_on=1;
  else
    genes_anno4(j).mask_on=0;
  end
end

for i=1:length(files_cat1)
  load(sprintf('%s%s_complete.mat',dir,files_cat1{i}))
  genes_pred=genes;
  fprintf('\n\n%s\n',sources_cat1{i})    
  res4(i) = evaluate_predictions(regions,genes_anno4,genes_pred,genome_info);
end

for i=1:length(files_cat1)
  for j=1:length(type_names)
    MC4(i,j) = [mean([res4(i).(type_names{j}).SN,res4(i).(type_names{j}).SP]) ];
  end
end
[tmp,idx] = sort(MC4(:,1),'descend');
MC4 = MC4(idx,:);
sources = sources_cat1 (idx);

figure(4)
bar(MC4')
title('CAT 1 unconfirmed');
ylabel('mean(sensitivity,specificity)');
legend(sources)
h=gca;
set(h,'xTickLABEL',type_names);

figure(5)
bar(MC2'-MC4')
title('CAT 1 diff: conf - unconf');
ylabel('mean(sensitivity,specificity)');
legend(sources_cat1)
h=gca;
set(h,'xTickLABEL',type_names);



%%%%%%%%%% CHECK REPEATS

repeat_chr = [genes.chr_num];

overlap=[];overlap_genes=[];
for i=1:length(genes)
  gene=genes(i);
  rep=repeats(repeat_chr==gene.chr_num);
  rep = rep([rep.start]<=gene.stop &[rep.stop]>=gene.start);
  overlap=[overlap [rep.id]];
  if ~isempty(rep)
    overlap_genes=[overlap_genes i];
    viewsplicegraph(gene);hold on
    for j=1:length(rep)
      plot([rep(j).start rep(j).stop],[1 1])
    end
    keyboard
  end
end