%%%GENERATE EXPERIMENT GENES

%%%LOAD ANNOTATION
%% WARNING ANNOTATION IS WS180 , yet predictions on WS170
if ~fexist('~/svn/tex/GR-mGene/results/wetlab_genes.mat')
  load(['/fml/ag-raetsch/share/databases/genomes/elegans_WS180/anno_WS180_final.mat'],'genes')
  anno_genes = genes;
  clear genes
  
  %%% LOAD PREDICTIONS
  target_config = '/fml/ag-raetsch/share/databases/genomes/elegans_WS180/genome.config' ;
  orig_config = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/' ...
                 'orig_data/genome.config']
  
  cleave = 6         
  base_dir = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1//test_predictions/'...  
              'new_signals_new_labels_better_all-17-11-2007/'];                                         
  
  fn_out_target_genome_genes = sprintf('%sgenome_genes_shiftedWS180_cleave%1.2f.mat',base_dir, cleave);  
  fn_out_orig_genome_genes = sprintf('%sgenome_genes_cleave%1.2f.mat',base_dir, cleave);                                          
  
  orig_genes = load_struct(fn_out_orig_genome_genes, 'genes') ;     
  load(fn_out_orig_genome_genes, 'experiment1_idx', 'experiment2_idx', 'experiment3_idx', 'orig_config',...
       'missing_anno_genes_idx', 'missing_anno_genes_num','missing_anno_genes_unconf_idx') ;
  
  rand('seed', 34598742388) ; 
  rand_idx = randperm(length(experiment1_idx)) ;
  rand_idx = rand_idx(1:100) ;    
  
  genes_exp1 = orig_genes(experiment1_idx(rand_idx));
  genes_exp2 = orig_genes(experiment2_idx); 
  
  rand('seed', 34598742388) ; 
  rand_idx = randperm(length(experiment3_idx)) ;
  rand_idx = rand_idx(1:100) ;              
  
  genes_exp3 = orig_genes(experiment3_idx(rand_idx)) ; 
  
  rand('seed', 34598742388) ; 
  rand_idx = randperm(length(missing_anno_genes_unconf_idx)) ;
  rand_idx = rand_idx(1:100) ;                                
  
  genes_exp4 = anno_genes(missing_anno_genes_unconf_idx(rand_idx));
  
  save('~/svn/tex/GR-mGene/results/wetlab_genes.mat',...
       'genes_exp1','genes_exp2','genes_exp3','genes_exp4')
end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% load primer candidates
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


load ~/svn/tex/GR-mGene/results/experiment1_cands.mat 
load ~/svn/tex/GR-mGene/results/experiment2_cands.mat 
load ~/svn/tex/GR-mGene/results/experiment3_cands.mat 
load ~/svn/tex/GR-mGene/results/experiment4_cands.mat 

genes_exp1(1).config = orig_config;
genes_exp2(1).config = orig_config;
genes_exp3(1).config = orig_config;
genes_exp4(1).config = target_config;

%%%exp 1
[genes_exp1, good_idx1] =  mapGenesExperiments(genes_exp1,experiment1_cands);
genes_exp1 = genes_exp1(good_idx1(1:50));

%% exp2 
[genes_exp2, good_idx2] =  mapGenesExperiments(genes_exp2,experiment2_cands);
genes_exp2 = genes_exp2(good_idx2) ;

%% exp3
[genes_exp3, good_idx3] =  mapGenesExperiments(genes_exp3,experiment3_cands);
genes_exp3 = genes_exp3(good_idx3) ;

%% exp4
[genes_exp4, good_idx4] =  mapGenesExperiments(genes_exp4,experiment4_cands);
genes_exp4 = genes_exp4(good_idx4) ;

save('~/svn/tex/GR-mGene/results/wetlab_genes_with_cands.mat',...
     'genes_exp1','genes_exp2','genes_exp3','genes_exp4')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%LOAD SEQUENCING RESULTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
base_dir = '~raetsch/svn/projects/wetlab/';
fn = sprintf('%s/sequencing28_11_07/sequences_abiview.psl',base_dir);
tmp_fname = tempname;
unix(sprintf('tail -n +6  %s>%s', fn, tmp_fname));
seq1 = parse_wetlab_psl(tmp_fname);
unix(sprintf('rm %s',tmp_fname));

fn = sprintf('%s/sequencing29_11_07/sequences_abiview.psl',base_dir);
unix(sprintf('tail -n +6  %s>%s', fn, tmp_fname));
seq2 = parse_wetlab_psl(tmp_fname);
unix(sprintf('rm %s',tmp_fname));

fn = sprintf('%s/sequencing30_11_07/sequences_abiview.psl',base_dir);
unix(sprintf('tail -n +6  %s>%s', fn, tmp_fname));
seq3 = parse_wetlab_psl(tmp_fname);
unix(sprintf('rm %s',tmp_fname));

fn = sprintf('%s/sequencing05_12_07/sequences_abiview.psl',base_dir);
unix(sprintf('tail -n +6  %s>%s', fn, tmp_fname));
seq4 = parse_wetlab_psl(tmp_fname);
unix(sprintf('rm %s',tmp_fname));

fn = sprintf('%s/sequencing10_12_07/sequences_abiview.psl',base_dir);
unix(sprintf('tail -n +6  %s>%s', fn, tmp_fname));
seq5 = parse_wetlab_psl(tmp_fname);
unix(sprintf('rm %s',tmp_fname));



seq = [seq1 seq2 seq3 seq4 seq5];
for j=1:length(seq)
  SEQ(j).id = j;
  SEQ(j).chr = seq(j).chr;
  SEQ(j).name = seq(j).name;
  SEQ(j).start = seq(j).start;
  SEQ(j).stop =seq(j).stop;
  SEQ(j).exons = seq(j).exons;
  SEQ(j).match = seq(j).match;
  SEQ(j).mismatch = seq(j).mismatch;
  SEQ(j).QgapCount = seq(j).QgapCount;
  SEQ(j).QgapBases = seq(j).QgapBases;
  SEQ(j).score = seq(j).match - seq(j).mismatch-seq(j).QgapBases;
end
clear seq1 seq2  seq3 seq4 seq5 seq


%%%exp 1
[genes_exp1, good_idx1] =  mapGenesSeqResults(genes_exp1,SEQ,'RNA');
%% exp2 
[genes_exp2, good_idx2] =  mapGenesSeqResults(genes_exp2,SEQ,'RNA');
%% exp3
[genes_exp3, good_idx3] =  mapGenesSeqResults(genes_exp3,SEQ,'RNA');
%% exp4
[genes_exp4, good_idx4] =  mapGenesSeqResults(genes_exp4,SEQ,'RNA');



save('~/svn/tex/GR-mGene/results/wetlab_results_1rndseq.mat',...
     'genes_exp1','good_idx1','genes_exp2','good_idx2','genes_exp3', ...
     'good_idx3','genes_exp4','good_idx4','SEQ')

%%%%%%%%%%%%%%%%%%%
%%% 2nd round primer design
%%%%%%%%%%%%%%%%%%%

Bad_idx1 = check_primer(genes_exp1,10);
Bad_idx2 = check_primer(genes_exp2,10);
Bad_idx3 = check_primer(genes_exp3,10);
Bad_idx4 = check_primer(genes_exp4,10);

%%from alignment pics
already_confirmed1 = [1 3 4 20 25 27 43 44 50]; %36
wrongstruct1 = [7 8 15 24 33 42 47 48 ];
repeat1 = [2 6 12 13 31 35 38 40 45 49 19 22 29 36 39];
repeat_idx1 = union(repeat1,Bad_idx1.any_bad2);
repeat_idx1 = setdiff(repeat_idx1,already_confirmed1);

already_confirmed2 = [11]; 
wrongstruct2 = [1 6];
repeat2 = [2 10 12];
repeat_idx2 = union(repeat2,Bad_idx2.any_bad2);
repeat_idx2 = setdiff(repeat_idx2,already_confirmed2);

already_confirmed3 = [15 18 19 20 24 25 36 43 46 49 51]; 
wrongstruct3 = [21 28 31 52];
repeat3 = [11 13 34 37 41 44 ];
repeat_idx3 = union(repeat3,Bad_idx3.any_bad2);
repeat_idx3 = setdiff(repeat_idx3,already_confirmed3);

already_confirmed4 = [16 18];
wrongstruct4 = [28];
repeat4 = [2 3 7 8 11 12 15 22 24 26 27 30 32 35 37 48 50];
repeat_idx4 = union(repeat4,Bad_idx4.any_bad2);
repeat_idx4 = setdiff(repeat_idx4,already_confirmed4);


% target_config = '/fml/ag-raetsch/share/databases/genomes/elegans_WS180/genome.config' ;
target_config = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/orig_data/genome1.config' ;
orig_config = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/orig_data/genome.config'

cd ~/svn/projects/genefinding/primer_design

experiment1_cands2 = genes2primers_py(genes_exp1(repeat_idx1), orig_config, '~/svn/tex/GR-mGene/results/mGPG_primers_2.txt', 'pseudo_gene', 'AA_1') ;
experiment2_cands2 = genes2primers_py(genes_exp2(repeat_idx2), orig_config, '~/svn/tex/GR-mGene/results/mGNC_primers_2.txt', 'noncoding_gene', 'AA_2') ;
experiment3_cands2 = genes2primers_py(genes_exp3(repeat_idx3), orig_config, '~/svn/tex/GR-mGene/results/mGNG_primers_2.txt', 'new_gene', 'AA_3') ;
experiment4_cands2 = genes2primers_py(genes_exp4(repeat_idx4), target_config, '~/svn/tex/GR-mGene/results/mGMG_primers_2.txt', 'missing_gene', 'AA_4') ;

for j=1:length(experiment1_cands2)
  experiment1_cands2(j).genes_idx=repeat_idx1(experiment1_cands2(j).genes_idx);
end
for j=1:length(experiment2_cands2)
  experiment2_cands2(j).genes_idx=repeat_idx2(experiment2_cands2(j).genes_idx);
end
for j=1:length(experiment3_cands2)
  experiment3_cands2(j).genes_idx=repeat_idx3(experiment3_cands2(j).genes_idx);
end
for j=1:length(experiment4_cands2)
  experiment4_cands2(j).genes_idx=repeat_idx4(experiment4_cands2(j).genes_idx);
end


%%controll primers
[genes_exp1, good_idx1] =  mapGenesExperiments(genes_exp1,experiment1_cands2,2);
[genes_exp2, good_idx2] =  mapGenesExperiments(genes_exp2,experiment2_cands2,2);
[genes_exp3, good_idx3] =  mapGenesExperiments(genes_exp3,experiment3_cands2,2);
[genes_exp4, good_idx4] =  mapGenesExperiments(genes_exp4,experiment4_cands2,2);

save ~/svn/tex/GR-mGene/results/experiment1_cands2.mat experiment1_cands2
save ~/svn/tex/GR-mGene/results/experiment2_cands2.mat experiment2_cands2
save ~/svn/tex/GR-mGene/results/experiment3_cands2.mat experiment3_cands2
save ~/svn/tex/GR-mGene/results/experiment4_cands2.mat experiment4_cands2
 

load ~/svn/tex/GR-mGene/results/experiment1_cands2.mat experiment1_cands2
load ~/svn/tex/GR-mGene/results/experiment2_cands2.mat experiment2_cands2
load ~/svn/tex/GR-mGene/results/experiment3_cands2.mat experiment3_cands2
load ~/svn/tex/GR-mGene/results/experiment4_cands2.mat experiment4_cands2



base_name = '~/svn/tex/GR-mGene/results/alignment_pics/N2genes1_';
view_results(genes_exp1,base_name)




close all
base_name = '~/svn/tex/GR-mGene/results/alignment_pics/Ngenes1_';
view_results(genes_exp1,base_name)

base_name = '~/svn/tex/GR-mGene/results/alignment_pics/Ngenes2_';
view_results(genes_exp2,base_name) 

base_name = '~/svn/tex/GR-mGene/results/alignment_pics/Ngenes3_';
view_results(genes_exp3,base_name)


base_name = '~/svn/tex/GR-mGene/results/alignment_pics/Ngenes4_';
view_results(genes_exp4,base_name)

% for file in `ls -1 *.eps` ; do epstopdf $file ; done

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%new sequencing results for old primers 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% cd ~/svn/projects/wetlab
% python wetlab_main.py  ...
%     /fml/ag-raetsch/share/projects/genefinding/C_elegans/results/wetlab/sequencing08_01_08 ...
%     elegans /fml/ag-raetsch/share/projects/genefinding/C_elegans/results/wetlab/chromosomelist_elegans  seq08_01_08
% 
% python alignment_only.py ...
%     /fml/ag-raetsch/share/projects/genefinding/C_elegans/results/wetlab/sequencing08_01_08     ...
%     elegans /fml/ag-raetsch/share/projects/genefinding/C_elegans/results/wetlab/chromosomelist_elegans  seq08_01_08

base_dir = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/results/wetlab';
fn = sprintf('%s/sequencing08_01_08/sequences_abiview.psl',base_dir);
tmp_fname = tempname;
unix(sprintf('tail -n +6  %s>%s', fn, tmp_fname));
seqnew = parse_wetlab_psl(tmp_fname);
unix(sprintf('rm %s',tmp_fname));

seq = seqnew;
for j=1:length(seq)
  SEQ(j).id = j;
  SEQ(j).chr = seq(j).chr;
  SEQ(j).name = seq(j).name;
  SEQ(j).start = seq(j).start;
  SEQ(j).stop =seq(j).stop;
  SEQ(j).exons = seq(j).exons;
  SEQ(j).match = seq(j).match;
  SEQ(j).mismatch = seq(j).mismatch;
  SEQ(j).QgapCount = seq(j).QgapCount;
  SEQ(j).QgapBases = seq(j).QgapBases;
  SEQ(j).score = seq(j).match - seq(j).mismatch-seq(j).QgapBases;
end
seqnew = SEQ;
load('~/svn/tex/GR-mGene/results/wetlab_genes_with_cands.mat',...
     'genes_exp1','genes_exp2','genes_exp3','genes_exp4')

%%%exp 1
[genes_exp1, good_idx1] =  mapGenesSeqResults(genes_exp1,SEQ,'RNA');
%% exp2 
[genes_exp2, good_idx2] =  mapGenesSeqResults(genes_exp2,SEQ,'RNA');
%% exp3
[genes_exp3, good_idx3] =  mapGenesSeqResults(genes_exp3,SEQ,'RNA');
%% exp4
[genes_exp4, good_idx4] =  mapGenesSeqResults(genes_exp4,SEQ,'RNA');

save('~/svn/tex/GR-mGene/results/wetlab_results_2rndseq.mat',...
     'genes_exp1','good_idx1','genes_exp2','good_idx2','genes_exp3', ...
     'good_idx3','genes_exp4','good_idx4','seqnew')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%new sequencing results for new primers 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

