function genes_est = extract_ests_fromconfirmed(genes,genome_info)
  
rmidx = [];
for i=1:length(genes)
  trmidx=[] ;
  for j=1:length(genes(i).transcripts),
    if ~isequal(genes(i).transcripts{j}(1:3), 'EST')& ~isequal(genes(i).transcripts{j}(1:3), 'GR-'),,
      trmidx(end+1)=j ;
    end ;
  end ;
  genes(i).transcripts(trmidx)=[] ;
  genes(i).exons(trmidx)=[] ;
  genes(i).exons_confirmed(trmidx)=[] ;
  if isempty(genes(i).transcripts),
    rmidx(end+1)=i ;
  end 
end ;

genes(rmidx)=[] ;

% cluster them again, after separating all transcripts into separate entries
genes_ = genes(1) ;
num_transcripts=0 ;
for i=1:length(genes) ;
  num_transcripts=num_transcripts+length(genes(i).exons) ;
end ;
genes_(num_transcripts)=genes(1) ;
num_transcripts=0;
for i=1:length(genes) ;
  %assert(length(genes(i).exons)==size(genes(i).terminal_info,2)) ;
  for j=1:length(genes(i).exons) ;
    assert(all(size(genes(i).exons{j})==size(genes(i).exons_confirmed{j}))) ;
    num_transcripts=num_transcripts+1 ;
    genes_(num_transcripts)=genes(i) ;
    genes_(num_transcripts).exons=genes(i).exons(j) ;
    genes_(num_transcripts).exons_confirmed=genes(i).exons_confirmed(j) ;
    genes_(num_transcripts).transcripts=genes(i).transcripts(j) ;
    genes_(num_transcripts).transcript_info=genes(i).transcript_info(j) ;
    if isfield(genes_(num_transcripts),'transcript_status')
      genes_(num_transcripts).transcript_status=genes(i).transcript_status(j);
    end
    genes_(num_transcripts).transcript_valid=genes(i).transcript_valid(j) ;
    
    genes_(num_transcripts).strand=genes(i).strand ;
    % genes_(num_transcripts).terminal_info=genes(i).terminal_info(:,j) ;
    genes_(num_transcripts).name=genes(i).transcripts{j} ;
  end ;
end ;

genes = merge_transcripts_by_colocation(genes_, genome_info) ;

% build splice graphs again
build_splice_graph;
infer_splice_graph;
for ix=1:length(genes)
  [dummy,exon_order] = sort(genes(ix).splicegraph{1}(1,:),2,'ascend');
  genes(ix).splicegraph{1} = genes(ix).splicegraph{1}(:,exon_order);
  genes(ix).splicegraph{2} = genes(ix).splicegraph{2}(exon_order,exon_order);
  genes(ix).orig_id =  genes(ix).id;
  genes(ix).id = ix;
end
genes_est = alt_const(genes) ;


clear genes
