addpath /fml/ag-raetsch/share/software/matlab_tools/utils
addpath ~/svn/tools/genomes
addpath ~/svn/projects/splicing/utils
addpath ~/svn/projects/genefinding/eval_lsl/

% Use the annotation as the labels
load('/fml/ag-raetsch/share/projects/nGASP/test_regions.mat')
regions=test_regions;
load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_C_complete.mat')
genes_anno=genes;
genome_info = init_genome('~/svn/projects/nGASP/eval/genome.config') ;


% Get the set of genes where mGene and annotation disagree
load('/fml/ag-raetsch/share/projects/nGASP/nGASP_Predictions_curated/MGENE/G3A_cat1_ver0_complete.mat');
genes_mgene = genes;

res = evaluate_predictions(regions,genes_anno,genes_mgene,genome_info);
%genes_diff_anno = find_genes_diff(res,genes_anno,genes_mgene);
genes_ME_idx = res.cds_exons.ME_gene_id;
assert(all(genes_ME_idx==[genes_anno(genes_ME_idx).id]));
genes_missing = genes_anno(genes_ME_idx);

% Use mGene predictions as the labels

files_cat1 = {'dummy','AGENE/AGENE','AUGUSTUS/AUGUSTUS_cat1_ver1','AUGUSTUS/AUGUSTUS_cat1_ver2',...
              'CRAIG/CRAIG','EUGENE/EuGene_cat1_ver1','EXONHUNTER/exonhunter_cat1_ver1',...
              'FGENESH/Fgenesh','GENEID/geneid_v1.3','GENEMARKHMM/GENEMARKHMM',...
              'GLIMMERHMM/GLIMMERHMM','SNAP/SNAP'};

basedir = '/fml/ag-raetsch/share/projects/nGASP/nGASP_Predictions_curated/';
res_mgene(1) = evaluate_predictions(regions,genes_mgene,genes_anno,genome_info);
%genes_disagree(1) = find_genes_diff(res_mgene(1),genes_mgene,genes_anno);
genes_ME_idx = res_mgene(1).cds_exons.ME_gene_id;
assert(all(genes_ME_idx==[genes_mgene(genes_ME_idx).id]));
anno_idx = genes_ME_idx;

disagree_count = zeros(size(genes_mgene));
for ix=2:length(files_cat1)
  load(sprintf('%s%s_complete.mat',basedir,files_cat1{ix}))
  fprintf('%s\n',files_cat1{ix});
  genes_pred=genes;
  res_mgene(ix) = evaluate_predictions(regions,genes_mgene,genes_pred,genome_info);
  %genes_disagree(ix) = find_genes_diff(res_mgene(ix),genes_mgene,genes_pred);
  genes_ME_idx = res_mgene(ix).cds_exons.ME_gene_id;
  assert(all(genes_ME_idx==[genes_mgene(genes_ME_idx).id]));
  disagree_count(genes_ME_idx) = disagree_count(genes_ME_idx) + 1;
end

all_disagree_idx = find([disagree_count]==11);
interest_idx = intersect(all_disagree_idx,anno_idx);
fid = fopen('~/genes_disagree.txt','w');
genes_print(genes_mgene(interest_idx),fid);
fclose(fid);

all_agree_idx = find([disagree_count]==0);
interest_idx = intersect(all_agree_idx,anno_idx);
fid = fopen('~/genes_agree.txt','w');
genes_print(genes_mgene(interest_idx),fid);
fclose(fid);

disagree_idx = find([disagree_count]==5);
interest_idx = intersect(disagree_idx,anno_idx);
fid = fopen('~/genes_5disagree.txt','w');
genes_print(genes_mgene(interest_idx),fid);
fclose(fid);

