
function [ adjMat, edges ] = find_overlaps( items );


% === prepare items
nofItems = length( items );
s = [ items.start ];
t = [ items.stop ];
assert_all( size(s) == [1,nofItems] );
assert_all( size(t) == [1,nofItems] );
assert_all( s < t );


% === match items
adjMatS = sparse( [], [], [], nofItems, nofItems );
adjMatT = sparse( [], [], [], nofItems, nofItems );
for( i = 1:nofItems )
  s_i = s(i);
  t_i = t(i);
  jS = find( ( s_i<=s & s<=t_i ) | ( s<=s_i & s_i<=t ) );
  jT = find( ( s_i<=t & t<=t_i ) | ( s<=t_i & t_i<=t ) );
  adjMatS( i, jS ) = 1;
  adjMatT( i, jT ) = 1;
end;
assert_all( adjMatS == adjMatT );
adjMat = adjMatS;
clear adjMatS;
clear adjMatT;
assert_all( adjMat == adjMat' );
assert_all( diag(adjMat) == 1 );


edges = [];

