function blocks = map_predictions_to_nGASP_blocks(fn_in,fn_out,fn_nGASP_test,fn_out_nGASP,old_chr_seq,new_chr_seq)
  


%-----------------------------

tmp = load(fn_nGASP_test, 'blocks');
nGASP_blocks = tmp.blocks;

is_replaced = zeros(1,length(nGASP_blocks));

for f=1:length(fn_in),
  fprintf('loading predictions from %s...\n', fn_in{f});
  load(fn_in{f}, 'blocks');
  new_block.chr = blocks(1).chr;
  new_block.chr_num = blocks(1).chr_num;
  new_block.strand = blocks(1).strand;
  new_block.id = blocks(1).id;
  new_block.block_start = blocks(1).block_start;
  new_block.block_end = blocks(1).block_end;
  if  blocks(1).strand== '-'
    new_block.offset = blocks(1).block_start+1;
  end
  assert(length(unique([blocks.strand]))==1);
  assert(length(unique([blocks.chr_num]))==1);
  % new_block.block_end = blocks(1).offset + length(blocks(1).genestr)-1;
  len = abs(new_block.block_end-new_block.block_start);
  
  % re-concatenate
  segments = [];
  genestr  = repmat('X', 1, len);
  switch new_block.strand,
   case '+',
    for b=1:length(blocks),
      blocks(b).prediction.segments(:,1:2) ...
          = blocks(b).prediction.segments(:,1:2) + blocks(b).offset;
      
      if b==1,
        segments = blocks(b).prediction.segments;
      else
        assert(segments(end,3) == blocks(b).prediction.segments(1,3));
        segments(end,2) = blocks(b).prediction.segments(1,2);
        segments = [segments;blocks(b).prediction.segments(2:end,:)];
      end
     
      genestr(blocks(b).offset+[0:length(blocks(b).genestr)-1]) = blocks(b).genestr;
    end     
   case '-'
    for b=length(blocks):-1:1,
     %  keyboard
      blocks(b).offset = blocks(b).block_start - blocks(b).offset+3;
      blocks(b).prediction.segments(:,1:2) ...
          = -(blocks(b).prediction.segments(:,1:2) -blocks(b).offset);
      blocks(b).prediction.segments=blocks(b).prediction.segments(end:-1:1,:) ;
      blocks(b).prediction.segments(:,1:2)=blocks(b).prediction.segments(:,2:-1:1) ;
      if b==length(blocks),
        segments = blocks(b).prediction.segments;
      else
        if segments(end,3) ~= blocks(b).prediction.segments(1,3)
          assert(blocks(b).prediction.segments(1,3)==4)
          assert(segments(end,2)>=blocks(b).prediction.segments(1,1)&...
                 segments(end,2)<=blocks(b).prediction.segments(1,1)+500)
          segments(end,2) = blocks(b).prediction.segments(1,1);
        else
          segments(end,2) = blocks(b).prediction.segments(1,2);
          segments = [segments; ...
                      blocks(b).prediction.segments(2:end,:)];
        end
      end
      
      assert(issorted(segments(:,1)));
      assert(issorted(segments(:,2)));
      genestr(blocks(b).offset+[-length(blocks(b).genestr)-1:-2]) ...
          = reverse_complement(blocks(b).genestr);
    end
  end 
  blocks = new_block;
  save(fn_out{f}, 'blocks');

  % try to map to nGASP sequence coordinates
  w = 5;
  max_shift = 10;
  shift = nan(size(segments,1),2);
  for xx=1:2
    pos = segments(:,xx);
    good_idx = find(pos > w+max_shift&pos <length(new_chr_seq{new_block.chr_num})-w-max_shift);
    if length(good_idx)<length(pos),
      fprintf('removing %i positions\n',length(pos)-length(good_idx) );
    end
    for i=good_idx',
      new_seq = new_chr_seq{new_block.chr_num} ...
                (pos(i)-w:pos(i)+w);
      if ~ismember('X',genestr(pos(i)-w:pos(i)+w))
        assert(isequal(genestr(pos(i)-w:pos(i)+w), new_seq))
      end
      old_seq = old_chr_seq{new_block.chr_num} ...
                (pos(i)-w-max_shift:pos(i)+w+max_shift);
      possible_shifts = strfind(old_seq, new_seq) - max_shift - 1;
      if ~isempty(possible_shifts),
        [tmp idx] = min(abs(possible_shifts));
        shift(i,xx) = possible_shifts(idx);
        if shift(i,xx)~=0,
          if(~isequal(new_seq, ...
                      old_seq(max_shift+[1:length(new_seq)]+shift(i,xx))));
            warning('old genestr not ok')
          else
            fprintf('old genestr for pos %i ok\r',i)
          end
        end
      end
    end
    fprintf('shifts found for %2.1f%% positions\n', ...
            100*mean(~isnan(shift(:,xx))));
    hist(shift,[-10:10]);drawnow;grid on
    
    % shift pos and segments into place for WS160 genome release
    segments(good_idx,xx) = segments(good_idx,xx) + shift(good_idx,xx);
    % segments(good_idx(2:end),2)= segments(good_idx(2:end),2) + shift(2:end);
    %%% check
    new_pos = segments(:,xx);
    for i=good_idx',
      new_seq = new_chr_seq{new_block.chr_num} ...
                (pos(i)-w:pos(i)+w);
      old_seq = old_chr_seq{new_block.chr_num} ...
                (new_pos(i)-w:new_pos(i)+w);
      assert(isequal(new_seq, old_seq))
    end
  end
  
  
  
  
  new_block.prediction.segments = segments;
  new_block.genestr = old_chr_seq{new_block.chr_num};
  
  blocks = new_block;
  save(fn_out{f}, 'blocks','shift');
  clear blocks
  
  % cut out nGASP test blocks and convert to coordinates
  for b=1:length(nGASP_blocks),
    part_segments =[];
    if isequal(nGASP_blocks(b).chr, new_block.chr) ...
          & isequal(nGASP_blocks(b).strand, new_block.strand),
      
      switch new_block.strand,
       case '+'
        start = nGASP_blocks(b).block_start;
        stop  = nGASP_blocks(b).block_end;
        assert(isequal(new_block.genestr(start:stop),nGASP_blocks(b).genestr));
        
        s_idx = find(segments(:,1)>start & segments(:,2)<stop);
        part_segments = [part_segments; segments(s_idx,:)];
        part_segments(:,1:2) = part_segments(:,1:2) - start + 1;
       case '-',
        start = nGASP_blocks(b).block_end;
        stop  = nGASP_blocks(b).block_start;
        assert(isequal(reverse_complement(new_block.genestr(start:stop)),nGASP_blocks(b).genestr));
        
        s_idx = find(segments(:,1)>start & segments(:,2)<stop);
        part_segments = segments(s_idx,:);
        part_segments(:,1:2) = -part_segments(:,1:2) + nGASP_blocks(b).offset;
        part_segments = part_segments(end:-1:1,:);
        part_segments(:,1:2) = part_segments(:,2:-1:1);
      end
      if part_segments(1,3)~=0
        part_segments = [[1 part_segments(1,1) 0];part_segments];
      else
        part_segments(1,1)=1;
      end
      if part_segments(end,3)~=0
        part_segments = [part_segments; [part_segments(end,2)  length(nGASP_blocks(b).genestr) 0]];
      else
        part_segments(end,2) = length(nGASP_blocks(b).genestr);
      end
      assert(all(all(part_segments(:,1:2)>0&part_segments(:,1:2)<=length(nGASP_blocks(b).genestr))))
      nGASP_blocks(b).prediction.segments = part_segments;
      assert(is_replaced(b)==0);
      is_replaced(b) = 1;
      
    end
  end
end

assert(all(is_replaced==1));
blocks = nGASP_blocks;
save(fn_out_nGASP, 'blocks');