
function [ mapA2b ] = match_items_via_distance( itemsA, itemsB );

% === prepare itemsA
nofItemsA = length( itemsA );
sA = [ itemsA.start ];
tA = [ itemsA.stop ];
assert_all( sA < tA );
assert_all( sA(1:(end-1)) <= sA(2:end) );
%assert_all( tA(1:(end-1)) <= tA(2:end) );
if( any( sA(1:(end-1)) == sA(2:end) ) )
  fprintf( 'WARNING: several items with same start!\n' );
  idx = find( sA(1:(end-1)) == sA(2:end) );
  for( i = idx )
    itemsA( i )
    itemsA( i+1 )
  end;
end;

% === prepare itemsB
nofItemsB = length( itemsB );
sB = [ itemsB.start ];
tB = [ itemsB.stop ];
assert_all( sB < tB );
assert_all( sB(1:(end-1)) <= sB(2:end) );
%assert_all( tB(1:(end-1)) <= tB(2:end) );

% === match items
mapA2b = repmat( nan, nofItemsA, 3 );
for( i = 1:nofItemsA )
  [ sDists, sIdx ] = sort( abs(sA(i)-sB) );
  [ tDists, tIdx ] = sort( abs(tA(i)-tB) );
  if( sIdx(1) == tIdx(1) )
    j = sIdx(1);
    mapA2b(i,:) = [ j , sA(i)-sB(j) , tA(i)-tB(j) ];
  else
    mapA2b(i,:) = [ 0, 0, 0 ];
  end;
end;

