
function [ m ] = match_operons( opersA, opersB, o2gA, g2oA, o2gB, g2oB, mapA2c, mapB2c );

nofOpersA = length( o2gA );
nofOpersB = length( o2gB );
m = [];
m(nofOpersA).size = [];
m(nofOpersA).clustersB = [];
m(nofOpersA).genesB = [];
m(nofOpersA).opersB = [];
m(nofOpersA).missedRate = [];
m(nofOpersA).excessRate = [];
for( i = 1:nofOpersA )
  genesA = o2gA(i).fullGenes;
  clustersA = unique( mapA2c( genesA, 1 ) );
  clustersB = [];
  clustersNoMapA  = [];
  clustersMappedA = [];
  genesB = [];
  for( c = clustersA' )
    idx = find( mapB2c(:,1) == c );
    if( ~isempty(idx) )
      clustersB = [ clustersB ; c ];
      genesB = [ genesB , idx' ];
      clustersMappedA = [ clustersMappedA , c ];
    else
      clustersNoMapA = [ clustersNoMapA , c ];
    end;
  end;
  mappedOpersB = [];
  for( g = genesB )
    mappedOpersB = [ mappedOpersB ; g2oB(g) ];
  end;
  m(i).size = length( clustersA );
  m(i).clustersNoMapA = clustersNoMapA;
  m(i).clustersB = clustersB;
  m(i).genesB = genesB;
  m(i).opersB = unique( mappedOpersB );
  % --- maps to operon?
  freqs = hist( mappedOpersB, -1:(nofOpersB+1) );
  assert( freqs(1) == 0 );
  assert( freqs(end) == 0 );
  nofExcessSingles = freqs( 2 );
  mappedOpersB = mappedOpersB( mappedOpersB ~= 0 );
  if( isempty(mappedOpersB) )
    % -- no
    m(i).operB = 0;
    m(i).missedClusters = [];
    m(i).missedRate = 0;
    m(i).excessRate = 1;
    m(i).excessRateNoGenes = length(clustersNoMapA)  / m(i).size;
    m(i).excessRateSingles = length(clustersMappedA) / m(i).size;
    m(i).excessRateOperons = 0;
  else
    % -- yes
    freqs = hist( mappedOpersB, 0:nofOpersB );
    [ maxFreq, operB ] = max( freqs(2:end) );
    if( length(operB) > 1 )
      fprintf( 'WARNING: matching %d operons to same degree\n' );
      keyboard;
      operB = operB( 1 );
    end;
    operGenesB = o2gB( operB ).fullGenes;
    operClustersB = unique( mapB2c( operGenesB, 1 ) );
    missedClusters = setdiff( operClustersB, clustersA );
    hitClusters = intersect( operClustersB, clustersA );
    assert( ~isempty(hitClusters) );
    % - store values
    m(i).operB = operB;
    m(i).missedClusters = missedClusters;
    m(i).missedRate = length(missedClusters) / m(i).size;
    m(i).excessRate = 1 - ( length(hitClusters) / m(i).size );
    m(i).excessRateNoGenes = length(clustersNoMapA) / m(i).size;
    m(i).excessRateSingles = nan;
    m(i).excessRateOperons = nan;
  end;
  %assert( m(i).excessRateNoGenes + m(i).excessRateSingles + m(i).excessRateOperons == m(i).excessRate );
end;


