function [obs_segms,pred_segms,correct_segms,correct_nucl] ...
    = eval_segment_type(true_segments,pred_segments,segment_name,model)
% [obs_segms,pred_segms,correct_segms,correct_nucl] = eval_segment_type(true_segments,pred_segments,segment_name,model)

if isempty(true_segments) & isempty(pred_segments),
  obs_segms     = zeros(0,2);
  pred_segms    = zeros(0,2);
  correct_segms = zeros(0,2);
  correct_nucl  = [];
  return
end

assert(true_segments(1,1)   == pred_segments(1,1));
assert(true_segments(end,2) == pred_segments(end,2));
len = true_segments(end,2);

map_obs  = zeros(len,1);
map_pred = zeros(len,1);
  
idx = find(true_segments(:,3)==getfield(model.segments, segment_name));
obs_segms = true_segments(idx,:);
for i=1:size(obs_segms,1),
  map_obs(obs_segms(i,1):obs_segms(i,2)-1) = 1 ;
end 

idx = find(pred_segments(:,3)==getfield(model.segments, segment_name));
pred_segms = pred_segments(idx,:);
for i=1:size(pred_segms,1),
  map_pred(pred_segms(i,1):pred_segms(i,2)-1) = 1 ;
end 

[correct_segms,dummy1,dummy2] = intersect(pred_segms, obs_segms, 'rows');
correct_nucl = map_pred&map_obs;

