
 addpath ~/svn/projects/genefinding/lsl/

L=load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/train/gr_old_all_loss_C=1-28-08-2007/train_iteration16.mat')
% L=load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/train/gr_old_all_loss-28-08-2007/train.mat')
model= L.TRAIN_PAR.model;
boundaries = model.boundaries;
[xis,parameters] = res2param(L.QP.res,L.num_examples,model,L.QP);


% length
namesl=fieldnames(boundaries.lengths);
for j=1:length(namesl)
  weights = parameters.(['lengths_' namesl{j}])(2:end);
  YYlo(j,:) = weights;
  weights = weights-mean(weights) ;
  % weights = weights/max(weights) ;
  XXl(j,:)=exp(boundaries.lengths.(namesl{j})(2:end-1));
  YYl(j,:)=weights;
  namesl{j} = strrep(namesl{j},'_',' ');
end

namesl{find(strcmp(namesl,'polya tail'))}='polya end';
if 0
  figure;
  plot(XXl([4:7],:)',YYl([4:7],:)')
  xlabel('length')
  ylabel('w')
  legend(namesl{[4:7]},'location','northeast')
  title('weights of lengths features')
end

figure;
set(gca,'FontSize',16)
idxl=[9 8 3 2];
plot(XXl(idxl,:)',YYl(idxl,:)','LineWidth',2,'Marker','x')
grid on
xlabel('segment length l')
ylabel('length feature score S_{l}')
axis([0 400 -5 7]);
legend(namesl{idxl},'location','northeast')
title('learnt PLif for length features')
print( '-dpsc','-loose', '~/svn/tex/Recomb08/mGene/Images/length_plifs.ps');

if 0
  figure;
  plot(XXl([10],:)',YYl([10],:)')
  xlabel('length')
  ylabel('w')
  legend(namesl{[10]},'location','northeast')
  title('weights of lengths features')
end
% signal

namess=fieldnames(boundaries.signals);
for j=1:length(namess)
  weights = parameters.(['signals_' namess{j}])(2:end);
  YYso(j,:)=weights;
  weights = weights-mean(weights) ;
  % weights =weights/max(weights) ;
  XXs(j,:)=boundaries.signals.(namess{j})(2:end-1);
  YYs(j,:)=weights;
  namess{j} = strrep(namess{j},'_',' ');
end
figure;set(gca,'FontSize',16)
idxs = [9 7 2 1];
plot(XXs(idxs,:)',YYs(idxs,:)','LineWidth',2,'Marker','x')
xlabel('SVM output for signal sensor')
ylabel('signal feature score S_{s}')
axis([-5 5 -5 7]);
grid on
legend(namess{idxs},'location','northwest')
title('learnt PLif for signal features')
print( '-dpsc','-loose', '~/svn/tex/Recomb08/mGene/Images/signal_plifs.ps');

if 0
  figure;
  plot(XXs([3:6 8],:)',YYs([3:6 8],:)')
  xlabel('score')
  ylabel('w')
  legend(namess{[3:6 8]},'location','northwest')
  title('weights of signal features')
end
% content

namesc=fieldnames(boundaries.contents);
for j=1:length(namesc)
  weights = parameters.(['contents_' namesc{j}])(2:end);
  YYco(j,:)=weights;
  weights = weights-mean(weights) ;
  % weights =weights/max(weights) ;
  XXc(j,:)=boundaries.contents.(namesc{j})(2:end-1);
  YYc(j,:)=weights;
  namesc{j} = strrep(namesc{j},'_',' ');
end
figure;set(gca,'FontSize',16)
idxc = [6 4 5 1];
plot(XXc(idxc,:)',YYc(idxc,:)','LineWidth',2,'Marker','x')
xlabel('SVM output for content sensor')
ylabel('content feature score S_{c}')
axis([-10 10 -5 7]);
grid on
legend(namesc{idxc},'location','northwest')
title('learnt PLif for content features')
print( '-dpsc','-loose', '~/svn/tex/Recomb08/mGene/Images/content_plifs.ps');


idxl=[1 11 2 3 10 4:9 ]; %no intergenic long
idxc=[1 5 2 4 3 6 7 8];
idxs=[1 4 5 2 3 6:9];
% namesl{find(strcmp(namesl,'polya tail'))}='polya end'
       
ML = mean((YYlo'));
MC = mean((YYco'));
MS = mean((YYso'));

% StL = std(YYlo');
% StC = std(YYco');
% StS = std(YYso');
StL = max(YYlo')-min(YYlo');
StC = max(YYco')-min(YYco');
StS = max(YYso')-min(YYso');

a_names = fieldnames(model.segments);
for j=1:length(a_names)
  idx = model.a_trans(4,:) ==model.segments.(a_names{j});
  transitions{j} = parameters.transitions(idx);
  MA(j)= mean(transitions{j});
end
idxa = [1 7 2 3 8 4 5 6];


figure; 
set(gca,'FontSize',13)
barh([StL(idxl) 0 0 0 0  StC(idxc) 0 0 0 0 StS(idxs)])


set(gca,'YTick',[1:length(idxl),length(idxl)+4+[1:length(idxc)],length(idxl)+length(idxc)+8+[1:length(idxs)]])
set(gca, 'YTickLabel' ,{namesl{[idxl]} namesc{[idxc]} namess{[idxs]}});
line([0 6],[length(idxl)+3,length(idxl)+3],'Color','k')
line([0 6],[length(idxl)+length(idxc)+7,length(idxl)+length(idxc)+7],'Color','k')
text(0.3 ,length(idxl)+2,'length fetaures','FontSize',16)
text(0.3 ,length(idxl)+length(idxc)+6,'content features','FontSize',16)
text(0.3 ,length(idxl)+length(idxc)+length(idxs)+10,'signal features','FontSize',16)
print( '-dpsc','-loose', '~/svn/tex/Recomb08/mGene/Images/contribs.ps');
