function plot_quality_control(res,names,fn);

close all

plot_hist(res,'num_cdsExons',[0:40],1,names)
xlabel('number of exons per gene')
axis([0 30 0 0.5])
if exist('fn')
  print( '-depsc2', [fn 'num_exons.eps'])
end

plot_hist(res,'length_cdsExons',[0:30:30000],2,names)
xlabel('exon length')
axis([0 2500 0 0.2])
if exist('fn')
  print( '-depsc2', [fn 'length_exons.eps'])
end

plot_hist(res,'length_cdsIntrons',[0:30:30000],3,names)
xlabel('intron length')
axis([0 1500 0 0.4])
if exist('fn')
  print( '-depsc2', [fn 'length_introns.eps'])
end

plot_hist(res,'length_cds',[0:30:30000],4,names)
xlabel('cds length')
axis([0 5000 0 0.05])
if exist('fn')
  print( '-depsc2', [fn 'length_cds.eps'])
end
if 0
plot_hist(res,'length_utr5',[0:30:30000],5,names)
xlabel('utr5 length')
if exist('fn')
  print( '-depsc2', [fn 'length_utr5.eps'])
end

plot_hist(res,'length_utr3',[0:30:30000],6,names)
xlabel('utr3 length')
if exist('fn')
  print( '-depsc2', [fn 'length_utr3.eps'])
end
  
end


function plot_hist(res,name,bins,fig_num,names)
  
color={'r','g','b','k','c','y'}  ;
for i=1:length(res)
  xx=res(i).genes.(name); 
  figure(fig_num); hold on;
  [y,x] = hist(xx,bins);
  plot(x,y./sum(y),color{i}); 
end 

grid on

ylabel('frequency')
if exist('names')
  legend(names)
end
if exist('fn')
  print( '-depsc2', fn)
end