function plot_result(res,sources,fname)
  

type_names={'cds_nucleotides','nucleotides','cds_exons','exons', ...
            'cds_transcripts','transcripts','genes','tis','stop','tss50','tss250','tss1000','cleave50','cleave250','cleave1000'};
%

for i=1:length(sources)
  for j=1:9
    MC1(i,j) = res(i).(type_names{j}).mean_SNSP ;
  end
  MC1(i,10) = res(i).tss.mean_SNSP50;
  MC1(i,11) = res(i).tss.mean_SNSP250;
  MC1(i,12) = res(i).tss.mean_SNSP1000;
  MC1(i,13) = res(i).cleave.mean_SNSP50;
  MC1(i,14) = res(i).cleave.mean_SNSP250;
  MC1(i,15) = res(i).cleave.mean_SNSP1000;
  missing(i,1) =res(i).genes.missing ;
  missing(i,2) =res(i).genes.missing_conf./res(i).genes.missing ;
  missing(i,3) =res(i).genes.missing_partconf./res(i).genes.missing;
  missing(i,4) =res(i).genes.missing_unconf./res(i).genes.missing ;
  wrong(i) = res(i).genes.wrong ;
end



[tmp,idx] = sort(MC1(:,3),'descend');
MC1 = MC1(idx,:);
missing = missing(idx,:);
wrong = wrong(idx);
sources = sources(idx);

idx_cds=[1 3 5];               
figure(1)
bar(MC1(:,idx_cds)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
legend(sources,'Location','BestOutside')
h=gca;
a=axis; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{[idx_cds]}});
if exist('fname')
  print( '-depsc2',[fname 'cds_legend.eps']); 
end

idx_cds=[1 3 5];               
figure(2)
bar(MC1(:,idx_cds)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
%legend(sources,'Location','BestOutside')
h=gca;
a=axis; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{[idx_cds]}});
if exist('fname')
  print( '-depsc2', [fname 'cds.eps']);
end



