function [res,colmap, genes] = prediction_quality_controll(genes_est,genes_pred,genome_info)
% [res,genes] = prediction_quality_controll(genes_est,genes_pred,genome_info)

  
idx = find([genes_pred.is_valid]);
genes_pred = genes_pred(idx);

fprintf('\ncreating colocation map\n')
colmap = compute_colocation_map(genes_est, genes_pred, genome_info,0) ;

% keyboard
num=0 ;
num_dev=0 ;

introns.num_obsv_total = 0;
introns.num_obsv_cov = 0;
introns.num_pred_total = 0;
introns.num_pred_cov = 0;
introns.num_corr = 0;

exons.num_obsv_total = 0;
exons.num_obsv_cov = 0;
exons.num_pred_total = 0;
exons.num_pred_cov = 0;
exons.num_corr = 0;

idx_est = [];


fprintf('\n comparing predictions with EST\n')

% keyboard

for i=1:length(colmap),
  if (mod(i,100)==0), 
    fprintf('%i/%i\r',i,length(colmap))
  end
  gene=genes_pred(i) ;
  if isempty(gene.splicegraph{1})
    continue ; 
  end ;
  introns_pred = unique([gene.splicegraph{1}(2,1:end-1); gene.splicegraph{1}(1,2:end)]','rows');
  exons_pred =  unique([gene.splicegraph{1}'],'rows');

  if isempty(colmap{i}), 
    continue ; 
  end ;
  % keyboard
  num=num+1 ;

  introns_obsv = [];
  exons_obsv = [];
  intron_idx = [];
  exon_idx = [];
  for j=colmap{i}
    if ~isempty(intersect(idx_est,j))
      % keyboard
      % warning('EST has already been mapped to different prediction.')
    end
    idx_est = [idx_est j];
    intron = [genes_est(j).splicegraph{1}(2,1:end-1); genes_est(j).splicegraph{1}(1,2:end)]';
    idx =  find(intron(:,1)>=gene.start&intron(:,2)<=gene.stop);
    if length(idx)<size(intron,1)
      %  keyboard
    end
    intron = intron(idx,:);
    introns_obsv = unique([introns_obsv; intron],'rows');
    if size(genes_est(j).splicegraph{1},2)>2
      exon = [genes_est(j).splicegraph{1}(:,2:end-1)]';
      idx =  find(exon(:,1)>=gene.start&exon(:,2)<=gene.stop);
      exon = exon(idx,:);
      exons_obsv =  unique([exons_obsv;  exon],'rows');
    end
    if ~isempty(intron)
      idx =  find(introns_pred(:,1)>=min(intron(:))&introns_pred(:,2)<=max(intron(:)));
      intron_idx = [intron_idx; idx];
      idx =  find(exons_pred(:,1)>=min(intron(:))&exons_pred(:,2)<=max(intron(:))); 
      exon_idx = [exon_idx; idx];
    end
    for k=1:length(genes_est(j).transcripts),
      gene.transcripts{end+1} = genes_est(j).transcripts{k} ;
      [dummy,exon_order] = sort(genes_est(j).exons{k}(:,1)',2,'ascend');
      gene.exons{end+1} = genes_est(j).exons{k}(exon_order,:) ;
    end ;
    
  end
  intron_idx = unique(intron_idx);
  %  introns_obsv = unique(introns_obsv,'rows');
  %  introns_pred = unique(introns_pred,'rows');
  introns.num_pred_total = introns.num_pred_total + size(introns_pred,1);  
  introns.num_pred_cov = introns.num_pred_cov + length(intron_idx);
  introns.num_obsv_cov = introns.num_obsv_cov + size(introns_obsv,1);
  introns.num_corr = introns.num_corr + size(intersect(introns_obsv,introns_pred,'rows'),1);
  
  if introns.num_pred_total ~=introns.num_corr
    % keyboard
  end
  %%%%
  exon_idx = unique(exon_idx);
  exons_obsv = unique(exons_obsv,'rows');
  exons_pred = unique(exons_pred,'rows');
  assert(size(exons_obsv,1)<200);
  exons.num_pred_total = exons.num_pred_total + size(exons_pred,1);  
  exons.num_pred_cov = exons.num_pred_cov + length(exon_idx);
  exons.num_obsv_cov = exons.num_obsv_cov + size(exons_obsv,1);
  exons.num_corr = exons.num_corr + size(intersect(exons_obsv,exons_pred,'rows'),1);
  genes(num)=gene;

end ;


exons_obsv = [];
introns_obsv = [];
introns.num_obsv_total = 0;
exons.num_obsv_total =0 ;
for j=1:length(genes_est)
  if (mod(j,100)==0), 
    fprintf('%i/%i\r',j,length(genes_est))
  end
  gene=genes_est(j);
  introns_obsv = unique([gene.splicegraph{1}(2,1:end-1); gene.splicegraph{1}(1,2:end)]','rows');
  exons_obsv = unique([gene.splicegraph{1}'],'rows');
  
  introns.num_obsv_total = introns.num_obsv_total+size(introns_obsv,1); 
  assert(size(introns_obsv,1)<200);
  if size(genes_est(j).splicegraph{1},2)>2
    exons.num_obsv_total = exons.num_obsv_total + size(exons_obsv,1)-2; 
    assert(size(exons_obsv,1)<200);
  end

end

introns.SN = introns.num_corr/introns.num_obsv_total;
introns.SP = introns.num_corr/introns.num_pred_cov;

exons.SN = exons.num_corr/exons.num_obsv_total;
exons.SP = exons.num_corr/exons.num_pred_cov;
res.exons = exons;
res.introns = introns;


res.exons
res.introns
if 0
genes = build_splice_graph_caller(genes) ;
genes = infer_splice_graph_caller(genes) ;

for i=1:length(genes)
  [dummy,exon_order] = sort(genes(i).splicegraph{1}(1,:),2,'ascend');
  genes(i).splicegraph{1} = genes(i).splicegraph{1}(:,exon_order);
  genes(i).splicegraph{2} = genes(i).splicegraph{2}(exon_order,exon_order);
end
genes = alt_const(genes) ;


if genes(i).is_alt,
  num_dev=num_dev+1 ; 
  viewsplicegraph(genes(i)) ;
  pause
end ;
end
