 function print_graph_dot(model,file,edgelabel)



if nargin==2
  edgelabel=0;
end
[row col] = find(model.A>-inf);

fd = fopen(file,'w+');

fprintf(fd, 'digraph G {\n');
fprintf(fd, 'graph [overlap="scale"] ;\n');
don_states = [];
acc_states = [];
for j=1:length(model.states)
  if ~isempty(findstr('CDS_acc',model.states(j).name))
    acc_states = [acc_states j];
  elseif ~isempty(findstr('CDS_don',model.states(j).name))
    don_states = [don_states j];
  end
end

fprintf(fd,'{rank=same; seq_start;}\n') 
fprintf(fd,'{rank=same; tss;}\n') 
fprintf(fd,'{rank=same; tis;}\n') 
fprintf(fd,'{rank=same; UTR5_don UTR5_acc;}\n') 
fprintf(fd,'{rank=same; CDS_don_0 CDS_don_1a CDS_don_1b CDS_don_2a CDS_don_2b CDS_don_2c ;}\n');
fprintf(fd,'{rank=same; intergenic_long;}\n') 
fprintf(fd,'{rank=same; CDS_acc_0 CDS_acc_1a CDS_acc_1b CDS_acc_2a CDS_acc_2b CDS_acc_2c ;}\n');
fprintf(fd,'{rank=same; cdsStop;}\n');
fprintf(fd,'{rank=same; UTR3_don UTR3_acc;}\n') 
fprintf(fd,'{rank=same; polya;}\n');
fprintf(fd,'{rank=same; cleave;}\n');
fprintf(fd,'{rank=same; seq_end;}\n');

acc_x = 300;
don_x = 6000;
for j=1:length(model.states)
  if ~isempty(findstr('CDS_acc',model.states(j).name))
    fprintf(fd,'    node [color=grey,pos="%f,%f"]  ',200+10*j^2,acc_x);
    fprintf(fd,'%s;\n ',model.states(j).name);
  elseif ~isempty(findstr('CDS_don',model.states(j).name))
    fprintf(fd,'    node [style=filled,color=grey,pos="%f,%f"]  ',200+10*j^2,don_x);
    fprintf(fd,'%s;\n ',model.states(j).name);
  else
    fprintf(fd,'    node [style=filled,color=grey,pos="%f,%f"]  ',100*j,100);
    fprintf(fd,'%s;\n ',model.states(j).name);
  end
end

for i=1:length(row)
  cont_id = model.transition_pointers(col(i),row(i),2);
  for name = fieldnames(model.contents)'
    name = name{1};
    if model.contents.(name) == cont_id
      break;
    end
  end
  if edgelabel
    fprintf(fd, ' %s -> %s [label=%s];\n',model.states(row(i)).name,model.states(col(i)).name,name);
  else
    fprintf(fd, ' %s -> %s [minlen=2];\n',model.states(row(i)).name,model.states(col(i)).name);
  end
end
fprintf(fd, '}\n')
fclose(fd);

ret = unix(sprintf('dot -Tpng -o %s.png %s', file, file));
assert(ret==0)
fprintf(1, 'png-file written to %s.png\n',file)


