function [SN,SP,type_names] = print_texTable(fn,res_SN,res_SP,sources)
  
  
type_names={'cds_nucleotides','cds_exons', ...
            'cds_transcripts','genes','acc','don','tis','cdsStop','tss','cleave'};

  
res=res_SN;
for i = 1:length(sources); 
  for j = 1:length(type_names)
    if ~isequal(type_names{j},'cleave')&~isequal(type_names{j},'tss')
      SN(i,j) = res(i).(type_names{j}).SN;
    else
      SN(i,j) = res(i).(type_names{j}).SN20;
    end
  end
end

res=res_SP;
for i = 1:length(sources); 
  for j = 1:length(type_names)
    if ~isequal(type_names{j},'cleave')&~isequal(type_names{j},'tss')
      SP(i,j) = res(i).(type_names{j}).SP;
    else
      SP(i,j) = res(i).(type_names{j}).SP20;
    end
    M(i,j) = mean([SP(i,j),SN(i,j)]);
  end
end

SN = round(SN*10000)/100;  
SP = round(SP*10000)/100;  
M = round(M*10000)/100 ; 

[tmp,idx] = max(M);

fd=fopen([fn '.txt'],'w+');


fprintf(fd,'& \\multicolumn{3}{c}{Base} & \\multicolumn{3}{c}{Exon} &\\multicolumn{3}{c}{Transcript} & \\multicolumn{3}{c}{Gene}  \\tabularnewline \n');
fprintf(fd,'& Sn & Sp & Avg & Sn & Sp & Avg & Sn & Sp & Avg & Sn & Sp & Avg \\tabularnewline\n');
fprintf(fd,'\\hline\\n');
      
segments = {'cds_nucleotides','cds_exons','cds_transcripts','genes'};     
for i=1:length(sources)
  fprintf(fd,'\n {\\sf %s} ',sources{i});
  for j=1:length(segments)
    num=find(strcmp(type_names,segments{j}));
    fprintf(fd,'& %.2f & %.2f ',SN(i,num),SP(i,num));
    if i==idx(num)
      fprintf(fd,'& \\bf{%.2f} ',M(i,num));
    else
      fprintf(fd,'& %.2f ',M(i,num));
    end
  end
  fprintf(fd,'\\tabularnewline');
end

fprintf(fd,'\n\n') ;


signals={'acc','don','tis','cdsStop','tss','cleave'};


fprintf(fd,'& \\multicolumn{3}{c}{Acc} & \\multicolumn{3}{c}{Don} &\\multicolumn{3}{c}{TIS} & \\multicolumn{3}{c}{Stop}  &\\multicolumn{3}{c}{TSS} & \\multicolumn{3}{c}{Cleave} \\tabularnewline \n');
fprintf(fd,'& Sn & Sp & Avg & Sn & Sp & Avg & Sn & Sp & Avg & Sn & Sp & Avg & Sn & Sp & Avg\\tabularnewline\n');
fprintf(fd,'\\hline\\n');
for i=1:length(sources) 
  fprintf(fd,'\n {\\sf %s} ',sources{i});
  for j=1:length(signals)
    num=find(strcmp(type_names,signals{j}));
    fprintf(fd,'& %.2f & %.2f ',SN(i,num),SP(i,num));
    if i==idx(num)
      fprintf(fd,'& \\bf{%.2f} ',M(i,num));
    else
      fprintf(fd,'& %.2f ',M(i,num));
    end
  end
  fprintf(fd,'\\tabularnewline');
end


fclose(fd);