
PAR.dir = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl';

PAR.fn_blocks_anno   = sprintf('%s/test_blocks_WS160.mat',PAR.dir);

PAR.fn_blocks_pred  = sprintf('%s/LSL/cat-1/test_predictions/gr_final_linear-30-12-2006/pred_final_cleave2.50.mat',PAR.dir,PAR.exp_name);
PAR.fn_blocks_final = sprintf('%s/LSL/cat-1/test_predictions/gr_final_linear-30-12-2006/pred_final_cleave2.50_anno_wb160.mat',PAR.dir,PAR.exp_name);
PAR.fn_eval      = sprintf('%s/RESULTS/cat-1.txt',PAR.dir,PAR.exp_name);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fid = fopen(PAR.fn_eval,'a+');

%% replace truth field and all annotation fields in structure blocks
%% with new annotation loaded from PAR.fn_signals:
%% if blocks are two big they are subdivided into smaller ones

L=load(PAR.fn_blocks_train,'PAR');
PAR.model = L.PAR.model ; clear L

if ~fexist(PAR.fn_blocks_final)
  blocks = add_annotation2blocks(PAR) ;
  L = load(PAR.fn_blocks,'PAR');
  blocks = check_blocks_2(blocks,L.PAR.model) ;
  blocks = divide_blocks(blocks);
  blocks = gen_truth(blocks,L.PAR.model,0) ;
  arraysave2(PAR.fn_blocks_save,blocks,'blocks')
end
 
%%% start evaluation
PAR.fn_blocks = PAR.fn_blocks_save 
% masks = {'confirmed', 'unconfirmed', 'all'};
masks =  {'all','confirmed','unconfirmed'};
fprintf(fid, 'Evaluation of predictions from %s \n', PAR.fn_blocks);
EV.confirmed = [];
EV.unconfirmed = [];
EV.all = [];
for m = 1:length(masks),
  fprintf('(%s)\n', upper(masks{m}));
  PAR.mask_on = masks{m};
  PAR.verb = 2;
  ev = evaluate_block_predictions(PAR);
  EV = setfield(EV,masks{m},ev);
  if 1
    fprintf(fid,'Evaluation on %s \n', masks{m});
    fprintf(fid,'  on nucleotide level:\n');
    fprintf(fid,'    sensitivity: %2.2f%%\n', 100*ev.nucleotides.SN);
    fprintf(fid,'    specificity: %2.2f%%\n', 100*ev.nucleotides.SP);
    fprintf(fid,'    number of obseved  %i\n\n', ev.nucleotides.num_obsv);
      
    fprintf(fid,'  on coding exon level:\n');
    fprintf(fid,'    sensitivity: %2.2f%% (missing exons: %2.2f%%)\n', ...
            100*ev.cds_exons.SN, 100*ev.cds_exons.ME);
    fprintf(fid,'    specificity: %2.2f%% (wrong exons:   %2.2f%%)\n', ...
            100*ev.cds_exons.SP, 100*ev.cds_exons.WE);
    fprintf(fid,'    number of obseved  %i\n\n', ev.cds_exons.num_obsv);
    
    fprintf(fid,'  on transcript level:\n');
    fprintf(fid,'    sensitivity: %2.2f%% (cut genes: %2.2f)\n', ...
            100*ev.transcripts.SN, 100*ev.cut.pc);
    fprintf(fid,'    specificity: %2.2f%% (merged genes: %2.2f)\n\n'...
            , 100*ev.transcripts.SP,100*ev.merged.pc);
    fprintf(fid,'    number of obseved  %i\n\n', ev.transcripts.num_obsv);
    fprintf(fid,'  TIS:\n');
    fprintf(fid,'    sensitivity: %2.2f%%\n', 100*ev.tis.SN);
    fprintf(fid,'    specificity: %2.2f%%\n\n', 100*ev.tis.SP);
    
    fprintf(fid,'  STOP:\n');
    fprintf(fid,'    sensitivity: %2.2f%%\n', 100*ev.stop.SN);
    fprintf(fid,'    specificity: %2.2f%%\n\n', 100*ev.stop.SP);
  end
  if i==1
    PAR.fn_eval_1 = [PAR.fn_eval(1:end-4), 'left_out.mat'];
  else
    PAR.fn_eval_1 = [PAR.fn_eval(1:end-4), 'test.mat'];
  end
  save(PAR.fn_eval_1, 'EV')
end
