function reconcatinate_blocks(fn_in,fn_out,model,genome_info)
  


%-----------------------------

for f=1:length(fn_in),
  if 0% fexist(fn_out{f})
    fprintf('file %s already there \n', fn_out{f});  
    continue
  end
  fprintf('loading predictions from %s...\n', fn_in{f});
  load(fn_in{f}, 'blocks');
  assert(length(unique([blocks.strand]))==1);
  new_block.chr = blocks(1).chr;
  for j=1:length(blocks)
    if ~isfield(blocks(j),'chr_num')|isempty(blocks(j).chr_num)
      blocks(j).chr_num= strmatch(blocks(j).chr,genome_info.contig_names, ...
                                  'exact');
    end
  end
  assert(length(unique([blocks.chr_num]))==1); 
  new_block.chr_num = blocks(1).chr_num;
  new_block.strand = blocks(1).strand;
  new_block.id = blocks(1).id;
  new_block.block_start = blocks(1).block_start;
  new_block.block_end = blocks(1).block_end;
  if  blocks(1).strand== '-'
    new_block.offset = blocks(1).block_start+1;
  else
    new_block.offset = 0;
  end
  % new_block.block_end = blocks(1).offset + length(blocks(1).genestr)-1;
  len = abs(new_block.block_end-new_block.block_start);
  
  % re-concatenate
  segments = [];
  genestr  = repmat('X', 1, len);
  
  for b=1:length(blocks),
    % if b==30 &isequal(fn_in{f},['/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1//'...
    %                       'test_predictions/new_signals_new_labels_better-17-11-2007/pred_contig_corrected7_cleave6.00.mat'])
    %   warning('correcting shift')
    %   blocks(b).prediction.segments(:,1:2) = blocks(b).prediction.segments(:,1:2)+2;      
    % end
    seg = blocks(b).prediction.segments;
    if 0
      idx = find(seg(:,3)==model.segments.utr5exon);
      seg(idx,2) = seg(idx,2)+1;
      seg(idx+1,1) = seg(idx+1,1)+1;
      ii = find(seg(:,2)-seg(:,1)<=0);
      if ~isempty(ii)
        keyboard
        seg(ii,1)=seg(ii,1)-1;
        seg(ii-1,2)=seg(ii-1,2)-1;
      end
    end
    [idx1,idx2] = find(seg(:,1:2)==0);
    if ~isempty(idx1) 
      for jj=1:length(idx1)
        seg(idx1(jj),idx2(jj))=1;    
      end  
      warning('position = 0 found')
      assert(all(seg(:,2)-seg(:,1)>=0))
    else   
      assert(all(seg(:,2)-seg(:,1)>0))   
    end
    assert(issorted(seg(:,1)))
    assert(issorted(seg(:,2)))
    assert(all(seg(2:end,1)-seg(1:end-1,2)==0))
    seg(:,1:2) = seg(:,1:2) + blocks(b).offset-1;
    
    if b==1,
      segments = seg;
    else
      assert(segments(end,3) == seg(1,3));
      segments(end,2) = seg(1,2);
      segments = [segments;seg(2:end,:)];
    end
    genestr(blocks(b).offset+[0:length(blocks(b).genestr)-1]) = blocks(b).genestr;
  end
%   segments_=unique(segments,'rows'); 
  assert(issorted(segments(:,1)));
  assert(issorted(segments(:,2)));
  idx = find(segments(2:end,3)==3&segments(1:end-1,3)==7)+1;                                                                    
  if ~(all(genestr(segments(idx,1)-2)=='A'))                                                           
    warning('invalid acceptor')
    keyboard
  end
  if ~(all(genestr(segments(idx,1)-1)=='G'))
    warning('invalid acceptor')                                                                     
    keyboard                                                                 
  end                                               
  
  idx = find(segments(1:end-1,3)==3&segments(2:end,3)==7);
  if ~(all(genestr(segments(idx,2))=='G'))
    warning('invalid donor') 
  end 
  if ~(all(genestr(segments(idx,2)+1)=='C'| ... 
           genestr(segments(idx,2)+1)=='T'))
    warning('invalid donor')                                                              
  end  
  new_block.prediction.segments = segments;
  new_block.genestr = genestr;
  blocks = new_block;
  save(fn_out{f}, 'blocks');
  clear blocks
end
