function genes = replace_contignames(genes,field,fn)
% genes = replace_contignames(genes,field,fn)
  

fd = fopen(fn,'r');

old_names={};
new_names={};
while ~feof(fd),
  Line = fgetl(fd);
  elems = separate(Line,' ',1);
  old_names{end+1} = elems{1};
  new_names{end+1} = elems{2};
end 

if ~isempty(genes)
  [genes try_inverse] = replace(genes,field,old_names,new_names);
  if try_inverse
    [genes try_inverse] = replace(genes,field,new_names,old_names);
    if try_inverse
      error('names not found in genes')      
    end
  end
end


fclose(fd);

function [genes try_inverse] = replace(genes,field,old_names,new_names)

done = ones(length(old_names),1);

for i=1:length(old_names)
  if length(genes)>1
    tmp = {genes.(field)};
  else
    tmp = genes.(field);
  end
  
  idx = strmatch(old_names{i},tmp,'exact');
  if isempty(idx)
    done(i) =0; 
    continue
  end
  if length(genes)>1
    for j=idx'
      genes(j).(field) = new_names{i};
    end
  else
    genes.(field){idx} = new_names{i};
  end
end
if ~any(done)
  try_inverse = 1;
else
  try_inverse = 0 ;
end