function view_overlapping_predictions(old_seg_inoverlap,seg_inoverlap,model,old_signal,new_signal)
  
clf ;hold on; grid on

plot_segments(old_seg_inoverlap,model,0)
plot_segments(seg_inoverlap,model,1.2)

if nargin>3   
  plot_signals(old_signal,-1)
  plot_signals(new_signal,-2)
end

hold off;

function plot_segments(segments,model,y_val)
  
exons = segments(segments(:,3)==model.segments.cds_exon,:);

for i=1:size(exons,1)  
  patch([exons(i,1) exons(i,2) exons(i,2) exons(i,1)],y_val+[0 0 1 1],'r')
end
intron = segments(segments(:,3)==model.segments.intron,:);
% keyboard
for i=1:size(intron,1)  
  h = line([intron(i,1) mean(intron(i,1:2)) intron(i,2)],y_val+[0.5, 1, 0.5]) ;
  set(h,'color','k') ;
  set(h, 'LineWidth',2) ;
  % patch([intron(i,1) intron(i,2) intron(i,2) intron(i,1)],y_val+[0.2 0.2 0.8 0.8],'k')
end

utr5 = segments(segments(:,3)==model.segments.utr5exon,:);
for i=1:size(utr5,1)  
  patch([utr5(i,1) utr5(i,2) utr5(i,2) utr5(i,1)],y_val+[0.2 0.2 0.8 0.8],'b')
end
utr3 = segments(segments(:,3)==model.segments.utr3exon,:);
for i=1:size(utr3,1)  
  patch([utr3(i,1) utr3(i,2) utr3(i,2) utr3(i,1)],y_val+[0.2 0.2 0.8 0.8],'g')
end
polya = segments(segments(:,3)==model.segments.polya_tail,:);
for i=1:size(polya,1)  
  patch([polya(i,1) polya(i,2) polya(i,2) polya(i,1)],y_val+[0.2 0.2 0.8 0.8],'g')
end
trans = segments(segments(:,3)==model.segments.transexon,:);
for i=1:size(trans,1)  
  patch([trans(i,1) trans(i,2) trans(i,2) trans(i,1)],y_val+[0.2 0.2 0.8 0.8],'b')
end

intercis = segments(segments(:,3)==model.segments.intercistronic,:);
for i=1:size(intercis,1)  
  patch([intercis(i,1) intercis(i,2) intercis(i,2) intercis(i,1)],y_val+[0.4 0.4 0.6 0.6],'k')
end


function plot_signals(signal,y_val)
 % sensors
plot(signal.contig_pos,y_val+signal.Conf_cum,'*-');
