function [auROC,auPRC]= get_content_performance(fn_base,types,orders, num_SVMs)
  
%   [auROC,auPRC]= get_content_performance(fn_base,types,orders,num_SVMs)

  
  
% fn= '/fml/ag-raetsch/share/projects/nGASP/content/RESULTS_2006-12-22_17h27/content_SVM_'
% fn= '/fml/ag-raetsch/share/projects/nGASP/content/RESULTS_2006-12-22_16h37/frame_SVM_split'

if nargin<2 
  types = { 'ige' 'utr' 'cex' 'ino' 'ics' 'frame'};
end
   
if nargin<3
  for t=1:length(types)
    if isequal(types{t},'frame')
      orders{t} = [3 6];
    else
      orders{t} = [3:6];
    end 
  end
end

if nargin<4 
  num_SVMs = [1:5]
end



for t = 1:length(types)
  for o = orders{t}
    for j = num_SVMs
      load(sprintf('%s%s_split%i_order%i_binHist1.mat',fn,type{t},j,o),'SVM');
      roc(t,o,j)=SVM.ROC_score;
      prc(t,o,j)=SVM.PrR_score;
    end
  end
end

%%%PRINT


for t=1:length(type)
  for o=orders{t}
    fieldname = sprintf('%s_order%i',types{t},o)
    auROC.(fieldname) = [mean(roc(t,o,:))*100, std(roc(t,o,:))*100];
    auPRC.(fieldname) = [mean(prc(t,o,:))*100, std(prc(t,o,:))*100];
    fprintf('%s\t',fieldname)
    fprintf('%.2f+-%.2f\n', mean(roc(t,o,:))*100,std(roc(t,o,:))*100)
  end
  fprintf('\n\n')
end