%%%%%%%%%PR curves// ROC Curves


PAR.dir = '/fml/ag-raetsch/share/projects/genefinding/';
num_partition = [1 1 1 1 1];
organism  = {'C_elegans','A_thaliana','D_melanogaster','D_rerio','H_sapiens'};
%organism  = {'C_elegans','A_thaliana','D_melanogaster','H_sapiens'};
method   =  {'PWM_output','output','WDS_output'};
opt.plotRoc = 0;
opt.plotFdr = 0;
color = {'r','g','b'}
for j = 1:-1
  for i = 1:3
    disp(organism{j});
    Confcum = [];
    LT = [];
    for p = 1:num_partition(j)
      L = load(sprintf('%s%s/sensors/acc/%s/predacc_partition=%i.mat',PAR.dir,organism{j},method{i},p),'Conf_cum','LT');
      Confcum = [Confcum L.Conf_cum'];
      LT = [LT L.LT];
    end
    % keyboard
    
    acc_res(i,j) = plotRoc(Confcum,LT,opt);
    
    Confcum = [];
    LT = [];
    for p = 1:num_partition(j)
      L = load(sprintf('%s%s/sensors/don/%s/preddon_partition=%i.mat',PAR.dir,organism{j},method{i},p),'Conf_cum','LT');
      Confcum = [Confcum L.Conf_cum'];
      LT = [LT L.LT];
    end
    % keyboard
    don_res(i,j) = plotRoc(Confcum,LT,opt);
  end
end
%save(sprintf('%sroc_pr.mat',PAR.dir),'don_res','acc_res')

figure;hold on;
color = {'r','g','b'}
type = {'-','--','-.',':','+'}
for j = 1:5
  for i = 1:3
    if j==5
      x=acc_res(i,j).TPRs;
      y=acc_res(i,j).PPVs;
      plot(x(1:10:end).*100,y(1:10:end).*100,[color{i} type{j}], 'LineWidth', 0.1,'MarkerSize',4);
    else
      plot(acc_res(i,j).TPRs.*100,acc_res(i,j).PPVs.*100,[color{i} type{j}], 'LineWidth', 2);
    end
  end
end
plot([0 100],[3 3],'k')
% plot([0 100],[0.3 0.3],'k')
text(10, 5,'random guess on worm','Fontsize',16 )
% text(10, 1.5,'random guess on human','Fontsize',16)
grid on
ylabel( 'positive predictive value [1-FDR] (%)','Fontsize',16 );
xlabel( 'true positive rate (%)','Fontsize',16 );
title( 'Acceptor','Fontsize',16 );
h = gca;
set(h,'Fontsize',16)
print( '-dpsc','-r300', sprintf('~/svn/tex/BMCSplice2007/pics/PRC_big_acc'));
print( '-dpng', sprintf('~/svn/tex/BMCSplice2007/pics/PRC_big_acc'));
print( '-djpeg90','-r300', sprintf('~/svn/tex/BMCSplice2007/pics/PRC_big_acc'));



figure;hold on;
for j = 1:5
  for i = 1:3
    if j==5
      x=acc_res(i,j).FPRs;
      y=acc_res(i,j).TPRs;
      plot(x(1:10:end).*100,y(1:10:end).*100,[color{i} type{j}], 'LineWidth', 0.1,'MarkerSize',4);
    else
      plot(acc_res(i,j).FPRs.*100,acc_res(i,j).TPRs.*100,[color{i} type{j}], 'LineWidth', 2);
    end
  end
end
plot([0 100],[0 100],'k')

grid on
xlabel( 'false positive rate (%)','Fontsize',16 );
ylabel( 'true positive rate (%)','Fontsize',16 );
title( 'Acceptor','Fontsize',16 );
h = gca;
set(h,'Fontsize',16)
print( '-dpsc','-r300', sprintf('~/svn/tex/BMCSplice2007/pics/ROC_big_acc'));
print( '-dpng', sprintf('~/svn/tex/BMCSplice2007/pics/ROC_big_acc'));
print( '-djpeg90','-r300', sprintf('~/svn/tex/BMCSplice2007/pics/ROC_big_acc'));



figure;hold on;
for j = 1:5
  for i = 1:3
    if j==5
      x=don_res(i,j).TPRs;
      y=don_res(i,j).PPVs;
      plot(x(1:10:end).*100,y(1:10:end).*100,[color{i} type{j}], 'LineWidth', 0.1,'MarkerSize',4);
    else
      plot(don_res(i,j).TPRs.*100,don_res(i,j).PPVs.*100,[color{i} type{j}], 'LineWidth', 2);
    end
  end
end
plot([0 100],[2 2],'k')
text(10, 5,'random guess on worm','Fontsize',16 )
% legend('wurm PSSM','wurm WD','wurm WDS','fly PSSM','fly WD','fly WDS',...
%        'cress PSSM','cress WD','cress WDS','human PSSM','human WD','human WDS','location','NorthEastOutside')
grid on
ylabel( 'positive predictive value [1-FDR] (%)','Fontsize',16 );
xlabel( 'true positive rate','Fontsize',16 );
title( 'Donor','Fontsize',16 );
h = gca;
set(h,'Fontsize',16)
print( '-dpsc','-r300', sprintf('~/svn/tex/BMCSplice2007/pics/PRC_big_don'));
print( '-dpng', sprintf('~/svn/tex/BMCSplice2007/pics/PRC_big_don'));
print( '-djpeg90','-r300', sprintf('~/svn/tex/BMCSplice2007/pics/PRC_big_don'));



figure;hold on;
for j = 1:5
  for i = 1:3
    if j==5
      x=acc_res(i,j).FPRs;
      y=acc_res(i,j).TPRs;
      plot(x(1:10:end).*100,y(1:10:end).*100,[color{i} type{j}], 'LineWidth', 0.01,'MarkerSize',4);
    else
      plot(don_res(i,j).FPRs.*100,don_res(i,j).TPRs.*100,[color{i} type{j}], 'LineWidth', 2);
    end
  end
end
plot([0 100],[0 100],'k')
 legend('worm MC','worm WD','worm WDS','cress MC','cress WD','cress WDS',...
        'fly MC','fly WD','fly WDS','fish MC','fish WD','fish WDS','human MC','human WD','human WDS','location','NorthEastOutside','Orientation','vertical')%'horizontal')

grid on
xlabel( 'false positive rate (%)','Fontsize',14 );
ylabel( 'true positive rate (%)','Fontsize',14 );
title( 'Donor','Fontsize',16 );
h = gca;
set(h,'Fontsize',14)
print( '-dpsc','-r300', sprintf('~/svn/tex/BMCSplice2007/pics/ROC_big_don'));
print( '-dpng', sprintf('~/svn/tex/BMCSplice2007/pics/ROC_big_don'));
print( '-djpeg90','-r300', sprintf('~/svn/tex/BMCSplice2007/pics/ROC_big_don'));


