function find_svm_motifs(svmFileName,motifsFileName)
% for usage with rproc
if nargin==1
  paths
  motifsFileName=svmFileName.motifsFileName;
  svmFileName=svmFileName.svmFileName;
end

addpath ~raetsch/shogun/trunk/src

%addpath /fml/ag-raetsch/share/svn/tools/shogun/
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% INIT SVM 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% addpath ~raetsch/projects/shogun/src
  
% addpath ~/svn/projects/splicesites_GS/t
which sg

load(svmFileName, 'Train') ;
PAR = Train.PAR;
% keyboard
%if isequal(Train.PAR.SVM.kernel,'WD');
%  Train.PAR.shift = 1e-9;
%  Train.PAR.SVM.kernel = 'WDs';
%end

sg( 'send_command', 'loglevel ALL');
%if ~Train.PAR.use_conservation
% POIMS can only be calculated using the WDS-kernel
PAR.method.kernels{1}.name='WDS';
PAR.method.kernels{1}.shift=0;
PAR.method.kernels{1}.order=8;
init_svm_and_kernels(PAR);
setFeatures('TRAIN', PAR, Train);
%else
%  SC = Train.SC;
%  init_svm_splicesites(XT,LT,Train.PAR,SC);
%end
Train.alphas(:,2)= (0:size(Train.alphas, 1)-1)';
sg('set_svm', Train.b, Train.alphas) ;  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Predict
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%sg('send_command', 'delete_kernel_optimization') ;
% sg('send_command', 'init_kernel_optimization') ;

len = PAR.method.kernels{1}.rwin-PAR.method.kernels{1}.lwin+1;
[ Contribs, maxContribs, cons_seq  ] = extractKmerContribs(len, PAR.method.poim_maxOrder);
sg('set_features', 'TEST', cons_seq,'DNA') ;
sg('send_command', 'init_kernel TEST') ;
output = sg('svm_classify') ;

for j=1:PAR.method.poim_maxOrder
  [ res(j), param(j) ] = findRelevantKmers(Train.PAR.method.kernels{1}.lwin+1, Contribs{j});
end
save(motifsFileName,'Contribs','maxContribs', 'cons_seq','res','param','output');
% [ figs, figMax ] = plotKmerContribs( Train.PAR.par.llen+1, Contribs, maxContribs, 'test' );
