function ret = predict(PAR,set)

paths

if nargin<2 || strcmp(set,'test')
  testset=1;
else
  testset=0;
end


PAR.submit=0;
PAR.iteration = find_iteration(PAR);
if testset
  PAR.fn_pred = [PAR.FN.output_lsl.fn_pred 'iteration_' num2str(PAR.iteration) '/'];
  PAR.fn_blocks = PAR.FN.input_lsl.fn_val_blocks;
else
  PAR.fn_pred = [PAR.FN.output_lsl.fn_pred 'trainset_iteration_' num2str(PAR.iteration) '/'];
  PAR.fn_blocks = PAR.FN.input_lsl.fn_training_blocks;
end

unix(sprintf('mkdir %s',PAR.fn_pred));
pred_path(PAR) ;

load(PAR.fn_blocks,'blocks');
genome_info = init_genome(PAR.FN.input.fn_genome_config);

for j=1:length(blocks)
  load(sprintf('%s_viterbi_block%i',PAR.fn_pred,blocks(j).id),'pred');
  blocks(j).pred = pred;
  clear pred
end
load(PAR.FN.output.fn_genes_merged,'genes') ;
% for j=1:length(genes)
%   genes(j).mask_on = max(genes(j).transcript_status)<1;
% end
genes_pred = blocks2genes(blocks,PAR.model,'pred',genome_info);
for j=1:length(genes_pred)
  genes_pred(j).id = j;
  if isempty(genes_pred(j).exons{1})
    warning('exons field empty');
  end
  if isempty(genes_pred(j).cds_exons{1})
    warning('exons field empty');
  end
end
[res,map] = evaluate_predictions(blocks,genes,genes_pred,genome_info,0);

ret = res.cds_transcripts.mean_SNSP;

save(sprintf('%sresults',PAR.fn_pred),'res','ret');

return


function iteration = find_iteration(PAR)

iteration = 1 ;
while (1)
  fname = sprintf('%s_iteration%i.mat', PAR.FN.output_lsl.fn_train,iteration) ;
  if ~fexist(fname), iteration=iteration-1 ; break ; end ;
  iteration=iteration+1 ;
end ;
return
