function gene = append_cds_exon_segment(gene, exons, tis, stop, model)
% function gene = append_cds_exon_segment(gene, exons, tis, stop, model)

start_idx = find(exons(:,1)<=tis & tis<=exons(:,2)); 
stop_idx = find(exons(:,1)<=stop & exons(:,2)>=stop);
assert(length(start_idx)==1);
assert(length(stop_idx)==1);

if start_idx==stop_idx,
  gene =  [gene; [tis stop model.segments.cds_exon]];
else
  assert(stop_idx>start_idx);
  gene = [gene; [tis exons(start_idx,2) model.segments.cds_exon]];      
  gene = [gene; [exons(start_idx,2) exons(start_idx+1,1) model.segments.intron]];
  for e=start_idx+1:stop_idx-1,
    gene = [gene; [exons(e,:) model.segments.cds_exon]];
    gene = [gene; [exons(e,2) exons(e+1,1) model.segments.intron]];
  end
  gene = [gene; [exons(stop_idx,1) stop model.segments.cds_exon]];
end
