function gene = append_utr3p_segment(gene, exons, stop, polya, cleave, model,block)
% function gene = append_utr3p_segment(gene, exons, stop, polya, cleave, model)

stop_idx = find(exons(:,1)<=stop & exons(:,2)>=stop);
assert(length(stop_idx)==1);

gene = [gene; [stop exons(stop_idx,2) model.segments.utr3exon]];
if stop_idx<size(exons,1),
  gene = [gene; [exons(stop_idx,2) exons(stop_idx+1,1) model.segments.intron]];
end
    
if isempty(polya),
  polya_idx = size(exons,1);
else
  polya_idx = max(find(exons(:,1)<=polya)); 
end
    
% polya  has to be in last exon
assert(polya_idx==size(exons,1));

for e=stop_idx+1:polya_idx,
  gene = [gene; [exons(e,:) model.segments.utr3exon]];
  if e < size(exons,1),
    gene = [gene; [exons(e,2) exons(e+1,1) model.segments.intron]];
  end
end

% keyboard
idx1= min(find(block.details.pos.cleave>=cleave));
if isempty(idx1)
  idx1=length(block.details.pos.cleave)-1;
end
cleave= block.details.pos.cleave(idx1);

assert(ismember(cleave,block.pos))

if isempty(polya),
  gene(end,2) = cleave;
else
  idx1 = find(block.details.pos.polya>stop&block.details.pos.polya<cleave);
  [tmp,idx2] =  min(abs(block.details.pos.polya(idx1)-polya));
  polya = block.details.pos.polya(idx1(idx2));
  if ~isempty(polya)
    assert(ismember(polya,block.pos))
    gene(end,2) = polya;
    gene = [gene; [polya cleave model.segments.polya_tail]];
  else
    gene(end,2) = cleave;
  end
end
