function [gene,tss,trans,in_complete] = append_utr5p_segment(gene, exons, tis, tss, trans,model, block)
% function gene = append_utr5p_segment(gene, exons, tis, tss, trans, model)
in_complete = 0;
start_idx = find(exons(:,1)<=tis & tis<=exons(:,2));
if block.id==13
  % keyboard
end
if isequal(block.genestr(tis+[-2:2]),'AGATG') && isempty(trans)
  %tss
  %trans
  %tis
  %exons
  idx_tis = find(block.details.pos.trans==tis) ;
  %block.details.pos.trans(idx_tis+[-2:2])
  %block.details.score.trans(idx_tis+[-2:2])
  disp('found AGATG signal with annotated tss--consider converting to trans-splice event') ;
  if block.details.score.trans(idx_tis)>max(block.details.score.trans(idx_tis+[-4:-1 1]))+0.1 && start_idx==1&...
        block.details.score.trans(idx_tis)>0.8,
    disp('take tis') ;
    trans = tis ;
  else
    [tmp,idx] = max(block.details.score.trans(idx_tis+[-4:-1])) ;
    if abs(block.details.pos.trans(idx_tis-5+idx)-tss)<5& block.details.score.trans(idx_tis-5+idx)>0.8,
      disp('take tss') ;
      trans = block.details.pos.trans(idx_tis-5+idx) ;
    end ;
  end
end


gene_start = max(1,size(gene,1));
assert(length(start_idx)==1);
if isempty(trans),
  for e=1:start_idx 
    gene = [gene; [exons(e,:) model.segments.utr5exon]];
    if e < start_idx,
      gene = [gene; [exons(e,2) exons(e+1,1) model.segments.intron]];
    end
  end
  gene(end,2) = tis;
else      
  assert(length(trans)==1);
  assert(isequal(block.genestr(tis+[0:2]),'ATG')) ;
  if isequal(block.genestr(tis+[-2:2]),'AGATG') & abs(trans-tis)<50,
    idx_trans = find(block.details.pos.trans==trans) ;
    idx_tis = find(block.details.pos.trans==tis) ;
    if block.details.score.trans(idx_trans)<block.details.score.trans(idx_tis)
      disp('trying to correct trans-splice location') ;
      block.details.score.trans(idx_trans-2:idx_tis)
      trans=tis; 
    else
      disp('do not try to correct trans-splice location ...') ;
      block.details.score.trans(idx_trans-2:idx_tis);
      %keyboard
    end ;
  end ;
  if trans<=tss
    % warning('trans<tss')
    tss=[];
    % keyboard
  end
  % keyboard
  start_idx2 = find(exons(:,1)<=trans & trans<=exons(:,2));
  assert(start_idx2<=start_idx )
  if ~isempty(tss)
    for e=1:start_idx2
      gene = [gene; [exons(e,:) model.segments.transexon]];
      if e < start_idx2,
        gene = [gene; [exons(e,2) exons(e+1,1) model.segments.intron]];
      end        
    end
    gene(end,2) = trans;
  end
  num=size(gene,1);
  for e=start_idx2:start_idx
    gene = [gene; [exons(e,:) model.segments.utr5exon]];
    if e < start_idx,
      gene = [gene; [exons(e,2) exons(e+1,1) model.segments.intron]];
    end        
  end
  gene(num+1,1) = trans;
  gene(end,2) = tis;  
end
%make shure tss is in predicted set!!
% keyboard
if ~isempty(tss)
  idx1= max(find(block.details.pos.tss<=tss));
  if isempty(idx1)
    idx1=2;
    in_complete = 1;
  end
  tss= block.details.pos.tss(idx1);
  gene(gene_start,1) = tss;
  assert(ismember(tss,block.pos))
else
  assert(gene(gene_start,1) ==trans)
end

if ~isempty(trans)
  assert(ismember(trans,block.details.pos.trans))
  assert(ismember(trans,block.pos))
end
if ~isempty(tss)
  assert(ismember(tss,block.details.pos.tss))
end
assert(all(gene(1:end-1,2)==gene(2:end,1))) ;    
if ~in_complete 
  assert(all(gene(:,2)-gene(:,1)>=0)) ;
end
assert(issorted(gene(:,1)))
assert(~isempty(trans)|~isempty(tss))
