function collect_predictions(PAR,blocks,pausetime)

if nargin<3
  pausetime=0;
end
if isfield(PAR.method.par_ms,'cleave_offset') ;
  cleave_offset = sprintf('%1.2f',PAR.method.par_ms.cleave_offset) 
else
  cleave_offset = ''
end

fn_pred = PAR.FN.output_lsl.fn_pred;
fn_blocks = PAR.FN.input_lsl.fn_test_blocks;

if nargin>1
  [blocks,ok] = load_pred(fn_pred,blocks, pausetime);

  % save blocks
  % fname = [fn_pred sprintf('pred_split=_cleave%1.2f.mat', cleave_offset)];
  fname = [fn_pred sprintf('pred_cleave%1.2f.mat', cleave_offset)];
  fprintf('saving blocks with predictions to %s\n', fname) ;
  save_struct(fname, blocks, 'blocks') ;
  save(fname, '-append', 'PAR', 'P') ;
  return
end

genome_info = init_genome(PAR.FN.input.fn_genome_config);

for i=1:length(genome_info.contig_names)
  for j='+-'
    % fname = sprintf('%s/pred_split=%i%s_cleave%s.mat',fn_pred,i,j, cleave_offset);
    fname = sprintf('%s/pred_%i%s_cleave%s.mat',fn_pred,i,j, cleave_offset);
    if fexist(fname)
      fprintf('file exists\n')
      continue
    end
    blocks = load_struct(sprintf('%s%i%s.mat',fn_blocks,i,j), 'blocks') ;
    [blocks,ok] = load_pred(fn_pred,blocks,cleave_offset, pausetime);
    % save blocks
    if ~ok
      continue
    end
    fprintf('saving blocks with predictions to %s\n', fname) ;
    save_struct(fname, blocks, 'blocks') ;
    save(fname, '-append', 'PAR') ;
  end
end



function [blocks,ok] = load_pred(fn_pred,blocks,cleave_offset,pausetime)
ok=1;
disp('collecting results') ;
blocks(1).prediction = struct;
for block_id = 1:length(blocks),
  block = blocks(block_id) ;
  % 5fname = sprintf('%s/blocks_pred/pred__viterbi_block%i_cleave=%s.mat', fn_pred, blocks(block_id).id, cleave_offset) ;  
  % fname = sprintf('%s/blocks_pred/pred_split=_viterbi_block%i_cleave=%s.mat', fn_pred, blocks(block_id).id, cleave_offset) ; 
  fname = sprintf('%s/blocks_pred/pred_block%i_cleave=%s.mat', fn_pred, blocks(block_id).id, cleave_offset) ;
  if pausetime>0
    while ~fexist(fname)
      fprintf('.') ;
      pause(pausetime)
    end
  elseif ~fexist(fname)
    warning('no prediction yet')
    ok=0;
  else
    load(fname,'pred');   
    blocks(block_id).prediction = pred; 
  end
end
