function [blocks, QP, viterbi_nbest, no_violation] = collect_results(blocks,block_idx,num_examples,PAR,QP,viterbi_nbest);
%   [blocks, QP, viterbi_nbest, no_violation] = collect_results(blocks,block_idx,num_examples,PAR,QP,viterbi_nbest);
% 
%


fid = fopen(PAR.fn_log,'a+') ;

%addpath /fml/ag-raetsch/share/software/matlab_tools/cplex10
%addpath ~/svn/projects/genefinding/utils

max_neg  = PAR.max_neg ;
opt_step = PAR.opt_step;
model = PAR.model ;

clear A1 A1_sparse
A1 = zeros(opt_step,model.cnt_parameters) ;
A2 = sparse([],[],[],length(blocks)*max_neg,size(QP.A,2)-model.cnt_parameters, length(blocks)*max_neg) ; 
b = zeros(opt_step, 1) ;
q = 0 ; r = 0 ; q2 = 0 ;

[xis,parameters] = res2param(QP.res,num_examples,model,QP);
param_vec = weights2vector(parameters) ;
num_correct = 0 ;
fprintf('\n') ;
losses = [] ;
no_violation = zeros(1,length(blocks)) ;

max_gap = 0 ;
for id = 1:length(blocks),
  block = blocks(id) ;
  fprintf(fid,'\n block: %i, example %i\n ',block.id,id);
  while ~fexist(sprintf('%s_viterbi_block%i.mat', PAR.fn_train, block.id ))
    fprintf('.') ;
    pause(10)
  end
  fprintf('block: %i, example %i\r', block.id, id);
  load(sprintf('%s_viterbi_block%i.mat', PAR.fn_train, block.id ), 'pred');   
  assert(isfield(pred, 'loss')) ;

  if isempty(pred), warning('empty'); continue; end ;

  all_identical = 1 ;
  for pred_num = 1:length(pred)
    
    %[pred(pred_num).weights, loss(pred_num)] = ...
    %    compute_weights(pred(pred_num), block, model,parameters) ;    
    loss(pred_num) = pred(pred_num).loss ;

    identical = 0 ;
    for t=1:length(block.truth)
      identical = equal(pred(pred_num).path, block.truth(1).path) & equal(pred(pred_num).pos, block.truth(1).pos) ;
      identical = identical | (loss(pred_num)==0) ;
      if identical, break ; end ;
    end ;
    if ~identical, all_identical=0 ; end ;

    true_score=sum(param_vec.*weights2vector(block.truth(1).weights));
    max_score=sum(param_vec.*weights2vector(pred(pred_num).weights));
    if pred_num==1 
      if max_score+loss(pred_num)-true_score<-1e-4,
        keyboard;
      %else
      %  disp('score seems alright') ;
      end ;
    end ;
    vec = weights2vector(block.truth(1).weights) - weights2vector(pred(pred_num).weights);
    diff_before = -sum(param_vec.*vec);
    
    if identical,
      %assert(norm(vec)<1e-8) ;
      assert(~loss(pred_num)) ;
      if pred_num==1, 
        num_correct = num_correct+1;
      end
    else
      assert(norm(vec)>1e-8) ;
      %if loss(pred_num==0), keyboard; end 
      assert(loss(pred_num)>0) ;
      this_gap = diff_before+loss(pred_num)-xis(block_idx(id)) ;
      if max_gap<this_gap,
        max_gap=this_gap ;
      end ;
      if this_gap < 1e-7
        fprintf(fid,'no margin violation') ;
        %fprintf('\nno margin violation\n') ;
        fprintf('No margin violation: %f > %f = %f - %f\n', -diff_before, loss(pred_num) - xis(block_idx(id)), loss(pred_num), xis(block_idx(id))) ;
        if pred_num ==length(pred)
          fprintf(fid,'no constraint added');
        end
        no_violation(id)=1 ;
        continue
      end
      fprintf('Adding violated constraint %f > %f = %f - %f \n', -diff_before, loss(pred_num) - xis(block_idx(id)), loss(pred_num), xis(block_idx(id))) ;
      q  = q+1 ; 
      q2 = q2+1 ;
      A1(q2,1:model.cnt_parameters) = -vec;
      b(q2)= -loss(pred_num) ;
      A2(q, block_idx(id)) = -1 ; % slack
      
      if q2==size(A1,1)
        fprintf('*\n') ;  
        A1 = sparse(A1(1:q2,:)) ;
        assert(q==size(A1,1));
        A2 = A2(1:q,:) ;
        A = [A1 A2] ;
        QP.A = [QP.A; A] ;
        QP.b = [QP.b; b] ;
        
        %tic;[res,lambda,how] = qp_solve(QP.lpenv, QP.Q, QP.f, QP.A, QP.b, QP.lb, QP.ub, 0, 1, PAR.solver);toc;
        %tic;[res,lambda,how] = qp_solve(QP.lpenv, QP.Q, QP.f, QP.A, QP.b, QP.lb, QP.ub, 0, 1, 'sift');toc;
        
        %OBJ = sum(res.*f) + 0.5*res'*QP.Q*res ;
        %[xis,parameters,hvar,H] = res2param(res,num_examples,model);
        %sum_xis = sum(xis) ;

        q2 = 0; q = 0 ;
        A1 = zeros(opt_step,model.cnt_parameters) ;
        A2 = sparse([],[],[],length(blocks)*max_neg, size(QP.A, 2)-model.cnt_parameters, length(blocks)*max_neg) ; 
        b = zeros(opt_step, 1) ;
      end ;
      if isempty(block.pred)
        block.pred = pred(pred_num) ; 
      else
        if ~isfield(block.pred, 'loss')
          block.pred(end).loss=nan ;
          block.pred=orderfields(block.pred) ;
        end ;
        block.pred = orderfields(block.pred) ;
        block.pred(end+1) = pred(pred_num) ; 
      end ;
      block.pred(end).loss = loss(pred_num) ;
      block.pred = orderfields(block.pred) ;
      %break
    end ;
  end ; %%% loop over predictions 
  if all_identical,
    viterbi_nbest(id)=viterbi_nbest(id)+1 ;
    fprintf('increasing number of nbest path to %i\n', viterbi_nbest(id)) ;
  end ;
  blocks(id) = block ;
  losses(id) = mean(loss) ;

end ;%%% loop over blocks
fprintf(fid,['id=%i    correct=%i(%2.2f)  average_loss=%2.2f  max_gap=%2.2f' ...
             '\r'],id,num_correct,num_correct/id, mean(losses), max_gap);
fprintf(['\nid=%i    correct=%i(%2.2f)  average_loss=%2.2f  max_gap=%2.2f' ...
             '\n'],id,num_correct,num_correct/id, mean(losses), max_gap);

A1     = sparse(A1(1:q2,:)) ;
b      = b(1:q2) ;
A2     = A2(1:q,:) ;
A      = [A1 A2] ;
QP.A   = [QP.A;A] ;
QP.b   = [QP.b;b] ;
QP.max_gap = max_gap ;

fclose(fid) ;

% it does not help anyways (GR)
viterbi_nbest(:)=1 ;
