function loss = compute_path_loss(pred,truth,C,model)
% loss = compute_path_loss(pred,truth)
%

if model.loss.zero_one_loss,
  loss = ~equal(pred.path, truth.path) | ~equal(pred.pos, truth.pos),
  return 
end ;

[total, predict, correct, dist] = eval_path(pred ,truth(1), model);

missing = 0 ;

segment_names = fieldnames(model.segments)  ;
for i = 1:length(segment_names)
  if getfield(model.loss.mustbe_corr,segment_names{i})
     tot = getfield(total.num_seg, segment_names{i}) ;
     cor = getfield(correct.num_seg, segment_names{i}) ;
     missing  = missing + (tot-cor);
  end  
end

if missing 
  loss=1;
else
  loss=0;
end
%%% distance to true signals

signal_names = fieldnames(model.signals)  ;
wrong = 0;
for i = 1:length(signal_names)
  d = getfield(dist,signal_names{i});
  wrong = wrong+ sum(d>getfield(model.loss.zero_range,signal_names{i})) ;
end

loss = wrong+missing ;

