function [weights, loss, score, losses, scores, ok] = compute_weights(SEG, block, model,parameters,check_result) ;
% weights=compute_weights(segmentation, block, model) ;

if nargin<4
  parameters = [];
end
if nargin<5
  check_result = 1 ;
end
ok=true ;
[penalty_array,dict_weights,state_signals,a_trans] = gen_penalty_array(model,block.content.subset_id,parameters) ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%for i=1:length(segmentation.genes)
%  segmentation.genes{i}(1,3)=model.segments.utr5exon ;
%  segmentation.genes{i}(end,3)=model.segments.utr3exon ;
%end ;

% simple state sequence -> generate this from segmentation
% if ~isfield(SEG,'path') | isfield(SEG,'pos_idx') 
%   [my_path,pos_idx,ok]=segmentation2path(SEG.segmentation, block, model);
% else
%   my_path = SEG.path ;
%   pos_idx = SEG.pos_idx
% end
my_path = SEG.path ;
pos_idx = SEG.pos_idx ;

% keyboard
% sg('send_command', 'loglevel WARNING') ;
% sg('send_command', 'loglevel ALL') ;
%model.loss.segments(:)=1 ;
%model.loss.segments(:,9:16)=2 ;
%keyboard

%[my_path,pos_idx,pos,ok]=segmentation2path(SEG, block, model) ;

model_loss = model.loss.segments ;
if isfield(block.truth(1), 'seg_path'),
  seg_path = block.truth(1).seg_path;
  % if the alternatives disagree, then don't incur a loss
  for i=2:length(block.truth)
    if isempty(block.truth(i).seg_path), continue ; end ;
    idx = find(block.truth(i).seg_path(1,:) ~= block.truth(1).seg_path(1,:)) ;
    seg_path(2,idx) = 0 ;
  end ;
else
  model_loss(:)=0 ;
  seg_path = zeros(2, length(block.pos)) ;
end ;

%sg4('send_command', 'loglevel ALL') ;
if isfield(model, 'use_conservation') && model.use_conservation
  [p_deriv, q_deriv, a_deriv, penalty_deriv, scores, losses]= ...
      sg5('best_path_trans_deriv', my_path-1, pos_idx-1, model.p', ...
          model.q', a_trans, block.seq, block.pos-1, [lower(block.genestr); lower(block.genestr_conserv)]', ...
          model.penalties, state_signals, penalty_array, dict_weights', model.mod_words, ...
          model_loss, seg_path) ;

else
  %sg('send_command', 'loglevel ALL') ;
  [p_deriv, q_deriv, a_deriv, penalty_deriv, scores, losses]= ...
      sg('best_path_trans_deriv', my_path-1, pos_idx-1, model.p', ...
         model.q', a_trans, block.seq, block.pos-1, lower(block.genestr)', ...
         model.penalties, state_signals, penalty_array, dict_weights', model.mod_words, ...
         model_loss, seg_path) ;
end ;

loss = sum(losses) ;
score = sum(scores) ;

if isempty(parameters)
  if ~sum(scores)==0
    idx = find(scores);
    if length(idx)==1 && idx>1,
      pos_idx(idx+[-1:1]) 
      block.pos(pos_idx(idx+[-1:1]))
      my_path(idx+[-1:1])
      model.state_ids
      %  keyboard
    end ;

    block.id
    warning('invalid path: sum(scores) ~= 0')
    weights = [];
    ok=false ;
    %keyboard
    return
  end
else
  if check_result,
    assert(~isinf(sum(scores))) ;
    if isinf(sum(scores)), 
      ok=false; 
    end ;
  end ;
end

weights = init_weights(model) ;
for i=1:size(penalty_deriv,1)
  pen = penalty_array{i} ;
  weights = setfield(weights, pen.name, penalty_deriv(pen.id,:)) ;
end ;

%%% transitions
weights.transitions(:) = a_deriv(model.active_transitions) ;



%%%% for debugging
if 0 
  dbup
  dbstack
  
  idx = find(isinf(scores))
  
  SEG.path(idx:idx+1)
  
  %%%check state

  block.seq(SEG.path(idx),SEG.pos_idx(idx))
  %%%check transition 
  
  trans_lengths = SEG.pos(idx+1)-SEG.pos(idx:idx+1)
  idx2 = find(ismember(SEG.segments(:,1:2),SEG.pos(idx:idx+1),'rows'));
  seg_type = SEG.segments(idx2,3)
  
  range = model.lengths_range
end
