function [model, a_trans, block, state_signals] = duplicate_states4transcript_loss(model, a_trans, block, state_signals);
% [model, a_trans, block.seq, state_signals] = duplicate_states4transcript_loss(model, a_trans, block, state_signals) ;
  
%%% model.q

model.p = [model.p; -inf(size(model.p))]; % has to start in true state
model.q = [model.q; model.q]; % may end in false state
  
state_signals = [state_signals; state_signals] ;

%%% change transition_pointers ... they are transposed for some stupid reason
for i = 1:size(model.transition_pointers,3)
  transition_pointers(:,:,i) = [model.transition_pointers(:,:,i) zeros(size(model.transition_pointers(:,:,i))); ...
                      model.transition_pointers(:,:,i) model.transition_pointers(:,:,i)] ; 
end
idx = model.state_ids.cleave + size(block.seq,1);
transition_pointers(size(block.seq,1)+1:end, idx, :) = 0; % no intergenic transitions
                                                % allowed within false states
A = [model.A model.A; 
     -inf(size(model.A)) model.A];
A(idx, size(block.seq,1)+1:end) = -inf; % no intergenic transitions
                                        % allowed within false states 

idx2 = find(~isinf(A(model.state_ids.cleave,1:size(block.seq,1))));
A(model.state_ids.cleave + size(block.seq,1), idx2) = 0; % any transition from cleave 
                                                         % is also allowd from end of false gene to the
                                                         % corresponding true state  

model.transition_pointers = transition_pointers ;

a_trans = zeros(4,sum(~isinf(A(:)))) ;
k = 0 ;
for i=1:size(A,1)
  idx = find(~isinf(A(i,:))) ;
  val = A(i,idx) ;
  pen = transition_pointers(idx,i,1) ;
  a_trans(1,k+1:k+length(idx)) = i-1 ;
  a_trans(2,k+1:k+length(idx)) = idx-1 ;  
  a_trans(3,k+1:k+length(idx)) = val ;    
  for q=1:length(pen) 
    idx_=find(model.seg_links(:,1)==pen(q)) ;
    if isempty(idx_), 
      assert(pen(q)==0) ; 
    else
      assert(length(idx_)==1) ;
      pen(q) = model.seg_links(idx_,2) ;
    end ;
  end ;
  a_trans(4,k+1:k+length(idx))= pen;
  k = k+length(idx) ;
end ;
a_trans = a_trans' ;

% false_a_trans = a_trans;
% false_a_trans(:,1:2) = false_a_trans(:,1:2)+size(block.seq,1) ;
%  %%% add transitions from any true to corresponding false states
% switch_a_trans = a_trans;
% switch_a_trans(:,2) = false_a_trans(:,2) ;

% %%% transition from gene end to gene start is forbidden within false_a_trans
% %(has to go back to true_trans)
% idx = find(false_a_trans(:,1)==model.state_ids.cleave-1+size(block.seq,1));
% false_a_trans(idx,:) = [];
% a_trans = [a_trans; false_a_trans; switch_a_trans];


%%% duplicate seq

true_seq = -inf(size(block.seq)); 
false_seq = block.seq;
%%% if state does not agree with true segmentation score in true_seq mustbe -inf;
true_pos = block.truth(1).pos;
true_state = block.truth(1).path;
[tmp,idx1,idx2] = intersect(true_pos,block.pos);
assert(length(tmp)==length(true_pos))
for i=1:length(idx2)
  tt = block.seq(true_state(idx1(i)),idx2(i));
  assert(~isinf(tt))
  true_seq(true_state(idx1(i)),idx2(i))=tt;
end

block.seq = [true_seq;false_seq];
