
clear all;
addpath( '/fml/ag-raetsch/share/software/matlab_tools/utils/' );

% === const
resDirName = '/fml/ag-raetsch/share/projects/nGASP/LSL/train';
runNames = {
%    'az2',  'az2_training_solver=dual__iteration%d.mat'
%    'az6',  'az6_06-12-2006_15h57_train_solver_dual.mat_iteration%d.mat'
%    'az5',  'az5_03-12-2006_14h43_train_solver_dual.mat_iteration%d.mat'
%    'az3',  'az3_02-12-2006_20h32_train_solver_dual.mat_iteration%d.mat'
%    'az4',  'az4_03-12-2006_14h27_train_solver_dual.mat_iteration%d.mat'
    'az3i', 'az3i_07-12-2006_15h30_train_solver_bar.mat_iteration%d.mat'
    'az4i', 'az4i_07-12-2006_15h33_train_solver_bar.mat_iteration%d.mat'
    'aS3i', 'aS3i_07-12-2006_15h42_train_solver_bar.mat_iteration%d.mat'
};

% === eval all
nofRuns = size( runNames, 1 );
for( run = 1:nofRuns )
  shortName = runNames{ run, 1 };
  iter = 0;
  while( 1 )
    iter = iter + 1;
    fileName = sprintf( runNames{run,2}, iter );
    fileName = sprintf( '%s/%s', resDirName, fileName );
    if( ~exist(fileName,'file') )
      break;
    end;
    load( fileName, 'blocks_train' );
    res = evaluate_block_predictions( blocks_train, 0 );
    t = sprintf( '%s %2d  %5.2f %5.2f  %5.2f %5.2f  %5.2f %5.2f', shortName, iter, res.nucSn, res.nucSp, res.cexSn, res.cexSp, res.rnaSn, res.rnaSp );
    fprintf( '%s\n', t );
  end;
  iter = iter - 1;
  if( iter > 0 )
    t(:) = '-';
    fprintf( '%s\n', t );
  end;
end;

