
res_dirs = {
    %'/fml/ag-raetsch/share/projects/nGASP/LSL/cat-3/predictions/gr_final_linear-30-12-2006/'
    '/fml/ag-raetsch/share/projects/nGASP/LSL/cat-2/predictions/gr_con_final-30-12-2006/'
    %%%%%%'/fml/ag-raetsch/share/projects/nGASP/LSL/cat-2/predictions/gr_con_final_qp-30-12-2006/'
    %'/fml/ag-raetsch/share/projects/nGASP/LSL/cat-1/predictions/gr_final_linear-30-12-2006/'
    %'/fml/ag-raetsch/share/projects/nGASP/LSL/cat-1/predictions/gr_compare-01-01-2007/'
    %%%%'/fml/ag-raetsch/share/projects/nGASP/LSL/cat-1/predictions/gr_final-30-12-2006/'
    %'/fml/ag-raetsch/share/projects/nGASP/LSL/predictions/gr7-19-12-2006/'
%    '/fml/ag-raetsch/share/projects/nGASP/LSL/predictions/gr8-19-12-2006/'
%    '/fml/ag-raetsch/share/projects/nGASP/LSL/predictions/gr9-19-12-2006/'
%    '/fml/ag-raetsch/share/projects/nGASP/LSL/predictions/gr10-19-12-2006/'
%    '/fml/ag-raetsch/share/projects/nGASP/LSL/predictions/gr11-19-12-2006/'
%    '/fml/ag-raetsch/share/projects/nGASP/LSL/predictions/gr12-19-12-2006/'
%    '/fml/ag-raetsch/share/projects/nGASP/LSL/predictions/gr13-19-12-2006/'
%    '/fml/ag-raetsch/share/projects/nGASP/LSL/predictions/gr14-19-12-2006/'
           };

masks = {'confirmed', 'unconfirmed', 'all'};

eval_dirs = {};
for d=1:length(res_dirs),
  idx = strfind(res_dirs{d}, 'gr');
  eval_dirs{d} = ['/fml/ag-raetsch/share/projects/nGASP/LSL/evaluation/' ...
                  res_dirs{d}(idx:end)];
  if ~fexist(eval_dirs{d}), mkdir(eval_dirs{d}); end
end

verb = 2;
results = {};
for d=1:length(res_dirs),
  files = ls([res_dirs{d} 'pred_split=5_cleave3.5*']);
  %files = ls([res_dirs{d} 'pred_split=5.mat']);
  f_ends = strfind(files, '.mat')-1; % split at '.mat'
  f_starts = [1 f_ends+6];
  
  fnames = [];
  for f=1:length(f_ends),
    fnames{f} = files(f_starts(f):f_ends(f));        
  end
  
  dt = datestr(now,'yyyy-mm-dd_HHhMM');
  out_file = [eval_dirs{d} 'eval_all_' dt '.txt'];
  [fid, msg] = fopen(out_file, 'w');
  if ~isempty(msg), disp(msg); end
  if (fid==-1), error(sprintf('Unable to write to %s!', out_file)); end

  for f=1:length(fnames),
    in_file = [fnames{f} '.mat'];
    fprintf('Evaluating predictions from %s...\n', in_file);
    load(in_file);
    
    if isempty(masks),
      fprintf('(everything)\n');
      ev = evaluate_block_predictions(blocks, verb);
      fprintf(fid, 'Evaluation of predictions from %s (no mask)\n', fnames{f});
      fprintf(fid, '  on nucleotide level:\n');
      fprintf(fid, '    sensitivity: %2.2f%%\n', ev.nucSn);
      fprintf(fid, '    specificity: %2.2f%%\n\n', ev.nucSp);
      fprintf(fid, '  on coding exon level:\n');
      fprintf(fid, '    sensitivity: %2.2f%% (missing exons: %2.2f%%)\n', ev.cexSn, ev.cexME);
      fprintf(fid, '    specificity: %2.2f%% (wrong exons:   %2.2f%%)\n\n', ev.cexSp, ev.cexWE);
      fprintf(fid, '  on transcript level:\n');
      fprintf(fid, '    sensitivity: %2.2f%%\n', ev.rnaSn);
      fprintf(fid, '    specificity: %2.2f%%\n\n', ev.rnaSp);
      
      results{d}{f}{1} = ev;
    else
      for m=1:length(masks),
        fprintf('(%s)\n', upper(masks{m}));
        ev = evaluate_block_predictions(blocks, verb, masks{m});
        fprintf(fid, 'Evaluation of predictions from %s %s\n', ...
                fnames{f}, upper(masks{m}));
        fprintf(fid, '  on nucleotide level:\n');
        fprintf(fid, '    sensitivity: %2.2f%%\n', ev.nucSn);
        fprintf(fid, '    specificity: %2.2f%%\n\n', ev.nucSp);
        fprintf(fid, '  on coding exon level:\n');
        fprintf(fid, '    sensitivity: %2.2f%% (missing exons: %2.2f%%)\n', ev.cexSn, ev.cexME);
        fprintf(fid, '    specificity: %2.2f%% (wrong exons:   %2.2f%%)\n\n', ev.cexSp, ev.cexWE);
        fprintf(fid, '  on transcript level:\n');
        fprintf(fid, '    sensitivity: %2.2f%%\n', ev.rnaSn);
        fprintf(fid, '    specificity: %2.2f%%\n\n', ev.rnaSp);
        
        results{d}{f}{m} = ev;
      end
    end
  end
  fclose(fid);
end



keyboard
