function res = evaluate_chromosome_predictions(chr_blocks, verb, varargin);
% res = evaluate_chromosome_predictions(chr_blocks, verb, varargin);
% chr_blocks are expected to be whole-chromosome blocks having a
% field prediction

% tmp = load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/data/test_region_I+_2007-08-31.mat');
% chr_blocks(1) = tmp.test_block; clear tmp

addpath ~/svn/projects/genefinding/lsl
addpath ~/svn/projects/genefinding/data_processing_lsl
  
tester_config;
fn_polya_signals = ['/fml/ag-raetsch/share/projects/genefinding/' ...
                    'C_elegans/sensors/polya/truesites_and_consensus.mat'];
tmp = load(fn_polya_signals, 'consensus');
PAR.polya_sixmers = tmp.consensus;
model = make_model(PAR);
clear PAR C

load(['/fml/ag-raetsch/share/projects/genefinding/'...
            '/C_elegans/genome_data/annotated_genes.mat'], 'genes');

if ~isfield(genes, 'id'),
  for g=1:length(genes),
    genes(g).id = g;
  end
end
genes = remove_invalid_transcripts(genes);

% TODO use asserts instead
for g=1:length(genes),
  if ~isempty(genes(g).splicegraph{1}),
    genes(g).start = min(min(genes(g).splicegraph{1}));
    genes(g).stop = max(max(genes(g).splicegraph{1}));
    assert(~isempty(genes(g).start));
    assert(~isempty(genes(g).stop));
  end
end

gene_ids     = [genes.id];
gene_starts  = [genes.start];
gene_ends    = [genes.stop];
gene_strands = [genes.strand];

g_chr = {genes.chr};
chrs = unique(g_chr);
for i=1:length(chrs),
  chr_idx{i} = strmatch(chrs{i}, g_chr, 'exact');
end

new_block_id = 1;
invalid_block_idx = [];
for r=1:length(chr_blocks),

if 0,
  tmp = load(sprintf(['/fml/ag-raetsch/share/projects/genefinding/C_elegans/' ...
                      'genome_data/gene_mask_%s.mat'], chr_blocks(r).chr));
  true_mask = tmp.mask;
  clear tmp
  
  switch chr_blocks(r).strand,
   case '+',
    assert(chr_blocks(r).block_start==1 ...
           & chr_blocks.block_end==length(true_mask));
   case '-',
    assert(chr_blocks(r).block_end==1 ...
           & chr_blocks.block_start==length(true_mask));
  end

  if isfield(chr_blocks(r), 'prediction'),
    segm = chr_blocks(r).prediction.segments;
    pred_mask = segm(:,3)~=model.segments.intergenic ...
        & segm(:,3)~=model.segments.intercistronic;
    
    mask = true_mask(1,:)>0 | true_mask(2,:)>0 & pred_mask;
  else
    mask = true_mask(1,:)>0 | true_mask(2,:)>0;
  end
  
  [blocks new_block_id] = split_blocks(chr_blocks(r), ...
                                       new_block_id, mask);

  save tmp1
  
end

  load tmp
 
  chr_num = strmatch(chr_blocks(r).chr, chrs, 'exact');
  for b=1:length(blocks),
    switch blocks(b).strand,
     case '+',
      g_idx = find(gene_strands==blocks(b).strand ...
                   & gene_starts<=blocks(b).block_end ...
                   & blocks(b).block_start<=gene_ends);
      g_idx = intersect(g_idx, chr_idx{chr_num});
     case '-',
      g_idx = find(gene_strands==blocks(b).strand ...
                   & gene_starts<=blocks(b).block_start ...
                   & blocks(b).block_end<=gene_ends);
      g_idx = intersect(g_idx, chr_idx{chr_num});
    end
    if isempty(g_idx)
      blocks(b).gene_pos = [];
    else
      switch blocks(b).strand,
       case '+',
        [tmp s_idx] = sort(gene_starts(g_idx), 'ascend');
        g_idx = g_idx(s_idx);
        blocks(b).gene_pos(:,1) = gene_starts(g_idx) - blocks(b).offset;
        blocks(b).gene_pos(:,2) = gene_ends(g_idx)   - blocks(b).offset;
       case '-',
        [tmp s_idx] = sort(gene_starts(g_idx), 'descend');
        g_idx = g_idx(s_idx);
        blocks(b).gene_pos(:,1) = blocks(b).offset - gene_ends(g_idx);
        blocks(b).gene_pos(:,2) = blocks(b).offset - gene_starts(g_idx);
      end
    end
    
    blocks(b).gene_ids = gene_ids(g_idx);
    blocks(b).gene_confirmed = [genes(gene_ids(g_idx)).confirmed];
    % TODO
%    keyboard
    
    if isempty(g_idx) || all([genes(g_idx).is_valid]),
      blocks_anno(b) = fill_block_anno(blocks(b), genes);
    else
      invalid_block_idx = [invalid_block_idx b];
    end
  end
end
fprintf('removing %i (%2.1f%%) invalid blocks.\n', ...
        length(invalid_block_idx), ...
        100*length(invalid_block_idx)/length(blocks));

blocks_anno(invalid_block_idx) = [];

blocks = blocks_anno;

keyboard

blocks = check_blocks_2(blocks, model);
blocks = gen_truth(blocks, model);

res = evaluate_block_predictions(blocks, verb, varargin);


% eof