function segments = gene2segments(gene,strand,offset,model)
% function segments = gene2segments(gene,strand,offset)

% transform al coordinates to local block coordinates
if strand=='+',
  exons = gene.exons{1}(:,1:2) - offset;
  exons(:,2) = exons(:,2)+1; % transform to awkward LSL segmentation
  tss = exons(1,1);
  trans = [];
  tis = gene.tis_pos - offset;
  stop = gene.stop_pos - offset - 2;
  polya = [];
  cleave = exons(end,2);
else
  exons = -1.*(gene.exons{1}(end:-1:1,2:-1:1) - offset);
  exons(:,2) = exons(:,2)+1; % transform to awkward LSL segmentation  
  tss = exons(1,1);
  trans = [];
  tis = -1.*(gene.tis_pos - offset);
  stop = -1.*(gene.stop_pos - offset) - 2;% transform to LSL segmentation  
  polya = [];
  cleave = exons(end,2);
end
assert(tss<=tis);
assert(tis<=stop);
assert(stop<=cleave);


% create segmentation
segments = [];
segments = append_utr5p_segment(segments, exons, tis, tss, trans, model) ;
segments = append_cds_exon_segment(segments, exons, tis, stop, model) ;
segments = append_utr3p_segment(segments, exons, stop, polya, cleave, model) ;

% assert proper segmentation
assert(all(segments(:,1) <= segments(:,2)));
assert(all(segments(2:end,1) == segments(1:end-1,2)));

