function DNA_block = fill_block_2(DNA_block,POS,SCORE,SIXMER,OUTPUT,model,content_block,LABEL,genes)

% keyboard

% add true positions

if nargin<7
  use_annotation = 0;
else
  use_annotation = 1;
end

if use_annotation
  DNA_block.is_alt_spliced = [];
  DNA_block.is_alt = [];
  DNA_block.is_valid = [];
  
  % keyboard
  if DNA_block.strand =='+'
    intergen_start = DNA_block.offset+1;
  else
    intergen_start = DNA_block.offset;
  end
  
  N_genes = length(DNA_block.gene_ids);
  for g = 1:N_genes
    clear tis_pos stop_pos start stop 
    % if DNA_block.gene_ids(g)==1495
    %   keyboard
    % end
    
    gene = genes(DNA_block.gene_ids(g)) ; 
    splicegraph = gene.splicegraph ;
    if gene.is_alt
      DNA_block.is_alt(end+1) = 1;
    else
      DNA_block.is_alt(end+1) = 0;
    end
    if gene.is_alt_spliced
      DNA_block.is_alt_spliced(end+1) = 1;
    else
      DNA_block.is_alt_spliced(end+1) = 0;
    end
    if ~gene.is_valid
      DNA_block.is_valid(end+1) = 0;
    else
      DNA_block.is_valid(end+1) = 1;
    end
    
    if ~gene.is_alt
      assert(length(unique(gene.start))==1);
      assert(length(unique(gene.stop))==1);
    end
    
    splicegraph = gene.splicegraph;
    edges = splicegraph{2};
    graph_exons = splicegraph{1}' ;
    
    tstart=[] ; tstart_idx = [] ;
    for ixv = 1:size(graph_exons,1)
      if sum(edges(ixv,1:ixv-1)) == 0
        tstart(end+1) = graph_exons(ixv,1) ;
        tstart_idx(end+1) = ixv ;
      end
    end
    tstop = []; tstop_idx = [] ;
    for ixv = 1:size(graph_exons,1)
      if sum(edges(ixv+1:end,ixv)) == 0
        tstop(end+1) = graph_exons(ixv,2);
        tstop_idx(end+1) = ixv ;
      end
    end
    
    if DNA_block.strand =='+'
      graph_exons(:,2) = graph_exons(:,2)+1 ;
      graph_exons(tstop_idx,2) = graph_exons(tstop_idx,2)-1 ;
      graph_exons = graph_exons - DNA_block.offset;
      
      DNA_block.anno_tss{g} = unique(tstart) - DNA_block.offset ;
      DNA_block.tss{g} = unique(tstart)  - DNA_block.offset ;
      DNA_block.trans{g} = [] ;
      DNA_block.anno_tis{g} = unique(gene.tis_pos) - DNA_block.offset ;
      DNA_block.tis_is_valid{g} = zeros(size(unique(gene.tis_pos))) ;
      DNA_block.tis{g} = unique(gene.tis_pos) - DNA_block.offset ;
      DNA_block.anno_stop{g} = unique(gene.stop_pos) - DNA_block.offset-2;
      DNA_block.stop_is_valid{g} = zeros(size(unique(gene.stop_pos))) ;
      DNA_block.stop{g} = unique(gene.stop_pos) - DNA_block.offset-2;
      DNA_block.polya{g} = [] ;
      %DNA_block.anno_cleave{g} = unique(tstop) ;
      %DNA_block.cleave{g} = unique(tstop) ;
      DNA_block.anno_cleave{g} = unique(tstop) - DNA_block.offset ;
      DNA_block.cleave{g} = unique(tstop) - DNA_block.offset ;
    else
      graph_exons = graph_exons(end:-1:1,2:-1:1);
      graph_exons = DNA_block.offset - graph_exons ;
      graph_exons(:,2) = graph_exons(:,2)+1 ;
      % graph_exons(tstart_idx,2) = graph_exons(tstart_idx,2)-1 ;
      splicegraph{2} = splicegraph{2}(end:-1:1,end:-1:1) ;
      
      DNA_block.anno_tss{g} = DNA_block.offset - unique(tstop) ;
      DNA_block.tss{g} = DNA_block.offset -  unique(tstop) ;
      %DNA_block.anno_tss{g} = unique(tstop) ;
      %DNA_block.tss{g} = unique(tstop) ;
      DNA_block.trans{g} = [] ;
      DNA_block.anno_tis{g} = DNA_block.offset - unique(gene.tis_pos) ;
      DNA_block.tis_is_valid{g} = zeros(size(unique(gene.tis_pos))) ;
      DNA_block.tis{g} = DNA_block.offset - unique(gene.tis_pos) ;
      DNA_block.anno_stop{g} = DNA_block.offset - unique(gene.stop_pos) - 2;
      DNA_block.stop_is_valid{g} = zeros(size(gene.stop_pos)) ;
      DNA_block.stop{g} = DNA_block.offset - unique(gene.stop_pos) - 2;
      DNA_block.polya{g} = [];
      %DNA_block.anno_cleave{g} = unique(tstart) ;
      %DNA_block.cleave{g} = unique(tstart) ;
      DNA_block.anno_cleave{g} = DNA_block.offset - unique(tstart) + 1 ;
      DNA_block.cleave{g} = DNA_block.offset - unique(tstart) + 1  ;
    end
    
    splicegraph{1} = graph_exons';
    
    DNA_block.splicegraph{g} = splicegraph ;
    
    assert(all(all(DNA_block.splicegraph{g}{1}>0)))
    assert(all(DNA_block.tss{g}>0))
    assert(all(DNA_block.tis{g}>0))
    assert(all(DNA_block.stop{g}>0))
    assert(all(DNA_block.cleave{g}>0))
    
    % keyboard
  end %%% loop over genes
end %%% if use_annotation

% keyboard

% add detector scores to details

DNA_block.details.pos = [];
DNA_block.details.score = [];
DNA_block.details.output = [];
DNA_block.details.label = [];
DNA_block.details.sixmer = [];
signal_names = fieldnames(model.signals) ;
for sig = 1:length(signal_names)
  if strcmp(signal_names{sig},'transacc')
    continue
  end
  cand_pos = getfield(POS,signal_names{sig});
  cand_score = getfield(SCORE,signal_names{sig});
  if DNA_block.strand =='+'
    idx1 = find(cand_pos > DNA_block.offset+50 & ...
                cand_pos < DNA_block.block_end-50);
    DNA_block.details.pos = setfield(DNA_block.details.pos,...
                                     signal_names{sig}, ...
                                     cand_pos(idx1)-DNA_block.offset);
  else
    idx1 = find(cand_pos < DNA_block.offset-50 & ...
                cand_pos > DNA_block.block_end+50);
    DNA_block.details.pos = setfield(DNA_block.details.pos,...
                                     signal_names{sig}, ...
                                     -cand_pos(idx1)+DNA_block.offset);
  end
  
  DNA_block.details.score = setfield(DNA_block.details.score,...
                                     signal_names{sig}, ...
                                     cand_score(idx1));
  if strcmp(signal_names{sig},'acc')|strcmp(signal_names{sig},'don')
    cand_out = getfield(OUTPUT,signal_names{sig});
    DNA_block.details.output = setfield(DNA_block.details.output,...
                                        signal_names{sig}, ...
                                       cand_out(idx1));
    
    % add acc scores to sensor transacc 
    DNA_block.details.score.transacc = cand_score(idx1);
    if DNA_block.strand =='+'
      idx1 = find(cand_pos > DNA_block.offset+50 & ...
                  cand_pos < DNA_block.block_end-50);
      DNA_block.details.pos.transacc = cand_pos(idx1)-DNA_block.offset;
    else
      idx1 = find(cand_pos < DNA_block.offset-50 & ...
                  cand_pos > DNA_block.block_end+50);
      DNA_block.details.pos.transacc = -cand_pos(idx1)+DNA_block.offset;
    end
  end
  % sort by position
  pp=getfield(DNA_block.details.pos, signal_names{sig});
  [pp, idxpp]=sort(pp) ;
  DNA_block.details.pos=setfield(DNA_block.details.pos, signal_names{sig}, pp);
  ss=getfield(DNA_block.details.score, signal_names{sig});
  DNA_block.details.score=setfield(DNA_block.details.score, signal_names{sig}, ss(idxpp));

  if strcmp(signal_names{sig},'polya')
    if use_annotation
      cand_label = getfield(LABEL,signal_names{sig});
      DNA_block.details.label = setfield(DNA_block.details.label,...
                                         signal_names{sig}, ...
                                         cand_label(idx1(idxpp)));
    end
    cand_sixmer = getfield(SIXMER,signal_names{sig});
    DNA_block.details.sixmer = setfield(DNA_block.details.sixmer,...
                                     signal_names{sig}, ...
                                     cand_sixmer(idx1(idxpp)));
  end
end

if use_annotation
  assert(DNA_block.block_start ==content_block.block_start);
  assert(DNA_block.block_end ==content_block.block_end);
  DNA_block.content.subset_id = content_block.content.subset_id ;
else
  DNA_block.content.subset_id = 1;
end