function [res,genes] = final_stuff(PAR,map_genes,replace_contigs)

paths  
if nargin<2
  verb=0;
end

jobinfo = rproc_empty(0) ;
    
fid=1;
q=0;
options = PAR.RPROC.options;
options.ncpus = 1;
options.identifier = sprintf('%sfinal',upper(PAR.organism.name(1:4))) ;
options.express=1;
MEMREQ = 2000;
  
  
if nargin<3
  replace_contigs = 0;
end
if nargin<2
  map_genes = 0;
end

cleave_offset = PAR.method.par_ms.cleave_offset ;
P.organism.name = PAR.organism.name;
P.fn_genome_config = PAR.FN.input.fn_genome_config;
P.genome_info = init_genome(P.fn_genome_config);
P.regions = PAR.regions;
P.model = PAR.model;


fn_pred = PAR.FN.output_lsl.fn_pred;
if map_genes & isfield(PAR.FN.genome, 'fn_genome_config_orig')
  fn_genome_config_uncondensed  = PAR.FN.genome.fn_genome_config_orig;
  genome_info_uncondensed = init_genome(fn_genome_config_uncondensed) ; 
else
  genome_info_uncondensed = P.genome_info ;
end
if isfield(PAR.FN.genome, 'fn_map')
  fn_map = PAR.FN.genome.fn_map;
end
if isfield(PAR.FN.genome, 'fn_name_to_contig_mapping')
  fn_replace = PAR.FN.genome.fn_name_to_contig_mapping;
  genome_info_final = replace_contignames(genome_info_uncondensed,'contig_names',fn_replace); 
end

fn_all_genes_condensed = sprintf('%s/pred_genes_cleave%1.2f_condensed.mat',fn_pred,cleave_offset);
dir = sprintf('%s/%s/current_predictions', PAR.FN.input_dir, PAR.organism.name);
fn_all_genes_uncondensed = sprintf('%s/pred_genes_cleave%1.2f_mapped.mat',fn_pred,cleave_offset);
fn_all_genes_final = sprintf('%s/pred_genes_cleave%1.2f_final.mat',fn_pred,cleave_offset);
fn_gff3 = sprintf('%s/pred_genes_cleave%1.2f_final.gff3',fn_pred,cleave_offset);
        
fn_gff3_2 = sprintf('%s/mGene_%s_%s.gff3',fn_pred,PAR.organism.name,PAR.organism.version);
fn_bz = sprintf('%s/mGene_%s_%s.gff3.bz2',fn_pred,PAR.organism.name,PAR.organism.version);
% fn_controll = sprintf('%sgenes_cleave%1.2fcontroll.mat',PAR.FN.output_lsl.fn_pred,PAR.method.par_ms.cleave_offset);
fn_controll = fn_all_genes_final ;
fn_est = [PAR.FN.input.fn_genes_conf_orig(1:end-4) '_ests_only.mat'];
fn_new = [PAR.FN.input.fn_genes_conf_orig(1:end-4) '_new.mat'];
fn_est_new = [PAR.FN.input.fn_genes_conf_orig(1:end-4) '_new_ests_only.mat'];

%-------------------------------
%%% reconcatinate blocks/ blocks2genes
%---------------------------------
load(PAR.FN.input.fn_test_regions,'test_regions') ;
for i = 1:length(P.genome_info.contig_names)
  for s = '+-'
    % fn_reconcat = sprintf('%s/pred_split=%i%s_cleave%1.2freconcat.mat',fn_pred,i,s,cleave_offset);
    % fn_genes = sprintf('%s/pred_split=%i%sgenes_cleave%1.2f.mat',fn_pred,i,s,cleave_offset);
    % fn_gff3 = sprintf('%s/pred_split=%i%sgenes_cleave%1.2f.gff3',fn_pred,i,s,cleave_offset);
    P.fn_reconcat = sprintf('%s/pred_%i%s_cleave%1.2freconcat.mat',fn_pred,i,s,cleave_offset);
    P.fn_genes = sprintf('%s/pred_%i%sgenes_cleave%1.2f.mat',fn_pred,i,s,cleave_offset);
    if ~fexist(P.fn_reconcat)|~fexist(P.fn_genes)
      q=q+1;
      % P.fn_blocks = sprintf('%spred_split=%i%s_cleave%1.2f.mat',fn_pred,i,s,cleave_offset);
      P.fn_blocks = sprintf('%spred_%i%s_cleave%1.2f.mat',fn_pred,i,s,cleave_offset);
      P.test = test_regions([test_regions.chr_num]==i&[test_regions.strand]==s);
      final_stuff_helper(P)
      % jobinfo(q) = rproc('final_stuff_helper', P, MEMREQ,options, 2*60);
    end
  end
end
[jobinfo,num_crashed] = rproc_wait(jobinfo,20,1,1);

%-------------------------------
%%% collect all genes
%---------------------------------

if ~fexist(fn_all_genes_condensed)
  fprintf('collecting genes from all contigs');
  genes =[];operons=[];
  for i = 1:length(P.genome_info.contig_names)
    for s = '+-'
      P.fn_genes = sprintf('%s/pred_%i%sgenes_cleave%1.2f.mat',fn_pred,i,s,cleave_offset);
      G = load(P.fn_genes,'genes','operons');
      if ~isempty(G.genes) 
        genes = [genes G.genes];
      end
      if ~isempty(G.operons) 
        operons = [operons G.operons];
      end
    end
  end
  for i=1:length(genes)
    genes(i).id = i;
    genes(i).name = sprintf('mGene_pred_%i',i);
  end
  
  for i=1:length(operons)
    operons(i).id = i;
    operons(i).name = sprintf('mGene_operon_%i',i);
  end
  save(fn_all_genes_condensed,'genes','operons','PAR') 
end

%-------------------------------
%%% map genes to uncondensed contigs
%---------------------------------

if map_genes
  if ~fexist(fn_all_genes_uncondensed)
    fprintf('start mapping operons to uncondensed contigs\n')
    load(fn_all_genes_condensed,'genes','operons','PAR') 
    maps = read_map(fn_map,P.genome_info,genome_info_uncondensed);
    if ~isempty(operons)
      operons = map_genes_different_config(operons,P.fn_genome_config,fn_genome_config_uncondensed,maps);
    end
    save(fn_all_genes_uncondensed,'operons','PAR')
    fprintf('start mapping genes to uncondensed contigs\n')
    genes = map_genes_different_config(genes,P.fn_genome_config,fn_genome_config_uncondensed,maps);
    which_checks.exons_sorted = 1;
    which_checks.intron_length = 1;
    which_checks.splicesites = 1;
    which_checks.orf = 1;
    which_checks.gene_length = 1;
    which_checks.graph = 0;
    which_checks.transacc = 0;
    genes = check_genes(genes, genome_info_uncondensed,which_checks);
    save(fn_all_genes_uncondensed,'-append','genes')
  end
else
  fn_all_genes_uncondensed = fn_all_genes_condensed;
end

%-------------------------------
%%% replace contig names
%---------------------------------

if replace_contigs
  if ~fexist(fn_all_genes_final)
    fprintf('start replacing contig names\n')
    load(fn_all_genes_uncondensed,'genes','operons');
    genes = replace_contignames(genes,'chr',fn_replace);
    operons = replace_contignames(operons,'chr',fn_replace);
    save(fn_all_genes_final,'genes','operons','PAR') 
    unix(sprintf('ln -s  %s %s',fn_all_genes_final,dir));
  end 
else
  fn_all_genes_final = fn_all_genes_uncondensed;
  genome_info_final = genome_info_uncondensed;
end

%-------------------------------
%%% write gff3 file
%---------------------------------


if  ~fexist(fn_gff3) 
  load(fn_all_genes_final,'genes','operons') 
  write_gff3(genes,fn_gff3,'mGENE','predicted') ;
  % fd = fopen(fname,'a');
  % write_regions2gff3(operons,fd,'operon','mGENE')
  % fclose(fd);
  unix(sprintf('cp %s %s',fn_gff3,fn_gff3_2));
  unix(sprintf('bzip2 -f %s',fn_gff3_2));
  unix(sprintf('ln -s %s %s',fn_bz,dir));
end



%-------------------------------
%%quality control
%-------------------------------

keyboard
if ~fexist(fn_est)
  genome_info= genome_info_final;
  save(fn_est,'genome_info')
  if ~(isempty(P.genome_info.est_fnames)&isempty(P.genome_info.cdna_fnames))
    C=load(PAR.FN.input.fn_genes_conf_orig,'genes');
    C.genes = prepare_confirmed(C.genes,PAR);
    genes_est = extract_ests_fromconfirmed(C.genes,P.genome_info);
    if map_genes
      fprintf('start mapping ests to uncondensed contigs\n')
      maps = read_map(fn_map,P.genome_info,genome_info_uncondensed);
      genes_est = map_genes_different_config(genes_est,P.fn_genome_config,fn_genome_config_uncondensed,maps);
    end
    if replace_contigs
      genes_est = replace_contignames(genes_est,'chr',fn_replace);
    end
    save(fn_est,'-append','genes_est')
  end
end

if fexist(fn_new)&~fexist(fn_est_new)
  genome_info= genome_info_final;
  C=load(fn_new,'genes');
  % PAR.FN.input.fn_genome_config = PAR.FN.genome.fn_genome_config_orig 
  C.genes = prepare_confirmed(C.genes,PAR);
  genes_est = extract_ests_fromconfirmed(C.genes,P.genome_info);
  if map_genes
    fprintf('start mapping ests to uncondensed contigs\n')
    maps = read_map(fn_map,P.genome_info,genome_info_uncondensed);
    genes_est = map_genes_different_config(genes_est,P.fn_genome_config,fn_genome_config_uncondensed,maps);
  end
  if replace_contigs
    genes_est = replace_contignames(genes_est,'chr',fn_replace);
  end
  save(fn_est_new,'genes_est','genome_info')
end

