function pred = gen_paths_debug(PAR)
% pred = gen_paths(PAR)

%addpath /fml/ag-raetsch/share/software/matlab_tools/shogun
addpath ~/svn/projects/genefinding/lsl

%%%%%%%%%%%%%%%%%

% avoid multiple loading of the big constant parameter file
global GLOBAL_cPAR ;%GLOBAL_blocks;
if isempty(GLOBAL_cPAR),
  L = load(PAR.cPAR_fname, 'cPAR') ;
  GLOBAL_cPAR = L ;
  %blocks = load_struct(L.cPAR.blocks_fname) ; 
  %GLOBAL_blocks = blocks ;
else
  L = GLOBAL_cPAR ;
  %blocks = GLOBAL_blocks ;
end ;

%block = blocks(PAR.block_id) ;
block = PAR.block ;
model = L.cPAR.model;
parameters = L.cPAR.parameters;

%%%%%%%%%%%%%%%%%

viterbi_nbest = PAR.viterbi_nbest ;  

if ~isfield(PAR, 'max_len')
  PAR.max_len=[] ;
end ;
if ~isfield(PAR, 'prediction')
  PAR.prediction=0 ;
end ;

[penalty_array,dict_weights,state_signals,a_trans] = gen_penalty_array(model, block.content.subset_id, parameters, PAR.max_len) ;

loss = model.loss.segments ;
if PAR.prediction,
  loss(:)=0 ;
  seg_path = zeros(2,length(block.pos)) ;
else
  %block.truth(1) = gen_loss_matrix(block.truth(1), block.pos, ...
  %                                 block.gene_confirmed, model) ;
  
  seg_path = block.truth(1).seg_path;
  % if the alternatives disagree, then don't incur a loss
  for i=2:length(block.truth)
    idx = find(block.truth(i).seg_path(1,:) ~= block.truth(1).seg_path(1,:)) ;
    seg_path(2,idx) = 0 ;
  end ;
end ;

if 0,
  keyboard
  old_model = model ;
  old_a_trans = a_trans ;
  old_block = block ;
  old_state_signals = state_signals ;
  
  [model, a_trans, block, state_signals] = duplicate_states4transcript_loss(model, a_trans, block, state_signals) ;
end ;

if isfield(model, 'use_conservation') && model.use_conservation
  [path_scores, path, ppos] = sg5('best_path_trans', model.p', model.q', a_trans, block.seq, ...
                                  block.pos-1, model.orf_info, [lower(block.genestr); lower(block.genestr_conserv)]', ...
                                  model.penalties, state_signals, penalty_array, viterbi_nbest, dict_weights', 1, model.mod_words, ...
                                  loss, seg_path) ;
else
  keyboard

  [path_scores, path, ppos] = sg('best_path_trans', model.p', model.q', a_trans, block.seq, ...
                                  block.pos-1, model.orf_info, lower(block.genestr)', ...
                                  model.penalties, state_signals, penalty_array, viterbi_nbest, dict_weights', 1, model.mod_words, ...
                                  loss, seg_path) ;
end ;
%keyboard

if 0,
  path_ = path(1,ppos(1,:)~=-1);
  ppos_ = ppos(1,ppos(1,:)~=-1);
  
  [p_deriv, q_deriv, a_deriv, penalty_deriv, scores, losses]= ...
      sg4('best_path_trans_deriv', path_, ppos_, model.p', model.q', ...
         a_trans, block.seq, block.pos-1, lower(block.genestr), ...
         model.penalties, state_signals, penalty_array, dict_weights', model.mod_words, loss, seg_path) ;
  
  %%% test
  A = model.A ;
  A(~isinf(A)) = parameters.transitions ;
  A(isinf(A)) = 0 ;
  score = sum(sum(a_deriv.*A))
  
  for i=1:size(penalty_deriv,1)
    score = score + sum(penalty_deriv(i,:).*penalty_array{i}.penalties);
  end ;
  
  assert(abs(score-path_scores(1))<1e-4)
end ;

pred = []; loss=[] ;
for i=1:sum(viterbi_nbest)
  pred(i).loss = nan ;
  pred(i).path = path(i,ppos(i,:)~=-1)+1;
  pred(i).pos_idx = ppos(i,ppos(i,:)~=-1)+1;
  pred(i).pos = block.pos(pred(i).pos_idx);
  [pred(i).segments, pred(i).genes] = path2segmentation(pred(i).path, pred(i).pos_idx, block, model);
  if ~PAR.prediction
    [pred(i).weights, pred(i).loss, s(i)] = compute_weights(pred(i), block, model, parameters) ;    
  end ;
end
pred = orderfields(pred) ;

disp(['saving to ' PAR.fn_save]) ;
save(PAR.fn_save, 'pred')

return


