function [paths,descr] = gen_wrong_paths(block, conten,max_num)
% paths=gen_wrong_paths(genestr, truepos, max_num)

truepos = block.best(:,1:2) ;
truedescr = block.best(:,3) ;
content_type =  unique(truedescr) ;

paths = {} ;
descr = {} ;
num = 0 ;

% simulate gene skip
gene_id = find(truedescr == getfield(content,'intergenic')) ;
true_intergenic = truepos(idx) ;
for i = 1:size(gene_id,1)-2,
  num = num+1 ;
  paths{num} = [truepos(1:gene_id(i)-1,:);
                truepos(gene_id(i),1) truepos(gene_id(i)+1,2) 
                truepos(gene_id(i)+2:end,:)] ;
  descr{num} = [truedescr(1:gene_id(i));
                truedescr(gene_id(i)+2:end)] ;
end ;


% simulate merged gene 
for i = 1:size(gene_id,1)-1,
  num = num+1 ;
  paths{num} = [truepos(1:gene_id(i)-1,:);
                truepos(gene_id(i+1):end,:)] ;
  descr{num} = [truedescr(1:gene_id(i)-1);truedescr(gene_id(i+1):end)] ;
end ;


% simulate intron skip
for g = 1:length(gene_id)
  truepos_g = truepos(gene_id(g):gene_id(g+1)-1,:);
  for i = 1:size(truepos_g,1)-2,
    if truedescr(i) == truedescr(i+1)
      num = num+1 ;
      paths{num} = truepos ;
      
      paths{num} = [truepos(1:i-1,:);
                    truepos(i,1) truepos(i+1,2) 
                    truepos(i+2:end,:)] ;
      descr{num} = [truedescr(1:i);
                    truedescr(i+2:end)] ;
    end
  end ;
end

% simulate exon skip
for i=2:size(truepos,1)-1,
  num=num+1 ;
  paths{num}=[truepos(1:i-1,:);
              truepos(i+1:end,:)] ;
  descr{num} = [truedescr(1:i-1);truedescr(i+1:end)] ;
end ;

% simulate alternative donor
for w = 1:length(unique(content_type))
  truepos_w = truepos(:,truedescr==w)
  for i = 1:size(truepos_w,1)-1,
    num = num+1 ;
    paths{num} = truepos ;
    descr{num} = truedescr
    range = truepos_w(i,1)+3:truepos_w(i+1,1) ;
    idx = range(strfind(seq(range),'gt')) ;
    idx = idx(idx~=truepos(i,2)) ;
    idx2 = randperm(length(idx)) ;
    if isempty(idx2),
      num = num-1 ;
    else
      paths{num}(i,2) = idx(idx2(1)) ;
    end ;
  end ;
end

% simulate alternative acceptor
for w = 1:length(unique(content_type))
  truepos_w = truepos(:,truedescr==w)
  for i = 1:size(truepos,1)-1,
    num = num+1 ;
    paths{num} = truepos ;
    descr{num} = truedescr
    range = truepos_w(i,2):truepos_w(i+1,2)-3 ;
    idx = range(strfind(seq(range),'ag'))+2 ;
    idx = idx(idx~=truepos(i+1,1)) ;
    idx2 = randperm(length(idx)) ;
    if isempty(idx2),
      num = num-1 ;
    else
      paths{num}(i+1,1)=idx(idx2(1)) ;
    end ;
  end ;
end

% simulate alternative starts 
for w = 1:length(unique(content_type))
  truepos_w = truepos(:,truedescr==w)
  for i = 1:size(truepos_w,1)-1,
    num = num+1 ;
    paths{num} = truepos ;
    descr{num} = truedescr
    range = truepos_w(i,1)+3:truepos_w(i+1,1) ;
    idx = range(strfind(seq(range),'gt')) ;
    idx = idx(idx~=truepos(i,2)) ;
    idx2 = randperm(length(idx)) ;
    if isempty(idx2),
      num = num-1 ;
    else
      paths{num}(i,2) = idx(idx2(1)) ;
    end ;
  end ;
end


% simulate alternative PolyA

% simulate alternative TIS

% simulate alternative STOP


for i=1:num
  assert(all(paths{i}(:,1)<paths{i}(:,2))) ;
  assert(all(paths{i}(1:end-1,2)<paths{i}(2:end,1))) ;
end ;

idx = randperm(num) ;
paths = paths(idx(1:min(max_num,num))) ;
descr = descr(idx(1:min(max_num,num)))