function dict_weights=load_dict_weights(fn_content, content_names, postfix, dict_weights)
% dict_weights=load_dict_weights(fn_content, content_names)

if nargin<3
  postfix = '' ;
end ;

if nargin<4
  disp('initializing dict_weights') ;
  dict_weights = struct ; 
  for s=1:length(content_names),
    dict_weights=setfield(dict_weights, content_names{s}, []) ;
  end ;
end ;

L = load(fn_content) ;

max_subset_id = max(L.content_SVMs{1}.subset(:)) ;
dict_weights(1:max_subset_id) = dict_weights(1) ;
for i = 1:max_subset_id,
  for s = 1:length(content_names),
    if ~isempty(postfix) && ~equal(content_names{s}(max(1,length(content_names{s})-length(postfix)+1):end),postfix)
      continue ; 
    end ;
    w = [] ;
    for order_idx = 1:length(L.content_SVMs),
      tmp = zeros(size(L.content_SVMs{order_idx}.w,3), 1) ;
      for jj = 1:size(L.content_SVMs{order_idx}.type, 1)
        if strcmp([L.content_SVMs{order_idx}.type{jj,i} postfix], content_names{s})
          tmp = squeeze(L.content_SVMs{order_idx}.w(jj, i, :)) ;          
        end
      end
      w = [w;tmp];
    end ;
    dict_weights(i)=setfield(dict_weights(i), content_names{s}, w') ;
  end ;
end ;

