function TRAIN = lsl_train(PAR,blocks_train)
  
% TRAIN = lsl_path(PAR,blocks)
%

  
fid = fopen( sprintf('%strain.txt',PAR.FN.output_lsl.fn_log),'a+') ;
fprintf(fid,'\n\n train_path \n');
fprintf(fid,'date: %s\n',date);
fprintf(fid,'\n initializing \n');

[blocks_train,model,QP,parameters] = init_path(PAR,blocks_train);

QP_orig = QP ;
max_neg  = PAR.max_neg ;
opt_step = PAR.opt_step;
num_examples = length(blocks_train) ;

old_OBJ = -100 ;

if 1,
  if isfield(PAR,'iteration'),
    iteration = PAR.iteration 
    PAR=rmfield(PAR,'iteration') ;
  else
    iteration=1 ;
    while (1)
      fname = sprintf('%s_iteration%i.mat', PAR.fn_train,iteration) ;
      if ~fexist(fname), iteration=iteration-1 ; break ; end ;
      iteration=iteration+1 ;
    end ;
  end ;
  fname = sprintf('%s_iteration%i.mat', PAR.fn_train,iteration) 
  if fexist(fname),
    clear blocks_train ;
    fprintf('restarting at iteration %i\n', iteration) ;
    load(fname, 'TRAIN_PAR', 'QP','num_examples') ;
    blocks_train = load_struct(sprintf('%s_iteration%i_blocks.mat', PAR.fn_train,iteration)) ;
  end ;
else
  iteration=0 ;
end ;

global last_p_lp last_num_con
last_p_lp = -1 ;
%last_p_lp=[] ;
%last_num_con=0 ;

QP.lpenv = QP_orig.lpenv ;

if 1,
  %how=lp_set_param(QP.lpenv,'CPX_PARAM_AGGIND', 0, 1) ;
  disp('trying 4 threads') ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_THREADS', 4,1) ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_BARTHREADS', 4,1) ;
  disp('trying 8 threads') ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_THREADS', 8,1) ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_BARTHREADS', 8,1) ;
  %how=lp_set_param(QP.lpenv,'CPX_PARAM_PRECOMPRESS', 0,1) ;
  %how=lp_set_param(QP.lpenv,'CPX_PARAM_SIFTALG', 1,1) ; % dual
  %how=lp_set_param(QP.lpenv,'CPX_PARAM_SIFTALG', 4,1) ; % Barrier
  %how=lp_set_param(QP.lpenv,'CPX_PARAM_SIFTALG', 3,1) ; 
  %how=lp_set_param(QP.lpenv,'CPX_PARAM_SIFTDISPLAY', 2,1) ; % verbose
end 

PAR.model = model;

% make sure parameters fit to QP.res
[xis,parameters] = res2param(QP.res, num_examples, model, QP);

solv_cnt = 0;
idx_blocks = 1:num_examples;
viterbi_nbest = ones(1,num_examples) ;
while iteration < PAR.max_num_iterations % | abs(old_OBJ-OBJ)<1e-3,
  iteration = iteration + 1 ;
  fprintf('user = %s  iteration = %i\n', PAR.user, iteration) ;

  OBJ = sum(QP.res.*QP.f)+0.5*QP.res'*QP.Q*QP.res ;
  fprintf(fid,'\n starting iteration: %i\n',iteration);
  fprintf(fid,'\n objective: %i\n',OBJ );
  old_OBJ = OBJ ;
  
  num_correct = 0 ;
  num_crashed = 0;
  jobinfo = rproc_empty(1) ;

  fprintf(fid,'\n submitting dynamic programming jobs ...');
  for block_id_start = 1:PAR.exm_per_solve:num_examples,
    block_ids = block_id_start:min(block_id_start+PAR.exm_per_solve-1, num_examples) ;
    
    %%%%%%%%%%%%%%%%%%%%%
    global GLOBAL_cPAR ;
    GLOBAL_cPAR=[] ;
    
    cPAR=[] ;
    cPAR.model = model ;
    %cPAR.blocks_fname = ['~/' tempname '.mat'] ;
    [xis, cPAR.parameters] = res2param(QP.res, num_examples, model, QP);
    
    P=[] ;
    P.cPAR_fname = sprintf('~/tmp/%i-%1.10f.mat', round(rand(1)*1e8), now) ;
    assert(~fexist(P.cPAR_fname)) ;
    save(P.cPAR_fname, 'cPAR') ;

    %save_struct(cPAR.blocks_fname, blocks_train) ;

    %%%%%%%%%%%%%%%%%%%%%

    jobinfo=rproc_empty(0) ; ii=0 ;
    for block_id = block_ids,
      idx = find(blocks_train(block_id).truth(1).segments(:,3)~=model.segments.intergenic) ;
      max_len = max(500, max(blocks_train(block_id).truth(1).segments(idx,2)- ...
                             blocks_train(block_id).truth(1).segments(idx,1))) ;
      max_len = max_len*1.2+1000 ;
      %max_len = 22000 ;

      P.block_id = block_id ;
      P.block = blocks_train(block_id) ;
      %P.model = model ;
      %P.parameters = parameters ;
      P.viterbi_nbest = viterbi_nbest(block_id) ;
      %P.max_len = max_len ;
      P.fn_save = sprintf('%s_viterbi_block%i.mat', PAR.fn_train, blocks_train(block_id).id); 
      unix(['rm -f ' P.fn_save]) ;
      P.prediction = 0 ;
      MEMREQ = PAR.RPROC.MEMREQ;
      time_req = P.viterbi_nbest*length(blocks_train(block_id).genestr)*sqrt(max_len)*0.01/60/100 ;
      options = PAR.RPROC.options;
      options.identifier = ['G'  num2str(block_id)] ;
      ii=ii+1 ;
      fprintf('creating job %i/%i  \r', ii, length(block_ids)) ;
      jobinfo(end+1) = rproc_create('gen_paths', P, MEMREQ, options, time_req) ;
      %gen_paths(P) ;
    end ;
    [jobinfo, meta_jobinfo] = rproc_submit_batch(jobinfo, PAR.exm_per_batch) ;
    [meta_jobinfo,num_crashed] = rproc_wait(meta_jobinfo, 20, 1);
    %unix(['rm ' P.cPAR_fname ' ' cPAR.blocks_fname]) ;

    solv_cnt = solv_cnt+1;
    blocks = blocks_train(block_ids) ;
    idx_temp = idx_blocks(block_ids) ;
    
    fprintf(fid,'\n solving qp: %i\n', solv_cnt);
    [blocks, QP, viterbi_nbest(block_ids)] = collect_results(blocks, idx_temp, num_examples, PAR, QP, viterbi_nbest(block_ids));
    blocks_train(block_ids) = blocks ;

    rproc_cleanup(jobinfo) ;
    rproc_cleanup(meta_jobinfo) ;

    QP = solve_qp(QP, PAR) ;
    [xis,parameters,hvar,H,obj] = res2param(QP.res, num_examples, model, QP);
    obj

    OBJ = sum(QP.res.*QP.f)+0.5*QP.res'*QP.Q*QP.res ;
    fprintf(fid,'\n sum(xis)  : %i\n',sum(xis) );
    print_struct(fid,obj);
    save([PAR.fn_train,'.mat'], 'PAR', 'QP','num_examples') ;
    %draw_pred(blocks_train(block_id).truth, blocks_train(block_id).pred,model) 

  end
  TRAIN_PAR = PAR;
  save(sprintf('%s_iteration%i.mat', PAR.fn_train,iteration), 'TRAIN_PAR', 'QP','num_examples') ;
  save_struct(sprintf('%s_iteration%i_blocks.mat', PAR.fn_train,iteration), blocks_train) ;
end
fclose(fid) ;
