function [segments, genes, ok] = path2segmentation(my_path,my_pos_idx,block, model,verb)
% [segmentation,ok] = path2segmentation(path,pos_idx,block, model)
%pos = [0     length(block.pos)-1] ;
%path = [model.state_ids.seq_start    model.state_ids.seq_end]-1 ;
  
if nargin<5
  verb=0;
end

segment_names = fieldnames(model.segments) ;
segments = [] ;
ok = 1 ;

my_pos_idx(my_path==getfield(model.state_ids,'intergenic_long'))=[];
my_path(my_path==getfield(model.state_ids,'intergenic_long'))=[];
if ~issorted(my_pos_idx)
  warning('positions not sorted')
  ok=0 ;
end
% keyboard
for i=1:length(my_path)-1

  lengths_idx = model.transition_pointers(my_path(i+1), my_path(i),1) ;
 
  if lengths_idx~=0
    segment_type = model.seg_links(find(model.seg_links(:,1)==lengths_idx),2) ;
    % hack 
    % if block.pos(my_pos_idx(i))== 17173  ; keyboard; end
    if isfield(model.segments,'intercistronic')&& segment_type==model.segments.intercistronic & ...
           block.pos(my_pos_idx(i+1)) - block.pos(my_pos_idx(i)) > model.lengths_range.intercistronic(2),
      % keyboard
      segment_type = model.segments.intergenic ;
    end
  elseif all([my_path(i), my_path(i+1)] == [model.state_ids.tss(1) model.state_ids.stop(1)] );
    if verb,    warning('invalid gene');end
    ok=0 ;
    segment_type = 'nan' ;
    return
  end ;
  segments = [segments; [block.pos(my_pos_idx(i)) block.pos(my_pos_idx(i+1)), segment_type ]] ;
  
  % handle the agatg-case properly 
  if my_path(i+1) == model.state_ids.tis(2)
    if ~(my_path(i) == model.state_ids.don(1)) ;
      warning('invalid path') ;
      ok=0 ;
      return ;
    end ;
    segments = [segments; [block.pos(my_pos_idx(i+1)) block.pos(my_pos_idx(i+1)), model.segments.utr5exon ]] ;
  end ;
  % handle the agtaa-case properly 
  if my_path(i+1) == model.state_ids.cdsStop(2)
    if ~ismember(my_path(i),model.state_ids.don(2:end-1)) ;
      warning('invalid path') ;
      ok=0 ;
      return ;
    end ;
    segments = [segments; [block.pos(my_pos_idx(i+1)) block.pos(my_pos_idx(i+1)), model.segments.cds_exon ]] ;
    continue ;
  end ;
  % handle the trans agatg-case properly 
  if isfield(model.state_ids,'SL1')&& my_path(i+1) == model.state_ids.SL1(2),
    segment_type = model.seg_links(find(model.seg_links(:,1)==lengths_idx),2) ;
    segments = [segments; [block.pos(my_pos_idx(i+1)),block.pos(my_pos_idx(i+1)), model.segments.utr5exon ]] ;
  end
  
end

segments(1,1) = 1;
if isfield(block,'genestr')
  segments(end,2) = length(block.genestr);
else
  segments(end,2) = length(block.seq);
end

if size(segments,1)==1
  % keyboard
  segments(1,3) =getfield(model.segments,'intergenic');
end
idx =  find(segments(:,3) ==getfield(model.segments,'intergenic'));
if isfield(model.segments,'intercistronic')
  idx = [idx; find(segments(:,3) ==getfield(model.segments,'intercistronic'))];
end
if isfield(model.segments,'intergenictrans')
  idx = [idx; find(segments(:,3) ==getfield(model.segments,'intergenictrans'))];
end

n_genes = length(idx)-1 ;
genes{1} = [];
for i=1:n_genes
  genes{i} = segments(idx(i)+1:idx(i+1)-1,:);
end
