function [blocks,PAR,P] = pred_path_cheat(PAR)
% [blocks,PAR,P] = pred_path(PAR)
%
%
  
fid = fopen( sprintf('%spred.txt',PAR.fn_log),'a+') ;
fprintf(fid,'\n\n pred path \n');
fprintf(fid,'date: %s\n',date);
fprintf(fid,'\n start \n');

%% load data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load(PAR.fn_blocks, 'blocks') ;
if isfield(PAR,'fn_splits')
  load(PAR.fn_splits, 'blocks_split') ; 
  block_idx = [blocks_split{PAR.pred_split_idx}] ;
  blocks = blocks(block_idx) ;
end
fprintf('predicting on %i blocks\n', length(blocks)) ;

%% parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
iteration = 1 ;
while (1)
  fname = [PAR.fn_train '_iteration' num2str(iteration) '.mat'];
  if ~fexist(fname), iteration=iteration-1; break ; end 
  iteration=iteration+1 ;
end ;
fname = [PAR.fn_train '_iteration' num2str(iteration) '.mat'];
fprintf('load iteration %i\n', iteration) ;
load(fname);

P.model = TRAIN_PAR.model;

%load([PAR.fn_train,'.mat'],'QP','num_examples','PAR');
%P.model = PAR.model;
P.viterbi_nbest = 1;
[xis,P.parameters] = res2param(QP.res, num_examples,P.model,QP);

num = 0 ; model = PAR.model ;
jobinfo = rproc_empty(1) ;
fprintf(fid,'\n submitting %i viterbi jobs ...',length(blocks));
for block_id = 1:length(blocks),
  num = num+1 
  block=blocks(block_id) ;

  for t=1:length(block.truth)
    for i=1:size(block.truth(t).segments,1)
      start = block.truth(t).segments(i,1) ;      
      stop  = block.truth(t).segments(i,2) ;
      type  = block.truth(t).segments(i,3) ;
      if type == model.segments.intron || type == model.segments.cds_exon ...
               || type == model.segments.utr5exon || type == ...
               model.segments.utr3exon || type == model.segments.transexon 
        idx   = find(block.details.pos.acc>=start & block.details.pos.acc<=stop) ;
        block.details.score.acc(idx) = 0 ;
        idx   = find(block.details.pos.don>=start & block.details.pos.don<=stop) ;
        block.details.score.don(idx) = 0 ;
      end ;
    end ;
  end ;

  for t=1:length(block.truth)
    for i=1:size(block.truth(t).segments,1)
      start = block.truth(t).segments(i,1) ;      
      stop  = block.truth(t).segments(i,2) ;
      type  = block.truth(t).segments(i,3) ;
      if type == model.segments.intron,
        idx   = find(block.details.pos.acc==stop) ;
        assert(length(idx)==1) ;
        block.details.score.acc(idx) = 1 ;
        idx   = find(block.details.pos.don==start) ;
        assert(length(idx)==1) ;
        block.details.score.don(idx) = 1 ;
      end ;
    end ;
  end ;

  [block.seq, block.pos] = gen_seq(block, model);

  P.block = block ;
  P.fn_save = sprintf('%s_viterbi_block%i.mat', PAR.fn_pred, P.block.id); 
  P.prediction = 1 ;
  MEMREQ = PAR.RPROC.MEMREQ;
  options = PAR.RPROC.options;
  options.identifier = ['G'  num2str(block_id)] ;
  time_req = P.viterbi_nbest*length(P.block.genestr)*sqrt(22000)*0.01/60/100 ;
  jobinfo(num) = rproc_create('gen_paths', P, MEMREQ, options, time_req) ;
  %pred = gen_paths(P) ;
end
[jobinfo, meta_jobinfo] = rproc_submit_batch(jobinfo, PAR.exm_per_batch) ;
[meta_jobinfo,num_crashed] = rproc_wait(meta_jobinfo, 10);

blocks(1).pred = struct;
for block_id = 1:length(blocks),
  block = blocks(block_id) ;
  while ~fexist(sprintf('%s_viterbi_block%i.mat', PAR.fn_pred, ...
                        block.id ))
    fprintf('.') ;
    pause(10)
  end
  load(sprintf('%s_viterbi_block%i.mat', PAR.fn_pred, block.id ),'pred');   
  blocks(block_id).prediction = pred; 
end

save(PAR.fn_pred,'blocks', 'PAR', 'P') ;
