function [blocks,PAR,P] = pred_path_cleave(PAR)
% [blocks,PAR,P] = pred_path(PAR)
%
%
check_split = 0 ;

cleave_offset = PAR.cleave_offset
fid = fopen( sprintf('%spred.txt',PAR.fn_log),'a+') ;
fid=1
fprintf(fid,'\n\n pred path \n');
fprintf(fid,'date: %s\n',date);
fprintf(fid,'\n start \n');

%% parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isfield(PAR, 'iteration')
  iteration = 1 ;
  while (1)
    fname = [PAR.fn_train '_iteration' num2str(iteration) '.mat'];
    if ~fexist(fname), iteration=iteration-1; break ; end 
    iteration=iteration+1 ;
  end ;
else
  iteration = PAR.iteration;
end ;
fname = [PAR.fn_train '_iteration' num2str(iteration) '.mat'];
%PAR.fn_train = [PAR.fn_train '_iteration' num2str(iteration) '.mat'];
fprintf('load iteration %i\n', iteration) ;
if check_split,
  load(fname, 'QP', 'TRAIN_PAR', 'num_examples');
  fname = [PAR.fn_train '_iteration' num2str(iteration) '_blocks.mat'];
  blocks_train=load_struct(fname);
  idx = [blocks_train.id] ;
  clear blocks_train
else
  load(fname, 'QP', 'TRAIN_PAR', 'num_examples');
end ;

%% load data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

blocks=load_struct(PAR.fn_blocks, 'blocks') ;
%if isfield(L,'blocks'),
%  blocks=L.blocks ;
%end ;
%if isfield(L,'test_block'),
%  blocks=L.test_block ;
%  assert(~isfield(blocks, 'content')) ;
%  blocks.content.subset_id=1; 
%  blocks.id = PAR.id ;
%end ;
if isfield(PAR,'fn_splits')
  load(PAR.fn_splits, 'blocks_split') ; 
  block_idx = [blocks_split{PAR.pred_split_idx}] ;
  if check_split
    if ~isempty(intersect(idx, block_idx))
      disp('test and training are overlapping') ;
      keyboard
      block_idx = setdiff([blocks_split{:}], idx) ;
    end ;
  end ;
  blocks = blocks(block_idx) ;
end
clear L;
fprintf('predicting on %i blocks\n', length(blocks)) ;

%for i=1:length(blocks),
%  fprintf('Regenerating seq-matrix for block %i\n', i) ;
%  [blocks(i).seq,blocks(i).pos]=gen_seq(blocks(i), PAR.model) ;
%end ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if isfield(TRAIN_PAR.model, 'use_conservation') && TRAIN_PAR.model.use_conservation 
  disp('Converting conservation levels') ;
  for id = 1:length(blocks),
    blocks(id).genestr_conserv = conservation2DNA_alphabet(blocks(id).conservation) ;
  end ;  
end ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% avoid multiple loading of the big constant parameter file
global GLOBAL_cPAR ;
GLOBAL_cPAR=[] ;

cPAR=[] ;
cPAR.model=TRAIN_PAR.model ;
%cPAR.blocks_fname = ['~/' tempname '.mat'] ;
%cPAR.blocks = blocks ;
[xis, cPAR.parameters] = res2param(QP.res, num_examples, TRAIN_PAR.model, QP);
%cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.cleave(1)-1 | cPAR.model.a_trans(2,:)==cPAR.model.state_ids.cleave(2)-1)) = ...
%    cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.cleave(1)-1 | cPAR.model.a_trans(2,:)==cPAR.model.state_ids.cleave(2)-1))+cleave_offset ;
%cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.cdsStop(1)-1)) = ...
%    cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.cdsStop(1)-1))+cleave_offset ;
%for i=[5 6 7 8 9 10 11 12]
%  cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==i-1)) = ...
%      cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==i-1))+cleave_offset/5 ;
%end ;
cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.tis(1)-1)) = ...
    cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.tis(1)-1))+cleave_offset ;
%cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.tis(2)-1)) = ...
%    cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.tis(2)-1))+cleave_offset ;
%cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.SL1(2)-1)) = ...
%    cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.SL1(2)-1))+cleave_offset ;
%cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.SL2(2)-1)) = ...
%    cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.SL2(2)-1))+cleave_offset ;

P=[] ;
P.cPAR_fname = sprintf('~/tmp/%i-%1.10f.mat', round(rand(1)*1e8), now) ;
assert(~fexist(P.cPAR_fname)) ;
save(P.cPAR_fname, 'cPAR') ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

P.viterbi_nbest = 1;

num = 0 ; model = TRAIN_PAR.model ;
jobinfo = rproc_empty(0) ;
fprintf(fid,'\n submitting %i viterbi jobs ...',length(blocks));
for block_id = 1:length(blocks),
  
  %idx = find(blocks(block_id).truth(1).segments(:,3)~=model.segments.intergenic) ;
  %max_len = max(500, max(blocks(block_id).truth(1).segments(idx,2)- ...
  %                       blocks(block_id).truth(1).segments(idx,1))) ;
  %max_len = max_len*1.2+1000 
  P.max_len = 22000 ;

  P.block_id = block_id ;
  P.block = blocks(block_id) ;
  P.fn_save = sprintf('%s_viterbi_block%i_cleave%1.2f.mat', PAR.fn_pred, ...
                      blocks(block_id).id, cleave_offset); 
  %if ~fexist(P.fn_save)
  %  keyboard
  %end ;
  %if fexist(P.fn_save)
  %  fprintf(fid,'\n file exists...',P.fn_save);
  %  continue
  %end
  num = num+1 ;
  P.prediction = 1 ;
  MEMREQ = PAR.RPROC.MEMREQ;
  options = PAR.RPROC.options;
  options.identifier = ['G'  num2str(block_id)] ;
  options.addpaths={[pwd '/lsl_paper'], '~raetsch/svn/projects/genefinding/shogun'} ;
  time_req = P.viterbi_nbest*length(blocks(block_id).genestr)*sqrt(22000)*0.03/60/100 ;
  jobinfo(num) = rproc_create('gen_paths', P, MEMREQ, options, time_req) ;
  %tic;pred = gen_paths(P) ;toc;%keyboard
end
% [jobinfo, meta_jobinfo] = rproc_submit_batch(jobinfo, PAR.RPROC.exm_per_batch) ;
% [meta_jobinfo,num_crashed] = rproc_wait(meta_jobinfo, 10);

unix(['rm ' P.cPAR_fname]) ;

blocks(1).pred = struct;
for block_id = 1:length(blocks),
  block = blocks(block_id) ;
  while ~fexist(sprintf('%s_viterbi_block%i_cleave%1.2f.mat', ...
                        PAR.fn_pred, block.id, cleave_offset ))
    fprintf('.') ;
    pause(10)
  end
  load(sprintf('%s_viterbi_block%i_cleave%1.2f.mat', PAR.fn_pred, ...
               block.id, cleave_offset ),'pred');   
  blocks(block_id).prediction = pred; 
end
blocks=rmfield(blocks,'seq') ;
%blocks=rmfield(blocks,'pos') ;
%blocks=rmfield(blocks,'details') ;

save([PAR.fn_pred sprintf('_cleave%1.2f.mat', cleave_offset)], 'blocks', 'PAR', 'P', '-v7.3') ;
