addpath eval

load PAR_old_signals_new_labels_better.mat

genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS160/orig_data/genome.config') ;
signal_masks = load_struct('/fml/ag-raetsch/share/projects/genefinding/C_elegans/nGASP_alignments/signal_masks.mat', 'signal_masks') ;

if isfield(PAR, 'cleave_offset'),
  PAR = rmfield(PAR, 'cleave_offset') ;
end ;
PAR.cleave_offset = 6 ;

% validation set (defaults loaded in PAR)
test_blocks=predict_blocks(PAR, []) ;
%test_blocks=predict_blocks(PAR, [], genome_info, signal_masks) ;

test_blocks = load_struct(fname, 'blocks') ;

evaluate_block_predictions(test_blocks, 2, 'confirmed');
evaluate_block_predictions(test_blocks, 2);

% test set (load the blocks explicitly and set the prediction output file)

blocks=load_struct('/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/test_data/blocks_2006-12-30-final.mat','blocks') ;
PAR.fn_pred = sprintf('%s/test_predictions/%s-%s/pred_final_signal_mask', PAR.dir, PAR.user, PAR.dt);

PAR.RPROC.MEMREQ=2000 ;
PAR.exm_per_batch=1
test_blocks=predict_blocks(PAR, blocks, genome_info, signal_masks) ;

evaluate_block_predictions(test_blocks, 2, 'confirmed');
evaluate_block_predictions(test_blocks, 2);


%%%%EVAL NEW

addpath ../eval_lsl/
addpath ../data_processing_sensors
addpath ../utils
addpath ../../splicing/splicegraphs/
addpath ../../splicing/splicegraphs/detect_altsplice/
                                                                                                                   
genes = blocks2genes(test_blocks, PAR.model, 'prediction', genome_info)                                                         

load('/fml/ag-raetsch/share/projects/nGASP/test_regions.mat','test_regions')
L=load('/fml/ag-raetsch/share/projects/nGASP/benchmark_gene_sets/phase1_confirmed_isoforms_CNEW_complete.mat','genes')
genes_anno = L.genes;

res = evaluate_predictions(test_regions,genes_anno,genes, genome_info,0);

%%% old results
file_results='/fml/ag-raetsch/share/projects/nGASP/nGASP_Predictions_curated/evaluation_results4poster.mat'
load(file_results,'res_cat1','sources_cat1');
  
res_cat1(end+1) = res;
sources_cat1{end+1} = 'cat3 new';
%%%%draw

type_names={'cds_nucleotides','nucleotides','cds_exons','exons', ...
            'cds_transcripts','transcripts','genes','tis','stop','tss50','tss250','tss1000','cleave50','cleave250','cleave1000'};
%

for i=1:length(sources_cat1)
  for j=1:9
    MC1(i,j) = res_cat1(i).(type_names{j}).mean_SNSP ;
  end
  MC1(i,10) = res_cat1(i).tss.mean_SNSP50;
  MC1(i,11) = res_cat1(i).tss.mean_SNSP250;
  MC1(i,12) = res_cat1(i).tss.mean_SNSP1000;
  MC1(i,13) = res_cat1(i).cleave.mean_SNSP50;
  MC1(i,14) = res_cat1(i).cleave.mean_SNSP250;
  MC1(i,15) = res_cat1(i).cleave.mean_SNSP1000;
  missing(i,1) =res_cat1(i).genes.missing ;
  missing(i,2) =res_cat1(i).genes.missing_conf./res_cat1(i).genes.missing ;
  missing(i,3) =res_cat1(i).genes.missing_partconf./res_cat1(i).genes.missing;
  missing(i,4) =res_cat1(i).genes.missing_unconf./res_cat1(i).genes.missing ;
  wrong(i) = res_cat1(i).genes.wrong ;
end



[tmp,idx] = sort(MC1(:,3),'descend');
MC1 = MC1(idx,:);
missing = missing(idx,:);
wrong = wrong(idx);
sources = sources_cat1(idx);

idx_cds=[1 3 5];               
figure(1)
bar(MC1(:,idx_cds)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
legend(sources,'Location','BestOutside')
h=gca;
a=axis; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{[idx_cds]}});

idx_all=[2 4];   
figure(3)
bar(MC1(:,idx_all)')
% title('CAT 1 all');
ylabel('mean(sensitivity,specificity)');
% legend(sources,'Location','BestOutside')
h=gca;
a=axis;a(1)=0.4; a(3)=0;a(4)=1;axis(a)
set(h,'xTickLABEL',{type_names{idx_all}});
print( '-depsc2', '~/svn/projects/genefinding/eval_lsl/pics/CAT_1_all.eps');
