function retrain_path(PAR, PAR_old, use_xis, new_model)
% retrain_path(PAR, PAR_old, use_xis, new_model)
%

%addpath /fml/ag-raetsch/share/software/matlab_tools/cplex10
%addpath ~/svn/projects/genefinding/utils

if nargin<3,
  use_xis = 0 ;
end ;
if nargin<4, 
  new_model = 0 ;
end ;
if nargin<2,
  PAR_old=PAR ;
  use_xis = 1 ;
end

fid = fopen( sprintf('%strain.txt',PAR.fn_log),'a+') ;
fprintf(fid,'\n\n train_path \n');
fprintf(fid,'date: %s\n',date);
fprintf(fid,'\n initializing \n');

[blocks_train, model, QP, parameters] = init_path(PAR);
QP_orig = QP ;
num_examples = length(blocks_train) ;
clear QP


if ~isfield(PAR_old, 'iteration')
  iteration=1 ;
  while (1)
    fname = sprintf('%s_iteration%i.mat', PAR_old.fn_train,iteration) ;
    if ~fexist(fname), iteration=iteration-1 ; break ; end ;
    iteration=iteration+1 ;
  end ;
else
  iteration = PAR_old.iteration ;
end ;

fname = sprintf('%s_iteration%i.mat', PAR_old.fn_train,iteration) ;
if fexist(fname),
  fprintf('restarting at iteration %i\n', iteration) ;
  L=load(fname, 'TRAIN_PAR', 'QP','num_examples', 'blocks_train') ;
  if ~isfield(L, 'blocks_train'),
    fname_ = sprintf('%s_iteration%i_blocks.mat', PAR_old.fn_train,iteration) ;
    L.blocks_train = load_struct(fname_) ;
  end ;
end ;
  
QP_before = L.QP ;
if use_xis,
  disp('reusing old xi variables to eliminate more constraints') ;
  QP_orig.res = QP_before.res ;
end ;

%idxs=[L.blocks_train.id] ;
num_dropped = 0 ; num_kept = 0 ;
for i=1:min(length(blocks_train),length(L.blocks_train))
  assert(blocks_train(i).id == L.blocks_train(i).id) ;
  assert(isequal(blocks_train(i).pos, L.blocks_train(i).pos)) ;
  assert(isequal(blocks_train(i).genestr, L.blocks_train(i).genestr)) ;
  blocks_train(i).pred = L.blocks_train(i).pred ;

  % recompute the pos_idx vectors for the changed positions
  % assume that positions did not disappear

  take_map = ones(1, length(blocks_train(i).pred)) ;
  for k=1:length(blocks_train(i).pred),
    [pos,pos_idx,tmp2]=intersect(blocks_train(i).pos, blocks_train(i).pred(k).pos) ;
    if ~(length(tmp2)==length(blocks_train(i).pred(k).pos)),
      fprintf('dropping prediction %i of block %i\n', k, i) ;
      take_map(k) = 0 ;
      %[a,b]=setdiff(blocks_train(i).pred(k).pos, blocks_train(i).pos) ;
      %for q=1:lenth(b),
      %  [tmp,idx]=min(abs(blocks_train(i).details.pos.polya-blocks_train(i).pred(k).pos(b(q)))) ;
      keyboard
    end ;
    blocks_train(i).pred(k).pos_idx = pos_idx ;
    %blocks_train(i).pred(k).pos = pos ;
    %blocks_train(i).pred(k).path = path ;
  end ;
  num_dropped = num_dropped + sum(take_map==0) ;
  num_kept = num_kept + sum(take_map==1) ;
  blocks_train(i).pred = blocks_train(i).pred(find(take_map==1)) ;
end ;

QP = QP_orig ;
QP.lpenv = cplex_license(0, 8) ;
if QP.lpenv==0,
  QP.lpenv = cplex_license(1, 2) ;
end 
global last_p_lp last_num_con
last_p_lp = -1 ;
%last_p_lp=[] ;
%last_num_con=0 ;

if 1,
  disp('trying 2 threads') ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_THREADS', 2,0) ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_BARTHREADS', 2,0) ;
  disp('trying 4 threads') ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_THREADS', 4,0) ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_BARTHREADS', 4,0) ;
  disp('trying 8 threads') ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_THREADS', 8,0) ;
  how=lp_set_param(QP.lpenv,'CPX_PARAM_BARTHREADS', 8,0) ;
end 

if new_model,
  PAR.model = model;
  TRAIN_PAR = PAR ;
else
  model = L.TRAIN_PAR.model ;
  PAR.model = model;
  TRAIN_PAR=L.TRAIN_PAR ;
end ;

num_correct = 0 ;
num_crashed = 0;
jobinfo = rproc_empty(0) ;

jobinfo=rproc_empty(0) ; ii=0 ;
cPAR=[] ;
%cPAR.blocks = blocks_train ;
cPAR.QP = QP ;
cPAR.QP.A = sparse(zeros(0,size(QP.A,2))) ;
cPAR.QP.b = [] ;
cPAR.num_examples = num_examples ;
cPAR.PAR = PAR ;
cPAR.old_model = L.TRAIN_PAR.model ;
%clear L

PP=[] ;
PP.cPAR_fname = sprintf('~/tmp/%i-%1.10f.mat', round(rand(1)*1e8), now) ;
assert(~fexist(PP.cPAR_fname)) ;
save(PP.cPAR_fname, 'cPAR') ;

% avoid multiple loading of the big constant parameter file
global GLOBAL_cPAR ;
GLOBAL_cPAR=[] ;

%cd ~/svn/projects/genefinding/lsl_paper/
for block_id = 1:num_examples,
  PP.block_idx = block_id ;
  PP.blocks = blocks_train(block_id) ;
  PP.old_block = L.blocks_train(block_id) ;

  MEMREQ = PAR.RPROC.MEMREQ;
  time_req = 20/60 ;
  options = PAR.RPROC.options;
  options.identifier = ['ReGen'  num2str(block_id)] ;
  options.addpaths={[pwd '/lsl_paper'], '~/svn/projects/genefinding/shogun'} ;
  ii=ii+1 ;
  fprintf('creating job %i/%i  \r', ii, num_examples) ;
  jobinfo(end+1) = rproc_create('regenerate_constraints', PP, MEMREQ, options, time_req) ;
  %keyboard
  %regenerate_constraints(PP) ;
end ;
clear L

[jobinfo, meta_jobinfo] = rproc_submit_batch(jobinfo, PAR.exm_per_batch) ;
[meta_jobinfo,num_crashed] = rproc_wait(meta_jobinfo, 20, 1);

for block_id=1:num_examples,
  fprintf('block_id = %i  \r', block_id) ;
  %if ~rproc_finished(jobinfo(block_id)),
  %  %jobinfo(block_id)=rproc(jobinfo(block_id).ProcName,jobinfo(block_id).P1, jobinfo(block_id).Mem, [], jobinfo(block_id).time) ;
  %  regenerate_constraints(jobinfo(block_id).P1) ;
  %end ;
  res = rproc_result(jobinfo(block_id)) ;
  blocks_train(block_id) = res.blocks ;
  nQP =res.QP ;
  QP.A = [QP.A; nQP.A] ;
  QP.b = [QP.b; nQP.b] ;
end ;
unix(['rm ' PP.cPAR_fname]) ;

fprintf('number of constraints before regeneration: %i\n', size(QP_before.A,1)) ;
fprintf('number of constraints after regeneration: %i\n', size(QP.A,1)) ;

rproc_cleanup(jobinfo) ;
rproc_cleanup(meta_jobinfo) ;

OBJ_before = sum(QP_before.res.*QP_before.f) + 0.5*QP_before.res'*QP_before.Q*QP_before.res ;
fprintf('objective before regeneration: %1.2f\n', OBJ_before) ;

QP = solve_qp(QP, PAR) ;
OBJ = sum(QP.res.*QP.f) + 0.5*QP.res'*QP.Q*QP.res ;

fprintf('objective before regeneration: %1.2f\n', OBJ_before) ;
fprintf('objective after regeneration: %1.2f\n', OBJ) ;

if 0,
  jobinfo=rproc_empty(0) ; ii=0 ;
  for block_id = 1:num_examples,
    PP.blocks = blocks_train(block_id) ;
    PP.block_idx = block_id ;
    PP.QP = QP ;
    PP.QP.A = sparse(zeros(0,size(QP.A,2))) ;
    PP.QP.b = [] ;
    PP.num_examples = num_examples ;
    PP.PAR = PAR ;
    
    MEMREQ = PAR.RPROC.MEMREQ;
    time_req = 10/60 ;
    options = PAR.RPROC.options;
    options.identifier = ['GR'  num2str(block_id)] ;
    ii=ii+1 ;
    QQ=regenerate_constraints(PP) ;
  end ;
end ;

iteration=1 ;
while (1)
  fname = sprintf('%s_iteration%i.mat', PAR.fn_train,iteration) ;
  if ~fexist(fname), break ; end ;
  iteration=iteration+1 ;
end ;
fprintf('saving as iteration %i\n', iteration) ;

keyboard

fname = sprintf('%s_iteration%i.mat', PAR.fn_train,iteration) 
if ~fexist(fname),
  save(fname, 'TRAIN_PAR', 'QP', 'num_examples') ;
  fname = sprintf('%s_iteration%i_blocks.mat', PAR.fn_train,iteration) 
  save_struct(fname, blocks_train) ;
else
  disp('file exists') ;
  keyboard
end ;
