if 0,
  rmpath('/fml/ag-raetsch/share/software/matlab_tools/cplex9')
  addpath('/fml/ag-raetsch/share/software/matlab_tools/utils')
  addpath /fml/ag-raetsch/share/software/matlab_tools/cplex9_matlab-7.0
  addpath /fml/ag-raetsch/share/software/matlab_tools/utils_matlab-7.0
  %addpath /fml/ag-raetsch/share/software/matlab_tools/shogun_matlab-7.0
  addpath ~/projects/shogun_matlab-7.0/src
else
  %addpath /fml/ag-raetsch/share/software/matlab_tools/shogun
  addpath ~/projects/shogun/src
  %addpath ~/projects/shogun_matlab-7.0/src
end ;  
lpenv=cplex_license(0,8) ;  

addpath ~/svn/projects/genefinding/data_processing_lsl
addpath ~/svn/projects/genefinding/lsl
addpath ~/svn/projects/genefinding/utils
addpath ~/svn/projects/genefinding/viz
addpath ~/svn/projects/genefinding/eval_lsl

tester_config_new_signals

unix(sprintf('mkdir -p %s', PAR.dir)) ;
unix(sprintf('mkdir -p %s/log_files', PAR.dir)) ;
unix(sprintf('mkdir -p %s/data', PAR.dir)) ;
unix(sprintf('mkdir -p %s/train', PAR.dir)) ;
unix(sprintf('mkdir -p %s/predictions', PAR.dir)) ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%% generate blocks
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

PAR.min_dist = 1000;
PAR.num_splits = 5 ; 

if PAR.new_signals
  L=load(PAR.fn_polya_signals,'consensus') ;
  PAR.polya_sixmers = L.consensus ;
else
  load(PAR.fn_polya_signals,'signal_sixmers') ;
  PAR.polya_sixmers = {signal_sixmers.sixmer} ;
end ;

if isfield(PAR, 'use_conservation') && PAR.use_conservation
  PAR.model = make_model_conserv(PAR);
else
  PAR.model = make_model(PAR);
end ;

PAR.use_annotation = 1;
if ~PAR.new_signals & ~fexist(PAR.fn_blocks)
  %DNA_blocks = generate_blocks(PAR);
  %check_details(DNA_blocks,PAR.model)
  %keyboard
  %blocks = check_blocks_2(DNA_blocks,PAR.model) ;  
  fprintf('use Gabis improved blocks from %s\n', PAR.fn_blocks_pre) 
  blocks = load_struct(PAR.fn_blocks_pre, 'blocks')  ;
  blocks = gen_truth(blocks,PAR.model) ;
  keyboard
  save_struct(PAR.fn_blocks, blocks, 'blocks')  ;
  save(PAR.fn_blocks,'-append','PAR')
end

if PAR.new_signals & ~fexist(PAR.fn_blocks)
  
  fprintf('use Gabis improved blocks from %s\n', PAR.fn_blocks_pre) 
  fprintf('use Georgs new signals from %s\n', PAR.fn_blocks_pre_new_signals) 

  blocks_pre = load_struct(PAR.fn_blocks_pre_new_signals, 'blocks')  ;
  blocks = load_struct(PAR.fn_blocks_pre, 'blocks')  ;

  for i=1:length(blocks)
    assert(isequal(blocks(i).genestr, blocks_pre(i).genestr)) ;
    blocks(i).details = blocks_pre(i).details ;
    for j=1:length(blocks(i).cleave)
      for k=1:length(blocks(i).cleave{j})
        [tmp,idx]=min(abs(blocks(i).cleave{j}(k)-blocks(i).details.pos.cleave)) ;
        if tmp>0,
          fprintf('replaced cleave in block %i\n', i) ;
          blocks(i).details.pos.cleave(idx) = blocks(i).cleave{j}(k) ;
        end ;
      end ;
    end ;
  end ;
  clear blocks_pre ;
  blocks = gen_truth(blocks,PAR.model) ;

  keyboard
  save_struct(PAR.fn_blocks, blocks, 'blocks')  ;
  save(PAR.fn_blocks,'-append','PAR')

end

if ~fexist(PAR.fn_splits)
  load(PAR.fn_blocks, 'blocks', 'PAR')  ;
  gen_block_splits(blocks, PAR)
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%% modelselection on path
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 


%%% train models

unix(sprintf('mkdir -p %s/result', PAR.dir)) ;

PAR.opt_step = 1000 ;
PAR.max_neg = 2 ;
PAR.margin = 1 ;
PAR.RPROC.MEMREQ = 1000;
PAR.RPROC.options = [];
PAR.RPROC.options.arch = 64 ;
PAR.RPROC.options.express = 0 ;

PAR.INF = 1e20;

PAR.max_num_iterations = 100;

PAR.fn_init =  sprintf('%strain/%s-%s/init.mat',PAR.dir,PAR.user,PAR.dt);
PAR.fn_train = sprintf('%strain/%s-%s/train',PAR.dir,PAR.user,PAR.dt);
PAR.fn_pred = sprintf('%spredictions/%s-%s/pred_split=%i',PAR.dir,PAR.user,PAR.dt,PAR.pred_split_idx);
PAR.fn_log = sprintf('%slog_files/%s_%s_log_',PAR.dir,PAR.user,PAR.dt);

unix(sprintf('mkdir -p %strain/%s-%s', PAR.dir,PAR.user,PAR.dt)) ;
unix(sprintf('mkdir -p %spredictions/%s-%s', PAR.dir,PAR.user,PAR.dt)) ;

%train_path(PAR) ;

return

pred_path(PAR) ;

%PAR.pred_split_idx = 1:4 ;
%PAR.fn_pred = sprintf('%spredictions/%s_%s_pred%i:%i.mat',PAR.dir,PAR.user,PAR.dt,PAR.pred_split_idx(1),PAR.pred_split_idx(end));
%pred_path(PAR) ;

% test error
tmp = load(PAR.fn_pred);
test_blocks = tmp.blocks;
evaluate_block_predictions(test_blocks, 2, 'confirmed');
evaluate_block_predictions(test_blocks, 2);


id=1 ;
draw_pred(test_blocks(id).truth, test_blocks(id).pred, PAR.model) 


PAR.pred_split_idx=5 ;
PAR.fn_pred = sprintf('%spredictions/%s_%s_pred_cheat%i:%i.mat',PAR.dir,PAR.user,PAR.dt,PAR.pred_split_idx(1),PAR.pred_split_idx(end));
pred_path_cheat(PAR) ;


PAR.cleave_offset = 3.5 ;
pred_path_cleave(PAR) ;
L=load([PAR.fn_pred sprintf('_cleave%1.2f.mat', PAR.cleave_offset)], 'blocks', 'PAR', 'P') ;
evaluate_block_predictions(L.blocks);



cleave_offsets=-2.5:0.5:5%[-3:0.5:3] ;
for cleave_offset=cleave_offsets
  PAR.cleave_offset = cleave_offset ;
  pred_path_cleave(PAR) ;
end ;

%cleave_offsets=0:0.5:5%[0:10] ;
for cleave_offset=cleave_offsets
  PAR.cleave_offset = cleave_offset ;
  cleave_offset
  L=load([PAR.fn_pred sprintf('_cleave%1.2f.mat', PAR.cleave_offset)], 'blocks', 'PAR', 'P') ;
  evaluate_block_predictions(L.blocks, 2, 'confirmed');
end ;

