%addpath /fml/ag-raetsch/share/software/matlab_tools/shogun  

addpath ~/svn/projects/genefinding/lsl
addpath ~/svn/projects/genefinding/utils
addpath ~/svn/projects/genefinding/eval

load PAR_pac_loss_C=1_final_sol100000_cor.mat


PAR.dir = ['/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/' PAR.exp_name ,'/'];

PAR.fn_blocks_pre = [PAR.dir '/data/test_blocks_new_1000.mat'] ;     
PAR.fn_blocks = [PAR.dir '/data/test_blocks_new_1000_final.mat'] ;     


if ~fexist(PAR.fn_blocks),
  load(PAR.fn_blocks_pre) ;
  
  blocks_new = [] ;
  for i=1:length(blocks)
    i
    idx=find(blocks(i).truth.segments(:,3)==PAR.model.segments.intron) ;
    if ~all(blocks(i).truth.segments(idx,2)-blocks(i).truth.segments(idx,1)>30),
      fprintf('block with intron of length %i skipped\n', min(blocks(i).truth.segments(idx,2)-blocks(i).truth.segments(idx,1))) ;
      continue ;
    end ;
    blocks(i).gene_confirmed=zeros(1,length(blocks(i).truth.genes)) ;
    blocks(i).content.subset_id=1;
    blocks(i).genestr = upper(blocks(i).genestr) ;
    idx = find(blocks(i).genestr~='A' & blocks(i).genestr~='C' & ...
               blocks(i).genestr~='G' & blocks(i).genestr~='T') ;
    blocks(i).genestr(idx) = 'A' ;
    block = blocks(i) ;
    block.id = i ;
    [block.seq, block.pos] = gen_seq(blocks(i), PAR.model);
    
    [block.truth.path,block.truth.pos_idx,block.truth.pos,ok] = segmentation2path(block.truth, block, PAR.model);
    %if ok==0, continue ; end ;
    
    if isempty(blocks_new), blocks_new = block; else blocks_new(end+1) = block ; end ;
  end ;

  blocks=blocks_new ;
  save(PAR.fn_blocks, 'blocks') ;
end ;

PAR.RPROC.MEMREQ = 1000;
PAR.RPROC.options = [];
PAR.RPROC.options.arch = 64 ;
PAR.RPROC.options.express = 0 ;

PAR.fn_init =  sprintf('%strain/%s-%s/init.mat',PAR.dir,PAR.user,PAR.dt);
PAR.fn_train = sprintf('%strain/%s-%s/train',PAR.dir,PAR.user,PAR.dt);
PAR.fn_log = sprintf('%slog_files/%s_%s_log_',PAR.dir,PAR.user,PAR.dt);

PAR.fn_pred = sprintf('%spredictions/%s-%s/pred_test',PAR.dir,PAR.user,PAR.dt);

unix(sprintf('mkdir -p %strain/%s-%s', PAR.dir,PAR.user,PAR.dt)) ;
unix(sprintf('mkdir -p %spredictions/%s-%s', PAR.dir,PAR.user,PAR.dt)) ;

PAR=rmfield(PAR, 'fn_splits') ;

pred_path(PAR) ;

load(PAR.fn_pred) ;

for i=1:length(blocks)
  blocks(i).truth
  blocks(i).prediction
  
  idx=find(blocks(i).truth.genes{1}(:,3)==3) ;
  blocks(i).truth.genes{1}(idx,:)

  idx=find(blocks(i).prediction.genes{1}(:,3)==3) ;
  blocks(i).prediction.genes{1}(idx,:)

  keyboard

end ;

num_found = 0 ; num=0 ;
for i=1:length(blocks)
  blocks(i).truth
  blocks(i).prediction
  
  if isempty(blocks(i).prediction.genes{1}), continue ; end ;

  idx=find(blocks(i).truth.genes{1}(:,3)==3) ;
  b1=blocks(i).truth.genes{1}(idx,:) ;

  idx=find(blocks(i).prediction.genes{1}(:,3)==3) ;
  b2=blocks(i).prediction.genes{1}(idx,:)

  for i=1:size(b2,1),
    num_found = num_found + sum(b1(:,1)==b2(i,1) & b1(:,2)==b2(i,2)) ;
    num=num+1 ;
  end ;
  %for i=1:size(b1,1),
  %  num_found = num_found + sum(b2(:,1)==b1(i,1) & b2(:,2)==b1(i,2)) ;
  %  num=num+1 ;
  %end ;
end ;
