function [pos chr_num strand]=calc_global_example_pos(POS, regions, all_pos_on_positive_strand)
genome_info = init_genome(regions(1).config);

if nargin<3 
  all_pos_on_positive_strand =1;
end
r_ids = POS.region_id;
l_pos   = POS.pos;
pos = zeros(1,length(l_pos));
region_ix = zeros(1,length(regions));
chr_num=zeros(1,length(l_pos));
strand=char(zeros(1,length(l_pos)));

for j=1:length(l_pos)
  if mod(j,1000)==0 
    fprintf(1, '%i of %i\r',j,length(l_pos))
  end
  r_id = r_ids(j);
  if(region_ix(r_id)==0)
    ix = find([regions.id]==r_id);
    region_ix(r_id)=ix;
  else
    ix=region_ix(r_id);
  end
  region = regions(ix);
  assert(region.id == r_id)
  start = region.start;
  chr_num(j)=region.chr_num;
  strand(j)=region.strand;
  if strand(j)=='+' 
    pos(j) = l_pos(j)+start-1;
  elseif strand(j)=='-' && all_pos_on_positive_strand
    reg_len=region.stop-region.start+1;
    assert(reg_len-l_pos(j)>0)
    pos(j)=reg_len-l_pos(j)+1+region.start-1;
  elseif strand(j)=='-' 
    d=dir(genome_info.flat_fnames{region.chr_num});
    chr_len = d.bytes;
    pos(j)=l_pos(j)+chr_len-region.stop;
  end
end
