function check_genomewide_output(PAR)

fprintf(1,'check_genomewide_output\n');
genome_info = init_genome(PAR.FN.input.fn_genome_config);
sig=PAR.Signal_name;

load(PAR.FN.output.fn_training_blocks,'blocks')
for j=1:5
  fn_pred_test = sprintf('%spartition=%i.mat',PAR.FN.output_sig.(sig).fn_SVMs,j) ;
  l2= load(fn_pred_test);
  [pos chr_num strand]=calc_global_example_pos(l2.POS,blocks,0);
  for chr = 1:length(genome_info.contig_names)
    for s = '+-'
      fn_pred_all = sprintf('%scontig_%i%s_all.mat',PAR.FN.output_sig.(sig).fn_pred,chr,s);
      l=load(fn_pred_all);
      cpos = pos(chr_num==chr&strand==s);
      [a b c]=intersect(l.pos, cpos);
      if length(a)~=length(cpos)
        warning('length different')
        diffpos=setdiff(cpos,a);
        assert(diffpos<=2002|diffpos==max(cpos))
      end
      % assert(length(a)==length(cpos))
      cout = l2.output(chr_num==chr&strand==s);
      if (max(abs(l.output(b)-cout(c)))>1e-5)
        warning('outputs different')
        sum(abs(l.output(b)-cout(c))>1e-5)
        keyboard
      end
      fprintf(1,'chr %i%s, partition %i :OK\n',chr, s, j)
    end
  end
end
