function ok = check_predictions(PAR)
 
paths
genome_info = init_genome(PAR.FN.input.fn_genome_config);
S = dir(genome_info.flat_fnames{PAR.chrom}) ;
contig_length = S.bytes;
CHR_NAME = genome_info.contig_names{PAR.chrom};
fprintf('contig: %i%s\n', PAR.chrom,PAR.strand);

%% GET ALL PREDICTIONS from mat file
filename = sprintf('%scontig_%i%s_all.mat', PAR.fn_pred, ...
                   PAR.chrom, PAR.strand);
load(filename);

% always save global coordinates on forward strand
if isequal(PAR.strand, '-'),
  pos = contig_length - pos + 1;
end
assert(all(pos>=1));

[pos sort_idx] = sort(pos);
Conf = Conf(sort_idx);
Conf_cum = Conf_cum(sort_idx);
output = output(sort_idx);

assert(all(Conf>=0&Conf<=1));

load(PAR.FN.output.fn_trivial_regions,'trivial_regions') 
idx  = find([trivial_regions.strand] == PAR.strand&[trivial_regions.chr_num] == PAR.chrom);
reg = trivial_regions(idx);

reg = add_signals2blocks(reg,PAR,{PAR.Signal_name}); 
[tmp,idx1,idx2] = intersect(reg.Signals.(PAR.Signal_name).contig_pos,pos);
num_pos = max(length(pos),length(reg.Signals.(PAR.Signal_name)));
if length(tmp)<num_pos
  fprintf('WARNING: found only %i of %i  postions (%i %%)\n',length(tmp),num_pos,round((length(tmp))/num_pos*100));
  fprintf('specified resolution:%i\n',PAR.Signals.(PAR.Signal_name).export_settings.resolution);
end
ok=1;
if ~(all(abs(reg.Signals.(PAR.Signal_name).Conf_cum(idx1)-Conf_cum(idx2)')<1e-3))
  keyboard
  ok=-1;
end
filename = sprintf('%sall_good.mat', PAR.fn_pred);
if fexist(filename)
  load(filename,'all_good');
else
  all_good = zeros(2, length(genome_info.contig_names));
end
all_good(find(strcmp({'+','-'},PAR.strand)),PAR.chrom) = ok;
save(filename,'all_good');