function jobinfo =  concat_genomewide_predictons(PAR)

jobinfo = rproc_empty(0) ;
q=0;
options = PAR.RPROC.options;
options.ncpus = 1;
options.identifier = sprintf('%sconcat%s_%s',upper(PAR.organism.name(1:4)),PAR.Signal_name,PAR.method.name) ;
MEMREQ = PAR.RPROC.MEMREQ;
if ~isfield(PAR.tasks,'run_locally')
  PAR.tasks.run_locally=0;
end

sig=PAR.Signal_name;
genome_info = init_genome(PAR.FN.input.fn_genome_config);
  
fn_pos = PAR.FN.input_sig.(PAR.Signal_name).fn_pos;
for c = 1:length(genome_info.contig_names)
  for s = '+-'
    PAR.fn_pred_all = sprintf('%scontig_%i%s_all.mat',PAR.FN.output_sig.(sig).fn_pred,c,s);
    PAR.fn_pred = sprintf('%scontig_%i%s_split=',PAR.FN.output_sig.(PAR.Signal_name).fn_pred,c,s);
    if fexist(PAR.fn_pred_all)
      continue
    else
      q=q+1;
      if ~PAR.tasks.run_locally
        if isfield(PAR.RPROC, 'collect_jobs') && PAR.RPROC.collect_jobs 
          jobinfo(q) = rproc_create('concat_genomewide_predictons_helper', PAR, PAR.RPROC.MEMREQ,options,10*60) ;
        else
          jobinfo(q) = rproc('concat_genomewide_predictons_helper', PAR, MEMREQ,options, 2*60);
        end
      else
        concat_genomewide_predictons_helper(PAR)
      end
    end
  end
end
