function jobinfo = convert_predictions2confs(PAR)

jobinfo = rproc_empty(0) ;
options = PAR.RPROC.options;
options.ncpus = 1;
options.identifier = sprintf('%sconf%s_%s',upper(PAR.organism.name(1:4)),PAR.Signal_name,PAR.method.name) ;
MEMREQ = PAR.RPROC.MEMREQ;
if ~isfield(PAR.tasks,'run_locally')
  PAR.tasks.run_locally=0;
end
fid=1;q=0;
for p = 1:PAR.SETs.num_splits
  fprintf(fid,'partition %i\n',p);
  if isfield(PAR.FN.input_sig.(PAR.Signal_name),'fn_SVM_best') 
    fn_SVMs = PAR.FN.input_sig.(PAR.Signal_name).fn_SVM_best;
    fn_SVMs = fn_SVMs{p};
  else
    fn_SVMs = sprintf('%sbest_partition=%i.mat', PAR.FN.output_sig.(PAR.Signal_name).fn_SVMs,p) ;
    if ~fexist(fn_SVMs)
      fn_SVMs = sprintf('%s_best_partition=%i.mat', PAR.FN.output_sig.(PAR.Signal_name).fn_SVMs,p) ;
    end
  end
  %--------------------------------------------------------------------------------%
  % load parameters from SVM file
  %--------------------------------------------------------------------------------%
  
  genome_info = init_genome(PAR.FN.input.fn_genome_config);
  clear  prob prob_cum limits Conf Conf_cum

  if ~(all(ismember({'prob', 'prob_cum','limits'}, who_file(fn_SVMs))))
    warning('Variables prob, prob_cum and or limits not found in %s',fn_SVMs)
    error('calculate PLIFS first: execute this function with PAR.tasks.pred_from_seq=0; to calculate PLIFS')
  else
    load(fn_SVMs,'Train');
    PAR_new = load(fn_SVMs,'prob', 'prob_cum','limits');
    if ~isfield(Train.PAR.SETs,'which_pred')
      Train.PAR.SETs.which_pred=Train.PAR.SETs.which_pred_svm;
    end
  end
  assert(Train.PAR.SETs.which_pred == p)
  %------------------------------------------------------------------------------------%
  % perform transformations
  %------------------------------------------------------------------------------------%
  for c = 1:length(genome_info.contig_names)
    for s = '+-'
      PAR_new.fn_pred = sprintf('%scontig_%i%s_split=%i.mat',PAR.FN.output_sig.(PAR.Signal_name).fn_pred,c,s,p);
      if ~fexist(PAR_new.fn_pred) 
        fprintf(fid,'\n file not found:');
        fprintf(fid,'%i',p);
        fprintf(fid,'\n run genomewide_prediction first');
      elseif all(ismember({'Conf', 'Conf_cum'},who_file(PAR_new.fn_pred)))
        continue
      else
        fprintf(fid,'\n start transforming on contig %i%s\n',c,s);
        %%% Convert SVM Outputs on test set `
        q=q+1; 
        if ~PAR.tasks.run_locally
          if isfield(PAR.RPROC, 'collect_jobs') && PAR.RPROC.collect_jobs 
            jobinfo(q) = rproc_create('Out2Confhelper', PAR_new, PAR.RPROC.MEMREQ,options,10*60) ;
          else
            jobinfo(q) = rproc('Out2Confhelper', PAR_new, MEMREQ,options, 2*60);
          end
        else
          Out2Confhelper(PAR_new)
        end
      end
    end%loop over strands
  end%loop over contigs
end %% loop over partitions

