L_svm_acc = load('/fml/ag-raetsch/share/projects/genefinding/H_sapiens/dataset-size_exp/acc/results.mat') ;
L_svm_don = load('/fml/ag-raetsch/share/projects/genefinding/H_sapiens/dataset-size_exp/don/results.mat') ;
L_mc_acc = load('/fml/ag-raetsch/share/projects/genefinding/H_sapiens/dataset-size_exp_sonne/acc_PWM/results.mat') ;
L_mc_don = load('/fml/ag-raetsch/share/projects/genefinding/H_sapiens/dataset-size_exp_sonne/don_PWM/results.mat') ;

close all
figure('PaperUnits', 'centimeters', 'PaperPosition', [2 2 12 12]) ;
loglog(L_svm_acc.sep, L_svm_acc.TrainTime, 'b-o', 'LineWidth', 2)
hold on ;
loglog(L_svm_don.sep, L_svm_don.TrainTime, 'r-o', 'LineWidth', 2)
loglog(L_mc_acc.sep, L_mc_acc.TrainTime, 'b--s', 'LineWidth', 2)
loglog(L_mc_don.sep, L_mc_don.TrainTime, 'r--s', 'LineWidth', 2)
legend('SVM acceptor', 'SVM donor', 'MC acceptor', 'MC donor', 'Location','NorthWest') ;
grid on  
set(gca,'XMinorGrid','off')
set(gca,'YMinorGrid','off')
xlabel('Number of training examples') ;
ylabel('CPU time in seconds required for training') ;
print('-depsc2', 'dataset_size_exp_time.eps') ;
saveas(gcf, 'dataset_size_exp_time.fig', 'fig')


close all
figure('PaperUnits', 'centimeters', 'PaperPosition', [2 2 12 12]) ;
semilogx(L_svm_acc.sep, L_svm_acc.RFV, 'b-o', 'LineWidth', 2)
hold on ;
semilogx(L_svm_don.sep, L_svm_don.RFV, 'r-o', 'LineWidth', 2)
semilogx(L_mc_acc.sep, L_mc_acc.RFV, 'b--s', 'LineWidth', 2)
semilogx(L_mc_don.sep, L_mc_don.RFV, 'r--s', 'LineWidth', 2)
legend('SVM acceptor', 'SVM donor', 'MC acceptor', 'MC donor', 'Location','NorthWest') ;
grid on  
set(gca,'XMinorGrid','off')
set(gca,'YMinorGrid','of')
xlabel('Number of training examples') ;
ylabel('Area under the precision recall curve') ;
print('-depsc2', 'dataset_size_exp_rfv.eps') ;
saveas(gcf, 'dataset_size_exp_rfv.fig', 'fig')

close all
figure('PaperUnits', 'centimeters', 'PaperPosition', [2 2 12 12]) ;
semilogx(L_svm_acc.sep, L_svm_acc.RSV, 'b-o', 'LineWidth', 2)
hold on ;
semilogx(L_svm_don.sep, L_svm_don.RSV, 'r-o', 'LineWidth', 2)
semilogx(L_mc_acc.sep, L_mc_acc.RSV, 'b--s', 'LineWidth', 2)
semilogx(L_mc_don.sep, L_mc_don.RSV, 'r--s', 'LineWidth', 2)
legend('SVM acceptor', 'SVM donor', 'MC acceptor', 'MC donor', 'Location','SouthEast') ;
grid on
set(gca,'XMinorGrid','off')
set(gca,'YMinorGrid','off')
xlabel('Number of training examples') ;
ylabel('Area under the receiver operator curve') ;
print('-depsc2', 'dataset_size_exp_rsv.eps') ;
saveas(gcf, 'dataset_size_exp_rsv.fig', 'fig')
