rand('state', 17);

paths

PAR=H_sapiens_don_PWM();
PAR.method.par_ms.winsize=35; %winsize 50 was optimal for human don
PAR.Signals.don.filter_label.train=rmfield(PAR.Signals.don.filter_label.train,'pos_conf');
PAR.Signals.don.filter_label.train=rmfield(PAR.Signals.don.filter_label.train,'neg_conf');
PAR.Signals.don.filter_label.eval=rmfield(PAR.Signals.don.filter_label.eval,'pos_conf');
PAR.Signals.don.filter_label.eval=rmfield(PAR.Signals.don.filter_label.eval,'neg_conf');
PAR.Signals.don.filter_label.test=rmfield(PAR.Signals.don.filter_label.test,'pos_conf');
PAR.Signals.don.filter_label.test=rmfield(PAR.Signals.don.filter_label.test,'neg_conf');

%PAR=H_sapiens_acc_PWM();
%PAR.method.par_ms.winsize=50; %winsize 50 was optimal for human acc
%PAR.Signals.acc.filter_label.train=rmfield(PAR.Signals.acc.filter_label.train,'pos_conf');
%PAR.Signals.acc.filter_label.train=rmfield(PAR.Signals.acc.filter_label.train,'neg_conf');
%PAR.Signals.acc.filter_label.eval=rmfield(PAR.Signals.acc.filter_label.eval,'pos_conf');
%PAR.Signals.acc.filter_label.eval=rmfield(PAR.Signals.acc.filter_label.eval,'neg_conf');
%PAR.Signals.acc.filter_label.test=rmfield(PAR.Signals.acc.filter_label.test,'pos_conf');
%PAR.Signals.acc.filter_label.test=rmfield(PAR.Signals.acc.filter_label.test,'neg_conf');

PAR.method.feature_type='uint8'; %we cannot afford 2byte per char

%collect model selection parameters
if isfield(PAR.method, 'kernels') & ~isempty(PAR.method.kernels{1})
  PAR.method.par_ms = collect_ms_parameters(PAR, PAR.method.par_ms);
end
[models,par_names] = generate_all_models(PAR.method.par_ms);

sig = PAR.Signal_name;
method = ['_' PAR.method.name];
if isfield(PAR.method, 'kernels')&& isfield(PAR.method.kernels{1}, 'name')
  kern1 = ['_' PAR.method.kernels{1}.name];
else
  kern1 = '';
end

fn_examples = [PAR.FN.input_dir,PAR.organism.name,'/dataset-size_exp_sonne/',sig,method,kern1,'/examples'];
fn_SVMs     = [PAR.FN.input_dir,PAR.organism.name,'/dataset-size_exp_sonne/',sig,method,kern1,'/SVMs']; 
fn_pred     = [PAR.FN.input_dir,PAR.organism.name,'/dataset-size_exp_sonne/',sig,method,kern1,'/pred']; 
fn_res      = [PAR.FN.input_dir,PAR.organism.name,'/dataset-size_exp_sonne/',sig,method,kern1,'/results.mat']; 
fn_time     = [PAR.FN.input_dir,PAR.organism.name,'/dataset-size_exp_sonne/',sig,method,kern1,'/time.eps']; 
fn_rfv      = [PAR.FN.input_dir,PAR.organism.name,'/dataset-size_exp_sonne/',sig,method,kern1,'/rfv.eps']; 
fn_rsv      = [PAR.FN.input_dir,PAR.organism.name,'/dataset-size_exp_sonne/',sig,method,kern1,'/rsv.eps']; 
unix(['mkdir ',PAR.FN.input_dir,PAR.organism.name,'/dataset-size_exp_sonne/']);
unix(['mkdir ',PAR.FN.input_dir,PAR.organism.name,'/dataset-size_exp_sonne/',sig,method,kern1]);


sep = floor(logspace(log10(1000),log10(8500000),10));

fn_ex=sprintf('%s_%i.mat',fn_examples, length(sep));
if ~fexist(fn_ex)
  %Data=load_data(PAR,[1],'train', PAR.SETs.train_subsample_neg,PAR.SETs.train_subsample_pos);
  Data=load_data(PAR,[1 2 3 4],'train', PAR.SETs.train_subsample_neg,PAR.SETs.train_subsample_pos);
  idxp = randperm(size(Data.XT,2)) ;
end

Data_pred=load_data(PAR,[5],'test', PAR.SETs.test_subsample_neg,PAR.SETs.test_subsample_pos);
clear sg

%train SVMs
for j=1:length(sep)
	for i=1:size(models,2),
		fprintf('%d of %d examples / %d of %d models\n', sep(j), sep(end), i, size(models,2));
		PAR = assign_model(PAR, models, par_names,i);
		PAR.fn_SVMs = sprintf('%s_%i_%i.mat',fn_SVMs, j, i);
		if ~fexist(PAR.fn_SVMs)
			D=[] ;
			D.XT = Data.XT(:,idxp(1:sep(j)));
			D.LT = Data.LT(idxp(1:sep(j)));
			D.PAR = PAR;
			PAR.RPROC.options.ncpus = 1 ;
			feval(PAR.method.train_fct,D);
		 end
		 fn_pred_tmp = sprintf('%s_%i_%i.mat',fn_pred, j, i);
		 if ~fexist(fn_pred_tmp)
			 D=[] ;
			 D.svmFileName = sprintf('%s_%i_%i.mat', fn_SVMs, j, i);
			 load(D.svmFileName, 'Train');
			 D.Train=Train;
			 D.Data = Data_pred;
			 D.outFileName = fn_pred_tmp;
			 D.Data_PAR = PAR ;
			 feval(PAR.method.predict_fct,D)
		 end

		 clear D
    end
end


% collect results
RSV=[]; RFV=[] ; TrainTime = [] ;
for j=1:length(sep)
	perf=[];
	for i=1:size(models,2),
	  fn_pred_tmp = sprintf('%s_%i_%i.mat',fn_pred, j, i);
	  disp(fn_pred_tmp)
	  L = load(fn_pred_tmp, 'RSV','RFV') ;
	  perf=[perf L];
	end

	[v1,ii1]=max([perf.RFV]);
	%ii2=ii1;
	[v2,ii2]=max([perf.RSV]);

  RFV(j)=perf(ii1).RFV;
  RSV(j)=perf(ii2).RSV;
  svmFileName = sprintf('%s_%i_%i.mat', fn_SVMs, j, ii1);
  load(svmFileName, 'Train');
  TrainTime(j) = Train.time ;
end

save(fn_res, 'RSV','RFV','sep', 'TrainTime')  

%close all
%loglog(sep, TrainTime, '-o')
%xlabel('Number of training examples') ;
%ylabel('CPU time in seconds required for training') ;
%print('-depsc2', fn_time) ;
%
%close all
%semilogx(sep, RFV, '-o')
%xlabel('Number of training examples') ;
%ylabel('Area under the precision recall curve') ;
%print('-depsc2', fn_rfv) ;
%
%close all
%semilogx(sep, RSV, '-o')
%xlabel('Number of training examples') ;
%ylabel('Area under the receiver operator curve') ;
%print('-depsc2', fn_rsv) ;
%keyboard
%
%return
