
function high_confs = filter_confs(sig,conf_names,thresholds,verb)
  
if isempty(conf_names) || isempty(thresholds)
  warning('thresholds or conf_names empty; I will not filter out anything')
  high_confs = (1:length(sig.pos))';
  return
end
  
high_confs = [];
reasonable = 0;%e.g. you fall into the continue case in all loops or length(val)<1
for i=1:length(conf_names)
  if ~isfield(sig,conf_names{i})&~isequal(conf_names{i},'any_conf')
    continue
  end
  if ~isequal(conf_names{i},'any_conf')
    if ~isfield(sig, 'any_conf')
      sig.any_conf = sig.(conf_names{i});
    elseif ~isequal(conf_names{i},'any_conf')
      sig.any_conf = sig.any_conf + sig.(conf_names{i});
    end
  end
  val = thresholds.(conf_names{i});
  if length(val)==1
    ii = find(sig.(conf_names{i})==val);
    high_confs = [high_confs; ii];
    reasonable = 1;
    if verb
      fprintf('finding pos with %s~=%.1f\n',conf_names{i},val);
    end
  elseif length(val)==2
    assert(val(1)<val(2));
    ii = find(sig.(conf_names{i})>=val(1)&sig.(conf_names{i})<=val(2));
    high_confs = [high_confs; ii];
    reasonable = 1;
    if verb
      fprintf('finding pos with %s not in interval [%.1f %.1f]\n',conf_names{i},val(1),val(2));
    end
  elseif length(val)>2
    ii = find(ismember(sig.(conf_names{i}),val));
    high_confs = [high_confs; ii];
    reasonable = 1;
    if verb
      fprintf('finding pos with %s not in set',conf_names{i})
      fprintf('%i, ',val);
      fprintf('\n')
    end
  end
end

if reasonable
  high_confs = unique(high_confs);
else
  warning('not reasonable!!!')
  high_confs = (1:length(sig.pos))';
end
