function jobinfo = gen_all_positions(PAR)
  
  
jobinfo = struct ;
jobinfo = rproc_empty(0) ;
options = PAR.RPROC.options;
options.ncpus = 1;
options.identifier = sprintf('%spos%s_%s',upper(PAR.organism.name(1:4)),PAR.Signal_name,PAR.method.name) ;
MEMREQ = PAR.RPROC.MEMREQ;
  
fn_pos = PAR.FN.input_sig.(PAR.Signal_name).fn_pos;
strands = '+-';
genome_info = init_genome(PAR.FN.input.fn_genome_config);

% keyboard
blocks = [];
if PAR.SETs.num_splits~=1 
  % load(PAR.FN.output.fn_regions, 'regions')
  % load(PAR.FN.output.fn_split,'split')
  if fexist(PAR.FN.output.fn_training_blocks)
    TR = load(PAR.FN.output.fn_training_blocks, 'blocks','split');
    if ~isempty(TR.split)& ~isempty(TR.blocks)
      has_split = isfield(TR.blocks,'split')&&~isempty(TR.blocks.split);
      splits = fields(TR.split);
      for f=1:length(splits)
        regids = getfield(TR.split, splits{f});
        [temp i1 i2] = intersect(regids, [TR.blocks.id]);
        if ~has_split
          [TR.blocks(i2).split] = deal(f);
        else
          assert(all([TR.blocks(i2).split] == f))      
        end
      end
      clear temp i1 i2 splits regids 
      blocks = [blocks TR.blocks];
      clear TR
    end
  end
  if fexist(PAR.FN.output.fn_test_blocks)
    TE = load(PAR.FN.output.fn_test_blocks, 'blocks','split');
    has_split = isfield(TE.blocks,'split');  
    splits = fields(TE.split);
    for f=1:length(splits)
      regids = getfield(TE.split, splits{f});
      [temp i1 i2] = intersect(regids, [TE.blocks.id]);
      if ~has_split
        [TE.blocks(i2).split] = deal(f);
      else
        assert(all([TE.blocks(i2).split] == f))      
      end
    end
    if isfield(TE.blocks,'right_dist')
      TE.blocks = rmfield(TE.blocks,'right_dist');
    end
    if isfield(TE.blocks,'right_dist')
      TE.blocks = rmfield(TE.blocks,'right_dist');
    end
    blocks = [blocks TE.blocks];
    clear TE;
  end
end

[temp, num_files] = unix(sprintf('ls %scontig_*.pos | wc -l',fn_pos));
[temp, num_files1] = unix(sprintf('ls %scontig_*.svm | wc -l',fn_pos));

%----------
% generate positions
%-----------
load(PAR.FN.output.fn_trivial_regions,'trivial_regions')
PAR.blocks = blocks;

% comp_region  = ones(1,length(trivial_regions));
num_jobs=0;
for t=1:length(trivial_regions)
  if fexist(sprintf('%scontig_%i%s.pos',fn_pos,trivial_regions(t).chr_num,trivial_regions(t).strand))&...
        fexist(sprintf('%scontig_%i%s.svm',fn_pos,trivial_regions(t).chr_num,trivial_regions(t).strand))
    % comp_region(t)  = 0;
    continue
  end
  num_jobs = num_jobs+1;
  PAR.trivial_region = trivial_regions(t);  
  if ~PAR.tasks.run_locally
    jobinfo(num_jobs) = rproc_create('gen_all_positions_rproc', PAR, PAR.RPROC.MEMREQ,options,10*60) ;
  else
    gen_all_positions_rproc(PAR);
  end
end

return
