function gen_all_positions_rproc(PAR)

paths  
trivial_region = PAR.trivial_region;  
blocks = PAR.blocks;
Signal = PAR.Signals.(PAR.Signal_name);
fn_pos = PAR.FN.input_sig.(PAR.Signal_name).fn_pos;

fprintf('start loading sequence for region %i%s\r',trivial_region.chr_num,trivial_region.strand)
tt = load_sequence(trivial_region);
if ~isempty(Signal.consensus)
  pos = find_consensus(tt.seq,Signal,trivial_region.strand);
elseif trivial_region.strand=='+'
  pos = Signal.lwin_big+1:length(tt.seq)-Signal.rwin_big; 
elseif trivial_region.strand=='-'
  pos = Signal.rwin_big+1:length(tt.seq)-Signal.lwin_big; 
end    
trivial_region.Signals.(PAR.Signal_name).pos = pos;
trivial_region.Signals.(PAR.Signal_name).contig_pos = pos; 
clear tt;

%-------------
% Determine SVM
%-------------

trivial_region.Signals.(PAR.Signal_name).svm_num = zeros(size(trivial_region.Signals.(PAR.Signal_name).pos));
for b_idx = 1:length(blocks)
  fprintf('block %i\r',b_idx)
  block = blocks(b_idx);
  if ~isfield(block, 'num_fragments'),
    block.num_fragments = 1 ;
  end ;
  if ~isfield(block, 'reg_no_overlap'),
    block.reg_no_overlap = [block.start block.stop] ;
  end ;
  for f_idx = 1:block.num_fragments
    if f_idx>1
      error('block.reg_no_overlap not implemented for more than one fragment')
    end
    if trivial_region.strand==block.strand(f_idx)&trivial_region.chr_num==block.chr_num(f_idx);
      pos = trivial_region.Signals.(PAR.Signal_name).contig_pos;
      svm_num = trivial_region.Signals.(PAR.Signal_name).svm_num;
      % idx =
      % find(pos>=block.start(f_idx)+PAR.regions.offset&pos<=block.stop(f_idx)-PAR.regions.offset);
      
      idx = find(pos>=block.start+block.reg_no_overlap(1)&pos<=block.start+block.reg_no_overlap(2));
      assert(all(svm_num(idx)==0))
      svm_num(idx) = block.split;
      trivial_region.Signals.(PAR.Signal_name).svm_num = svm_num;
      % keyboard
    end
  end    
end
 
filename = sprintf('%scontig_%i%s',fn_pos,trivial_region.chr_num,trivial_region.strand)
pos = trivial_region.Signals.(PAR.Signal_name).contig_pos;
svm_num = trivial_region.Signals.(PAR.Signal_name).svm_num;
if ~isempty(find(svm_num==0))
  idx = find(svm_num==0);
  nums = repmat([1:PAR.SETs.num_splits],1,ceil(length(idx)/PAR.SETs.num_splits));
  nums = nums(randperm(length(nums)));
  svm_num(idx) = nums(1:length(idx));
end
if ~isempty(pos)
  save_score_pos(pos,svm_num, filename ,{'svm'});
else
  unix(sprintf('touch %s.pos',filename));
  unix(sprintf('touch %s.svm',filename));
  warning('no position found')
end