function jobinfo = genomewide_predictions(PAR,verb)


if nargin<2
  verb=0;
end
% ok = check_file_consistency(PAR) 
jobinfo = rproc_empty(0) ;
    
fid=1;
q=0;
options = PAR.RPROC.options;
options.ncpus = 1;
options.identifier = sprintf('%spred%s_%s',upper(PAR.organism.name(1:4)),PAR.Signal_name,PAR.method.name) ;
MEMREQ = PAR.RPROC.MEMREQ;
genome_info = init_genome(PAR.FN.input.fn_genome_config);
num_pred = PAR.SETs.num_splits * length(genome_info.contig_names)*2;
fprintf(fid,'total number of jobs for prediction (num_svms*num_contigs*num_strands): %i\n',num_pred);

load(PAR.FN.output.fn_trivial_regions,'trivial_regions')

for p = 1:PAR.SETs.num_splits
  fprintf(fid,'partition %i\n',p);
  if ~isfield(PAR.FN.input_sig.(PAR.Signal_name),'fn_SVM_best')
    fn_SVMs = sprintf('%sbest_partition=%i.mat', PAR.FN.output_sig.(PAR.Signal_name).fn_SVMs,p) ;
    if fexist(fn_SVMs)
      load(fn_SVMs,'Train');
    else
      fn_SVMs = sprintf('%s_best_partition=%i.mat', PAR.FN.output_sig.(PAR.Signal_name).fn_SVMs,p) ;
      load(fn_SVMs,'Train');
    end
    if ~isfield(Train.PAR.SETs,'which_pred')
      Train.PAR.SETs.which_pred = Train.PAR.SETs.which_pred_svm;
    end
    assert(Train.PAR.SETs.which_pred == p)
  else
    fn_SVMs = PAR.FN.input_sig.(PAR.Signal_name).fn_SVM_best{p};
    load(fn_SVMs,'Train');
    warning('using SVM from file %s\n',fn_SVMs)
  end
  %--------------------------------------------------------------------------------%
  % load parameters from SVM file
  %--------------------------------------------------------------------------------%
  load(fn_SVMs,'Train');
  
  PAR_new = Train.PAR;
  PAR_new.fn_SVMs = fn_SVMs;
  PAR_new.tasks.pred_from_seq=1;
  if ~isfield(PAR_new.SETs,'which_pred')
    PAR_new.SETs.which_pred=PAR_new.SETs.which_pred_svm;
  end
  clear Train
  
  %------------------------------------------------------------------------------------%
  % perform genome-wide predictions
  %------------------------------------------------------------------------------------%
  for r_idx = 1:length(trivial_regions) 
    c = trivial_regions(r_idx).chr_num;
    s = trivial_regions(r_idx).strand;
    PAR_new.fn_pos = PAR.FN.input_sig.(PAR.Signal_name).fn_pos;
    PAR_new.fn_pred = sprintf('%scontig_%i%s_split=%i.mat',PAR.FN.output_sig.(PAR.Signal_name).fn_pred,c,s,p);
    if isfield(PAR.tasks,'verbose') && PAR.tasks.verbose
      fprintf(fid,'\n start predicting on contig %i%s\n',c,s);
    end
    if ~fexist(PAR_new.fn_pred) 
      PAR_new.region = trivial_regions(r_idx);
      PAR_new.plif_on = 0;
      PAR_new.eval_on = 0;
      if ~isfield(PAR.tasks,'run_locally')
         PAR.tasks.run_locally=0;
      end
      q=q+1; 
      if ~PAR.tasks.run_locally
        if ~isfield(PAR.RPROC,'divide4pred') || ~PAR.RPROC.divide4pred
          if isfield(PAR.RPROC, 'collect_jobs') && PAR.RPROC.collect_jobs 
            jobinfo(q) = rproc_create('load_and_predict', PAR_new, PAR.RPROC.MEMREQ,options,10*60) ;
          else
            jobinfo(q) = rproc('load_and_predict', PAR_new, MEMREQ,options, 2*60);
          end
        else
          q=q-1;
          
          output = [];
          pos = [];
          all_done=1;Temp_old =[];
          for junk_idx=1:PAR.RPROC.numjunks
            PAR_new.junk_idx = junk_idx;PAR_new.RPROC.numjunks =PAR.RPROC.numjunks ;
            PAR_new.RPROC.divide4pred = PAR.RPROC.divide4pred;
            if  ~fexist(sprintf('%s%i.mat',PAR_new.fn_pred, junk_idx))&& isfield(PAR.RPROC, 'collect_jobs') && PAR.RPROC.collect_jobs 
              q=q+1;
              jobinfo(q) = rproc_create('load_and_predict', PAR_new, MEMREQ,options, 2*60);
              all_done=0;
            elseif  ~fexist(sprintf('%s%i.mat',PAR_new.fn_pred, junk_idx))
              q=q+1;
              jobinfo(q) = rproc('load_and_predict', PAR_new, MEMREQ,options, 2*60);
              all_done=0;
            else 
              Temp = load(sprintf('%s%i.mat',PAR_new.fn_pred, junk_idx) )
              Temp.PAR = rmfield(Temp.PAR,'RPROC');
              Temp.PAR = rmfield(Temp.PAR,'junk_idx');
              if ~isempty(Temp_old)
                assert(isequal(Temp_old.svmFileName,Temp.svmFileName));
                assert(isequal(Temp_old.PAR,Temp.PAR));
                assert(isequal(Temp_old.sg_ver,Temp.sg_ver));
              end
              Temp_old = Temp;
              output = [output Temp.output];
              pos = [pos Temp.pos];
            end
          end
          if all_done
            Temp = rmfield(Temp,'output');Temp = rmfield(Temp,'pos');
            %save(PAR_new.fn_pred,'struct','Temp');
            save_append(PAR_new.fn_pred, 0, Temp);
            %save(PAR_new.fn_pred,'-append','output','pos');
            save_append(PAR_new.fn_pred, 1, 'output', output, 'pos', pos);
          end
        end
      else
        load_and_predict(PAR_new)
      end
    else
      if verb
        fprintf(fid,'\n file already exists ');
      end
    end
  end%loop over contigs
end %% loop over partitions
if ~exist('jobinfo')| isempty(jobinfo),
  jobinfo = [];
  return 
end

% [jobinfo, meta_jobinfo] = rproc_submit_batch(jobinfo, PAR.RPROC.exm_per_batch) ;
if ~(isfield(PAR.RPROC, 'collect_jobs') && PAR.RPROC.collect_jobs),
  [jobinfo,num_crashed] = rproc_wait(jobinfo,20,1,0);
end ;
