function ALL = get_cand_transacc(genes,ALL,PAR)
% [LABEL,COV1,CONF] = add_stuff4transacc(genes,POS,PAR)  

  
Signal = getfield(PAR.Signals, PAR.Signal_name);
 
info_trans = PAR.info_genes.(PAR.Signal_name);
info_names_trans = fieldnames(info_trans);
use = [];
fprintf(1,'getting conf for ');
for i=1:length(info_names_trans)
  if ismember([info_names_trans{i} '_conf'],Signal.Conf_names)
    % if PAR.label_source.transacc.(info_names_trans{i})
    use = [use i];
    fprintf(1,'%s, ',info_names_trans{i})
  end
end
fprintf('\n')
info_names_trans = info_names_trans(use);


fprintf(1,'preparing transacc stuff; loop over genes\n');

true_trans = [];
dist_trans = [];
conf_trans = [];
num=0;
for g_idx = 1:length(genes)
  fprintf(1,'%i\r',num);num = num+1;
  gene = genes(g_idx) ;
  gene = genes(g_idx) ;
  genic_idx = find(ALL.POS>gene.start&ALL.POS<gene.stop);

  %%%GETTING POSITVE LABELS FOR TRANSACC
  if ~isempty(gene.(PAR.Signal_name))
    [true_tr,conf_tr,dist_tr]  = get_positive_transacc(gene,PAR,info_names_trans)   ;
    true_trans = [true_trans true_tr];
    dist_trans = [dist_trans dist_tr];
    conf_trans = [conf_trans conf_tr];
  end
end

[ii,ii1,ii2] = intersect(ALL.POS,true_trans);
if length(true_trans)~=length(ii)
  keyboard
end
if ~isempty(ii1)
  ALL.LABEL(ii1) = 1;
  ALL.DIST(ii1) = dist_trans(ii2);
  ALL.CONF_TRANS(:,ii1) = conf_trans(:,ii2) ;
end





function  [true_pos,conf_trans,dist_trans] = get_positive_transacc(gene,PAR,info_names_trans)   
% [conf_trans,num_trans] = get_positive_transacc(gene,PAR,num_trans,info_names_trans)   
  
 strand = gene.strand;
  
 if strand=='+'
   if ~isempty(gene.tss)
     tss = min(gene.tss);
   else
     tss = gene.start;
   end
 else
   if ~isempty(gene.tss)
     tss = max(gene.tss);
   else
     tss = gene.stop;
   end
 end
 
 true_pos = unique(gene.(PAR.Signal_name));
 dist_trans = true_pos-tss;
 % assert(length(unique(true_pos(1:num_trans+length(unique_pos))))==length(true_pos(1:num_trans+length(unique_pos))))
 conf_trans = zeros(length(info_names_trans),length(true_pos));
 for i=1:length(info_names_trans)
   idx = find(gene.([PAR.Signal_name '_info'])== ...
              PAR.info_genes.(PAR.Signal_name).(info_names_trans{i}));
   pos_temp = gene.(PAR.Signal_name)(idx);
   [temp,idx1,idx2] = intersect(true_pos,pos_temp);
   assert(length(idx) == length(pos_temp))
   conf_trans(i,idx1) = gene.([PAR.Signal_name '_conf'])(idx(idx2));
 end

