function [roc_hmm roc_wd, roc_wds, roc_spectrum]=  hmm_svm_vergleich(nex, sigma)
% nex -> number of training and test examples

seed=175;
acgt = 'ACGT';
ac='AC';

% parameters for hmm_training
PAR.method.par_ms.order=5;
PAR.method.par_ms.winsize=99;
PAR.method.par_ms.ppseudo = 10;
PAR.method.par_ms.npseudo = 10;
PAR.method.center=49;
PAR.fn_SVMs = 'schrott.mat';

n = [acgt(ceil(rand(100,nex)*4))];
p = [acgt(ceil(rand(100,nex)*4))];
norm= ceil(randn(1,nex)*sigma+50);
% cut of tails
norm(norm>95)=ceil(rand(1,sum(norm>95))*95);
norm(norm<1)= ceil(rand(1,sum(norm<1))*95);

pattern='ACGTT';
for j=1:length(norm)
  p(norm(j):norm(j)+4,j)=pattern;
end
  

D.XT = [n p];
D.LT = [ones(1,size(n,2))*-1 ones(1,size(p,2))];
D.Pos.pos = ones(1,length(D.LT));
D.Pos.region_id =  ones(1,length(D.LT));
D.PAR = PAR;
Train = hmm_train(D);

nt = [acgt(ceil(rand(100,nex)*4))];
pt = [acgt(ceil(rand(100,nex)*4))];
norm= ceil(randn(1,nex)*sigma+50);
% cut of tails
norm(norm>95)=ceil(rand*95);
norm(norm<1)= ceil(rand*95);
for j=1:length(norm)
  pt(norm(j):norm(j)+4,j)=pattern;
end


test.LT = [-1*ones(1,size(nt,2)) 1*ones(1,size(pt,2)) ];
test.XT = [nt pt];
test.Pos.pos = ones(1,length(test.LT));
test.Pos.region_id =  ones(1,length(test.LT));
hmm_test(Train, test, 'schrott.mat', 'schrottout.mat')

% parameters for WD training
PAR1 = C_elegans_acc_SVM_WD;
D.PAR.method  = PAR1.method;
D.PAR.method.kernels{1}.order = 5;
D.PAR.method.kernels{1}.lwin = -49;
D.PAR.method.kernels{1}.rwin =  50;
D.PAR.method.center=49;
D.PAR.tasks = PAR1.tasks;
D.PAR.fn_SVMs = 'schrott_wd.mat'
svm_train(D);

load('schrott_wd.mat','Train');
test.PAR = D.PAR;
svm_predict(Train,test,'schrott_wd.mat','schrott_wd_out.mat')

% parameters for WDS training
D.PAR.method.kernels{1}.name = 'WDS';
D.PAR.method.kernels{1}.shift_const = 5;
D.PAR.method.kernels{1}.order = 5;
D.PAR.method.kernels{1}.lwin = -49;
D.PAR.method.kernels{1}.rwin =  50;
D.PAR.method.center=49;
D.PAR.tasks = PAR1.tasks;
D.PAR.fn_SVMs = 'schrott_wds.mat'
svm_train(D);
load('schrott_wds.mat','Train');
test.PAR = D.PAR;
svm_predict(Train,test,'schrott_wds.mat','schrott_wds_out.mat')

% parameters for WDS training
D.PAR.method.kernels{1}.name = 'SP';
D.PAR.method.kernels{1}.wordlen = 5;
D.PAR.method.kernels{1}.lwin = -49;
D.PAR.method.kernels{1}.rwin =  50;
D.PAR.method.center=49;
D.PAR.tasks = PAR1.tasks;
D.PAR.fn_SVMs = 'schrott_spectrum.mat'
svm_train(D);
load('schrott_spectrum.mat','Train');
test.PAR = D.PAR;
svm_predict(Train,test,'schrott_spectrum.mat','schrott_spectrum_out.mat')


%load('schrott_spectrum.mat','Train');
test.PAR = D.PAR;
svm_predict(Train,test,'schrott_spectrum.mat','schrott_svm_out.mat')




wd_out = load('schrott_wd_out.mat')
wds_out = load('schrott_wds_out.mat')
spectrum_out = load('schrott_spectrum_out.mat')
hmm_out=load('schrottout.mat')

roc_hmm = hmm_out.RSV;
roc_wd = wd_out.RSV;
roc_wds = wds_out.RSV;
roc_spectrum = spectrum_out.RSV;


