function hmm_test(Train, Data, svmFileName,outFileName);
%hmm_test(Train, Data, svmFileName,outFileName);


% for usage with rproc
if nargin==1
  %paths
  Data  = Train.Data;
  svmFileName = Train.svmFileName;
  outFileName = Train.outFileName;
  Train = Train.Train;
end
PAR = Data.PAR;

%----------------------------------------------------------------------%
% cut out window around signal-site
%----------------------------------------------------------------------%
lwin = -floor(PAR.method.par_ms.winsize/2);
rwin = ceil(PAR.method.par_ms.winsize/2);
select = (lwin:rwin)+PAR.method.center+1;
fprintf('use XT(%i:%i,:)\n',min(select),max(select))


%----------------------------------------------------------------------%
% for genome-wide predictions:
%   - cut out examples from single string
%----------------------------------------------------------------------%
if isfield(PAR.tasks,'pred_from_seq') && PAR.tasks.pred_from_seq
  XT = char(ones(PAR.method.par_ms.winsize+1,length(Data.pos)));
  for j=1:length(Data.pos)
    XT(:,j) = Data.seq(Data.pos(j)+(lwin:rwin))';
  end
else
  assert(length(Data.LT)==size(Data.XT,2))
  XT = Data.XT(select,:);
end

%----------------------------------------------------------------------%
% classify with positiv model
%----------------------------------------------------------------------%
  %sg('send_command', 'loglevel ALL');
  sg('send_command', sprintf('pseudo %f',PAR.method.par_ms.ppseudo));
  assert(size(Train.b_p,2)==4^PAR.method.par_ms.order)
  sg('set_hmm', Train.p_p,Train.q_p,Train.a_p,Train.b_p) ;
  sg('set_features', 'TEST', XT,'DNA') ;
  sg('send_command', sprintf('convert TEST STRING BYTE STRING WORD %i',PAR.method.par_ms.order));

  posout_test=sg('one_class_linear_hmm_classify');

%----------------------------------------------------------------------%
% classify with negativ model  
%----------------------------------------------------------------------%
  %sg('send_command', 'loglevel ALL');
  sg('send_command', sprintf('pseudo %f',PAR.method.par_ms.npseudo));
  assert(size(Train.b_n,2)==4^PAR.method.par_ms.order)
  sg('set_hmm', Train.p_n,Train.q_n,Train.a_n,Train.b_n) ;
  sg('set_features', 'TEST', XT,'DNA') ;
  sg('send_command', sprintf('convert TEST STRING BYTE STRING WORD %i',PAR.method.par_ms.order));

  negout_test=sg('one_class_linear_hmm_classify');

%----------------------------------------------------------------------%
% calculate output
%----------------------------------------------------------------------%
  output = posout_test - negout_test;

%----------------------------------------------------------------------%
% save output
%----------------------------------------------------------------------%
fprintf( 'save output to %s\n',outFileName );
if ~isfield(PAR.tasks,'pred_from_seq') | ~PAR.tasks.pred_from_seq
  RSV = calcrocscore(output, Data.LT)
  RFV = calcrfcscore(output, Data.LT)
  LT = Data.LT;
  POS = Data.Pos;
  save( outFileName, 'output','LT','POS', 'PAR', 'svmFileName','RSV','RFV');
else
  pos = Data.pos;
  save( outFileName, 'output','pos', 'PAR', 'svmFileName');
end
