function [Train]=hmm_train(Data)
% hmm_train(Data)
% Data has to have fields: PAR, LT, XT
% output is saved to file PAR.fn_SVMs
%keyboard
%paths
PAR = Data.PAR;
LT  = Data.LT;
XT  = Data.XT;
clear Data

%----------------------------------------------------------------------%
% cut out window around signal-site
%----------------------------------------------------------------------%
lwin = -floor(PAR.method.par_ms.winsize/2);
rwin = ceil(PAR.method.par_ms.winsize/2);
select = (lwin:rwin)+PAR.method.center+1;
fprintf('use XT(%i:%i,:)\n',min(select),max(select))

%----------------------------------------------------------------------%
% train positive model
%----------------------------------------------------------------------%
t = cputime;
sg('send_command','clean_features TRAIN')
PAR.method.pseudo_tmp = PAR.method.par_ms.ppseudo;
init_hmm(PAR, 'TRAIN', XT(select,LT==1));
sg('send_command', 'linear_train');
[Train.p_p,Train.q_p,Train.a_p,Train.b_p]=sg('get_hmm');
Train.time = cputime-t;

%----------------------------------------------------------------------%
% train negative model
%----------------------------------------------------------------------%
t = cputime;
sg('send_command','clean_features TRAIN')
PAR.method.pseudo_tmp = PAR.method.par_ms.npseudo;
init_hmm(PAR, 'TRAIN', XT(select,LT==-1));
sg('send_command', 'linear_train');
[Train.p_n,Train.q_n,Train.a_n,Train.b_n]=sg('get_hmm');
Train.time = cputime-t;


%----------------------------------------------------------------------%
% save
%----------------------------------------------------------------------%
fprintf( 'save hmms to %s\n',PAR.fn_SVMs );
Train.PAR=PAR;
save(PAR.fn_SVMs, 'Train', 'PAR')

