function  load_and_predict(PAR, Test_Data)

% varargout =  
% predict_svm_splicesites(PAR)
%
% used for both evaluation on the leftout set of the training region and
% prediction on test regions
% 
% * IF PAR.eval_on is set to 1 prediction is performed on the evaluation
%   set specified by PAR.SETs.which_val. The model saved in PAR.fn_SVMs is used for
%   prediction. Additionally RSV and RFV are determined.
%  
% * IF PAR.eval_on is set to 0  only prediction is performed on the test set
%   specified by PAR.SETs.which_pred.
% 
% 
%addpath ~raetsch/shogun/trunk/src
paths 
debug = 0;

load(PAR.fn_SVMs, 'Train') ;

if PAR.eval_on
  which_set = PAR.SETs.which_val
  if isfield(PAR,'fn_eval')
    fn_pred = PAR.fn_eval;
  else
    fn_pred = [];
  end
elseif isfield(PAR,'plif_on') && PAR.plif_on
  which_set = PAR.SETs.which_plif
  if isfield(PAR,'fn_plifs')
    fn_pred = PAR.fn_plifs;
  else
    fn_pred = [];
  end
else
  which_set = PAR.SETs.which_pred
  if isfield(PAR,'fn_pred')
    fn_pred = PAR.fn_pred;
  else
    fn_pred = [];
  end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% load data 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isfield(PAR.SETs,'test_subsample_pos')
  PAR.SETs.test_subsample_pos = 1;
end
if ~isfield(PAR.SETs,'test_subsample_neg')
  PAR.SETs.test_subsample_neg = 1;
end


if ~isfield(PAR.tasks,'pred_from_seq') || ~PAR.tasks.pred_from_seq
  PAR.tasks.pred_from_seq=0;
  if ~exist('Test_Data')
    Test_Data = load_data(PAR,which_set, 'test', PAR.SETs.test_subsample_neg, PAR.SETs.test_subsample_pos, PAR.method.use_cons); 
  end
  
  Test_Data.PAR=PAR;
 %  if isequal(PAR.method.name,'SVM')
    % [RFV RSV]=tssTest(Train, Test_Data, PAR.fn_SVMs, fn_pred);
    % varargout{1} = RFV;
    % varargout{2} = RSV;
 %  elseif isequal(PAR.method.name,'PWM')
    % hmm_test(Train, Test_Data, PAR.fn_SVMs,fn_pred);
 %  end
else %genomweite Vorhersage
  Signal = PAR.Signals.(PAR.Signal_name);
  region = load_sequence(PAR.region);
  region = retrieve_signals(region,PAR.fn_pos,Signal.name,{'svm'});
  Test_Data.seq = region.seq;
  Test_Data.pos = region.Signals.(Signal.name).pos';
  Test_Data.svm = region.Signals.(Signal.name).svm';
  idx = find((Test_Data.pos<Signal.lwin_big+1)|(Test_Data.pos>length(Test_Data.seq)-Signal.rwin_big-1));
  if length(idx)==length(Test_Data.pos), error('no examples in valid region found'); end
  Test_Data.pos(idx)=[];
  Test_Data.svm(idx)=[];
  % load(PAR.fn_pos,'pos','seq','region_id','svm_num') ;
  if ~all(ismember(unique(Test_Data.seq),['ACGT']))
    warning('sequence alphabet different from ACGT; setting all Ns to A')
    Test_Data.seq(~ismember(Test_Data.seq,['ACGT']))='A';
  end
  idx = find(Test_Data.svm==which_set);
  if length(idx)==0, error('no examples for specified svm found'); end
  Test_Data.pos = Test_Data.pos(idx);
  Test_Data.svm = Test_Data.svm(idx);
  fn_pred = PAR.fn_pred;
  if isfield(PAR.RPROC,'divide4pred')&&PAR.RPROC.divide4pred
    junk_length = ceil(length(Test_Data.pos)/PAR.RPROC.numjunks) ;
    idx_sub = (PAR.junk_idx-1)*junk_length+1:min(PAR.junk_idx*junk_length,length(Test_Data.pos));
    Test_Data.pos = Test_Data.pos(idx_sub);
    Test_Data.svm = Test_Data.svm(idx_sub);
    fn_pred = sprintf('%s%i.mat',fn_pred, PAR.junk_idx);
  end
  %   Test_Data.region_id = Test_Data.region_id(idx);
  assert(isfield(PAR.tasks, 'pred_from_seq'))
  Test_Data.PAR = PAR;
end

feval(PAR.method.predict_fct,Train, Test_Data,PAR.fn_SVMs,fn_pred);
