function load_and_train(PAR, Train_Data)

% train_svm_splicesites(PAR)
%
% INPUT: PAR with fields:   
%         - fn_set,             file name of sets to be loaded 
%         - SETs.which_svm,     specifies the sets on which training is
%                               performed (e.g [1 2 3])
%         - SETs.train_subsample_neg  number between 0-1: for subsampling of negative examples, 
%                                0: setting label of examples labeled with 0 to -1   
%                               -1: removing examples labeled with 0 
%                               default(1) no subsampling 
%         - SETs.train_subsample_pos  number between 0-1: for subsampling of positive examples,                             
%                               default(1) no subsampling 
%         - par,                window around consensus to be used  
%         - use_cons            specifies if conservation is to be used
%         - fn_SVMs             file nmame to save results  
%  
%   
% OUTPUT: Train_Data with fields:
%  (XT,LT,SC,pos,reg,str,PAR)
%  saved to file PAR.fn_SVMs
  
%if( ~PAR.method.submit_batch )
%  paths;
%end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% load data of training set
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

input_sig = getfield(PAR.FN.input_sig, PAR.Signal_name);
Signal = getfield(PAR.Signals, PAR.Signal_name);

if ~isfield(PAR.SETs,'train_subsample_pos') && isfield(PAR.SETs,'subsample_pos')
  PAR.SETs.train_subsample_pos= PAR.SETs.subsample_pos ;
  error('warning: please rename field from subsample_pos to train_subsample_pos') ;
end

if ~isfield(PAR.SETs,'train_subsample_neg') && isfield(PAR.SETs,'subsample_neg')
  PAR.SETs.train_subsample_neg= PAR.SETs.subsample_neg ;
  error('warning: please rename field from subsample_neg to train_subsample_neg') ;
end

if ~exist('Train_Data')
 Train_Data= load_data(PAR, PAR.SETs.which_train, 'train', PAR.SETs.train_subsample_neg, PAR.SETs.train_subsample_pos, PAR.method.use_cons);
end
Train_Data.PAR = PAR;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% TRAIN 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

feval(PAR.method.train_fct,Train_Data);
% if PAR.method.name=='SVM'
%   tssTrain(Train_Data)
% elseif PAR.method.name=='PWM'
%   hmm_train(Train_Data)
% else 
%   error('unknown method');
% end
