function [PAR, jobinfo ,all_done]=masterscript_sensors(PAR,check_files,verb)

% [PAR, jobinfo ,all_done] = masterscript_sensors(PAR,check_files,verb)

%cd ~/svn/projects/genefinding/sensors
%paths

if nargin<2 
  check_files =0;
end
if nargin<3 
  verb = 0;
end

fid =1;
fprintf(fid,'\n\n-----------\n');
fprintf(fid,'SENSOR :  %s\n',PAR.Signal_name);
fprintf(fid,'-----------\n');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Train and Predict SENSORS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PAR.method.submit_batch=1;
all_done=0;
train_ok = 0;

jobinfo=struct ;
PAR.method = PAR.Signals.(PAR.Signal_name).method;
if PAR.tasks.prepare_labels
  %fprintf('start training for sensor %s on organism %s with method %s: %s\n\n',sensor,organism,method)
  gen_training_examples4signal(PAR) ;
end
if PAR.tasks.signals.modelsel | PAR.tasks.signals.train
  jobinfo = ms_gfwd_starter(PAR);
  if ~isempty(jobinfo), return ; end ;
end
if PAR.tasks.signals.get_train_error
  jobinfo = predict_testplif_geterror(PAR)
  if ~isempty(jobinfo), return ; end ;
end
if PAR.tasks.signals.learn_plifs
  calc_plifs(PAR);
end
train_ok = 1 ;
if check_files
  train_ok = check_file_consistency(PAR);
end

if ~train_ok
  fprintf('something wrong with training files, check first!!  \n')
end


if ~PAR.tasks.signals.pred_on_genome
  all_done = train_ok ;
  return
end

% genomewide predictions 

[temp, num_files] = unix(sprintf('ls %scontig_*.pos | wc -l',PAR.FN.input_sig.(PAR.Signal_name).fn_pos));
[temp, num_files1] = unix(sprintf('ls %scontig_*.svm | wc -l',PAR.FN.input_sig.(PAR.Signal_name).fn_pos));
genome_info = init_genome(PAR.FN.input.fn_genome_config);
if isempty(str2num(num_files))|(str2num(num_files)<length(genome_info.contig_names)*2)|...
      isempty(str2num(num_files1))|(str2num(num_files1)<length(genome_info.contig_names)*2)
  jobinfo = gen_all_positions(PAR);
  if ~isempty(jobinfo), return ; end ;  
else
  fprintf('genome position files already exist\n')
end
jobinfo = genomewide_predictions(PAR) ;
if ~isempty(jobinfo),
  return ;
else
  fprintf('all %s predictions done\n',PAR.Signal_name)
end ;  

jobinfo = convert_predictions2confs(PAR);
if ~isempty(jobinfo), 
    return ; 
else
  fprintf('conversion done\n')
end ;  
%keyboard

jobinfo = concat_genomewide_predictons(PAR);
if ~isempty(jobinfo), 
  return ; 
else
  fprintf('concatination done\n')
end ;  
if PAR.tasks.modelsel_on | PAR.tasks.modelsel_on
  check_genomewide_output(PAR)
end

[all_done,jobinfo] = save_predictions(PAR);
if ~isempty(jobinfo), 
  return ; 
else
  fprintf('saving done\n')
end ;  
if all_done
  fprintf('%s COMPLETE !\n\n',PAR.Signal_name)
end










