function save_predictions_helper(PAR)
 
paths
genome_info = init_genome(PAR.FN.input.fn_genome_config); 
S = dir(genome_info.flat_fnames{PAR.chrom}) ;
contig_length = S.bytes;
CHR_NAME = genome_info.contig_names{PAR.chrom};
fprintf('contig: %i%s\n', PAR.chrom,PAR.strand);

%----------------------------
%% GET ALL PREDICTIONS from mat file
%----------------------------

filename = sprintf('%scontig_%i%s_all.mat', PAR.fn_pred, ...
                   PAR.chrom, PAR.strand);
load(filename);

% always save global coordinates on forward strand
if isequal(PAR.strand, '-'),
  pos = contig_length - pos + 1;
end
assert(all(pos>=1));

[pos sort_idx] = sort(pos);
Conf = Conf(sort_idx);
Conf_cum = Conf_cum(sort_idx);
output = output(sort_idx);

%----------------------------
%% downsample if demanded
%----------------------------

assert(all(Conf>=0&Conf<=1));
resolution = PAR.Signals.(PAR.Signal_name).export_settings.resolution ;
side = floor(resolution/2) ;
if (resolution~=1), 
  fprintf('Reducing resolution to one prediction per %i nucleotides\n', resolution) ;
  idx = 1:resolution:length(pos) ;
  cc = zeros(1,length(idx)) ;
  co = zeros(1,length(idx)) ;
  oo = zeros(1,length(idx)) ;
  pp = zeros(1,length(idx)) ;
  
  for j=1:length(idx),
    if mod(j,1000)==0, fprintf(' %i  \r', j), end ;
    win = max(1,idx(j)-side):min(idx(j)+side,length(pos)) ;
    neighbour = find((pos(win)>=pos(idx(j))-side) & (pos(win)<pos(idx(j))+side)) ;
    %pos(win(neighbour))
    [mv,mi] = max(Conf_cum(win(neighbour))) ;
    assert(Conf_cum(win(neighbour(mi)))==mv) ;
    
    pp(j) = pos(win(neighbour(mi))) ;
    cc(j) = Conf_cum(win(neighbour(mi))) ;
    co(j) = Conf(win(neighbour(mi))) ;
    oo(j) = output(win(neighbour(mi))) ;
  end;
  pos = pp ;
  Conf_cum = cc ;
  Conf = co ;
  output = co ;
end ;

%----------------------------
%%check if files exist
%----------------------------
filename = sprintf('%scontig_%i%s', PAR.fn_pred, ...
                       PAR.chrom, PAR.strand);
if fexist([filename '.pos']),
  fprintf('removing position file (%s). type *return* to continue \n', filename);
  % keyboard
  unix(sprintf('rm %s', [filename '.pos']));
end
if fexist([filename '.output']),
  fprintf('removing output file (%s)\n', filename);
  unix(sprintf('rm %s', [filename '.output']));
end
if fexist([filename '.Conf']),
  fprintf('removing Conf file (%s)\n', filename);
  unix(sprintf('rm %s', [filename '.Conf']));
end
if fexist([filename '.Conf_cum']),
  fprintf('removing Conf_cum file (%s)\n', filename);
  unix(sprintf('rm %s', [filename '.Conf_cum']));
end

Conf=round(Conf*1000)/1000;
output = round(output*1000)/1000;
Conf_cum=round(Conf_cum*1000)/1000; 

save_score_pos(pos, [output; Conf; Conf_cum], filename, ...
               {'output', 'Conf', 'Conf_cum'});



%----------------------------
%% SAVE PREDICTIONS as wiggle files
%---------------------------- 
if isequal(PAR.Signal_name, 'transacc'),
  disp('Using acceptor predictions in combination with transacc predictions (for wiggle files only)') ;
  FN2.fn_pred = strrep(PAR.fn_pred,'transacc', 'acc') ;
  
  filename2 = sprintf('%scontig_%i%s_all.mat', FN2.fn_pred, ...
                      PAR.chrom,PAR.strand);
  L=load(filename2);
  % always save global coordinates on forward strand
  if isequal(PAR.strand, '-'),
    L.pos = contig_length - L.pos + 1;
  end
  assert(all(pos>=1));
  if ~isequal(sort(L.pos),pos)
    warning('position lists not identical') ;
    setdiff(L.pos, pos)
    setdiff(pos, L.pos)
    
    [tmp,idx1,idx2]=intersect(pos,L.pos) ;
    
    L.Conf = L.Conf(idx2) ;
    L.Conf_cum = L.Conf_cum(idx2) ;
    L.output = L.output(idx2) ;
    L.pos = L.pos(idx2) ;
    
    Conf = Conf(idx1) ;
    Conf_cum = Conf_cum(idx1) ;
    output = output(idx1) ;
    pos = pos(idx1) ;
  else
    [L.pos sort_idx] = sort(L.pos);
    L.Conf = L.Conf(sort_idx);
    L.Conf_cum = L.Conf_cum(sort_idx);
    L.output = L.output(sort_idx);
  end ;
  
  Conf_cum = Conf_cum .* L.Conf_cum ;
  Conf = Conf .* L.Conf ;
  output = output + L.output ;
  clear L ;
end ;


Conf=round(Conf*1000)/1000;
output = round(output*1000)/1000;
Conf_cum=round(Conf_cum*1000)/1000; 


%----------------------------
% REMOVE PREDICTIOND BELOW THRESHOLD
%----------------------------
fprintf('Removing all predictions below %.2f before saving wiggle file') 

idx = find(Conf > PAR.Signals.(PAR.Signal_name).export_settings.conf_cum_thresh);
output   = output(idx);
Conf     = Conf(idx); 
Conf_cum = Conf_cum(idx);
pos = pos(idx);



save_predictions_as_wiggle(filename, pos,output, 'output', PAR.Signal_name, CHR_NAME, PAR.strand);
save_predictions_as_wiggle(filename, pos,Conf, 'Conf', PAR.Signal_name, CHR_NAME, PAR.strand);
save_predictions_as_wiggle(filename, pos,Conf_cum, 'Conf_cum', PAR.Signal_name, CHR_NAME, PAR.strand);