function [ alphas, b, betas, PAR1 ] = svm_train(Data);

paths


PAR=Data.PAR;
%------------------------------------------------------------------------------%
% SVM already trained?
%------------------------------------------------------------------------------%

%if( ~isfield(PAR,'conservWeighting') )
  PAR.conservWeighting = 0;
%end;
if( ~exist('testDataPar','var') )
  testDataPar = [];
end;


%------------------------------------------------------------------------------%
% train SVM
%------------------------------------------------------------------------------%


if( PAR.conservWeighting == 0 )
  Data.W = [];
else
  Data.W = res.W;
  assert( ~isempty(W) );
end;

% keyboard
init_svm_and_kernels(PAR);


if isequal(PAR.method.feature_type,'double') && PAR.method.normalize_features
  idx_rm = find(std(Data.XT')<1e-8);
  Data.XT(idx_rm,:)  = [];
  mean_tr = mean(Data.XT');
  Data.XT = Data.XT - repmat(mean_tr,size(Data.XT,2),1)';
  std_tr = std(Data.XT');
  Data.XT = Data.XT./repmat(std_tr,size(Data.XT,2),1)';
end

setFeatures('TRAIN',PAR,Data);
m = length( Data.LT );
PAR1 = PAR;
PAR1.POS = Data.Pos;
PAR1.lenTrain = size( Data.XT, 1 );

sg_ver=sg('get_version');

% === train
nofKernels = length(PAR.method.kernels);
t0 = cputime;
sg( 'send_command', 'set_kernel_optimization_type FASTBUTMEMHUNGRY' );
%sg( 'send_command', 'set_kernel_optimization_type SLOWBUTMEMEFFICIENT' );
if( PAR.method.use_mkl )
  sg( 'send_command', 'use_mkl 1' );
  sg( 'send_command', 'mkl_parameters 1e-3 0' );
  betas = sg( 'get_subkernel_weights' );
  assert( size(betas) == [nofKernels,1] );
end;
sg( 'send_command', 'svm_train' );
fprintf( '\n' );
t = cputime - t0;

%------------------------------------------------------------------------------%
% get alphas and betas
%------------------------------------------------------------------------------%

% === alphas
[ b, alphas ] = sg( 'get_svm' );


% === betas (kernel weights)
if(PAR.method.use_mkl)
  betas = sg( 'get_subkernel_weights' );
  assert( size(betas) == [nofKernels,1] );
  betas
else
  betas = ones( nofKernels, 1 );
end;


%------------------------------------------------------------------------------%
% save SVM
%------------------------------------------------------------------------------%
Train.alphas = alphas;
Train.b = b;
Train.PAR = PAR;
Train.POS = Data.Pos;
sup_vec_idx = alphas(:,2)+1;
Train.XT = Data.XT(:,sup_vec_idx);
Train.LT = Data.LT(sup_vec_idx);
Train.POS.pos = Data.Pos.pos(sup_vec_idx);
Train.POS.region_id = Data.Pos.region_id(sup_vec_idx);

if isequal(PAR.method.feature_type,'double') && PAR.method.normalize_features
  Train.idx_rm = idx_rm
  Train.mean = mean_tr;
  Train.std = std_tr;
end

Train.time=t;
Train.sg_ver = sg_ver ; 
fprintf('save: %s',PAR.fn_SVMs)
save(PAR.fn_SVMs, 'Train')


