% Write example matrices for C_elegans as fasta
%______________________________________________
check_only = 0
basedir='/fml/ag-raetsch/share/projects/genefinding';
signals={'acc','don'};
organisms={'C_elegans', 'A_thaliana_paper', 'D_melanogaster_old','H_sapiens_nohomologs','D_rerio'};
organisms_nice={'C_elegans', 'A_thaliana', 'D_melanogaster','H_sapiens','D_rerio'};
regions_dirs={'genome_data', 'orig_data', 'orig_data', 'orig_data', 'orig_data'};
if 1
for org_idx=5:5
  fn_regions = sprintf('%s/%s/%s/regions.mat',basedir, organisms{org_idx},regions_dirs{org_idx})
  fn_trivial_regions = sprintf('%s/%s/%s/trivial_regions.mat',basedir, organisms{org_idx},regions_dirs{org_idx})
  fn_config = sprintf('%s/%s/%s/genome.config',basedir, organisms{org_idx},regions_dirs{org_idx})
  if ~check_only
    assert(ismember({'regions'},who('-file',fn_regions)))
    load(fn_regions, 'regions')
    [regions.config]=deal(fn_config);
  end
  for sig_idx=2:2
    fasta_file = sprintf('%s/%s/sensors/%s/%s_%s_all_examples.fasta',basedir,organisms{org_idx},signals{sig_idx},organisms_nice{org_idx},signals{sig_idx})
    if ~check_only
      if fexist(fasta_file)
        fprintf('file already exists, type <return> to delete file and continue')
        %keyboard
        assert(unix(sprintf('rm %s',fasta_file))==0)
      end
      for j=1:5
        split = mod(j+3,5)+1; 
        if org_idx>=4 %human and zebrafish
          fasta_file = sprintf('%s/%s/sensors/%s/%s_%s_examples_split=%i.fasta',basedir,organisms{org_idx},signals{sig_idx},organisms_nice{org_idx},signals{sig_idx},split)
          if fexist(fasta_file)
            fprintf('file already exists, type <return> to delete file and continue')
            %keyboard
            assert(unix(sprintf('rm %s',fasta_file))==0)
          end
        end
        fn_examples = sprintf('%s/%s/sensors/%s/examples_settings=%i_split=%i.mat', basedir, organisms{org_idx},signals{sig_idx},j,split)
        assert(fexist(fn_examples)==1)
        load(fn_examples,'POS','LT');
        XT = load_matrix(fn_examples, 'XT');
        [global_pos chr_num strand] = calc_global_example_pos(POS,regions,1);
        
        save_examples_as_fasta(XT, LT, chr_num, strand,  global_pos ,fasta_file);
        clear XT LT chr_num strand global_pos 
      end
    end
    fprintf(1,'check fasta file: %s\n',fasta_file)
    assert(check_example_fasta_file(fasta_file,fn_trivial_regions,fn_config)==1)
  end
end
end

%Write conf and conf_cum to wiggle-files
%-------------------------------------------
if 0
j=4;
fn_genome_config=sprintf('%s/%s/%s/genome.config',basedir, organisms{j},regions_dirs{j});
genome_info = init_genome(fn_genome_config);
prefix = {'pred_contig','predcontig','predcontig','predcontig','predcontig'};
for sig  = {'don'}
  for c = 1:length(genome_info.contig_names)
    for s = '+-'
      if j==4 %human
        out_fn_prefix = sprintf('%s/%s/sensors/%s/output/%s_%i%s_all',basedir, organisms{j},sig{1},prefix{j},c,s)
      else
        out_fn_prefix = sprintf('%s/%s/sensors/%s/output/%s_%s%s%s_all',basedir, organisms{j},sig{1},prefix{j},genome_info.contig_names{c},s,sig{1})
      end
      load([out_fn_prefix '.mat'],'Conf','Conf_cum','pos')
      [pos sort_idx]=sort(pos);
      Conf_cum = Conf_cum(sort_idx);
      Conf = Conf(sort_idx);
      save_predictions_as_wiggle(out_fn_prefix, pos, Conf_cum, 'Conf_cum',sig{1},genome_info.contig_names{c},s)
      save_predictions_as_wiggle(out_fn_prefix, pos, Conf, 'Conf',sig{1},genome_info.contig_names{c},s)
    end
  end
end
end

