function PAR = alt_splice_template(PAR,signal_name)

INF=1e6;  
PAR = splicesites_template(PAR,signal_name);

Signal = PAR.Signals.(signal_name);

Signal.type = 'altsplice' ;

Signal.label_fct = '';
Signal.filter_fct = 'filter_cands';


Signal.filter_label.train.use_intergenic=0;
Signal.filter_label.train.use_alt=1;
Signal.filter_label.train.use_alt_neg=0;
Signal.filter_label.test.use_intergenic=0;
Signal.filter_label.test.use_alt=1;
Signal.filter_label.test.use_alt_neg=0;

% FILTER PARAMETERS FOR positive examnples
Signal.filter_label.train.conf_pos.est = [1 INF];
Signal.filter_label.train.conf_pos.cDNA = [1 INF];
Signal.filter_label.train.conf_pos.fulllength = [1 INF];
Signal.filter_label.train.any_conf_pos = [1 INF];

Signal.filter_label.test.conf_pos.est = [1 INF];
Signal.filter_label.test.conf_pos.cDNA = [1 INF];
Signal.filter_label.test.conf_pos.fulllength = [1 INF];
Signal.filter_label.test.any_conf_pos = [1 INF];

Signal.filter_label.train.conf_pos_skip.est = [1 INF];
Signal.filter_label.train.conf_pos_skip.cDNA = [1 INF];
Signal.filter_label.train.conf_pos_skip.fulllength = [1 INF];
Signal.filter_label.train.any_conf_pos_skip = [1 INF];

Signal.filter_label.test.conf_pos_skip.est = [1 INF];
Signal.filter_label.test.conf_pos_skip.cDNA = [1 INF];
Signal.filter_label.test.conf_pos_skip.fulllength = [1 INF];
Signal.filter_label.test.any_conf_pos_skip = [1 INF];


% FILTER PARAMETERS FOR negative examnples
% only used for true splicesites
Signal.filter_label.train.conf_neg.est = [20 INF];
Signal.filter_label.train.conf_neg.cDNA = [20 INF];
Signal.filter_label.train.conf_neg.fulllength = [20 INF];
Signal.filter_label.train.any_conf_neg = [20 INF];

Signal.filter_label.test.conf_neg.est = [20 INF];
Signal.filter_label.test.conf_neg.cDNA = [20 INF];
Signal.filter_label.test.conf_neg.fulllength = [20 INF];
Signal.filter_label.test.any_conf_neg = [20 INF];

% only used for decoys
Signal.filter_label.train.conf_neg_skip.est = [20 INF];
Signal.filter_label.train.conf_neg_skip.cDNA = [20 INF];
Signal.filter_label.train.conf_neg_skip.fulllength = [20 INF];
Signal.filter_label.train.any_conf_neg_skip = [20 INF];

Signal.filter_label.test.conf_neg_skip.est = [20 INF];
Signal.filter_label.test.conf_neg_skip.cDNA = [20 INF];
Signal.filter_label.test.conf_neg_skip.fulllength = [20 INF];
Signal.filter_label.test.any_conf_neg_skip = [20 INF];


Signal.filter_label.train.use_decoys = 1;
Signal.filter_label.test.use_decoys = 1;


PAR.Signals = setfield(PAR.Signals,signal_name,Signal);