function PAR=exp_3(PAR)

if nargin<1 
  PAR=init_PAR();
end

PAR.date=date;
PAR.exp_name='exp';
PAR.dir_name ='jonas_new_genes';
PAR.organism.name = 'A_thaliana';
PAR.organism.release = 'arabidopsis_tair7';
PAR.organism.genebuilt = 'genebuild';
PAR.use_tiling = 0;
PAR.FN.output.fn_genes_anno = 'annotated_genes.mat';
PAR.domain_adapt.x = 0;


if ~isfield(PAR,'use_tiling')||~PAR.use_tiling
  %PAR.method.exp_name = 'use_frame';
  PAR.LSL.method.exp_name = 'on_Umaps_blocks';
  PAR.add_lin_feat = 0;
else
  %PAR.method.exp_name = 'tiling_use_frame';
  PAR.LSL.method.exp_name = 'tiling_on_Umaps_blocks';
  PAR.FN.input_lsl.fn_tiling_data = '/fml/ag-raetsch/share/projects/tiling_arrays/array_data_mat/D_QN_RR.mat';
  PAR.add_feat_fun = 'add_intensities2blocks';
  PAR.add_lin_feat = 1;
end

PAR.LSL.method.block_filter_fct = 'filter_high_conf';
PAR.LSL.method.model_fct = 'make_model_no_trans';
PAR.LSL.method.cleave_offset = 0;
PAR.LSL.method.length_fct = 'A_thaliana_lengths';

train=0
if train
  PAR.tasks.modelsel_on = 1;
  PAR.tasks.learn_plifs_on =1;
  PAR.tasks.pred_from_seq=0;
  PAR.tasks.train_on = 1;
  PAR.tasks.prepare_labels=1;
  PAR.tasks.pred_on_genome = 0;
else 
  PAR.tasks.modelsel_on = 0;
  PAR.tasks.learn_plifs_on =0;
  PAR.tasks.pred_from_seq=1;
  PAR.tasks.train_on = 0;
  PAR.tasks.prepare_labels=0;
  PAR.tasks.pred_on_genome = 1;
end
PAR.tasks.train_error_on = 0;
PAR.tasks.run_locally = 0;
PAR.tasks.all_models_one_job = 0;

PAR.RPROC.collect_jobs = 1;
PAR.RPROC.options.ncpus = 1;
PAR.RPROC.exm_per_batch = 10;
PAR.RPROC.time_req = 3600;
PAR.RPROC.MEMREQ = 3000;

