function PAR=exp_Umaps_and_intron(PAR)

if nargin<1 
  PAR=init_PAR();
end

PAR.date=date;
PAR.exp_name='exp';
PAR.dir_name ='jonas_new_genes';
PAR.organism.name = 'A_thaliana';
PAR.organism.release = 'arabidopsis_tair7';
PAR.organism.genebuilt = 'genebuild';
PAR.LSL.method.use.tiling = 1;
PAR.LSL.method.use.rna_seq = 1;
PAR.FN.output.fn_genes_anno = 'annotated_genes.mat';
PAR.domain_adapt = struct;
PAR.LSL.train_blocks_num = 400;


PAR.LSL.method.exp_name = 'U_and_Imaps_mon';
PAR.LSL.method.add_feat_fun = {'add_rna_seq_like_tiling', 'add_intron'};
PAR.LSL.method.add_lin_feat = 1;
PAR.FN.input_lsl.fn_lin_feat_data = {'/fml/ag-raetsch/share/projects/NG_genefinding/Umaps_new.mat', '/fml/ag-raetsch/share/projects/NG_genefinding/Imaps_new.mat'};

PAR.LSL.method.block_filter_fct = 'filter_high_conf';
PAR.LSL.method.model_fct = 'make_model';
%PAR.LSL.method.model_fct = 'make_model_no_trans_old';
PAR.LSL.method.cleave_offset = 0;
PAR.LSL.method.length_fct = 'A_thaliana_lengths';

PAR.tasks.modelsel_on = 0;
PAR.tasks.learn_plifs_on =0;
PAR.tasks.pred_from_seq=1;
PAR.tasks.train_on = 0;
PAR.tasks.prepare_labels=0;
PAR.tasks.pred_on_genome = 1;

PAR.tasks.train_error_on = 0;
PAR.tasks.run_locally = 1;
PAR.tasks.all_models_one_job = 0;

PAR.RPROC.collect_jobs = 1;
PAR.RPROC.options.ncpus = 1;
PAR.RPROC.exm_per_batch = 1;
PAR.RPROC.time_req = 3600;
PAR.RPROC.MEMREQ = 3000;

