function PAR=exp_new_model(PAR)

if nargin<1 
  PAR=init_PAR();
end

PAR.date=date;
PAR.exp_name='exp';
PAR.dir_name ='jonas_new_genes';
PAR.organism.name = 'A_thaliana';
PAR.organism.release = 'arabidopsis_tair7';
PAR.organism.genebuilt = 'genebuild';
PAR.LSL.method.use.tiling = 1;
PAR.LSL.method.use.rna_seq = 1;
PAR.FN.output.fn_genes_anno = 'annotated_genes.mat';
PAR.domain_adapt.x = 0;
PAR.LSL.train_blocks_num = 400;


if ~PAR.LSL.method.use.tiling && ~PAR.LSL.method.use.rna_seq
  PAR.LSL.method.exp_name = 'abinitio_C1';
  %PAR.LSL.method.exp_name = 'abinitio_test2';
  PAR.LSL.method.add_lin_feat = 0;
elseif PAR.LSL.method.use.tiling&& ~PAR.LSL.method.use.rna_seq
  %PAR.LSL.method.exp_name = 'tiling_C1';
  %PAR.LSL.method.exp_name = 'tiling_inf';
  PAR.LSL.method.exp_name = 'tiling_test2';
  PAR.LSL.method.add_lin_feat = 1;
  PAR.FN.input_lsl.fn_lin_feat_data = {'/fml/ag-raetsch/share/projects/tiling_arrays/array_data_mat/D_QN_RR.mat'};
  PAR.LSL.method.add_feat_fun = {'add_intensities2blocks'};
  %PAR.LSL.method.add_feat_fun = {'add_tissue_intensity_to_block'};
elseif PAR.LSL.method.use.rna_seq && ~PAR.LSL.method.use.tiling
  PAR.LSL.method.exp_name = 'rna_seq_test2';
  %PAR.LSL.method.exp_name = 'rna_seq_C1';
  PAR.LSL.method.add_lin_feat = 1;
  PAR.FN.input_lsl.fn_lin_feat_data = {'/fml/ag-raetsch/share/projects/NG_genefinding/Umaps.mat'};
  PAR.LSL.method.add_feat_fun = {'add_Umaps'};
  %PAR.LSL.method.add_feat_fun = {'add_S_and_Umaps'};
else 
  %PAR.LSL.method.exp_name = 'tiling_and_rna_seq';
  PAR.LSL.method.exp_name = 'tiling_and_rna_seq';
  PAR.LSL.method.add_feat_fun = {'add_intensities2blocks', 'add_Umaps'};
  PAR.LSL.method.add_lin_feat = 1;
  PAR.FN.input_lsl.fn_lin_feat_data = {'/fml/ag-raetsch/share/projects/tiling_arrays/array_data_mat/D_QN_RR.mat', '/fml/ag-raetsch/share/projects/NG_genefinding/Umaps.mat'};
end

PAR.LSL.method.block_filter_fct = 'filter_high_conf';
%PAR.LSL.method.model_fct = 'make_model';
PAR.LSL.method.model_fct = 'make_model_no_trans_old';
PAR.LSL.method.cleave_offset = 0;
PAR.LSL.method.length_fct = 'A_thaliana_lengths';

train=0
if train
  PAR.tasks.modelsel_on = 1;
  PAR.tasks.learn_plifs_on =1;
  PAR.tasks.pred_from_seq=0;
  PAR.tasks.train_on = 1;
  PAR.tasks.prepare_labels=1;
  PAR.tasks.pred_on_genome = 0;
else 
  PAR.tasks.modelsel_on = 0;
  PAR.tasks.learn_plifs_on =0;
  PAR.tasks.pred_from_seq=1;
  PAR.tasks.train_on = 0;
  PAR.tasks.prepare_labels=0;
  PAR.tasks.pred_on_genome = 1;
end
PAR.tasks.train_error_on = 0;
PAR.tasks.run_locally = 0;
PAR.tasks.all_models_one_job = 0;

PAR.RPROC.collect_jobs = 1;
PAR.RPROC.options.ncpus = 1;
PAR.RPROC.exm_per_batch = 10;
PAR.RPROC.time_req = 3600;
PAR.RPROC.MEMREQ = 3000;

