function PAR = lsl_cat1_nematodemodel(PAR)  
  
if nargin<1 
  PAR=init_PAR ;
end

PAR = lsl_template(PAR)  

% -------


PAR.method.model_name = 'onlyorf';
PAR.method.use_gc = 1 ;
PAR.method.use_cons = 0 ;
PAR.method.use_ests = 0 ;
PAR.method.use_proteins = 0 ;
PAR.method.dt = datestr(now,'dd-mm-yyyy');
PAR.method.exp_name = 'cat-1';
PAR.method.user = 'GS';

PAR.FN.output_lsl.dir = sprintf('/fml/ag-raetsch/share/projects/genefinding/%s/%s/%s/lsl/%s/', ...
                                PAR.organism.name,PAR.dir_name,PAR.exp_name,PAR.method.exp_name ); 
PAR.FN.output_lsl.fn_init =  sprintf('%strain/%s-%s/init.mat',PAR.FN.output_lsl.dir,PAR.method.user,PAR.method.dt);
PAR.FN.output_lsl.fn_train = sprintf('%strain/%s-%s/train',PAR.FN.output_lsl.dir,PAR.method.user,PAR.method.dt);
PAR.FN.output_lsl.fn_pred = sprintf('%spredictions/%s-%s/pred_split=',PAR.FN.output_lsl.dir,PAR.method.user,PAR.method.dt);
PAR.FN.output_lsl.fn_log = sprintf('%slog_files/%s-%s_log_',PAR.FN.output_lsl.dir,PAR.method.user,PAR.method.dt);





unix(sprintf('mkdir -p %s', PAR.FN.output_lsl.dir)) ;
unix(sprintf('mkdir -p %s/log_files', PAR.FN.output_lsl.dir)) ;
unix(sprintf('mkdir -p %s/data', PAR.FN.output_lsl.dir)) ;
unix(sprintf('mkdir -p %s/train', PAR.FN.output_lsl.dir)) ;
unix(sprintf('mkdir -p %s/predictions', PAR.FN.output_lsl.dir)) ;
unix(sprintf('mkdir -p %s/result', PAR.FN.output_lsl.dir)) ;

unix(sprintf('mkdir -p %strain/%s-%s', PAR.FN.output_lsl.dir,PAR.method.user,PAR.method.dt)) ;
unix(sprintf('mkdir -p %spredictions/%s-%s', PAR.FN.output_lsl.dir,PAR.method.user,PAR.method.dt)) ;



