function ok=check_signals_in_region(PAR, signals, block)
% check if there is at least one signal consensus position in the 
% region with enough sequence flanking for full window lengths left and right

ok = zeros(1,length(signals));
for s=1:length(signals)
  sig = signals{s};
  if isempty(PAR.Signals.(sig).consensus)
    ok(s) = length(block.seq)>PAR.Signals.(sig).lwin_big+PAR.Signals.(sig).rwin_big+1;
  end
  for j=1:length(PAR.Signals.(sig).consensus), 
    idx = findstr(lower(PAR.Signals.(sig).consensus{j}),...
	          lower(block.seq(PAR.Signals.(sig).lwin_big:end-PAR.Signals.(sig).rwin_big)));
    if ~isempty(idx)
      ok(s)=1;
      break;
    end
  end
end


