#!/usr/bin/env python 
# -*- coding: utf-8 -*-

from distutils.core import setup, Extension
from distutils.unixccompiler import UnixCCompiler

Genefinding = Extension(
   name='_Genefinding',
   sources = ['find_interval.c', 'interval_query.c', 'mmap.c','Genefinding.i'],
   swig_opts=['-c++'],
   extra_compile_args=['-O3','-fPIC'],
   language='c++'
   )

comp = UnixCCompiler
comp.cc = 'g++'

setup (
   name = 'Genefinding',
   description = 'A package for accessing data structures',
   version = '0.5', 
   long_description = '''
   A
   ''', 
   author = 'Andre Noll, Fabio De Bona',
   author_email = '@tuebingen.mpg.de',
   url = 'http://',
   license = 'GNU GPL version 3',
   ext_modules = [Genefinding],
   py_modules = ['Genefinding'],
   compiler=comp
   )
