rand('state', 08111979);

a = 1;
b = 100000;
n = 100;

r_pos   = round(a + (b-a).*rand(1,n));
r_score = rand(1,n);

[r_pos idx] = sort(r_pos);
r_score     = r_score(idx);

filename = 'test_file';
unix(sprintf('rm %s.pos', filename));
unix(sprintf('rm %s.score', filename));

save_score_pos(r_pos, [r_score], filename, {'score'});

fprintf('\nretrieving complete interval\n');
[res_pos res_score] = interval_query(filename, {'score'}, [a;b]); 
res_pos   = res_pos';
res_score = res_score';
assert(isequal(r_pos, res_pos));
fprintf('  successful\n\n');

fprintf('boundary test 1\n');
[res_pos res_score] = interval_query(filename, {'score'}, [r_pos(1);r_pos(end)]); 
res_pos   = res_pos';
res_score = res_score';
assert(isequal(r_pos, res_pos));
fprintf('  successful\n\n');

fprintf('boundary test 2\n');
[res_pos res_score] = interval_query(filename, {'score'}, [r_pos(1)-1;r_pos(end)+1]); 
res_pos   = res_pos';
res_score = res_score';
assert(isequal(r_pos, res_pos));
fprintf('  successful\n\n');

fprintf('retrieving interval where position set is empty\n');
[res_pos res_score] = interval_query(filename, {'score'}, [r_pos(10)+1;r_pos(11)-1]); 
res_pos   = res_pos';
res_score = res_score';
assert(isempty(res_pos));
fprintf('  successful\n\n');


a = 1;
b = 20;
n = 50;

r_pos   = round(a + (b-a).*rand(1,n));
r_score = rand(1,n);

[r_pos idx] = sort(r_pos);
r_score     = r_score(idx);

r_pos(3) = r_pos(2);
r_pos(1) = r_pos(2)-1;

r_pos(end-2) = r_pos(end-1);
r_pos(end) = r_pos(end-1)+1;

filename = 'test_file';
unix(sprintf('rm %s.pos', filename));
unix(sprintf('rm %s.score', filename));

save_score_pos(r_pos, [r_score], filename, {'score'});

[res_pos res_score] = interval_query(filename, {'score'}, [r_pos(2);r_pos(end-1)]); 
res_pos   = res_pos';
res_score = res_score';
assert(isequal(r_pos(2:end-1), res_pos));
fprintf('\ntest for multiple identical pos values\n');
fprintf('  successful\n\n');



%disp(r_pos')
%disp(res_pos')

