%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

anno_names={sprintf('%s/annotation_sequences.mat', genome_info.basedir),
            sprintf('%s/annotation_sequences_all.mat', genome_info.basedir)
            sprintf('%s/annotation_sequences_coding.mat', genome_info.basedir)
            sprintf('%s/annotation_sequences_all_coding.mat', genome_info.basedir)} ;

for q=1:length(anno_names),
  if fexist(anno_names{q})
    disp(anno_names{q});
    
    L1=[] ; L2=[] ;
    L1.genes=arrayload2(sprintf('%s/confirmed_sequences.mat', ...
                          genome_info.basedir), 'genes') ;
    L2.genes=arrayload2(anno_names{q}, 'genes') ;
    colmap21=compute_colocation_map(L1.genes, L2.genes, genome_info) ;
    colmap12=compute_colocation_map(L2.genes, L1.genes, genome_info) ;
    
    genes=L1.genes ;
    for i=1:length(genes)
      if q==1,
        genes(i).annotation_genes = colmap12{i} ;
      elseif q==2,
        genes(i).annotation_genes_all = colmap12{i} ;
      elseif q==3,
        genes(i).annotation_genes_coding = colmap12{i} ;
      else 
        genes(i).annotation_genes_all_coding = colmap12{i} ;
      end 
    end ;
    arraysave2(sprintf('%s/confirmed_sequences.mat', genome_info.basedir), ...
               genes, 'genes') ;
    
    genes=L2.genes ;
    for i=1:length(genes)
      genes(i).confirmed_genes = colmap21{i} ;
    end ;
    arraysave2(anno_names{q}, genes, 'genes') ;
  end 
end ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if fexist(sprintf('%s/est_matches.mat', genome_info.basedir))
  L1=[] ; L2=[] ;
  L1.genes=arrayload2(sprintf('%s/confirmed_sequences.mat', genome_info.basedir), 'genes') ;
  L2.genes=arrayload2(sprintf('%s/est_matches.mat', genome_info.basedir), 'genes') ;
  colmap21=compute_colocation_map(L1.genes, L2.genes, genome_info) ;
  colmap12=compute_colocation_map(L2.genes, L1.genes, genome_info) ;
  
  %save(sprintf('%s/confirmed_est_colocation_map.mat', ...
  %             genome_info.basedir), 'colmap21', 'colmap12') ;
  
  cover1=0 ;
  for i=1:length(L1.genes)
    L1.genes(i).est_matches = colmap12{i} ;
    if ~isempty(colmap12{i}), cover1 = cover1 + 1 ; end ;
  end ;
  fprintf('%i of %i Genes covered\n', cover1, length(L1.genes)) ;
  arraysave2(sprintf('%s/confirmed_sequences.mat', genome_info.basedir), L1.genes, 'genes') ;
  
  cover2=0 ;
  for i=1:length(L2.genes)
    if ~isempty(colmap21{i}), cover2 = cover2 + 1 ; end ;
    L2.genes(i).confirmed_genes = colmap21{i} ;
  end ;
  fprintf('%i of %i EST matches covered\n', cover2, length(L2.genes)) ;
  arraysave2(sprintf('%s/est_matches.mat', genome_info.basedir), L2.genes, 'genes') ;
  
elseif fexist(sprintf('%s/est_matches_%s%c.mat', genome_info.basedir, genome_info.contig_names{1}, '+'))
  L1=[] ; L2=[] ;
  L1.genes=arrayload2(sprintf('%s/confirmed_sequences.mat', genome_info.basedir), 'genes') ;

  count1 = 0 ; 
  count2 = 0 ;
  num1 = 0 ;
  num2 = 0 ;
  for c=1:length(genome_info.contig_names),
    for strand='+-', 
      disp([genome_info.contig_names{c} strand])
      L2.genes=arrayload2(sprintf('%s/est_matches_%s%c.mat', genome_info.basedir, ...
                                  genome_info.contig_names{c}, strand), 'genes') ;
      colmap21=compute_colocation_map(L1.genes, L2.genes, genome_info) ;
      colmap12=compute_colocation_map(L2.genes, L1.genes, genome_info) ;
      fprintf('\n') ;
%keyboard

      for i=1:length(L1.genes)
        if isequal(L1.genes(i).chr, genome_info.contig_names{c}) & L1.genes(i).strands(1)==strand,
          if ~isempty(colmap12{i}), count1 = count1 + 1 ; end ;
          num1 = num1+1 ;
          L1.genes(i).est_matches = colmap12{i} ;
        end ;
      end ;
      fprintf('%i of %i Genes covered\n', count1, num1) ;

      for i=1:length(L2.genes)
        if ~isempty(colmap21{i}), count2 = count2 + 1 ; end ;
        num2 = num2 + 1 ;
        L2.genes(i).confirmed_genes = colmap21{i} ;
      end ;
      fprintf('%i of %i EST matches covered\n', count2, num2) ;
      arraysave2(sprintf('%s/est_matches_%s%c.mat', genome_info.basedir, ...
                         genome_info.contig_names{c}), L2.genes, 'genes') ;
    end ;
  end ;
  arraysave2(sprintf('%s/confirmed_sequences.mat', genome_info.basedir), ...
             L1.genes, 'genes') ;
end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if fexist(sprintf('%s/est_matches.mat', genome_info.basedir)) && ...
  fexist(sprintf('%s/annotation_sequences.mat', genome_info.basedir))
  
  L1=load(sprintf('%s/annotation_sequences.mat', genome_info.basedir)) ;
  L2=load(sprintf('%s/est_matches.mat', genome_info.basedir)) ;
  colmap21=compute_colocation_map(L1.genes, L2.genes, genome_info) ;
  colmap12=compute_colocation_map(L2.genes, L1.genes, genome_info) ;
  
  save(sprintf('%s/annotation_est_colocation_map.mat', ...
               genome_info.basedir), 'colmap21', 'colmap12') ;
  
  genes=L1.genes ;
  for i=1:length(genes)
    genes(i).est_matches = colmap12{i} ;
  end ;
  save(sprintf('%s/annotation_sequences.mat', genome_info.basedir), 'genes') ;
  
  genes=L2.genes ;
  for i=1:length(genes)
    genes(i).annotation_genes = colmap21{i} ;
  end ;
  save(sprintf('%s/est_matches.mat', genome_info.basedir), 'genes') ;
  
end 
