function colmap=compute_colocation_map(genes1, genes2, genome_info)
  
  chr_maps = {} ;
  for i=1:length(genome_info.flat_fnames)
    d=dir(genome_info.flat_fnames{i}) ;
    chr_maps{1,i}=uint32(zeros(1,d(1).bytes)) ;
    chr_maps{2,i}=uint32(zeros(1,d(1).bytes)) ;
  end ;
  
  for i=1:length(genes1) ;
    start=inf; stop=0 ;
    for j=1:length(genes1(i).exons)
      if start>min(genes1(i).exons{j}(:)), tmp=genes1(i).exons{j}(:,1:2) ; start=min(tmp(:)) ; end ;
      if stop<max(genes1(i).exons{j}(:)), tmp=genes1(i).exons{j}(:,1:2) ; stop=max(tmp(:)) ; end ;
    end ;
    assert(~isinf(start) & stop~=0) ;
    genes1(i).start=start ;
    genes1(i).stop=stop ;
  end

  for i=1:length(genes2) ;
    start=inf; stop=0 ;
    for j=1:length(genes2(i).exons)
      if start>min(genes2(i).exons{j}(:)), tmp=genes2(i).exons{j}(:,1:2) ; start=min(tmp(:)) ; end ;
      if stop<max(genes2(i).exons{j}(:)), tmp=genes2(i).exons{j}(:,1:2) ; stop=max(tmp(:)) ; end ;
    end ;
    assert(~isinf(start) & stop~=0) ;
    genes2(i).start=start ;
    genes2(i).stop=stop ;
  end
  
  for i=1:length(genes1) ;
    if (mod(i,100)==0), fprintf(1,'%i\r',i);end;
    chr = find(ismember(genome_info.contig_names,genes1(i).chr)) ;
    gene_start = genes1(i).start ;
    gene_end = genes1(i).stop ;
    if genes1(i).strands(1)=='+'
      chr_maps{1,chr}(gene_start:gene_end) = i ;
    else 
      chr_maps{2,chr}(gene_start:gene_end) = i ;
    end ;
  end ;
  fprintf('\n') ;

  colmap={} ;
  for i=1:length(genes2) ;
    colmap{i} = {} ;
    if (mod(i,100)==0), fprintf(1,'%i\r',i);end;
    chr = find(ismember(genome_info.contig_names,genes2(i).chr)) ;
    gene_start = genes2(i).start ;
    gene_end = genes2(i).stop ;
    if genes2(i).strands(1)=='+'
      colmap{i} = unique(chr_maps{1,chr}(gene_start:gene_end)) ;
    else 
      colmap{i} = unique(chr_maps{2,chr}(gene_start:gene_end)) ;
    end ;
    colmap{i}(colmap{i}==0)=[] ;
    %if length(colmap{i})>1, keyboard; end ;
  end ;
  