function genes=detect_short_exons(genes) ;
%function genes=detect_short_exons(genes) ;
%
% removes exons at the beginning or end of an transcript that are
% shorter than 10, if the resulting splice site has not appeared in
% any other sequence
  
to_delete=[] ;
init_removed = 0 ;
term_removed = 0 ;
whole_removed = 0 ;

for ix=1:length(genes)
  problem=[] ;
  if mod(ix,1000)==0,
    fprintf('%i\r', ix) ;
  end ;
  
  nr_transcripts=length(genes(ix).strands) ;
  
  if length(genes(ix).strands)==0
    keyboard ;
  end
  
  splice_donors = [] ; splice_acceptors = [] ;

  for i=1:length(genes(ix).strands) ;
    splice_donors = [splice_donors; genes(ix).exons{i}(1:end-1,2)] ;
    splice_acceptors = [splice_acceptors; genes(ix).exons{i}(2:end,1)] ;
  end ;
  for i=1:length(genes(ix).strands) ;
    if genes(ix).exons{i}(1,2)-genes(ix).exons{i}(1,1)<10
      if sum(genes(ix).exons{i}(1,2)==splice_donors)>1,
        continue ;
      end ;
      if size(genes(ix).exons{i},1)==1
        %fprintf('problem: first and only, gene: %i, transcript: %i\n', ix, i) ;
        problem=[problem,i] ;
      else
        %fprintf('problem:first, gene: %i, transcript: %i\n', ix, i) ;
        genes(ix).exons{i}=genes(ix).exons{i}(2:end,:) ;
        genes(ix).exons_confirmed{i}=genes(ix).exons_confirmed{i}(2:end,:) ;
        init_removed=init_removed+1 ;
      end
    end
  end
    
  for i=1:length(genes(ix).strands) ;
    if genes(ix).exons{i}(end,2)-genes(ix).exons{i}(end,1)<10
      if sum(genes(ix).exons{i}(end,1)==splice_acceptors)>1,
        continue ;
      end ;
      if size(genes(ix).exons{i},1)==1
        %fprintf('problem: last and only, gene: %i, transcript: %i\n', ix, i) ;
        problem=[problem,i] ;
      else
        %fprintf('problem: last, gene: %i, transcript: %i\n', ix, i) ;
        genes(ix).exons{i}=genes(ix).exons{i}(1:end-1,:) ;
        genes(ix).exons_confirmed{i}= [genes(ix).exons_confirmed{i}(1:end-1,1) genes(ix).exons_confirmed{i}([1:end-2 end],2)];
        term_removed=term_removed+1 ;
      end
    end
  end

  problem = unique(problem) ;
  whole_removed=whole_removed+length(problem) ;
  
  genes(ix).transcripts(problem)=[] ;
  genes(ix).exons(problem)=[] ;
  genes(ix).exons_confirmed(problem)=[] ;
  genes(ix).strands(problem)=[] ;
  genes(ix).terminal_info(:,problem)=[] ;
  %genes(ix).is_cDNA(problem)=[] ;
  %genes(ix).transcript_valid(problem)=[] ;
  
  if length(genes(ix).strands) ==0,
    to_delete=[to_delete, ix] ;    
  end
end
fprintf('\ndeleting %i initial exons.\n', init_removed) ;
fprintf('deleting %i terminal exons.\n', term_removed) ;
fprintf('deleting %i transcripts.\n', whole_removed) ;
fprintf('deleting %i genes.\n', length(to_delete)) ;

% delete empty genes
genes(to_delete)=[] ;
