addpath ../../utils
addpath ../../splicegraphs
addpath /fml/ag-raetsch/share/software/matlab_tools/utils

genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS145_new/genome.config') ;
load(sprintf('%s/confirmed_sequences.mat', genome_info.basedir)) ;

addpath ../../../../tools/mysql
mysql('open', 'huangho') ;
mysql('use elegans_WS145') ;
mysql('drop table if exists exons ') ;
mysql('create table exons (start int, end int, contig int, strand char, level int, transcript_id char(50), gene_id char(50))')
mysql('drop table if exists introns ') ;
mysql('create table introns (start int, end int, contig int, strand char, level int, transcript_id char(50), gene_id char(50))')
mysql('drop table if exists contigs ') ;
mysql('create table contigs (contig_name char(50), contig_id int)')

for i=1:length(genome_info.contig_names)
  mysql(sprintf('insert contigs (contig_name, contig_id) values ("%s", %i)', genome_info.contig_names{i},i)) ;
end ;

for i=1:length(genes),
  i
  contig_idx=find(ismember(genome_info.contig_names, genes(i).chr)) ;

  [max_exon_level,max_intron_level,exon_level,intron_level] = detectsplicegraph(genes(i)) ;
  assert(max_exon_level==max(exon_level(3,:))) ;
  assert(max_intron_level==max(intron_level(3,:))) ;
  
  for k=1:size(exon_level,2) ;
    for j=1:length(genes(i).exons)
      idx=find(genes(i).exons{j}(:,1) == exon_level(1,k) & genes(i).exons{j}(:,2) == exon_level(2,k)) ;
      if ~isempty(idx), idx = j ; break ; end ;
    end ;
    if ~isempty(idx), 
      transcript_name = genes(i).transcripts{idx} ;
    else
      transcript_name = 'combined' ;
    end ;
    
    mysql(sprintf('insert exons (start, end, contig, strand, level, transcript_id, gene_id) values (%i, %i, %i, "%c", %i, "%s", "%s")', exon_level(1,k), exon_level(2,k), contig_idx, genes(i).strands(1), exon_level(3,k), transcript_name, genes(i).name)) ;
  end 

  for k=1:size(intron_level,2) ;
    %for j=1:length(genes(i).exons)-1
    for j=1:length(genes(i).exons)
      idx=find(genes(i).exons{j}(1:end-1,2) == intron_level(1,k) & genes(i).exons{j}(2:end,1) == intron_level(2,k)) ;
      if ~isempty(idx), idx=j ; break ; end ;
    end ;
    if ~isempty(idx), 
      transcript_name = genes(i).transcripts{idx} ;
    else
      transcript_name = 'intron not found (bug somewhere)' ;
    end ;
    mysql(sprintf('insert introns (start, end, contig, strand, level, transcript_id, gene_id) values (%i, %i, %i, "%c", %i, "%s", "%s")', intron_level(1,k), intron_level(2,k), contig_idx, genes(i).strands(1), intron_level(3,k), transcript_name, genes(i).name)) ;
  end 
end ;
