function genes = filter_microexons(genes)
% filter out transcripts with containing short exons

MIN_EXON_LEN = 5;

num_removed = 0;
for ix = 1:length(genes)
  % --- for each transcript, check that all exons are longer than MIN_EXON_LEN
  has_microexon = [];
  for ix2 = 1:length(genes(ix).exons)
    len = genes(ix).exons{ix2}(:,2) - genes(ix).exons{ix2}(:,1) ;
    if any(len <= 5)
      has_microexon(end+1) = ix2;
    end
  end
  if ~isempty(has_microexon)
    num_removed = num_removed + length(has_microexon);
    genes(ix).transcripts(has_microexon) = [];
    genes(ix).exons(has_microexon) = [];
    genes(ix).exons_confirmed(has_microexon) = [];
    genes(ix).strands(has_microexon) = [];
    genes(ix).terminal_info(:,has_microexon) = [];
  end
end


fprintf(1,'Removed %d transcripts\n',num_removed);
