function merge_conf_anno(which) ;
% function merge_conf_anno(which) ;

addpath ../../utils
addpath ../../splicegraphs
addpath /fml/ag-raetsch/share/software/matlab_tools/utils

fprintf('initializing genome\n') ;


switch which,
 case 1
  genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS147_new/genome.config') ;
 case 2
  genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/arabidopsis_new/genome.config') ;
 case 3
  genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/drosophila_new/genome.config') ;
 case 4
  genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/rerio_new/genome.config') ;
end
fprintf('directory: %s\n',genome_info.basedir) ;


if equal(genome_info.annotation_fnames{1}(end-2:end),'gff')
  genes = read_gff_files_anno(genome_info) ;
else
  genes = read_xmlparse_files(genome_info) ;
end ;
% eliminate duplicated gene descriptors
genes = merge_transcripts_by_name(genes) ;
genes = merge_transcripts_by_colocation(genes, genome_info) ;
% filter only genes with valid introns and other properties
genes = check_genes(genes) ;

save(sprintf('%s/annotation_sequences_transcripts.mat', genome_info.basedir), 'genes') ;

genes2=genes 

load(sprintf('%s/confirmed_sequences_transcripts.mat', genome_info.basedir), ...
     'genes') ;

genes3=[genes, genes2] ;

genes=genes3
genes = merge_transcripts_by_colocation(genes, genome_info) ;
% filter only genes with valid introns and other properties
genes = check_genes(genes) ;

save(sprintf('%s/conf_anno_sequences_transcripts.mat', genome_info.basedir), 'genes') ;

build_splice_graph ;

save(sprintf('%s/conf_anno_sequences_build.mat', genome_info.basedir), 'genes') ;

merge_splice_graph ;

save(sprintf('%s/conf_anno_sequences_merge.mat', genome_info.basedir), 'genes') ;

infer_splice_graph ;

save(sprintf('%s/conf_anno_sequences_infer.mat', genome_info.basedir), 'genes') ;