function genes=merge_transcripts_by_colocation(genes, genome_info)
  
% reconsider colocation
while (1)
  chr_maps = {} ;
  for i=1:length(genome_info.flat_fnames)
    %d=dir(genome_info.flat_fnames{i}) ;
    chr_maps{1,i}=[] ;%zeros(1,d(1).bytes, 'uint32') ;
    chr_maps{2,i}=[] ;%zeros(1,d(1).bytes, 'uint32') ;
  end ;
  
  num_mistakes = 0 ;
  %mistakes=[] ; 
  take_map = zeros(1,length(genes)) ;

  for i=1:length(genes) ;
    start=inf; stop=0 ;
    for j=1:length(genes(i).exons)
      genes(i).exons{j}= genes(i).exons{j}(:,1:2) ;
      %min(genes(i).exons{j}(:))
      if start>min(genes(i).exons{j}(:)), start=min(genes(i).exons{j}(:)) ; end ;
      if stop<max(genes(i).exons{j}(:)), stop=max(genes(i).exons{j}(:)) ; end ;
    end ;
    assert(~isinf(start) & stop~=0) ;
    genes(i).start=start ;
    genes(i).stop=stop ;
  end
  
  for i=1:length(genes) ;
    if (mod(i,100)==0), fprintf(1,'%i\r',i);end;
    chr = find(ismember(genome_info.contig_names,genes(i).chr)) ;
    if isempty(chr_maps{1,chr})
      d=dir(genome_info.flat_fnames{chr}) ;
      chr_maps{1,chr}=zeros(1, d(1).bytes, 'uint32') ;
      chr_maps{2,chr}=zeros(1, d(1).bytes, 'uint32') ;
    end ;
    gene_start = genes(i).start ;
    gene_end = genes(i).stop ;
    if genes(i).strands(1)=='+'
      if gene_end>length(chr_maps{1,chr}), 
        chr_maps{1,chr}(gene_end)=0 ;
      end 
      if ~all(chr_maps{1,chr}(gene_start:gene_end)==0), 
        a=unique(chr_maps{1,chr}(gene_start:gene_end)) ; a(a==0)=[] ;
        %assert((length(a)==2 && a(1)==0) | (length(a)==1)) ;
        %mistakes = [mistakes; i a(end)] ;
        num_mistakes = num_mistakes + 1 ;
        chr_maps{1,chr}(gene_start:gene_end) = a(end) ;
        genes(a(end)).transcripts = {genes(a(end)).transcripts{:} genes(i).transcripts{:}} ;
        genes(a(end)).terminal_info = [genes(a(end)).terminal_info genes(i).terminal_info] ;
        genes(a(end)).exons = {genes(a(end)).exons{:} genes(i).exons{:}} ;
        genes(a(end)).exons_confirmed = {genes(a(end)).exons_confirmed{:} genes(i).exons_confirmed{:}} ;
        genes(a(end)).strands = [genes(a(end)).strands genes(i).strands] ;
      else
        take_map(i) = 1 ;
        chr_maps{1,chr}(gene_start:gene_end) = i ;
      end 
    else 
      if gene_end>length(chr_maps{2,chr}), 
        chr_maps{2,chr}(gene_end)=0 ;
      end 
      if ~all(chr_maps{2,chr}(gene_start:gene_end)==0), 
        a=unique(chr_maps{2,chr}(gene_start:gene_end)) ; a(a==0)=[] ;
        %assert((length(a)==2 && a(1)==0) | (length(a)==1)) ;
        %mistakes = [mistakes; i a(end)] ;
        num_mistakes = num_mistakes + 1 ;
        chr_maps{2,chr}(gene_start:gene_end) = a(end) ;
        genes(a(end)).transcripts = {genes(a(end)).transcripts{:} genes(i).transcripts{:}} ;
        genes(a(end)).terminal_info = [genes(a(end)).terminal_info genes(i).terminal_info] ;
        genes(a(end)).exons = {genes(a(end)).exons{:} genes(i).exons{:}} ;
        genes(a(end)).exons_confirmed = {genes(a(end)).exons_confirmed{:} genes(i).exons_confirmed{:}} ;
        genes(a(end)).strands = [genes(a(end)).strands genes(i).strands] ;
      else
        take_map(i) = 1 ;
        chr_maps{2,chr}(gene_start:gene_end) = i ;
      end 
    end ;
  end ;
  genes=genes(find(take_map)) ;
  fprintf(1,'reduced by %d transcripts, %d genes remaining\n',num_mistakes,length(genes));
  if num_mistakes==0, break ; end ;
end 