addpath ../../utils
addpath ../../splicegraphs
addpath ../../splicegraphs/detect_altsplice
addpath /fml/ag-raetsch/share/software/matlab_tools/utils

fprintf('initializing genome\n') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS147_new/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS160_mSplicer/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/altsplicedata/arabidopsis/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/drosophila_new/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/rerio_new/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/human/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS147_new_cdna/genome.config') ;

%genome_info = init_genome('/fml/ag-raetsch/share/projects/nGASP/cat3_alignments/genome.config')
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS150_strict/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS120_mSplicer/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS120_WS150_mSplicer/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS150_mSplicer/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/pacificus_mSplicer/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/briggsae_mSplicer/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/remanei_mSplicer/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/drosophila_mSplicer/genome.config') ;

% most recent genomes
genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/arabidopsis/genome.config') ;

genome_info = init_genome('/fml/ag-raetsch/share/projects/polyAsites/arabidopsis/genome.config') ;
genome_info = init_genome('/fml/ag-raetsch/share/projects/polyAsites/pacificus/genome.config') ;
genome_info = init_genome('/fml/ag-raetsch/share/projects/polyAsites/elegans/genome.config') ;
genome_info = init_genome('/fml/ag-raetsch/share/projects/polyAsites/drosophila/genome.config') ;
genome_info = init_genome('/fml/ag-raetsch/share/projects/polyAsites/human/genome.config') ;
genome_info = init_genome('/fml/ag-raetsch/share/projects/volvox/gff_blat_best_0.05/genome.config') ;
genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/zebrafish_zv6/genome.config') ;

fprintf('directory: %s\n', genome_info.basedir) ;

read_confirmed_sequences 
read_annotation_sequences
read_est_segments
colocate_sequences


% split genes
genes=arrayload2(sprintf('%s/confirmed_sequences_transform.mat', genome_info.basedir),'genes') ;
genes_split = split_genes(genes)

save(sprintf('%s/confirmed_sequences_split.mat', genome_info.basedir), 'genes_split') ;

%%%% can be done: merge_conf_anno


return 

% mSplicer WS120 split
% stay as close as possible to the WS150 mSplicer split

genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS150_mSplicer/genome.config') ;
load(sprintf('%s/confirmed_sequences_split.mat', genome_info.basedir), 'genes_split') ;

genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS150_mSplicer/genome.config') ;
L1=load(sprintf('%s/confirmed_sequences.mat', genome_info.basedir)) ;

cDNAs=[] ;
for i=1:4,
  cDNAs{i}={} ;
  idx=[genes_split{i,1} genes_split{i,2}] ;
  for j=idx,
    cDNAs{i}={cDNAs{i}{:} L1.genes(j).transcripts{L1.genes(j).is_cDNA==1}} ;
  end ;
  for j=1:length(cDNAs{i})
    idx=find(cDNAs{i}{j}=='-') ;
    cDNAs{i}{j}=cDNAs{i}{j}(idx(1)+1:idx(2)-1) ;
  end ;
end ;


%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS150_strict/genome.config') ;
genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS160_mSplicer/genome.config') ;
L2=load(sprintf('%s/confirmed_sequences.mat', genome_info.basedir)) ;

genes_split=[] ;
genes_split{4,2}=[] ;

multiple=0 ;
not_found=0 ;
num_ests=0 ;
num_cDNAs=0 ;
for i=1:length(L2.genes)
  map=zeros(1,4) ;
  idx = find(L2.genes(i).has_cDNA==1) ;
  for j=idx,
    idx=find(L2.genes(i).transcripts{j}=='-') ;
    query=L2.genes(i).transcripts{j}(idx(1)+1:idx(2)-1) ;
    for k=1:4,
      if any(ismember(cDNAs{k},query))
        map(k)=map(k)+1 ;
      end ;
    end ;
  end ;
  if (sum(map>0)>=2)
    idx=randperm(3) ;
    map(:)=0 ;
    map(idx(1)+1)=1 ;
    multiple=multiple+1 ;
  elseif sum(map>0)==0
    map(1)=1 ;
    not_found=not_found+1 ;
  end ;
  if all(L2.genes(i).has_cDNA~=1)
    num_ests=num_ests+1 ;
  else
    num_cDNAs=num_cDNAs+1 ;
  end ;
  assert(sum(map>0)==1) ;
  L2.genes(i).inset=find(map) ;
  %if sum(map>0)==1, found=found+1 ; end 
  %if ~isempty(idx), bla=bla+1 ; end ;
  genes_split{find(map),L2.genes(i).is_alt+1}=[genes_split{find(map),L2.genes(i).is_alt+1} i] ;
end ;

for i=1:4,
  for j=1:2,
    idx=randperm(length(genes_split{i,j})) ;
    genes_split{i,j}=genes_split{i,j}(idx) ;
  end ;
end ;

save(sprintf('%s/confirmed_sequences_split.mat', genome_info.basedir), 'genes_split') ;
