coding_only = 0 

if equal(genome_info.annotation_fnames{1}(end-2:end),'gff')
  if ~isempty(strfind(genome_info.annotation_fnames{1},'WS1'))
    genes = read_gff_files_anno_wormbase(genome_info, 3*coding_only) ;
  else
    genes = read_gff_files_anno(genome_info) ;
  end ;
else
  genes = read_xmlparse_files(genome_info) ;
end ;

% eliminate duplicated gene descriptors
genes = merge_transcripts_by_name(genes) ;
genes = merge_transcripts_by_colocation(genes, genome_info) ;

% filter only genes with valid introns and other properties
[genes,all_genes] = check_genes(genes, genome_info, coding_only) ;

% build splicegraphs
build_splice_graph
infer_splice_graph
genes = alt_const(genes) ;
if coding_only,
  save(sprintf('%s/annotation_sequences_coding.mat', genome_info.basedir), 'genes') ;
else
  save(sprintf('%s/annotation_sequences.mat', genome_info.basedir), 'genes') ;
end ;

% generate splice graphs for all annotated sequences
valid_genes = genes ;
genes = all_genes ; 
build_splice_graph
infer_splice_graph
genes = alt_const(genes) ;
if coding_only,
  save(sprintf('%s/annotation_sequences_all_coding.mat', genome_info.basedir), 'genes') ;
else
  save(sprintf('%s/annotation_sequences_all.mat', genome_info.basedir), 'genes') ;
end ;
all_genes=genes ;
genes=valid_genes ;


% transform genes and build splice graphs again
genes = transform(genes) ;
build_splice_graph
infer_splice_graph
genes = alt_const(genes) ;

if coding_only,
  save(sprintf('%s/annotation_sequences_transform_coding.mat', genome_info.basedir), 'genes') ;
else
  save(sprintf('%s/annotation_sequences_transform.mat', genome_info.basedir), 'genes') ;
end ;

genes=all_genes ;
genes = transform(genes) ;
build_splice_graph
infer_splice_graph
genes = alt_const(genes) ;

if coding_only,
  save(sprintf('%s/annotation_sequences_transform_all_coding.mat', genome_info.basedir), 'genes') ;
else
  save(sprintf('%s/annotation_sequences_transform_all.mat', genome_info.basedir), 'genes') ;
end ;

