addpath /fml/ag-raetsch/share/software/matlab_tools/utils
addpath /fml/ag-raetsch/share/software/matlab_tools/rproc/
addpath ../../utils
addpath ../../splicegraphs
addpath ../../splicegraphs/detect_altsplice



fprintf('initializing genome\n') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS120_new/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/briggsae_new/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS147_new/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/arabidopsis_new/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/drosophila_new/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/elegans_WS147_new_cdna/genome.config') ;
%genome_info = init_genome('/fml/ag-raetsch/share/projects/splicing/musmusculus_new/genome.config') ;
fprintf('directory: %s\n', genome_info.basedir) ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% read_confirmed_sequences 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

infos={} ;
infos.genome_info=genome_info ;
infos.fname='' ;
jobinfo=rproc_empty ;

fprintf('reading gff files\n')

for i=1:length(genome_info.contig_names) 
  for j=['+', '-']
    fname=sprintf('%s/gff/myexons_%s%s.gff', genome_info.basedir, genome_info.contig_names{i}, j) ;
    save_fname=sprintf('%s/genes_para_%s%s.mat', genome_info.basedir, genome_info.contig_names{i}, j)
    if fexist(fname)
      fprintf('%s\n', fname) ;
      infos.fname=fname ;
      infos.save_fname = save_fname ;
      if j=='+'
        jobinfo(2*i-1) = rproc('read_gff_files_para', infos, 1000, {}, 120) ;
      else
        jobinfo(2*i) = rproc('read_gff_files_para', infos, 1000, {}, 120) ;
      end
    else fprintf('file does not exists') ; keyboard;  
    end
  end
end

jobinfo = rproc_wait(jobinfo) ;
rproc_cleanup(jobinfo) ;

if 0, % filter transcripts with GC introns -- we only need this for
      % the ASSIG Palma submission
  for i=1:length(genome_info.contig_names) 
    for j=['+', '-']
      save_fname=sprintf('%s/genes_para_%s%s.mat', genome_info.basedir, genome_info.contig_names{i}, j)
      load(save_fname, 'genes') ;
      genes = check_genes(genes, genome_info, 0, 1, 0) ;
      save(save_fname, 'genes') ;
    end ;
  end ;
end ;

k=0 ;
jobinfo=rproc_empty(0)
for i=1:length(genome_info.contig_names)
  for j=['+', '-']
    fname=sprintf('%s/genes_para_%s%s.mat', genome_info.basedir, genome_info.contig_names{i}, j)
    k=k+1 ;
    PAR.genes_fname = fname ;
    PAR.genome_info = genome_info ;
    jobinfo(k)=rproc('merge_transcripts_by_colocation_helper', PAR, 5000, [], 60) ;
  end 
end    
jobinfo = rproc_wait(jobinfo) ;

genes = [] ; jobinfo2=rproc_empty(0) ;
for k=1:length(jobinfo)
  k
  genes = rproc_result(jobinfo(k)) ;

  fprintf('eliminate exons of length less than 10 at the end or beginning of a transcript') ;
  genes = detect_short_exons(genes) ;
  
  fprintf('separate transcripts into separate gene descriptors\n') ;
  genes_ = genes(1) ; 
  num_transcripts=0 ; 
  for i=1:length(genes) ; 
    num_transcripts=num_transcripts+length(genes(i).exons) ;
  end ;
  genes_(num_transcripts)=genes(1) ;
  num_transcripts=0;
  for i=1:length(genes) ;
    for j=1:length(genes(i).exons) ;
      num_transcripts=num_transcripts+1 ;
      genes_(num_transcripts)=genes(i) ;
      genes_(num_transcripts).exons=genes(i).exons(j) ;
      genes_(num_transcripts).transcripts=genes(i).transcripts(j) ;
      genes_(num_transcripts).strands=genes(i).strands(j) ;
      genes_(num_transcripts).name=genes(i).transcripts{j} ;
      genes_(num_transcripts).exons_confirmed=genes(i).exons_confirmed(j) ;
      genes_(num_transcripts).terminal_info=genes(i).terminal_info(:,j) ;
    end ;
  end ;
  genes=genes_ ;

  fprintf('Remove ESTs sequences with only one exon\n');
  genes=filter_single_exons(genes) ;
  
  fname=sprintf('%s/genes_para_%i.mat', genome_info.basedir, k)
  arraysave2(fname, genes, 'genes') ;

  PAR.genes_fname = fname ;
  PAR.genome_info = genome_info ;
  jobinfo2(k)=rproc('merge_transcripts_by_colocation_helper', PAR, 5000, [], 60) ;
end    

jobinfo2 = rproc_wait(jobinfo2) ;

genes = [] ;
for k=1:length(jobinfo2)
  k
  genes_tmp = rproc_result(jobinfo2(k)) ;
  genes = [genes genes_tmp] ;
end 
fprintf('-> %d transcripts\n',length(genes));

rproc_cleanup(jobinfo) ;
rproc_cleanup(jobinfo2) ;

fprintf('filter only genes with valid introns and other properties\n') ;
genes = check_genes(genes, genome_info, 0, 0) ;

save(sprintf('%s/confirmed_sequences_transcripts.mat', genome_info.basedir), 'genes') ;


step_size=ceil(length(genes)/100)
k=0 ; PAR=[] ;
jobinfo=rproc_empty(0) ;
for i=1:step_size:length(genes)
  idx = i:min(i+step_size-1,length(genes)) ;
  k=k+1 ;
  PAR.genes = genes(idx) ;
  PAR.genome_info = genome_info ;
  jobinfo(k) = rproc('read_confirmed_sequences_para_helper', PAR, 3500, [], 60) ;
end ;
jobinfo = rproc_wait(jobinfo) ;


%extra_genes = [] ; k=0 ;
%for i=1:step_size:length(genes)
%  idx = i:min(i+step_size-1,length(genes)) ;
%  k=k+1 ;
%  if ~rproc_finished(jobinfo(k)), 
%    k
%    extra_genes = [extra_genes genes(idx)] ;
%  end
%end ;
%genes2=genes ;
%genes=extra_genes ;
%jobinfo2=jobinfo ;


genes = [] ; genes_transform = [] ;
for k=1:length(jobinfo)
  k
  if rproc_finished(jobinfo(k)),
    [ret1,ret2] = rproc_result(jobinfo(k)) ;
    genes = [genes ret1] ;
    genes_transform = [genes_transform ret2] ;
  else
    disp('not finished')
  end ;
end 
fprintf('-> %d transcripts\n',length(genes));
fprintf('-> %d transcripts\n',length(genes_transform));

%genes = find_paralogs(genes) ;
arraysave2(sprintf('%s/confirmed_sequences.mat', genome_info.basedir), genes, 'genes') ;
arraysave2(sprintf('%s/confirmed_sequences_transform.mat', genome_info.basedir), genes_transform, 'genes') ;

rproc_cleanup(jobinfo) ;
