function [genes, genes_transform] = read_confirmed_sequences_para_helper(PAR)
% [genes, genes_transform] = read_confirmed_sequences_para_helper(genes)

genes = PAR.genes ;

% initialize genome_info for load_genomic
global g_genome_info genome_strings;

genome_strings = [];
g_genome_info = PAR.genome_info 


addpath ../../utils
addpath ../../splicegraphs
addpath ../../splicegraphs/detect_altsplice

fprintf('build splice graph\n') ;
build_splice_graph;

fprintf('infer splice graph\n') ;
infer_splice_graph;

fprintf('Sorting exons...\n') ;
for ix=1:length(genes)
  [dummy,exon_order] = sort(genes(ix).splicegraph{1}(1,:),2,'ascend');
  genes(ix).splicegraph{1} = genes(ix).splicegraph{1}(:,exon_order);
  genes(ix).splicegraph{2} = genes(ix).splicegraph{2}(exon_order,exon_order);
end

fprintf('detect alternatively spliced genes\n') ;
genes = alt_const(genes) ;

genes_ = genes ;

% transform genes and build splice graphs again
fprintf('transforming to local coordinates\n') ;
genes = transform(genes) ;

fprintf('build splice graph\n') ;
build_splice_graph
fprintf('infer splice graph\n') ;
infer_splice_graph

fprintf('Sorting exons...\n') ;
for ix=1:length(genes)
  [dummy,exon_order] = sort(genes(ix).splicegraph{1}(1,:),2,'ascend');
  genes(ix).splicegraph{1} = genes(ix).splicegraph{1}(:,exon_order);
  genes(ix).splicegraph{2} = genes(ix).splicegraph{2}(exon_order,exon_order);
end

fprintf('detect alternatively spliced genes\n') ;
genes = alt_const(genes) ;

% order things
genes_transform = genes ;
genes = genes_ ;