addpath /fml/ag-raetsch/share/software/matlab_tools/utils
addpath ../../utils

fprintf('directory: %s\n', genome_info.basedir) ;


fprintf('reading est matches files\n')
fnames={} ;
for i=1:length(genome_info.contig_names) 
fname=sprintf('%s/gff/mymatches_%s+.gff', genome_info.basedir, ...
                genome_info.contig_names{i}) ;
  if fexist(fname), fnames{end+1}=fname ; end ;
  fname=sprintf('%s/gff/mymatches_%s-.gff', genome_info.basedir, ...
                genome_info.contig_names{i}) ;
  if fexist(fname), fnames{end+1}=fname ; end ;
end ;

genes=[] ;
for i=1:length(fnames)
  genes_ = read_gff_files(fnames(i), genome_info);
  genes_ = merge_transcripts_by_colocation(genes_, genome_info) ;
  if isempty(genes),
    genes = genes_ ;
  else
    genes(end+1:end+length(genes_)) = genes_ ;
  end ;
end ;
fprintf('-> %d transcripts\n',length(genes));

genes = merge_transcripts_by_colocation(genes, genome_info) ;

save(sprintf('%s/est_matches.mat', genome_info.basedir), 'genes') ;
