addpath /fml/ag-raetsch/share/software/matlab_tools/utils
addpath ../../utils

fprintf('directory: %s\n', genome_info.basedir) ;

infos={} ;
infos.genome_info=genome_info ;
infos.fname='' ;
jobinfo=rproc_empty ;

for i=1:length(genome_info.contig_names) 
  for j=['+', '-']
    fname=sprintf('%s/gff/mymatches_%s%c.gff', genome_info.basedir, genome_info.contig_names{i}, j) ;
    save_fname=sprintf('%s/genes_para_%s%s.mat', genome_info.basedir, genome_info.contig_names{i}, j);
    if fexist(fname)
      fprintf('%s\n', fname) ;
      infos.fname=fname ;
      infos.save_fname = save_fname ;
      if j=='+'
        jobinfo(2*i-1) = rproc('read_gff_files_para', infos, 3000, {}, 120) ;
      else
        jobinfo(2*i) = rproc('read_gff_files_para', infos, 3000, {}, 120) ;
      end
    else fprintf('file does not exists') ; keyboard;  
    end
  end
end
jobinfo = rproc_wait(jobinfo) ;
rproc_cleanup(jobinfo) ;

k=0 ;
jobinfo=rproc_empty(0)
for i=1:length(genome_info.contig_names)
  for j=['+', '-']
    fname=sprintf('%s/genes_para_%s%s.mat', genome_info.basedir, genome_info.contig_names{i}, j)
    k=k+1 ;
    PAR.genes_fname = fname ;
    PAR.genome_info = genome_info ;
    jobinfo(k)=rproc('merge_transcripts_by_colocation_helper', PAR, 5000, [], 60) ;
  end 
end    
jobinfo = rproc_wait(jobinfo) ;
keyboard

% collect results
genes = [] ;
for k=1:length(jobinfo)
  k
  genes_tmp = rproc_result(jobinfo(k)) ;
  arraysave2(sprintf('%s/est_matches_%s%c.mat', genome_info.basedir, ...
                     genes_tmp(1).chr, genes_tmp(1).strands(1)), genes_tmp, 'genes') ;
  genes = [genes genes_tmp] ;
end 
fprintf('-> %d transcripts\n',length(genes));

rproc_cleanup(jobinfo) ;

arraysave2(sprintf('%s/est_matches.mat', genome_info.basedir), genes, 'genes') ;
