function genes=read_gff_files(fnames, genome_info)
% genes=read_gff_files(genome_info)
  
include_ests = 1 ;
genes = [] ;
all_genes = [] ;

for dd=1:length(fnames)
  fname = fnames{dd} ;
  disp(fname)
  fd=fopen(fname, 'r') ;
  old_gene_name = '';
  while ~feof(fd),
    line=fgetl(fd) ;
    %disp(line)
    if ~ischar(line), break; end ;
    if length(line)>10000, keyboard; end ;

    elems=separate(line) ;

    if ~isequal(elems{3},'exon') & ~isequal(elems{3}, 'EST'), continue ; end ;
    if isequal(elems{3}, 'EST'),
      % special treatment of the est matches file ...
      gi = elems{7} ;
      elems_=elems ;
      elems = elems_([1:6]) ;
      elems{9}=elems_{7} ;
      elems{7}=elems_{8} ;
      elems{8}='0' ;
      elems{10}='0' ;
      elems{12}=elems_{9} ;
      elems{13}=elems_{10} ;
    else
      gi = elems{9} ;
    end ;
    if ~equal(gi(1:3),'GR-') & ~include_ests, continue ; end ;
    assert(elems{6}=='+' | elems{6}=='-') ;
    if ~equal(old_gene_name,gi)
      genes(end+1).name = gi ;
      genes(end).transcripts= {} ;
      genes(end).transcripts{1}= gi ;
      genes(end).exons = {} ;
      genes(end).exons_confirmed = {} ;
      genes(end).strands = char(elems{6}) ;
      genes(end).chr=elems{1} ;
      genes(end).terminal_info = [] ;
      assert(~isempty(genes(end).chr)) ;
      gi_idx = length(genes) ;
    end ;
    
    idx = str2num(elems{10});
    if (idx==0)
      genes(gi_idx).exons{end+1}=[];
      genes(gi_idx).exons_confirmed{end+1}=[];
      genes(gi_idx).transcripts{length(genes(gi_idx).exons)}=gi ;
      genes(gi_idx).strands(length(genes(gi_idx).exons))=char(elems{6}) ;
      genes(gi_idx).terminal_info(:,length(genes(gi_idx).exons))= ...
          [str2num(elems{12});str2num(elems{13})] ;
      assert(str2num(elems{12})>=-1) ;
      assert(str2num(elems{13})>=-1) ;
    end
    
    idx = length(genes(gi_idx).transcripts);
    genes(gi_idx).exons{idx}(end+1,:)=[str2num(elems{4}), str2num(elems{5})];
    assert(str2num(elems{7})>0) ;
    assert(str2num(elems{8})>=0) ;
    genes(gi_idx).exons_confirmed{idx}(end+1,:)=[str2num(elems{7}), str2num(elems{8})];

    old_gene_name = gi;
    if (mod(length(genes),1000)==0) fprintf(1,'%i\r',length(genes)+length(all_genes)); end;
    if length(genes)>=25000,
      if isempty(all_genes),
        all_genes=genes ;
      else
        all_genes(end+1:end+length(genes)-1) = genes(1:end-1) ;
      end ;
      genes(1:end-1) = [] ;
      gi_idx = 1 ;
      %size(all_genes)
    end ;
  end ;
  fclose(fd) ;
end;

if isempty(all_genes),
  all_genes=genes ;
else
  all_genes(end+1:end+length(genes)) = genes ;
end ;
genes = all_genes ;

disp(length(genes));
  