function genes=read_gff_files_anno(genome_info)
% genes=read_gff_files(genome_info)
  
genes = [] ;

for fi=1:length(genome_info.annotation_fnames)
  fname=genome_info.annotation_fnames{fi} ;
  disp(fname)
  tmpfname=tempname ;
  if equal(genome_info.contig_names{1},'2L')
      unix(sprintf('LC_ALL="C" grep exon %s > %s', fname, tmpfname)) ; % drosophila
  elseif ~isempty(strfind(genome_info.annotation_fnames{1},'wu_merged')) ...
        || ~isempty(strfind(genome_info.annotation_fnames{1},'briggsae'))
      unix(sprintf('LC_ALL="C" grep coding %s| grep exon> %s', fname, tmpfname)) ;
  else
      unix(sprintf('LC_ALL="C" grep curated %s| grep exon | grep -v MtDNA > %s', fname, tmpfname)) ;%wormbase
  end
  fd=fopen(tmpfname, 'r+') ;
  while ~feof(fd),
    line=fgetl(fd) ; 
    if ~ischar(line),  break; end ;
    if length(line)>10000, keyboard; end ;

    elems=separate(line) ;
    if ~isequal(elems{2},'curated') && ~isequal(elems{2},'WU_MERGED') && ~isequal(elems{2},'hybrid')
      if ~isequal(genome_info.contig_names{1},'2L'), continue ; end ; % drosophila:
    end
    if ~isequal(elems{3}, 'exon') & ~isequal(elems{3}, 'coding_exon'), continue ; end ;
    %if ~isequal(elems{3}, 'coding_exon'), continue ; end ;
    if ~any(ismember(genome_info.contig_names, elems{1})), fprintf('not found: %s\n',elems{1});continue ; end ;

    if equal(elems{9}(1:5),'CDS "') % Wormbase & WU_MERGED
      ii=find(elems{9}=='"') ; 
      gi = elems{9}(ii(1)+1:ii(2)-1) ; 
      ti = elems{9}(ii(1)+1:ii(2)-1) ;
      if gi(end)>='a' & gi(end)<='z', 
        %keyboard
        gi(end)=[] ;
      end ;
    elseif equal(elems{9}(1:8),'Sequence') % ???
      gi = elems{9}(11:end-1) ; 
      ti = elems{9}(11:end-1) ;
    elseif equal(elems{9}(1:3),'ID=') % drosophila
      idx=find(elems{9}==';') ;
      idx2=find(elems{9}(1:idx(1)-1)==':') ;
      assert(length(idx2)==1) ;
      gi = elems{9}(4:idx2-1) ;
      ti = gi ;
    else 
      error(sprintf('do not understand "%s"', elems{9})) ;
    end ;
    if length(genes)>0 & equal(gi,genes(end).name),
      gi_idx = length(genes) ;
    else
      gi_idx=[] ;
    end ;
    %line
    if isempty(gi_idx)
      genes(end+1).name = gi ;
      genes(end).transcripts={} ;
      genes(end).terminal_info=[] ;
      genes(end).exons = {} ;
      genes(end).exons_confirmed = {} ;
      genes(end).strands = '' ;
      genes(end).chr=elems{1} ;
      assert(~isempty(genes(end).chr)) ;
      gi_idx = length(genes) ;
    end ;

    idx = find(ismember(genes(gi_idx).transcripts,ti)) ;
    if isempty(idx),
      genes(gi_idx).transcripts{end+1}=ti; 
      genes(gi_idx).exons{end+1}=[] ;
      genes(gi_idx).exons_confirmed{end+1}=[] ;
      genes(gi_idx).strands(end+1)=char(elems{7}) ;
      genes(gi_idx).terminal_info(:,end+1)=[0;0] ;
      idx = length(genes(gi_idx).transcripts) ;
    end ;
    genes(gi_idx).exons{idx}(end+1,:)=[str2num(elems{4}), ...
		    str2num(elems{5})];
    genes(gi_idx).exons_confirmed{idx}(end+1,:)=[0 0];
    
    if (mod(length(genes),10)==0) fprintf(1,'%i\r',length(genes)); end;
    
  end ;
  fclose(fd) ;
  unix(sprintf('rm %s', tmpfname)) ;
  disp(length(genes));
end;
