function genes=read_gff_files_anno_wormbase(genome_info, types)
% genes=read_gff_files(genome_info)
  
genes = [] ;
cds=[] ;
query='Coding_transcript' ;

for fi=1:length(genome_info.annotation_fnames)
  fname=genome_info.annotation_fnames{fi} ;
  disp(fname)
  tmpfname=tempname ;
  unix(sprintf('LC_ALL="C" grep %s %s | grep -v MtDNA | sort -k 9 > %s', query, fname, tmpfname)) ;

  fd=fopen(tmpfname, 'r+') ;
  while ~feof(fd),
    line=fgetl(fd) ; 
    if ~ischar(line),  break; end ;
    if length(line)>10000, keyboard; end ;
    
    elems=separate(line) ;
    switch lower(elems{3}),
     case 'coding_exon'
      type=3 ;
     case 'five_prime_utr'
      type=2 ;
     case 'three_prime_utr'
      type=4 ;
     case 'exon'
      type=0 ;
     case 'intron'
      type=-1 ;
     otherwise
      continue ;
    end ;
    if ~any(type==types), continue ; end ;
    if ~any(ismember(genome_info.contig_names, elems{1})), 
      fprintf('not found: %s\n',elems{1});
      continue ; 
    end ;

    if equal(elems{9}(1:12),'Transcript "') 
      ii=find(elems{9}=='"') ; 
      gi = elems{9}(ii(1)+1:ii(2)-1) ; 
      ti = elems{9}(ii(1)+1:ii(2)-1) ;
      if gi(end)>='a' & gi(end)<='z', 
        gi(end)=[] ;
      end ;
    else 
      error(sprintf('do not understand "%s"', elems{9})) ;
    end ;
    if length(genes)>0 & equal(gi,genes(end).name),
      gi_idx = length(genes) ;
    else
      gi_idx=[] ;
    end ;
    if isempty(gi_idx)
      genes(end+1).name = gi ;
      genes(end).transcripts={} ;
      genes(end).terminal_info=[] ;
      genes(end).exons = {} ;
      genes(end).exons_confirmed = {} ;
      genes(end).strands = '' ;
      genes(end).chr=elems{1} ;
      assert(~isempty(genes(end).chr)) ;
      gi_idx = length(genes) ;
    end ;

    idx = find(ismember(genes(gi_idx).transcripts,ti)) ;
    if isempty(idx),
      genes(gi_idx).transcripts{end+1}=ti; 
      genes(gi_idx).exons{end+1}=[] ;
      genes(gi_idx).exons_confirmed{end+1}=[] ;
      genes(gi_idx).strands(end+1)=char(elems{7}) ;
      genes(gi_idx).terminal_info(:,end+1)=[0;0] ;
      idx = length(genes(gi_idx).transcripts) ;
    end ;
    genes(gi_idx).exons{idx}(end+1,:)=[str2num(elems{4}), str2num(elems{5}), type];
    genes(gi_idx).exons_confirmed{idx}(end+1,:)=[0 0];
    
    if (mod(length(genes),10)==0) fprintf(1,'%i\r',length(genes)); end;
    
  end ;
  fclose(fd) ;
  unix(sprintf('rm %s', tmpfname)) ;
  disp(length(genes));
end;
