function genes_transform=transform(genes, save_genestr_flag) ;
% genes_transform=tranform(genes) ;
  
if nargin<2,
  save_genestr_flag=1; 
end ;
    
genes(1).tis_pos=[] ;
genes(1).stop_pos=[] ;
genes(1).original_exons=[] ;
genes(1).genestr = [] ;
genes(1).original_splicegraph=[] ;
genes(1).original_strands=[] ;
genes_transform=genes ;
num_cDNA_genes = 0 ; num_bad = 0 ; num_no_consensus = 0 ;
for gene_id=1:length(genes)
  gene = genes(gene_id) ;
  assert(gene.has_cDNA==any(gene.is_cDNA)) ;
  if gene.has_cDNA, 
    num_cDNA_genes = num_cDNA_genes + 1 ;
  end ;
  if mod(gene_id,1000)==0
    [gene_id num_cDNA_genes]
  end 
  [tmp,idx] = sort(-gene.is_cDNA) ;
  gene.is_cDNA=gene.is_cDNA(idx) ;
  gene.transcript_valid=gene.transcript_valid(idx) ;
  gene.exons=gene.exons(idx) ;
  gene.exons_confirmed=gene.exons_confirmed(idx) ;
  gene.transcripts=gene.transcripts(idx) ;
  gene.terminal_info=gene.terminal_info(:,idx) ;
  
  starts = [] ;
  ends = [] ;
  for i=1:length(gene.exons),
    assert(all(size(gene.exons{i})==size(gene.exons_confirmed{i}))) ;
    starts(end+1)= gene.exons{i}(1,1) ;
    ends(end+1)  = gene.exons{i}(end,2) ;
  end ;
  gene.strands = char(gene.strands) ;
  genestr = to_upper_case(load_mrna(gene.chr, gene.strands(1), min(starts) - 2000, ...
                                         max(ends)+2000)) ;
  stop_it=0;
  gene.original_exons = gene.exons ;
  gene.original_splicegraph = gene.splicegraph ;
  gene.original_strands = gene.strands ;
  if equal(gene.strands(1),'+')
    gene.splicegraph{1}      = gene.splicegraph{1} - min(starts) + 2000 +1 ;
    %gene.splicegraph{1}(2,:) = gene.splicegraph{1}(2,:) + 1 ;
  else
    gene.splicegraph{1}      = max(ends) + 2000 - gene.splicegraph{1} + 1 ;
    gene.splicegraph{1}      = [gene.splicegraph{1}(2,end:-1:1); gene.splicegraph{1}(1,end:-1:1)] ;
    %gene.splicegraph{1}(2,:) = gene.splicegraph{1}(2,:) + 1 ;
    gene.splicegraph{2} = gene.splicegraph{2}(end:-1:1,end:-1:1) ;
  end ;
  for i=1:length(gene.exons),
    if gene.strands(i)=='+'
      if gene.is_cDNA(i),
        gene.tis_pos(end+1)       = gene.exons{i}(1,1) - min(starts) + 2000 +1 ;
        gene.stop_pos(end+1)       = gene.exons{i}(end,2) - min(starts) + 2000 +1 ;
      end ;
      gene.exons{i}      = gene.exons{i} - min(starts) + 2000 +1 ;
      %gene.exons{i}(:,2) = gene.exons{i}(:,2) + 1 ;
    else
      if gene.is_cDNA(i),
        gene.tis_pos(end+1)       = max(ends) + 2000 - gene.exons{i}(end,2) + 1 ;
        gene.stop_pos(end+1)      = max(ends) + 2000 - gene.exons{i}(1,1) + 1 ;
      end ;
      gene.exons{i}      = max(ends) + 2000 - gene.exons{i} + 1 ;
      gene.exons{i}      = [gene.exons{i}(end:-1:1,2) gene.exons{i}(end:-1:1,1)] ;
      assert(gene.exons_confirmed{i}(end)==0) ;
      gene.exons_confirmed{i} = [gene.exons_confirmed{i}(end:-1:1,1) ...
                          [gene.exons_confirmed{i}(end-1:-1:1,2);0]] ;
      %gene.exons{i}(:,2) = gene.exons{i}(:,2) + 1 ;
      gene.strands(i) = '+' ;
    end ;
    if ~all(genestr(gene.exons{i}(2:end,1)-2)=='A') | ~all(genestr(gene.exons{i}(2:end,1)-1)=='G') | ...
          ~all(genestr(gene.exons{i}(1:end-1,2)+1)=='G') | ...
          ~all(genestr(gene.exons{i}(1:end-1,2)+2)=='T' | genestr(gene.exons{i}(1:end-1,2)+2)=='C') 
      warning('no consensus') ;
      stop_it = 1;
      %keyboard
      %break ;
    end ;

    idx = find(~(genestr(gene.tis_pos)=='A' & genestr(gene.tis_pos+1)=='T' & ...
               genestr(gene.tis_pos+2)=='G')) ;
    gene.tis_pos(idx) = [] ;
    gene.tis_pos=unique(gene.tis_pos) ;

    idx = find(~((genestr(gene.stop_pos-2)=='T' & genestr(gene.stop_pos-1)=='A' & ...
               genestr(gene.stop_pos)=='A') | ...
               (genestr(gene.stop_pos-2)=='T' & genestr(gene.stop_pos-1)=='G' & ...
               genestr(gene.stop_pos)=='A') | ...
               (genestr(gene.stop_pos-2)=='T' & genestr(gene.stop_pos-1)=='A' & ...
               genestr(gene.stop_pos)=='G'))) ;
    gene.stop_pos(idx) = [] ;
    gene.stop_pos=unique(gene.stop_pos) ;
  end ;
  if length(gene.tis_pos)>1 & ~gene.is_alt, gene.is_valid=0; end ;
  if length(gene.stop_pos)>1 & ~gene.is_alt, gene.is_valid=0; end ;
  
  if stop_it, 
    num_no_consensus=num_no_consensus+1 
    gene.is_valid = 0 ;
    gene_id
  end ;
  if save_genestr_flag
    gene.genestr = genestr ;
  end ;
  genes_transform(gene_id)=gene ;
end ;

disp('Sorting exons...');
for ix=length(genes_transform) ;
  [dummy,exon_order] = sort(genes_transform(ix).splicegraph{1}(1,:));
  genes_transform(ix).splicegraph{1} = genes_transform(ix).splicegraph{1}(:,exon_order);
  genes_transform(ix).splicegraph{2} = genes_transform(ix).splicegraph{2}(exon_order,exon_order);
end