#!/bin/tcsh

if ( -d ~/svn/projects/splicing/gff/bin )  set path=( ~/svn/projects/splicing/gff/bin $path)
if ( -d ~/svn/projects/splicing/gff/scripts )  set path=( ~/svn/projects/splicing/gff/scripts $path)

if ( -d ~/projects/splicing/gff/bin )  set path=( ~/projects/splicing/gff/bin $path)
if ( -d ~/projects/splicing/gff/scripts )  set path=( ~/projects/splicing/gff/scripts $path)

setenv BASEDIR    `list_files basedir $1`
setenv CDNADIR    "$BASEDIR/cDNA"
setenv GENOMEDIR  "$BASEDIR/genome"

rm -f $CDNADIR/all_cDNAs.fa; 
touch $CDNADIR/all_cDNAs.fa
foreach i (`list_files cdnafiles $1`)
  echo $i
  cat $i >> $CDNADIR/all_cDNAs.fa
end ;

echo $CDNADIR/all_cDNAs.fa  > /tmp/all_cDNAs.fa

blat $GENOMEDIR/contig_list /tmp/all_cDNAs.fa $CDNADIR/all_cDNAs.psl -dots=100 -noHead -trimHardA -ooc=$GENOMEDIR/11.ooc

rm /tmp/all_cDNAs.fa


sort -k 10 $CDNADIR/all_cDNAs.psl > $CDNADIR/all_cDNAs_prefiltered.psl

filterbesthit $CDNADIR/all_cDNAs_prefiltered.psl $1 > $CDNADIR/all_cDNAs_filtered.psl
mv $CDNADIR/all_cDNAs_filtered.psl $CDNADIR/all_cDNAs.psl
