#!/bin/tcsh 
#
#$ -cwd
#$ -j y
####$ -N arabidopsis
#$ -l arch=lx26-amd64
####$ -l h_vmem=8G
####$ -R y


#if ( -d ~/svn/projects/splicing/gff/bin )  set path=( ~/svn/projects/splicing/gff/bin $path)
#if ( -d ~/svn/projects/splicing/gff/scripts )  set path=( ~/svn/projects/splicing/gff/scripts $path)


# make sure that the programs are compiled by executing gff/src/make.sh on a 64 bit machine

# check that JOBNAME is the same as -N above.
setenv JOBNAME    "$2"
setenv ORIGPATH   `pwd`

if ( -d $ORIGPATH/gff/bin )  set path=( $ORIGPATH/gff/bin $path)
if ( -d $ORIGPATH/gff/scripts )  set path=( $ORIGPATH/gff/scripts $path)
set path=( /fml/ag-raetsch/share/software/blat $path)  # for blat


setenv BASEDIR    `list_files basedir $1`
setenv LOGNAME    "$BASEDIR/log1.txt"
setenv GENOMEDIR  "$BASEDIR/genome"
setenv CDNADIR    "$BASEDIR/cDNA"
setenv DBESTDIR   "$BASEDIR/dbEST"
setenv GFFDIR     "$BASEDIR/gff"
setenv STATDIR    "$BASEDIR/statistics"
setenv TRAINDIR   "$BASEDIR/training"

#env

cd $BASEDIR
pwd

whoami >> $LOGNAME
date >> $LOGNAME
echo "compute_gff_s.sh" >> $LOGNAME
setenv JOBNUM     `qstat -u $USER | grep $JOBNAME | cut -d ' ' -f 1`
setenv IDENT      `echo $JOBNAME | cut -b 1`
setenv DATNAME    "$JOBNAME.o$JOBNUM" 

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
echo processing the genome files
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mkdir -p -m 775 $GENOMEDIR
genome_script.sh $1

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
echo processing the cDNAs
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mkdir -p -m 775 $CDNADIR
cDNA_script.sh $1

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
echo processing the ESTs
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mkdir -p -m 775 $DBESTDIR
dbEST_script.sh $1
#dbEST_script_cluster.sh $1 $IDENT

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
echo generating GFF files
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mkdir -p -m 775 $GFFDIR
gff_script.sh $1
#gff_script_cluster.sh $1 $IDENT

cd $ORIGPATH
pwd

#echo
#echo processing
#echo matlab -nojvm -nodisplay -r "process('$1','$ORIGPATH'); exit"
#matlab -nojvm -nodisplay -r "process('$1','$ORIGPATH'); exit"

#echo
#echo statistics
#mkdir -p -m 775 $STATDIR
#echo matlab -nojvm -nodisplay -r "statistics('$1','$ORIGPATH','$STATDIR'); exit"
#matlab -nojvm -nodisplay -r "statistics('$1','$ORIGPATH','$STATDIR'); exit"

cat $DATNAME >> $LOGNAME

#echo
#echo training
#mkdir -p -m 775 $TRAINDIR
#foreach i ('alt_5prime' 'alt_3prime')
#    echo $i
#    qsub training.sh $1 $ORIGPATH $TRAINDIR $i
#end


#while (`nqstat | grep training |wc -l`)
#  echo `nqstat | grep training |wc -l` jobs left
#  sleep 10
#end ;
