#!/bin/tcsh


if ( -d ~/svn/projects/splicing/gff/bin )  set path=( ~/svn/projects/splicing/gff/bin $path)
if ( -d ~/svn/projects/splicing/gff/scripts )  set path=( ~/svn/projects/splicing/gff/scripts $path)

if ( -d ~/projects/splicing/gff/bin )  set path=( ~/projects/splicing/gff/bin $path)
if ( -d ~/projects/splicing/gff/scripts )  set path=( ~/projects/splicing/gff/scripts $path)

setenv BASEDIR    `list_files basedir $1`
setenv DBESTDIR   "$BASEDIR/dbEST"
setenv GENOMEDIR  "$BASEDIR/genome"

# reverse EST files
echo reverse EST files
rm -f $DBESTDIR/all_ESTs.fa
touch $DBESTDIR/all_ESTs.fa
foreach i (`list_files estfiles $1`)
  echo $i
  cat $i >> $DBESTDIR/all_ESTs.fa
  cat $i | reverse_complement_fasta >> $DBESTDIR/all_ESTs.fa 
end ;

# make ESTs unique
echo make ESTs unique
unique_fasta $DBESTDIR/all_ESTs.fa > $DBESTDIR/all_ESTs_unique.fa 

# align ESTs
echo align ESTs
@ j = 0
foreach i (`list_contigs fasta $1`)
  @ j++
  echo "/fml/ag-raetsch/home/ong/bin/blat_64 $i $DBESTDIR/all_ESTs_unique.fa $DBESTDIR/tmp_$j.psl -dots=100 -noHead -ooc=$GENOMEDIR/11.ooc>& $DBESTDIR/tmp_$j.out"| qsub -cwd -l h_vmem=6G -N "blat_$2$j"
end ;

while (`qstat -u $USER | grep "blat_$2" | wc -l`)
  echo `qstat -u $USER | grep "blat_$2" | wc -l` jobs left
  sleep 600
end ;

cat $DBESTDIR/tmp_*.psl >  $DBESTDIR/all_ESTs_unique.psl
rm $BASEDIR/blat_*.[eo][0-9]*

sort -k 10 $DBESTDIR/all_ESTs_unique.psl > $DBESTDIR/all_ESTs_unique_prefiltered.psl

filterbesthit $DBESTDIR/all_ESTs_unique_prefiltered.psl $1 > $DBESTDIR/all_ESTs_unique_filtered.psl
mv $DBESTDIR/all_ESTs_unique_filtered.psl $DBESTDIR/all_ESTs_unique.psl
