#!/bin/tcsh

echo Warning: this script does not properly work when using the best alignments!

if ( -d ~/svn/projects/splicing/gff/bin )  set path=( ~/svn/projects/splicing/gff/bin $path)
if ( -d ~/svn/projects/splicing/gff/scripts )  set path=( ~/svn/projects/splicing/gff/scripts $path)

if ( -d ~/projects/splicing/gff/bin )  set path=( ~/projects/splicing/gff/bin $path)
if ( -d ~/projects/splicing/gff/scripts )  set path=( ~/projects/splicing/gff/scripts $path)

setenv BASEDIR    `list_files basedir $1`
setenv CDNADIR    "$BASEDIR/cDNA"
setenv DBESTDIR   "$BASEDIR/dbEST"
setenv GFFDIR     "$BASEDIR/gff"

# cDNAs ############################################################################### 

list_contigs name $1 > $GFFDIR/cdna_hit_contigs
list_contigs name $1 > $GFFDIR/est_hit_contigs

echo generate cDNA derived sequences
foreach i (`cat $GFFDIR/cdna_hit_contigs`)
  echo " "
  echo $i ;
  psl2gff CDNA $CDNADIR/all_cDNAs.psl $i + $GFFDIR/{$i}+.gff $GFFDIR/$i+_microexon.asc $1 > $GFFDIR/{$i}+.out 
  echo " "
  psl2gff CDNA $CDNADIR/all_cDNAs.psl $i - $GFFDIR/{$i}-.gff $GFFDIR/$i-_microexon.asc $1 > $GFFDIR/{$i}-.out 
end 

rm -f $GFFDIR/all_cdna.gff $GFFDIR/all.out
touch $GFFDIR/all_cdna.gff $GFFDIR/all.out
foreach i (`cat $GFFDIR/cdna_hit_contigs`)
  echo $i ;
  cat $GFFDIR/{$i}+.gff >> $GFFDIR/all_cdna.gff
  cat $GFFDIR/{$i}+.gff | grep intron > $GFFDIR/myintrons_{$i}+.gff
  cat $GFFDIR/{$i}+.gff | grep exon > $GFFDIR/myexons_{$i}+.gff
  cat $GFFDIR/{$i}-.gff >> $GFFDIR/all_cdna.gff
  cat $GFFDIR/{$i}-.gff | grep intron > $GFFDIR/myintrons_{$i}-.gff 
  cat $GFFDIR/{$i}-.gff | grep exon > $GFFDIR/myexons_{$i}-.gff
  cat $GFFDIR/{$i}+.out >> $GFFDIR/all.out 
  cat $GFFDIR/{$i}-.out >> $GFFDIR/all.out 
end 

echo number of cDNA intron errors 
grep "### intron" $GFFDIR/all.out | wc -l 

echo number of cDNA derived sequences 
grep -e 0$ $GFFDIR/all_cdna.gff| cut -f 9 | sort | uniq | sed "s/GR-//g" | wc -l

# ESTS ###############################################################################
echo generate EST derived sequences 
@ j = 0
foreach i (`list_contigs name`)
  @ j++
  echo $i $j;
  echo "`which psl2gff` EST $DBESTDIR/tmp_$j.psl $i + $GFFDIR/$i+_est.gff $GFFDIR/$i+_microexon_est.asc $1 > $GFFDIR/$i+_est.out" | qsub -cwd -l arch=lx26-amd64 -N "e2g_$2$j+"  -l h_vmem=3G
  echo "`which psl2gff` EST $DBESTDIR/tmp_$j.psl $i - $GFFDIR/$i-_est.gff $GFFDIR/$i-_microexon_est.asc $1 > $GFFDIR/$i-_est.out" | qsub -cwd -l arch=lx26-amd64 -N "e2g_$2$j-"  -l h_vmem=3G
end

while (`qstat -u $USER | grep "e2g_$2" |wc -l`)
  echo `qstat -u $USER | grep "e2g_$2" |wc -l` jobs left
  sleep 60
end ;

rm $BASEDIR/e2g_*.[eo][0-9]*


wait

rm -f $GFFDIR/all.out $GFFDIR/all_est.gff 
foreach i (`list_contigs name`)
  echo $i ;
  cat $GFFDIR/{$i}+_est.gff | grep intron >> $GFFDIR/myintrons_{$i}+.gff
  cat $GFFDIR/{$i}-_est.gff | grep intron >> $GFFDIR/myintrons_{$i}-.gff
  cat $GFFDIR/{$i}+_est.gff | grep exon >> $GFFDIR/myexons_{$i}+.gff
  cat $GFFDIR/{$i}-_est.gff | grep exon >> $GFFDIR/myexons_{$i}-.gff
  cat $GFFDIR/{$i}+_est.gff | grep matching > $GFFDIR/mymatches_{$i}+.gff
  cat $GFFDIR/{$i}-_est.gff | grep matching > $GFFDIR/mymatches_{$i}-.gff
  cat $GFFDIR/$i+_est.out $GFFDIR/$i-_est.out >> $GFFDIR/all.out 
  cat $GFFDIR/{$i}+_est.gff $GFFDIR/{$i}-_est.gff >> $GFFDIR/all_est.gff
end 

echo number of potential AT-AC introns
grep "### intron" $GFFDIR/all.out | egrep 'at[acgt][acgt]..[acgt][acgt]ac' | wc -l 

echo number of EST intron errors 
grep "### intron" $GFFDIR/all.out | egrep -v 'ct[acgt][acgt]..[acgt][acgt]ac' | wc -l 

echo number of EST derived sequences
cat $GFFDIR/all_est.gff | cut -f 9 | sort | uniq | sed "s/EST-//g" | wc -l

