#!/bin/tcsh 

if ( -d ~/svn/projects/splicing/gff/bin )  set path=( ~/svn/projects/splicing/gff/bin $path)
if ( -d ~/svn/projects/splicing/gff/scripts )  set path=( ~/svn/projects/splicing/gff/scripts $path)

if ( -d ~/projects/splicing/gff/bin )  set path=( ~/projects/splicing/gff/bin $path)
if ( -d ~/projects/splicing/gff/scripts )  set path=( ~/projects/splicing/gff/scripts $path)

setenv ORIGPATH   `pwd`
setenv BASEDIR    `list_files basedir $1`
setenv GENOMEDIR  "{$BASEDIR}/genome"
setenv CDNADIR    "{$BASEDIR}/cDNA"
setenv DBESTDIR   "{$BASEDIR}/dbEST"
setenv GFFDIR     "{$BASEDIR}/gff"

cd $BASEDIR

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
echo processing the genome files
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mkdir -p $GENOMEDIR
genome_script.sh $*

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
echo processing the cDNAs
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mkdir -p $CDNADIR
cDNA_script.sh $*

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
echo processing the ESTs
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mkdir -p $DBESTDIR
dbEST_script_cluster.sh $*

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
echo generating GFF files
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mkdir -p $GFFDIR
gff_script_cluster.sh $*

cd $ORIGPATH
