#!/bin/tcsh

if ( -d ~/svn/projects/splicing/gff/bin )  set path=( ~/svn/projects/splicing/gff/bin $path)
if ( -d ~/svn/projects/splicing/gff/scripts )  set path=( ~/svn/projects/splicing/gff/scripts $path)

if ( -d ~/projects/splicing/gff/bin )  set path=( ~/projects/splicing/gff/bin $path)
if ( -d ~/projects/splicing/gff/scripts )  set path=( ~/projects/splicing/gff/scripts $path)

setenv BASEDIR    `list_files basedir $1`
setenv PROTDIR   "$BASEDIR/protein_sequences"
setenv GENOMEDIR  "$BASEDIR/genome"

echo collect protein sequence files
rm -f $PROTDIR/all_prot.fa
touch $PROTDIR/all_prot.fa
foreach i (`list_files protfiles $1`)
  echo $i
  cat $i >> $PROTDIR/all_prot.fa
end ;

# align Protein sequences
list_contigs fasta $1 > $PROTDIR/tmp_contig_list

/fml/ag-raetsch/share/software/blat/blat -t=dnax -q=prot -tileSize=5 -minMatch=2 -maxGap=4  $PROTDIR/tmp_contig_list $PROTDIR/all_prot.fa $PROTDIR/all_prot.psl -dots=100 -noHead -ooc=$GENOMEDIR/5.ooc

sort -k 10 $PROTDIR/all_prot.psl > $PROTDIR/all_prot_prefiltered.psl

filterbesthit $PROTDIR/all_prot_prefiltered.psl $1 > $PROTDIR/all_prot_filtered.psl
mv $PROTDIR/all_prot_filtered.psl $PROTDIR/all_prot.psl
