#!/bin/tcsh


if ( -d ~/svn/projects/splicing/gff/bin )  set path=( ~/svn/projects/splicing/gff/bin $path)
if ( -d ~/svn/projects/splicing/gff/scripts )  set path=( ~/svn/projects/splicing/gff/scripts $path)

if ( -d ~/projects/splicing/gff/bin )  set path=( ~/projects/splicing/gff/bin $path)
if ( -d ~/projects/splicing/gff/scripts )  set path=( ~/projects/splicing/gff/scripts $path)

setenv BASEDIR    `list_files basedir $1`
setenv PROTDIR   "$BASEDIR/protein_sequences"
setenv GENOMEDIR  "$BASEDIR/genome"

echo collect protein sequence files
rm -f $PROTDIR/all_prot.fa
touch $PROTDIR/all_prot.fa
foreach i (`list_files protfiles $1`)
  echo $i
  cat $i >> $PROTDIR/all_prot.fa
end ;

# align protein sequences
echo align protein sequences
@ j = 0
foreach i (`list_contigs fasta $1`)
  @ j++
  #echo "/fml/ag-raetsch/home/ong/bin/blat_64 -t=dnax -q=prot -tileSize=5 -minMatch=2 -maxGap=4  $i $PROTDIR/all_prot.fa $PROTDIR/tmp_$j.psl -dots=100 -noHead -ooc=$GENOMEDIR/5.ooc >& $PROTDIR/tmp_$j.out"| qsub -cwd -l h_vmem=6G -N "blat_$2$j"
  /fml/ag-raetsch/home/ong/bin/blat_64 -t=dnax -q=prot -tileSize=5 -minMatch=2 -maxGap=4 $i $PROTDIR/all_prot.fa $PROTDIR/tmp_$j.psl -dots=100 -noHead -ooc=$GENOMEDIR/5.ooc >& $PROTDIR/tmp_$j.out &
end ;

wait

#while (`qstat -u $USER | grep "blat_$2" | wc -l`)
#  echo `qstat -u $USER | grep "blat_$2" | wc -l` jobs left
#  sleep 600
#end ;

cat $PROTDIR/tmp_*.psl >  $PROTDIR/all_prot.psl
rm $BASEDIR/blat_*.[eo][0-9]*

sort -k 10 $PROTDIR/all_prot.psl > $PROTDIR/all_prot_prefiltered.psl

filterbesthit $PROTDIR/all_prot_prefiltered.psl $1 > $PROTDIR/all_prot_filtered.psl
mv $PROTDIR/all_prot_filtered.psl $PROTDIR/all_prot.psl
