function train_msplicer(info, origpath) 

% info points to genome.config
% origpath is the root directory, splicing

addpath(sprintf('%s/utils', origpath)) ;
addpath(sprintf('%s/splicegraphs', origpath)) ;
addpath(sprintf('%s/splicegraphs/detect_altsplice', origpath)) ;
addpath(sprintf('%s/sensors/altsplice', origpath)) ;
addpath(sprintf('%s/sensors/splice', origpath)) ;
addpath ~/svn/tools/genomes
addpath ~/svn/tools/rproc
addpath ~/svn/tools/shogun
addpath /fml/ag-raetsch/share/software/matlab_tools/utils

%PAR = getPAR(info,'alt_exon')
%genes2events_alt_exon(info,origpath,PAR);
%PAR = getPAR(info,'alt_intron')
%genes2events_alt_intron(info,origpath,PAR);

%PAR = getPAR(info,'alt_5prime')
%genes2events_alt_5prime(info,origpath,PAR);
%genes2events_alt_5prime_single(info,origpath,PAR);
%PAR = getPAR(info,'alt_3prime')
%genes2events_alt_3prime(info,origpath,PAR);
%genes2events_alt_3prime_single(info,origpath,PAR);


PAR = getPAR(info,'alt_5prime')



% create the events that are used to train the splice site predictor
genome_info = init_genome(info) ;
fname=sprintf('%s/result/events_splice_sites.mat', genome_info.basedir) ;
if ~exist(fname)
  genes2splice(info,origpath,PAR);
end

% train the splice site predictor
cd(sprintf('%s/sensors/splice', origpath)) ;
process_splice_site_sets(genome_info,PAR);
[accfname,donfname,RFVs]=ms_gfwd_starter(genome_info,[8,9],PAR);


return






% get the distribution of scores
fprintf(1,'get the splice site scores\n');
svm_par = init_splice(accfname, donfname);
load(fname,'genes');
as_events = genes;
clear genes;
for num=1:length(as_events) ;
  if (mod(num,1000)==0)
    fprintf(1,'.') ;
  end
  event = as_events(num);
  exons = event.exons{:};

  genestr = load_genomic(event.chr, event.strands(1), ...
			 exons(1,1)-PAR.seq_window_splice,...
			 exons(2,2)+PAR.seq_window_splice);
  
  if event.strands(1) == '+'
    truepos = exons;
    truepos = truepos - exons(1,1)+1+PAR.seq_window_splice;
  else
    truepos = [exons(2,2),exons(2,1);...
               exons(1,2),exons(1,1)];
    truepos = exons(1,1) - PAR.seq_window_splice + length(genestr) - truepos;
  end
  truepos(:,2) = truepos(:,2) + 1;

  dseq(1,:) = genestr(truepos(1,2)-svm_par.llen.don:truepos(1,2)+svm_par.rlen.don);
  don_output = predict_donor_sites(dseq);
  as_events(num).score_5prime = don_output(4,1);

  aseq = genestr(truepos(2,1)-svm_par.llen.acc-2:truepos(2,1)+svm_par.rlen.acc-2);
  acc_output = predict_acceptor_sites(aseq);
  as_events(num).score_3prime = acc_output(4,1);
end
genes = as_events;
save(fname,'genes');
clear genes;
score_5prime = [as_events(:).score_5prime];
score_3prime = [as_events(:).score_3prime];
keyboard

keyboard
