function training(info, origpath, spliceform ) 
% training(info, origpath, spliceform ) 
%
% info points to genome.config
% origpath is the location of the main script, $ORIGPATH
% spliceform tells us which problem we are studying (alt_5prime, alt_3prime, intron_reten, exon_skip)


%info = '/fml/ag-raetsch/share/projects/altsplicedata/test/genome.config';
%origpath = '/fml/ag-raetsch/home/ong/ag-raetsch/projects/splicing';

fprintf(1,'training\n\n');
addpath(origpath) ;
addpath(sprintf('%s/utils', origpath)) ;
addpath(sprintf('%s/gff/scripts', origpath)) ;
addpath(sprintf('%s/sensors/altsplice', origpath)) ;
addpath(sprintf('%s/sensors/altsplice/split', origpath)) ;
addpath /fml/ag-raetsch/share/software/matlab_tools/utils
addpath ~/svn/tools/genomes
addpath ~/svn/tools/shogun

  
% --- the training and test set splits
train_set = [1 1;
	     1 2];
valid_set = [2 1;
	     2 2];
test_set = [3 1;
	    3 2];
pred_set = [1 3];
splice_set = [1 4];



genome_info = init_genome(info) ;

PAR = getPAR(info, spliceform)
svm_train(info,origpath,spliceform,[train_set;valid_set],PAR)
%svm_aroc_fdr(info,origpath,spliceform,test_set,PAR)
%svm_pred_fdr(info,origpath,spliceform,pred_set,PAR)

