#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include "common.h"
#include "genome.h"
#include "est2gff.h"


int main(int argc, char**argv)
{
	int i, what=0 ;
	char * genome_config_fname=NULL ;
	char *target_name="" ;

	if (argc<2)
	{
		fprintf(stderr, "usage: %s <name|flat|fasta|flat__fasta> [<genome_config_fname [<name>]]\n", argv[0]) ;
		exit(-1) ;
	} 

	if (strcmp(argv[1], "name")==0)
		what=1 ;
	else if (strcmp(argv[1], "flat")==0)
		what=2 ;
	else if (strcmp(argv[1], "fasta")==0)
		what=3 ;
	else if (strcmp(argv[1], "flat__fasta")==0)
		what=4 ;
	
	assert( what==1 || what==2 || what==3 || what==4) ;

	// genome config
	if (argc<3)
		genome_config_fname = "genome.config" ;
	else
		genome_config_fname = argv[2] ;

	// target name
	if (argc<4)
		target_name = "" ;
	else
		target_name = argv[3] ;

	// genome initialization
	if (init_genome(genome_config_fname)!=0)
	{
		fprintf(stderr, "genome initialization failed\n") ;
		exit(-1) ;
	}
	
	// output contig fnames
	for (i=0; i<num_contigs; i++)
		if ((target_name==NULL) || (strlen(target_name)==0)||
			(strcmp(target_name, contig_names[i])==0))
			switch (what)
			{
			case 1:
				fprintf(stdout, "%s\n", contig_names[i]) ;
				break ;
			case 2:
				fprintf(stdout, "%s\n", contig_fnames[i]) ;
				break ;
			case 3:
				fprintf(stdout, "%s\n", contig_fasta_fnames[i]) ;
				break ;
			case 4:
				fprintf(stdout, "%s__%s\n", contig_fnames[i], contig_fasta_fnames[i]) ;
				break ;
			}
	
	return 0;
} 

