function include_preds_all(origpath,organismlistfile)
% A wrapper script to include the predicted alternative splicing events
% into the splice graph

addpath ~/svn/tools/rproc

orglist = textread(organismlistfile,'%s')
numorgs = length(orglist);


% setup rproc
options={} ;
options.identifier = 'PA';
options.start_dir = [getenv('HOME') '/svn/projects/splicing/splicegraphs'] ;
MEMREQ = 5000;

joblist=rproc_empty(0) ;
% do the includes for each fdr
for ixr = [5 10 25 50]
  for ixo = 1:numorgs
    data.ginfo = sprintf('/fml/ag-raetsch/share/projects/altsplicedata/%s/genome.config',orglist{ixo});
    data.origpath = origpath;
    data.fd_rate = ixr;
    joblist(end+1) = rproc('include_preds',data,MEMREQ,options,30);
    pause(1);
  end
end

[joblist, num_crashed] = rproc_wait(joblist,60,1,0);
if num_crashed > 0
  fprintf(1,'Error: jobs crashed\n');
  [joblist, num_crashed] = rproc_wait(joblist,60,1,0);
  %keyboard;
end

if num_crashed == 0
  rproc_cleanup(joblist);
  clear joblist;
end
