function [map12, map21] = build_assoc_map(genes1,genes2)
% function [map12, map21] = build_assoc_map(genes1,genes2)
%
% Use blat to map two sets of genes to each other.
%
% Written by: Cheng Soon Ong, 23 May 2007

fname1 = genes2fasta(genes1);
fname2 = genes2fasta(genes2);
fname12 = tempname;
fname21 = tempname;

fprintf('BLAT 1 against 2\n');
unix(sprintf('blat -minIdentity=50 %s.fa %s.fa %s.psl -dots=1000 -noHead', fname1, fname2, fname12)) ;
fprintf('BLAT 2 against 1\n');
unix(sprintf('blat -minIdentity=50 %s.fa %s.fa %s.psl -dots=1000 -noHead', fname2, fname1, fname21)) ;

map12 = psl2similarity(fname12,length(genes1),length(genes2));
map21 = psl2similarity(fname21,length(genes2),length(genes1));

assert(all(size(map12)==[length(genes1),length(genes2)]));
assert(all(size(map21)==[length(genes2),length(genes1)]));


unix(sprintf('rm %s.fa %s.fa %s.psl %s.psl', fname1, fname2, fname12, fname21)) ;
