function [isoform, cnt] = dfs_search_max_len(vertices, adj_mat, startv, dagpath)
% the recursive function call

dagpath = [dagpath, startv];
% if at a leaf node, then include path into isoform list
children = find(adj_mat(startv,:));
if isempty(children)
  isoform = dagpath ;
  cnt = 1 ;
else
  best_isoform = [] ;
  max_len = 0 ;
  cnt=0; 
  for child = children,
    [isoform,cnt_] = dfs_search_max_len(vertices, adj_mat, child, dagpath) ;
    len = sum(vertices(2,isoform)-vertices(1,isoform)) ;
    if len>max_len,
      max_len=len ;
      best_isoform = isoform ;
    end ;
    cnt = cnt + cnt_ ;
    if cnt>10000, 
      fprintf(' canceling search after considering 10.000 isoforms ...') ; 
      isoform = best_isoform ;
      return ; 
    end ;
  end
  isoform = best_isoform ;
end
