function ret = dfs_visit(adj_mat, startv, dagpath)
% the recursive function call
global g_isoforms

ret = 1 ;
if length(g_isoforms)>50000, 
  fprintf('too many isoforms (%i exons)\n', size(adj_mat,2)) ; 
  ret = 0 ;
  return ; 
end ;

dagpath = [dagpath, startv];
% if at a leaf node, then include path into isoform list
children = find(adj_mat(startv,:));
if isempty(children)
  g_isoforms{end+1} = dagpath;
else
  for child = children,
    if ~dfs_visit(adj_mat, child, dagpath),
      ret = 0 ;
      return ;
    end ;
  end
end
