function events_intersect


addpath /fml/ag-raetsch/share/software/matlab_tools/utils

doIntersect('alt_exon')
doIntersect('alt_intron')
doIntersect('alt_5prime')
doIntersect('alt_3prime')



function doIntersect(alt_type)
fprintf(1,'%s\n',alt_type);
events1 = arrayload(sprintf('~/altsplicedata/elegans_blat/prediction3/events_%s.mat',alt_type));
events2 = arrayload(sprintf('~/altsplicedata/elegans_palma/prediction3/events_%s.mat',alt_type));
str1={events1(:).string} ;
str2={events2(:).string} ;

[dummy,idx1,idx2] = intersect(str1,str2);

org1len = length(events1);
org2len = length(events2);
events1 = events1(idx1);
% they should be the same
events2 = events2(idx2);
for ix=1:length(events1)
  if events1(ix).string ~= events2(ix).string
    keyboard;
  end
end
fprintf(1,'Number of events: %d in elegans_blat, %d in elegans_palma, ',org1len,org2len);
fprintf(1,'%d common events (%3.1f%% and %3.1f%% respectively)\n',length(events1),...
	100*length(events1)/org1len,100*length(events1)/org2len);

idx_pos1 = find([events1(:).label]==1);
idx_pos2 = find([events2(:).label]==1);
idx_neg1 = find([events1(:).label]==-1);
idx_neg2 = find([events2(:).label]==-1);

idx_pp = intersect(idx_pos1,idx_pos2);
idx_nn = intersect(idx_neg1,idx_neg2);
idx_pn = intersect(idx_pos1,idx_neg2);
idx_np = intersect(idx_neg1,idx_pos2);

confmat = [length(idx_pp), length(idx_pn);...
	   length(idx_np), length(idx_nn)]
100.*confmat./length(events1)


assert(isempty(intersect(idx_pp,idx_nn)));


common_events = events1([idx_pp,idx_nn]);
arraysave(sprintf('~/altsplicedata/elegans_agree/prediction3/events_%s.mat',alt_type),common_events);
