% export all the positive events, 
%as well as the predicted events at less than 1% false positive rate.

addpath /fml/ag-raetsch/share/software/matlab_tools/utils
cd /fml/ag-raetsch/share/projects/altsplicedata/elegans/prediction

as_events = load_cell('events_alt_exon.mat');
load('split_alt_exon_0511.mat','events_idx');
posidx = [events_idx{:,2}];
alt_exon_pos_events = as_events(posidx);
load('cand_alt_exon','cand_as_event');
topidx = find([cand_as_event.fp_rate] <= 0.01);
alt_exon_cand_events = cand_as_event(topidx);
assert(all([alt_exon_pos_events.label]==1));
assert(all([alt_exon_cand_events.fp_rate] <= 0.01));

as_events = load_cell('events_alt_intron.mat');
load('split_alt_intron_0511.mat','events_idx');
posidx = [events_idx{:,2}];
alt_intron_pos_events = as_events(posidx);
load('cand_alt_intron','cand_as_event');
topidx = find([cand_as_event.fp_rate] <= 0.01);
alt_intron_cand_events = cand_as_event(topidx);
assert(all([alt_intron_pos_events.label]==1));
assert(all([alt_intron_cand_events.fp_rate] <= 0.01));

as_events = load_cell('events_alt_5prime.mat');
load('split_alt_5prime_0511.mat','events_idx');
posidx = [events_idx{:,2}];
alt_5prime_pos_events = as_events(posidx);
load('cand_alt_5prime','cand_as_event');
topidx = find([cand_as_event.fp_rate] <= 0.01);
alt_5prime_cand_events = cand_as_event(topidx);
assert(all([alt_5prime_pos_events.label]==1));
assert(all([alt_5prime_cand_events.fp_rate] <= 0.01));

as_events = load_cell('events_alt_3prime.mat');
load('split_alt_3prime_0511.mat','events_idx');
posidx = [events_idx{:,2}];
alt_3prime_pos_events = as_events(posidx);
load('cand_alt_3prime','cand_as_event');
topidx = find([cand_as_event.fp_rate] <= 0.01);
alt_3prime_cand_events = cand_as_event(topidx);
assert(all([alt_3prime_pos_events.label]==1));
assert(all([alt_3prime_cand_events.fp_rate] <= 0.01));

save('events_ucsc.mat',...
     'alt_exon_pos_events','alt_exon_cand_events',...
     'alt_intron_pos_events','alt_intron_cand_events',...
     'alt_5prime_pos_events','alt_5prime_cand_events',...
     'alt_3prime_pos_events','alt_3prime_cand_events');

