function frac_gap(gap,ss,fd)

if nargin < 3
  fd = 1;
end

num_sites = 5;
max_confirms = size(gap,2);

frac_nogap = zeros(2,max_confirms);
for ix = 1:max_confirms
  frac_nogap(1,ix) = length(find(ss(:,ix)==0))./length(find(~isnan(ss(:,ix))));
  frac_nogap(2,ix) = length(find(ss(:,ix)<=num_sites))./length(find(~isnan(ss(:,ix))));
end

fprintf(fd,'Fraction with no gap: ');
for ix = 1:max_confirms
  fprintf(fd,'%1.2f%%,',frac_nogap(1,ix)*100);
end
fprintf(fd,'\n');
fprintf(fd,'Fraction with at most %d between: ',num_sites);
for ix = 1:max_confirms
  fprintf(fd,'%1.2f%%,',frac_nogap(2,ix)*100);
end
fprintf(fd,'\n');

frac90 = zeros(2,max_confirms);
for ix = 1:max_confirms
  counts = ss(isfinite(ss(:,ix)));
  counts = sort(counts,'ascend');
  frac90(1,ix) = counts(round(0.9*length(counts)));
  gaps = gap(isfinite(gap(:,ix)));
  gaps = sort(gaps,'ascend');
  frac90(2,ix) = gaps(round(0.9*length(gaps)));
end
fprintf(fd,'Number of consensus sites at 90%%: ');
for ix = 1:max_confirms
  fprintf(fd,'%d, ',frac90(1,ix));
end
fprintf(fd,'\n');

fprintf(fd,'Sequence length bewteen splice sites at 90%%: ');
for ix = 1:max_confirms
  fprintf(fd,'%d, ',frac90(2,ix));
end
fprintf(fd,'\n\n');

