function frac_gap_latex(organism,gap,ss,alt_type,fd)

if nargin < 5
  fd = 1;
end

num_sites = 5;
max_confirms = size(gap,2);
confirms = 2;
assert(confirms <= max_confirms);

frac_nogap = zeros(2,max_confirms);
for ix = 1:max_confirms
  frac_nogap(1,ix) = length(find(ss(:,ix)==0))./length(find(~isnan(ss(:,ix))));
  frac_nogap(2,ix) = length(find(ss(:,ix)<=num_sites))./length(find(~isnan(ss(:,ix))));
end

if alt_type == '5prime'
  fprintf(fd,'%s&',organism);
end
fprintf(fd,'%1.2f\\%%&',frac_nogap(1,confirms)*100);
fprintf(fd,'%1.2f\\%%&',frac_nogap(2,confirms)*100);

frac90 = zeros(2,max_confirms);
for ix = 1:max_confirms
  counts = ss(isfinite(ss(:,ix)));
  counts = sort(counts,'ascend');
  frac90(1,ix) = counts(round(0.9*length(counts)));
  gaps = gap(isfinite(gap(:,ix)));
  gaps = sort(gaps,'ascend');
  frac90(2,ix) = gaps(round(0.9*length(gaps)));
end
fprintf(fd,'%d&',frac90(1,confirms));
fprintf(fd,'%d',frac90(2,confirms));

if alt_type == '5prime'
  fprintf(fd,'&');
else
  fprintf(fd,'\\\\\n');
end

%[gap_3prime,ss_3prime,gap_5prime,ss_5prime] = count_altprime_gap_events(organism)
%    &&&\multicolumn{2}{c|}{90\% quantile}&&&\multicolumn{2}{c|}{90\% quantile}\\
%    Organism&No gap&$\leq$ 5ss&cons.&nt.&No gap&$\leq$ 5ss&cons.&nt.\\
