function [predP,fracpos] = frac_pos(svmouttrain,labeltrain,fracpostrain,svmout)
%function [predP,fracpos] = frac_pos(svmouttrain,labeltrain,fracpostrain,svmout)
%

[fpr,tpr] = calcroc(svmouttrain,labeltrain);
[sortedout,outidx] = sort(svmouttrain(find(labeltrain==-1)),2,'descend');

predP = zeros(size(tpr));
fracpos = zeros(size(tpr));
for ix = 1:length(tpr)
  biasidx = floor(fpr(ix)*length(outidx));
  if biasidx > 0
    threshold = sortedout(biasidx);
  else
    threshold = sortedout(1);
  end
  predP(ix) = sum(svmout>threshold);
  fracpos(ix) = (predP(ix)/(length(svmout)) - fpr(ix)*(1-fracpostrain))/tpr(ix);
end
figure;
plot(fpr,predP)
xlabel('False positive rate (training set)')
ylabel('Number of predicted positives')
figure;
plot(fpr,fracpos,'b-')
hold on;plot([0 1],[fracpostrain fracpostrain],'r-.') 
xlabel('False positive rate (training set)')
ylabel('Estimated fraction of positive alternative splicing events')
axis([0 1 0 1])
