function num_arf_nt = isframeshifted(rfpos1,rfpos2,tstart1,tstart2)
% function num_arf_nt = isframeshifted(rfpos1,rfpos2,tstart1,tstart2)
%
% returns 1 if there is a frameshift,
% and 0 otherwise.
%
% Written by: Cheng Soon Ong, 31 May 2007

tstart = min(tstart1,tstart2);
len = max(tstart1+length(rfpos1),tstart2+length(rfpos2));

ntarray = repmat(nan,2,len-tstart);
ntarray(1,tstart1-tstart+1:tstart1+length(rfpos1)-tstart) = rfpos1;
ntarray(2,tstart2-tstart+1:tstart2+length(rfpos2)-tstart) = rfpos2;

num_arf_nt = sum(ntarray(1,:)~=ntarray(2,:) & ~isnan(ntarray(1,:)) & ~isnan(ntarray(2,:)));
