function olen = overlap_length(blocks1, blocks2)
% function olen = overlap_length(blocks1, blocks2)
%
% compare two sets of blocks, each a (2 x n) matrix (e.g. representing exons)
% return olen - the number of bases which overlap
%
% Written by: Cheng Soon Ong, 30 May 2007

start = min(blocks1(1,1),blocks2(1,1));
stop = max(blocks1(2,end),blocks2(2,end));
assert(stop-start > 0);
ntarray = zeros(1,stop-start+1);
blocks1 = blocks1 - start + 1;
blocks2 = blocks2 - start + 1;

olen = 0;

for ix=1:size(blocks1,2)
  ntarray(blocks1(1,ix):blocks1(2,ix)) = ntarray(blocks1(1,ix):blocks1(2,ix)) + 1;
end
for ix=1:size(blocks2,2)
  ntarray(blocks2(1,ix):blocks2(2,ix)) = ntarray(blocks2(1,ix):blocks2(2,ix)) + 1;
end

overlap2 = find(ntarray==2);
olen = length(overlap2);
