function pen = penalty_lookup_new(penalty_struct, value)
% pen = penalty_lookup(penalty_struct, value)

limits    = penalty_struct.limits ;
penalties = penalty_struct.penalties ;

%if value<penalty_struct.min_len || value>penalty_struct.max_len
%  pen=-inf ;
%  return ;
%end ;
switch penalty_struct.transform,
 case 'log'  
  value = log(value) ;
 case 'log(+3)'
  value = log(value+3) ;
 case 'log(+1)'
  value = log(value+1) ;
 case ''
 case '(+3)'
  value = value+3 ;
 case 'mod3'
  value = mod(value,3) ;
 otherwise
  error('unknown penalty transform') ;
end ;

idx = sum(limits<=value) ;
if idx==0,
  pen=penalties(1) ;
elseif idx==length(limits),
  pen=penalties(end) ;
else
  pen = (penalties(idx+1)*(value-limits(idx)) + penalties(idx)* ...
	  (limits(idx+1)-value)) / (limits(idx+1)-limits(idx)) ;  
end ;
   