function similarity = psl2similarity(fname,geneslen1,geneslen2)
% function similarity = psl2similarity(fname,geneslen1,geneslen2)
%
% Parse blat output to find similar sequences (to be used with genes2fasta.m)
%
% Written by: Cheng Soon Ong, 23 May 2007

fprintf('Parse blat output to find similar sequences\n');
fd=fopen([fname '.psl'], 'r') ;
%similarity = sparse(0) ; similarity(geneslen, geneslen)=0 ; 
similarity = spzeros(geneslen1,geneslen2);
while ~feof(fd),
  line=fgetl(fd) ;
  if ~ischar(line), break; end ;
  elems=separate(line) ;

  percent_identity = str2num(elems{1})./min(str2num(elems{11}), str2num(elems{15}));
  if percent_identity >= 0.50
    id1 = str2num(elems{10}(4:end)) ; % remove "seq"
    id2 = str2num(elems{14}(4:end)) ; % remove "seq"
    similarity(id2,id1) = percent_identity ; 
  end ;
end ;
fclose(fd);
