function event = sort_splicesites(event, splicesite)
% function sort_splicesite(event, splicesite)
% sorts exon_5prime, exon_3prime and exon_alternative such that
% exon_alternative always protrudes into the intron.


if splicesite == 5
  if (event.strand == '+') ...
	&& (event.exon_5prime(2) > event.exon_alternative(2))
    temp = event.exon_5prime;
    event.exon_5prime = event.exon_alternative;
    %event.exons_5prime(end,:) = event.exon_alternative;
    event.exon_alternative = temp;

    tempcount = event.alt0_confirm_by;
    event.alt0_confirm_by = event.alt1_confirm_by;
    event.alt1_confirm_by = tempcount;           ;
    
  elseif (event.strand == '-') ...
	&& (event.exon_5prime(1) < event.exon_alternative(1))
    temp = event.exon_5prime;
    event.exon_5prime = event.exon_alternative;
    %event.exons_5prime(1,:) = event.exon_alternative;
    event.exon_alternative = temp;

    tempcount = event.alt0_confirm_by;
    event.alt0_confirm_by = event.alt1_confirm_by;
    event.alt1_confirm_by = tempcount;           ;
    
  end
elseif splicesite == 3
  if (event.strand == '+') ...
	&& (event.exon_3prime(1) < event.exon_alternative(1))
    temp = event.exon_3prime;
    event.exon_3prime = event.exon_alternative;
    %event.exons_3prime(1,:) = event.exon_alternative;
    event.exon_alternative = temp;

    tempcount = event.alt0_confirm_by;
    event.alt0_confirm_by = event.alt1_confirm_by;
    event.alt1_confirm_by = tempcount;           ;
    
  elseif (event.strand == '-') ...
	&& (event.exon_3prime(2) > event.exon_alternative(2))
    temp = event.exon_3prime;
    event.exon_3prime = event.exon_alternative;
    %event.exons_3prime(end,:) = event.exon_alternative;
    event.exon_alternative = temp;

    tempcount = event.alt0_confirm_by;
    event.alt0_confirm_by = event.alt1_confirm_by;
    event.alt1_confirm_by = tempcount;           ;
    
  end
else
  fprintf(1,'Please use splicesite == 5 or splicesite == 3\n');
  keyboard;
end
