function [isostartpos, isostoppos, isoform] = strloc2genloc(isoform, vertices, strstart, strstop)
% function [isostartpos, isostoppos, isoform] = strloc2genloc(isoform, vertices, strstart, strstop)
%
% convert string start and stop to genomic locations
% Written by: Cheng Soon Ong 14 May 2007

first_exon = 1;
last_exon = length(isoform);
isostartpos = vertices(1,isoform(1));
isostoppos = vertices(2,isoform(end));
for ix = 1:length(isoform)
  exon_len = vertices(2,isoform(ix)) - vertices(1,isoform(ix)) + 1;
  if (strstart > 0) && (strstart <= exon_len)
    isostartpos = strstart + vertices(1,isoform(ix));
    first_exon = ix;
  end
  if (strstop > 0) && (strstop <= exon_len)
    isostoppos = strstop + vertices(1,isoform(ix));
    last_exon = ix;
  end
  strstart = strstart - exon_len;
  strstop = strstop - exon_len;
end
isoform = isoform(first_exon:last_exon);
