function lpenv = cplex_license(waitflag, num_cpus)
%  lpenv = cplex_license(waitflag, num_cpus)

global lpenv ;

if nargin<1, waitflag = 0 ; end ;
if nargin<2, num_cpus = 1 ; end ;

envstr1 = 'ILOG_LICENSE_FILE=/fml/ag-raetsch/share/software/ilog/licenses/access-587380.ilm';%9
envstr2 = 'ILOG_LICENSE_FILE=/fml/ag-raetsch/share/software/ilog/licenses/access-703040.ilm';%9 p=2
envstr3 = 'ILOG_LICENSE_FILE=/fml/ag-raetsch/share/software/ilog/licenses/access-820980.ilm';%10 p=8

lpenv = 0 ;
while (lpenv==0)
  nc = num_cpus ;

  while ~lpenv && nc<4,
    
    if nc == 0,
      envstr = getenv('ILOG_LICENSE_FILE') ;
    elseif nc == 1,
      envstr = envstr1 ;
    elseif nc == 2,
      envstr = envstr2 ;
    elseif nc > 2,
      envstr = envstr3 ;
    end ;
    
    fprintf('\ntrying license file %s\n', strrep(envstr, 'ILOG_LICENSE_FILE=', '')) ;
    lpenv = cplex_init_quit(0, envstr) ;
    
    if ~lpenv, 
      nc=nc+1 ; 
    end ;
  end ;

  if lpenv == 0 & ~waitflag,
    break ;
  end ;
  if lpenv==0,
    global THIS_IS_A_RPROC_PROCESS  
    if ~isequal(THIS_IS_A_RPROC_PROCESS,1),
      disp('waiting for cplex license') ;
      pause(60)
    else 
      fprintf(':') ;
    end ;
  end;

end ;

