function save_matrix(filen, M, varname, split_size)
%save_matrix(filen, M, varname, split_size)
%split matrix into parts with size of about split_size 
%bytes (1e+8 default) and save them in one file

if nargin<4
  split_size=1e+8;
end

info = whos('M');
num_splits = ceil(info.bytes/split_size);
num_cols = ceil(size(M, 2)/num_splits);

  
  meta.size=size(M);
  meta.num_splits = num_splits;
  mata.name = varname;
  if fexist(filen)
    save(filen, '-append', 'meta');
  else
    save(filen, 'meta');
  end
  for j=1:num_splits-1
    eval(sprintf('%s_split_%i = M(:, 1:num_cols);',varname, j));
    M(:, 1:num_cols)=[];
    save(filen, '-append', sprintf('%s_split_%i',varname,j));
  end
  if isempty(j), j=0; end;
  eval(sprintf('%s_split_%i = M;',varname, j+1));  
  save(filen, '-append', sprintf('%s_split_%i',varname,j+1));
