organism='brenneri' ;

if isequal(organism, 'elegans')
  genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/orig_data/genome.config');
  load elegans_masked
  
elseif isequal(organism, 'briggsae')
  genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp2/orig_data/genome.config');
  load briggsae_masked
elseif isequal(organism, 'remanei')
  genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_remanei/exp1/orig_data/genome.config');
  load remanei_masked
elseif isequal(organism, 'brenneri')
  genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_brenneri/exp1/orig_data/genome.config');
  load brenneri_masked
end  

num_only_Ns = 0;
for j=1:length(seqs)
  if isequal(unique(seqs{j}),'N')
    num_only_Ns = num_only_Ns+1;
  end
end
num_only_Ns
assert(length(unique(names))==length(names));
map(length(seqs)).names_masked = '';
map(length(seqs)).names_unmasked = {};
map(length(seqs)).num_unmasked = 0;
map(length(seqs)).num_masked = 0;
for i=1:length(seqs)
  seqs{i} = upper(seqs{i}) ;
  map(i).names_masked = names{i} ;
  map(i).names_unmasked = {} ;
  map(i).num_unmasked = 0;
  map(i).num_masked = 1;
end ;

for i=7090:length(genome_info.contig_names),
  fprintf('%i/%i  \r', i, length(genome_info.contig_names)) ;

  str=load_genomic(genome_info.contig_names{i},'+', 1, inf, genome_info, 0) ;
  str=upper(str) ;
  
  idx=[] ;
  for j=1:length(seqs)
    if length(seqs{j})==length(str)
      diff=seqs{j}(seqs{j}~=str) ;
      if all(unique(diff)=='N')
        idx=[idx j] ;
      end ;
    end ;
  end ;
  if length(idx)>1
    rank = zeros(length(idx),1);
    for j=1:length(idx)
      rank(j) = sum(seqs{j}=='N');
    end    
    [rank,ii] =sort(rank);
    if rank(1)~=rank(2);
      idx = idx(1);
    else
      keyboard
    end
  end
  if isempty(idx),
    map(end+1).name_unmasked{1} = genome_info.contig_names{i} ;
    map(end).num_masked = 0;
  elseif length(idx)==1
    assert(isequal(map(idx).names_masked,names{idx}));
    if ~isempty(map(idx).names_unmasked),
      assert(mean(seqs{idx}=='N')>0.7)
    end ;
    map(idx).names_unmasked{end+1} = genome_info.contig_names{i} ;
    map(idx).num_unmasked =  map(idx).num_unmasked +1;
  else
    keyboard
  end ;
end ;

N1=0 ; N2=0 ; N=size(map,1) ;
for i=1:N,
  if isempty(map{i,1}), N1=N1+1 ; end ;
  if isempty(map{i,2}), N2=N2+1 ; end ;
end ;
N1/N
N2/N


%%%

base_name = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/exp1/' ...
             'lsl/cat-3/predictions/GS-07-12-2007/pred_genes'];

cnt_pred.genes = 0;
cnt_pred.genesInRepeats = 0;
cnt_pred.genesIntronsInRepeats = 0; 
cnt_pred.genesExonsInRepeats = 0;
cnt_pred.exons = 0;
cnt_pred.exonsInRepeats = 0;
cnt_pred.introns = 0;
cnt_pred.intronsInRepeats = 0;
cnt_pred.splicesites = 0;
cnt_pred.affectedSS = 0;
cnt_pred.genesAffectedSS= 0;
cnt_anno = cnt_pred;

A = load('/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/orig_data/annotated_genes.mat')
for i=1:6
  for strand='+-'
    L=load(sprintf('%s%i%s_cleave=6.00.mat',base_name,i,strand));
    cnt.genes = cnt.genes +length(L.genes);
    idx_seq = find(strcmp(map(:,2),L.genes(1).chr));
    seq = seqs{idx_seq};
    cnt_pred = count_repeats(L.genes,seq,cnt_pred);
    idx_genes = find([A.genes.strand]==strand&strcmp({A.genes.chr},map(idx_seq,1)));
    genes = A.genes(idx_genes);
    cnt_anno = count_repeats(genes,seq,cnt_anno);
  end %%strands
end %% contigs

cnt=cnt_anno;
cnt.intronsInRepeats/cnt.introns
cnt.exonsInRepeats/cnt.exons
cnt.genesInRepeats/cnt.genes
cnt.genesExonsInRepeats/cnt.genes 
cnt.genesIntronsInRepeats/cnt.genes 

return



%%OLD
organism='brenneri' ;

if isequal(organism, 'elegans')
  genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_elegans/WS180/orig_data/genome.config');
  load elegans_masked
elseif isequal(organism, 'briggsae')
  genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_briggsae/exp2/orig_data/genome.config');
  load briggsae_masked
elseif isequal(organism, 'remanei')
  genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_remanei/exp1/orig_data/genome.config');
  load remanei_masked
elseif isequal(organism, 'brenneri')
  genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding/C_brenneri/exp1/orig_data/genome.config');
  load brenneri_masked
end  


map={} ;
for i=1:length(seqs)
  seqs{i} = upper(seqs{i}) ;
  map{i,1} = names{i} ;
  map{i,2} = '' ;
end ;

for i=1:length(genome_info.contig_names),
  fprintf('%i/%i  \r', i, length(genome_info.contig_names)) ;

  str=load_genomic(genome_info.contig_names{i},'+', 1, inf, genome_info, 0) ;
  str=upper(str) ;
  
  idx=[] ;
  for j=1:length(seqs)
    if length(seqs{j})==length(str)
      diff=seqs{j}(seqs{j}~=str) ;
      if all(unique(diff)=='N')
        idx=j ;
      end ;
    end ;
  end ;
  if isempty(idx),
    map{end+1,2}=genome_info.contig_names{i} ;
  else
    map{idx,1}=names{idx} ;
    if ~isempty(map{idx,2}), keyboard; end ;
    map{idx,2}=genome_info.contig_names{i} ;
  end ;
end ;

N1=0 ; N2=0 ; N=size(map,1) ;
for i=1:N,
  if isempty(map{i,1}), N1=N1+1 ; end ;
  if isempty(map{i,2}), N2=N2+1 ; end ;
end ;
N1/N
N2/N

