addpath ../../sensors/
addpath ../../utils

genome_info = init_genome('/fml/ag-raetsch/share/projects/genefinding//C_elegans/orig_data/genome.config') ;

base_dirs{1}    = ['/fml/ag-raetsch/share/projects/genefinding/' ...
                   'C_elegans/sensors/transacc/output_SVMWDS/pred'];
blocks(1).chr_num=1 ;

fdir = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/data/' ;
fnames={'test_region_I+_2007-08-31', 'test_region_I-_2007-08-31', ...
        'test_region_II+_2007-08-31', 'test_region_II-_2007-08-31', ...
        'test_region_III+_2007-08-31', 'test_region_III-_2007-08-31', ...
        'test_region_IV+_2007-08-31', 'test_region_IV-_2007-08-31', ...
        'test_region_V+_2007-08-31', 'test_region_V-_2007-08-31', ...
        'test_region_X+_2007-08-31', 'test_region_X-_2007-08-31'} ;

fields = {'Conf_cum'};
signal_names{1}='transacc'
% blocks = load_sequence(blocks);
for r=9%10:length(fnames)
  clear test_block

  fn_blocks = [fdir fnames{r} '.mat'] ;
  load(fn_blocks) ;
  if test_block.strand=='+',
    test_block.start = test_block.block_start ;
    test_block.stop = test_block.block_end ;
  else
    test_block.start = test_block.block_end ;
    test_block.stop = test_block.block_start ;
  end ;
  test_block.chr_num = find(ismember({'I', 'II', 'III', 'IV', 'V', 'X'}, test_block.chr)) ;

  fprintf('Processing block %i...\r', r);
  % fill the field genestr
  for s=1:length(signal_names),
    f_name = sprintf('%scontig_%i%c%s.pos', base_dirs{s}, test_block.chr_num, test_block.strand, signal_names{s});
    d = dir(f_name) 
    if d.bytes>0
      block = retrieve_signals(test_block, base_dirs{s}, signal_names{s}, fields);
    end
    test_block.details.pos.trans= block.Signals.(signal_names{s}).pos;
    test_block.details.score.trans= block.Signals.(signal_names{s}).Conf_cum .* test_block.details.score.acc;
  end
  fn_blocks = [fdir fnames{r} 'corrected.mat'] ;
  test_block = rmfield(test_block, 'start') ;
  test_block = rmfield(test_block, 'stop') ;
  test_block = rmfield(test_block, 'chr_num') ;
  save(fn_blocks, 'test_block', '-v7.3') ;
end
