function gene_mask(region_idx)

EXTENSION = 1000;
  
tmp = load(['/fml/ag-raetsch/share/projects/genefinding/C_elegans/' ...
            'genome_data/genes.mat'], 'genes');
genes = tmp.genes;
% TODO use asserts instead
for g=1:length(genes),
  if ~isempty(genes(g).splicegraph{1}),
    genes(g).start = min(min(genes(g).splicegraph{1}));
    genes(g).stop = max(max(genes(g).splicegraph{1}));
  end
end

tmp = load(['/fml/ag-raetsch/share/projects/genefinding/'...
            '/C_elegans/genome_data/annotated_genes.mat'], 'genes');
genes_anno = tmp.genes;
% TODO use asserts instead
for g=1:length(genes_anno),
  if ~isempty(genes_anno(g).splicegraph{1}),
    genes_anno(g).start = min(min(genes_anno(g).splicegraph{1}));
    genes_anno(g).stop = max(max(genes_anno(g).splicegraph{1}));
  end
end
clear tmp

load(['/fml/ag-raetsch/share/projects/genefinding/C_elegans/' ...
      'genome_data/trivial_regions.mat'], 'trivial_regions');
regions = trivial_regions;
clear trivial_regions


fn_out = ['/fml/ag-raetsch/share/projects/genefinding/C_elegans/' ...
          'genome_data/gene_mask_'];

for r=region_idx,
  fprintf('generating gene mask for chr %s...\n', regions(r).chr);
  mask = zeros(4, regions(r).stop - regions(r).start + 1);
  
  for g=1:length(genes),
    if isequal(genes(g).chr, regions(r).chr),
      switch genes(g).strand,
       case '+',
        mask(1, genes(g).start:genes(g).stop) ...
            = mask(1, genes(g).start:genes(g).stop) + 1;
        b = max(genes(g).start-EXTENSION, 1);
        e = min(genes(g).stop+EXTENSION, size(mask,2));
        mask(3, b:e) = mask(3, b:e) + 1;
       case '-',
        mask(2, genes(g).start:genes(g).stop) ...
            = mask(2, genes(g).start:genes(g).stop) + 1;
        b = max(genes(g).start-EXTENSION, 1);
        e = min(genes(g).stop+EXTENSION, size(mask,2));
        mask(4, b:e) = mask(4, b:e) + 1;
      end
    end
  end
  for g=1:length(genes_anno),
    if isequal(genes_anno(g).chr, regions(r).chr),
      switch genes_anno(g).strand,
       case '+',
        mask(1, genes_anno(g).start:genes_anno(g).stop) ...
            = mask(1, genes_anno(g).start:genes_anno(g).stop) + 1;
        b = max(genes(g).start-EXTENSION, 1);
        e = min(genes(g).stop+EXTENSION, size(mask,2));
        mask(3, b:e) = mask(3, b:e) + 1;
       case '-',
        mask(2, genes_anno(g).start:genes_anno(g).stop) ...
            = mask(2, genes_anno(g).start:genes_anno(g).stop) + 1;
        b = max(genes(g).start-EXTENSION, 1);
        e = min(genes(g).stop+EXTENSION, size(mask,2));
        mask(4, b:e) = mask(4, b:e) + 1;
      end
    end
  end
  fprintf('%2.2f%%\n', 100*(mean(any(mask(1:2,:)))));
  fprintf('%2.2f%%\n', 100*(mean(any(mask))));
  fprintf('saving gene mask to %s...\n', [fn_out regions(r).chr '.mat']);
  save([fn_out regions(r).chr '.mat'], 'mask');
end