function [best_prot_id,Nums] = select_protein_ident(basedir,min_prot_id)

% basedir = '/fml/ag-raetsch/share/databases/genomes/C_briggsae/briggsae_cb3_WS180/';
% min_prot_id  = [30 40 50 60 70 80];

cd ~/svn/projects/genefinding/

paths
addpath ~/svn/projects/splicing/gff/read_sequences
addpath ~/svn/projects//splicing/utils/
addpath  ~/svn/projects/genefinding/protein_alignments/

sets1= {'EST-','GR-'}
sets2= {'PR-'}

for id=min_prot_id
  if ~fexist(sprintf('%sgenebuild%iminprotcov/prot_check.mat',basedir,id))
    load(sprintf('%sgenebuild%iminprotcov/confirmed_sequences.mat',basedir,id),'genes');
    fn_config = sprintf('%sgenebuild%iminprotcov/genome.config',basedir,id);
    genome_info =init_genome(fn_config);
    genes_transform=transform(genes);
    for i=1:length(genes_transform)
      genes_transform(i).genestr = load_genomic_2(genes_transform(i).chr,genes_transform(i).original_strands(1),genes_transform(i).start-2000,genes_transform(i).stop+2000,genome_info);
    end 
    % keyboard
    Nums = check_alignments(genes_transform,sets1,sets2);
    save(sprintf('%sgenebuild%iminprotcov/prot_check.mat',basedir,id),'genes_transform','Nums')
  end
end


cnt=0;
for id=min_prot_id
  cnt=cnt+1;
  
  % load(sprintf('%sgenebuild%iminprotcov/prot_check.mat',basedir,id),'genes_transform');
  % Nums = check_ss(genes_transform,sets)
  % save(sprintf('%sgenebuild%iminprotcov/prot_check.mat',basedir,id),'-append','Nums')
  L = load(sprintf('%sgenebuild%iminprotcov/prot_check.mat',basedir,id),'Nums');
  Nums(cnt) = L.Nums;
  errors_don(cnt) =  L.Nums.num_don_errors+L.Nums.num_don-L.Nums.num_likely_don_pos;
  errors_acc(cnt) =  L.Nums.num_acc_errors+L.Nums.num_acc-L.Nums.num_likely_acc_pos;
  tp_don(cnt) = L.Nums.num_likely_don_pos;
  tp_acc(cnt) = L.Nums.num_likely_acc_pos;
  sensitivity_don(cnt) =  L.Nums.num_likely_don_pos/L.Nums.num_don;
  specificity_don(cnt) =  L.Nums.num_likely_don_pos/(L.Nums.num_likely_don_pos+ L.Nums.num_don_errors);
  sensitivity_acc(cnt) =  L.Nums.num_likely_acc_pos/L.Nums.num_acc;
  specificity_acc(cnt) =  L.Nums.num_likely_acc_pos/(L.Nums.num_likely_acc_pos+ L.Nums.num_acc_errors);
end
best_prot_id = max(mean([specificity_acc;sensitivity_acc]));


figure; plot(errors_don./tp_don)

figure; plot(min_prot_id,specificity_acc,'x-')                
hold on; plot(min_prot_id,specificity_don,'rx-')       
figure; plot(min_prot_id,sensitivity_acc,'x-')    
hold on;plot(min_prot_id,sensitivity_don,'rx-')   

figure; plot(min_prot_id,mean([sensitivity_acc;specificity_acc]))    
hold on;plot(min_prot_id,mean([sensitivity_don;specificity_don]),'rx-')  

[tmp,i]= max(mean([sensitivity_acc;specificity_acc]));
best_prot_id = min_prot_id(i);