function genes = check_genes(genes, genome_info,which_checks) ;
% genes = check_genes(genes, genome_info,which_checks) ;

% TO DO CHECK SPLICE GRAPH: 
%  CHECK if splice graoh is connected. SHOULd WORK NOW
%  
addpath ~/svn/tools/genomes/

if nargin<3 | isempty(which_checks), 
  fprintf('no checks performed\n')
  return
end

if ~isfield(which_checks,'exons_sorted')
  which_checks.exons_sorted = 1;
end ;
if ~isfield(which_checks,'intron_length')
  which_checks.intron_length = 0;
end
if ~isfield(which_checks,'exon_length')
  which_checks.exon_length = 0;
end
if ~isfield(which_checks,'splicesites');
  which_checks.splicesites = 0;
end
if ~isfield(which_checks,'orf')
  which_checks.orf = 0;
end
if ~isfield(which_checks,'gene_length')
   which_checks.gene_length = 0;
end
if ~isfield(which_checks,'graph')
  which_checks.graph = 0;
end ;
if ~isfield(which_checks,'transacc')
  which_checks.transacc = 0;
end ;
if ~isfield(which_checks,'complete')
  which_checks.complete = 0;
end ;
which_checks


num_invalid_transcripts = 0 ;
num_invalid_genes = 0 ;
num_splice_not_ok = 0 ;
num_intron_not_ok = 0 ;
num_orf_not_ok = 0 ;
num_graphs_not_ok = 0 ;
num_transacc_not_ok = 0;

genes_not_ok = [];

if isfield(genes,'transcript_valid')
  fprintf('\n')
  warning('field transcript_valid aleady exists. Will be taken into account')
end
if isfield(genes,'is_valid')
  fprintf('\n')
  warning('field is_valid aleady exists. Will be taken into account')
end
for i=1:length(genes), 
  fprintf(['gene=%i  invalid_genes=%i  invalid_transcripts=%i  ' ...
           'num_splice_not_ok=%i num_orf_not_ok=%i num_graphs_not_ok =%i num_trans_not_ok =%i \r'],...
          i,num_invalid_genes,num_invalid_transcripts , num_splice_not_ok,...
          num_orf_not_ok,num_graphs_not_ok,num_transacc_not_ok);
  
  transcript_valid = [] ;
  is_valid = 1 ;
  
  % CHECK TRANSACC CONSENSUS
  trans_not_ok = 0;
  rm_trans=[];
  if which_checks.transacc 
    [transacc,idx] = unique(genes(i).transacc);
    for trans_=transacc'
      mRNA =  load_genomic_2(genes(i).chr, char(genes(i).strand),...
                                            trans_-5, trans_+5,genome_info,1);
      if ~isequal(mRNA(4:5),'ag')% &genes(i).strand=='-';
        mRNA(2:6)
        idx=find(ismember(genes(i).transacc,trans_));
        genes(i).transacc_info
        trans_not_ok = trans_not_ok+1;
        rm_trans=[rm_trans trans_];
      end
    end
    idx=find(ismember(genes(i).transacc,rm_trans));
    if trans_not_ok
      keyboard
    end
    genes(i).transacc(idx)=[];
    genes(i).transacc_info(idx)=[];
    genes(i).transacc_conf(idx)=[];
    num_transacc_not_ok = num_transacc_not_ok+trans_not_ok; 
    
  end

  for j=1:length(genes(i).exons),


    [tmp,idx] = sort(genes(i).exons{j}(:,1)) ;
    
    genes(i).exons{j} = genes(i).exons{j}(idx,:) ;
    if ~isempty(genes(i).exons_confirmed) && ~isempty(genes(i).exons_confirmed{j})
      genes(i).exons_confirmed{j} = genes(i).exons_confirmed{j}(idx,:) ;
    end
    

    %%% CHECK BOUNDARY
    % keyboard
    boundary_not_ok=0;
    exons = genes(i).exons{j};
    if any(exons(:,1:2)<genes(i).start-1|exons(:,1:2)>genes(i).stop+1)
      keyboard
      warning('overlaying transcript found')
      boundary_not_ok=1;
    end
   
    %%% CHECK EXONS SORTED
    exons_not_ok = 0 ;
    if which_checks.exons_sorted
      [tmp,idx] = sort(genes(i).exons{j}(:,2)) ;
      if ~equal(idx',1:length(idx)), 
        fprintf('something wrong with exons\n') ;
        exons_not_ok = 1 ;
      end ;
    end
    %%% CHECK EXON LENGTH
    if which_checks.exon_length
      exon_length = genes(i).exons{j}(:,2)-genes(i).exons{j}(:,1);
      if any(exon_length<10)
	exons_not_ok = 1;
      end ;
    end

    
    %%% SPLICE SITE CONSENSUS
    splice_not_ok = 0 ;  
    
    if which_checks.splicesites & size(genes(i).exons{j},1)>1
      % if any(genes(i).exons{j}(:,1)>genes(i).exons{j}(:,2))
      %    valid_splice(1:2,1:2)=0
      % else
      [mRNA,valid_splice] =  load_genomic_2(genes(i).chr, char(genes(i).strand),...
                                              genes(i).exons{j}(:,1), ...
                                              genes(i).exons{j}(:,2),genome_info,1);
      % end
      if genes(i).strand=='+'
        splice_not_ok = sum(sum(valid_splice(2:end-1,:)')<2) + ~valid_splice(1,2)+~valid_splice(end,1);
      else
        splice_not_ok = sum(sum(valid_splice(2:end-1,:)')<2) + ~valid_splice(1,1)+~valid_splice(end,2);
      end
      if splice_not_ok
        genes_not_ok = [genes_not_ok i];
        % keyboard
      end
      num_splice_not_ok = num_splice_not_ok+splice_not_ok; 
    end
    
    %%% CHECK INTRON LENGTH
    intron_not_ok = 0 ;
    if which_checks.intron_length
      intron_length = genes(i).exons{j}(2:end,1)-genes(i).exons{j}(1:end-1,2);
      if any(intron_length>genome_info.max_intron_len)|...      
            any(intron_length<genome_info.min_intron_len)
        
        fprintf('\nintron lenghts: %i - %i \n',min(intron_length),max(intron_length)) ;
        intron_not_ok = sum(intron_length>genome_info.max_intron_len |...
                            intron_length<genome_info.min_intron_len);
      end ;
      num_intron_not_ok = num_intron_not_ok+intron_not_ok; 
    end
    transcript_valid(j) = ~any([exons_not_ok splice_not_ok intron_not_ok boundary_not_ok]);
  end %%loop over exons
  
  %%% CHECK ORF
  for j=1:length(genes(i).cds_exons), 
    orf_not_ok = 0 ;
    if which_checks.orf ,
      cds_exons = genes(i).cds_exons{j};
      if isempty(cds_exons), continue; end
      if genes(i).strand=='+'
        if ~isempty(genes(i).tis)
          if ~(genes(i).tis(j)==cds_exons(1,1)),
            warning('this was an assert') ;
            transcript_valid(j) =0;
            keyboard
            continue ;
          end ;
        end
        if ~isempty(genes(i).cdsStop)
          if ~(genes(i).cdsStop(j)==cds_exons(end,2)-3),
            warning('this was an assert') ;
            transcript_valid(j) =0;
            keyboard ;
            continue ;
          end ;
        end
        cds_exons(:,2) = cds_exons(:,2)-1;
      else
        if ~isempty(genes(i).tis)
          assert(genes(i).tis(j)==cds_exons(end,2))
        end
        if ~isempty(genes(i).cdsStop) 
          assert(genes(i).cdsStop(j)==cds_exons(1,1)+3);
        end
        cds_exons(:,1) = cds_exons(:,1)+1;
      end
      [cds,valid_splice] =  load_genomic_2(genes(i).chr, char(genes(i).strand),cds_exons(:,1),cds_exons(:,2),genome_info,1);
      f = find_open_frames(cds,1) ;

      % if first (last) cds_exon is smaler than 3 the start (stop) codon is 
      % spliced together, thus we will not have predictions for it
      too_short = cds_exons(1,2)-cds_exons(1,1)+1<3||cds_exons(end,2)-cds_exons(end,1)+1<3;
      if mod(length(cds),3)~=0 || f(1)~=1 || isempty(cds) || any(cds(1:3)~='atg') || ~any(ismember({'taa', 'tag', 'tga'}, cds(end-2:end)))|| too_short
        % if  mod(length(cds),3)~=0 || any(cds(1:3)~='atg') || ~any(ismember({'taa', 'tag', 'tga'}, cds(end-2:end)))
        orf_not_ok(j) = 1 ;
        transcript_valid(j) =0;
        warning('invalid transcript') ;
        keyboard
      end ;
      num_orf_not_ok  = num_orf_not_ok+sum(orf_not_ok);
    end
  end ; %% loop over cds_exons
  num_invalid_transcripts = num_invalid_transcripts + sum(~transcript_valid);
  if isfield(genes(i),'transcript_valid')&~isempty(genes(i).transcript_valid)
    genes(i).transcript_valid = genes(i).transcript_valid.*transcript_valid ;  
  else
    genes(i).transcript_valid = transcript_valid ;
  end
    
  %%% check genes length (only the region of the valid transcripts)
  length_not_ok = 0;
  if which_checks.gene_length,
    starts = [] ;
    ends = [] ;
    for j=1:length(genes(i).exons),
      if genes(i).transcript_valid(j)&~isempty(genes(i).exons{j})
        starts(end+1)= genes(i).exons{j}(1,1) ;
        ends(end+1)  = genes(i).exons{j}(end,2) ;
      end ;
    end ;
    if max(ends)-min(starts)>genome_info.max_intron_len*10,
      % fprintf('gene length: %i\n', max(ends)-min(starts)) ;
      length_not_ok = 1;
    end ;
  end
  
  %%% splicegraph
  graph_not_ok = 0;
  if which_checks.graph &isfield(genes,'splicegraph'), 
    edges = genes(i).splicegraph{2} ;
    if ~isequal(edges,0)
      ss = 0 ;
      for e=1:size(edges,1), 
        ss=ss+edges^e ; 
      end ; 
      if any(ss==0)
        graph_not_ok = 1;
        % viewsplicegraph(genes(i))
        % keyboard
      end
      num_graphs_not_ok = num_graphs_not_ok+graph_not_ok ;
    end
  end
  if ~isfield(genes(i),'is_valid')|isempty(genes(i).is_valid)
    genes(i).is_valid = 1;
  end    
  genes(i).is_valid = genes(i).is_valid&any(genes(i).transcript_valid)&~length_not_ok&...
      ~graph_not_ok& ~isempty(genes(i).exons);
  
  num_invalid_genes = num_invalid_genes + ~genes(i).is_valid; 
  
end ; %%loop over genes


if which_checks.complete
  for i=1:length(genes),
    for k=1:length(genes(i).transcripts)
      complete = 1;

% does not work since exons can be split into a cds and a utr part      
%      intersection = intersect(genes(i).cds_exons,genes(i).exons,'rows');
%      if ~(size(intersection,1)==size(genes(i).cds_exons,1)
%        error('adsfadfasdf')
%      end
%      intersection = intersect(genes(i).utr3_exons,genes(i).exons,'rows');
%      if ~(size(intersection,1)==size(genes(i).utr3_exons,1)
%        error('adsfadfasdf')
%      end
%      intersection = intersect(genes(i).utr5_exons,genes(i).exons,'rows');
%      if ~(size(intersection,1)==size(genes(i).utr5_exons,1)
%        error('adsfadfasdf')
%      end
%      clear intersection
      if length(genes(i).cds_exons)<k||isempty(genes(i).cds_exons{k})
        complete = 0;
      end
      if length(genes(i).utr3_exons)<k||isempty(genes(i).utr3_exons{k})
        complete = 0;
      end
      if length(genes(i).utr5_exons)<k||isempty(genes(i).utr5_exons{k})
        complete = 0;
      end
      if ~isempty(genes(i).tis)
        if length(genes(i).tis)<k||~(genes(i).tis(k)>=genes(i).start&genes(i).tis(k)<=genes(i).stop)
          complete = 0;
        end
      else
        complete = 0;
      end

      if ~isempty(genes(i).cdsStop)
        if length(genes(i).cdsStop)<k||~(genes(i).cdsStop(k)>=genes(i).start&genes(i).cdsStop(k)<=genes(i).stop)
          complete=0;
        end
      else
        complete = 0;
      end
    
      if isempty(genes(i).tss)|| length(genes(i).tss)<k||length(genes(i).tis)<k||genes(i).tss(k)==genes(i).tis(k)
        complete = 0;
      end
      
      if isempty(genes(i).cleave)|| length(genes(i).cleave)<k||length(genes(i).cdsStop)<k||genes(i).cleave(k)==genes(i).cdsStop(k)
        complete = 0;
      end
      
      for j=1:length(genes(i).exons),
        assert(all(all(genes(i).exons{j}(:,1:2)>=genes(i).start&genes(i).exons{j}(:,1:2)<=genes(i).stop)))
      end
      
      genes(i).transcript_complete(k) = complete&genes(i).transcript_valid(k);
    end
    if ~any(genes(i).transcript_complete)
      %keyboard
    end
    genes(i).is_complete = any(genes(i).transcript_complete);
  end
end


