function blocks = make_blocks_from_genes(genes)

fn_config = '/fml/ag-raetsch/share/databases/genomes//F_graminearum/F_graminearumOct2007/genebuild_noproteins/genome.config';
genome_info = init_genome(fn_config);
marg = 2000;
min_dist = 100;

%blocks = genes;
blocks = struct('strand',{genes.strand},'chr',{genes.chr},'chr_num',{genes.chr_num},'start',{genes.start},...
		'stop',{genes.stop},'gene_ids',{genes.id},'paralogs',{genes.paralogs},'is_alt',{genes.is_alt},...
		'gene_complete',{genes.is_complete}, 'config' ,fn_config )




% ADJUST BOUNDARIES
for j=1:length(blocks)
  blocks(j).gene_ids = genes(j).id;
  blocks(j).paralogs = [];
  blocks(j).gene_status = max(genes(j).transcript_status); 
  blocks(j).id = j; 
  if blocks(j).start<1
    keyboard
  end
  flat_fn = genome_info.flat_fnames{blocks(j).chr_num};
  d = dir(flat_fn);
  len = d.bytes;
 
  if blocks(j).stop+marg<=len
    blocks(j).stop=blocks(j).stop+marg;
  else
    assert(blocks(j).stop<=len)
    blocks(j).stop=len;
  end
  if blocks(j).start-marg>1
    blocks(j).start=blocks(j).start-marg;
  else
    assert(blocks(j).start>=1)
    blocks(j).start=1;
  end
end


% MERGE BLOCKS
len = length(blocks)
for s='+-'
  strands = [blocks.strand];
  str_blocks = blocks(strands==s);
  x = unique({str_blocks.chr});
  for c = 1:length(x)
    c_idx = find(strcmp({str_blocks.chr},x(c)));
    contig_blocks = str_blocks(c_idx);
    %keyboard
    starts = [contig_blocks.start];
    stops  = [contig_blocks.stop];
    [starts sort_idx] = sort(starts);
    stops = stops(sort_idx);
    contig_blocks = contig_blocks(sort_idx);
    dist = starts(2:end)-stops(1:end-1);
    merge_idx = find(dist<min_dist);
   
    rm_idx = [];
    for j=merge_idx;
      contig_blocks(j+1)=merge(contig_blocks(j),contig_blocks(j+1));
      %keyboard
      rm_idx = [rm_idx j];
    end 
    contig_blocks(rm_idx) = []; 
    blocks(c_idx) = [];
    blocks = [blocks contig_blocks];
  end
end
len = length(blocks)


for j=1:length(blocks)
  blocks(j).id = j;
  off = [blocks(j).start-1 blocks(j).stop+1];
  blocks(j).offset = off((blocks(j).strand=='-')+1); 
end

return
function block = merge(block1,block2)
  block = block1;
  block.gene_ids = [block1.gene_ids block2.gene_ids];
  block.paralogs = unique([block1.paralogs block2.paralogs]);
  block.gene_status = [block1.gene_status block2.gene_status];
  block.start = min([block1.start block2.start]);
  block.stop = max([block1.stop block2.stop]);
return


