function genes2  = map_two_genes_structures(genes1, genes2, genome_info)
%
% genes2  = map_two_genes_structures(genes1, genes2, genome_info)
%
% merges two genes structrures; fields of genes 1 are used
% calls merge_transcripts_by_colocation
  
genes2  = convert_struct(genes1, genes2);

if length(genes1)>1
  genes2 = [genes1 genes2];
end
genes2 = merge_transcripts_by_colocation(genes2, genome_info);
genes2 = rmfield(genes2,'gene_merged');

clear genes1

for i=1:length(genes2)
  
  for j=1:length(genes2(i).transcripts)
    exons = genes2(i).exons{j};
    genes2(i).start = min(genes2(i).start, min(min(exons)));
    genes2(i).stop =  max(genes2(i).stop, max(max(exons)));
  end
end

%fprintf(1,'\nnumber of genes1 not covered by genes2: %i\n ',not_found )
%fprintf(1,'\nnumber of new genes2: %i\n ',length(idx2_unused))
