function genes = prepare_genes_struct(genes,genome_info,PAR,type)

%  genes = prepare_genes_struct(genes,genome_info,PAR,type)
%  type could be 'anno', 

if isequal(type,'anno')
  cds_info = getfield(PAR.info_genes.cds,type);
  transcript_info = getfield(PAR.info_genes.transcript,type);
end
num = 0;


for i=1:length(genes)
  fprintf(1,'%i\r',num); num=num+1;
  if ~isfield(genes(i),'chr')|isempty(genes(i).chr)
    genes(i).chr = genome_info.contig_names{genes(i).chr_num};
  end
   
  if ~isfield(genes(i),'chr_num')|isempty(genes(i).chr_num)
    genes(i).chr_num =  strmatch(genes(i).chr,genome_info.contig_names,'exact') ;
  end
  
  if ~isfield(genes(i),'strand')|isempty(genes(i).strand)
    genes(i).strand = genes(i).strands(1) ;
  end
 
  if ~isfield(genes(i),'id')
    genes(i).id=i;
  end
  for j = 1:length(genes(i).transcripts)
    genes(i).exons{j}=genes(i).exons{j}(:,1:2);
  end
  if ~isfield(genes(i),'transcript_info')|isempty(genes(i).transcript_info)
    if isfield(genes,'is_cDNA')
      assert(length(genes(i).is_cDNA)==length(genes(i).transcripts));
      genes(i).transcript_info = genes(i).is_cDNA;
      assert(PAR.info_genes.transcript.cDNA==1);
      assert(PAR.info_genes.transcript.est==0);
    else
      genes(i).transcript_info = ones(1,length(genes(i).transcripts)).*transcript_info;
    end
  end
  if ~isfield(genes(i),'transcript_valid')|isempty(genes(i).transcript_valid)
    genes(i).transcript_valid = ones(1,length(genes(i).transcripts)) ;
  end
  
  if ~isfield(genes(i),'exons_confirmed')|isempty(genes(i).exons_confirmed)
    genes(i).exons_confirmed = cell(1,size(genes(i).exons,2));
  end
  
  if isequal(type,'anno')&isfield(genes(i),'cds_exons')&PAR.label_source.cds.anno
   if (~isfield(genes,'tis')|isempty(genes(i).tis))
      for j = 1:length(genes(i).transcripts)
        if ~isempty(genes(i).cds_exons{j})
          genes(i).tis(j,1) =  min(min(genes(i).cds_exons{j}(:,1:2)));
          genes(i).Stop(j,2) =  max(max(genes(i).cds_exons{j}(:,1:2)));
          
          genes(i).tis_info(j) =  cds_info ;
          genes(i).Stop_info(j)=  cds_info ;
          genes(i).tis_conf(j) =  1;
          genes(i).Stop_conf(j) =  1;
        end
      end
    end 
    if 0%(~isfield(genes,'cds')|isempty(genes(i).cds))
      for j = 1:length(genes(i).transcripts)
        if ~isempty(genes(i).cds_exons{j})
          genes(i).cds(j,1) =  min(min(genes(i).cds_exons{j}(:,1:2)));
          genes(i).cds(j,2) =  max(max(genes(i).cds_exons{j}(:,1:2)));
          
          genes(i).cds_info(j) =  cds_info ;
          genes(i).cds_conf(j) =  1;
        end
      end
    end
    
  end
  assert(all(size(genes(i).transcripts)==size(genes(i).transcript_info)))
  assert(all(size(genes(i).transcripts)==size(genes(i).transcript_valid)))
  assert(all(size(genes(i).transcripts)==size(genes(i).exons)))
  assert(all(size(genes(i).transcripts)==size(genes(i).exons_confirmed)))
  
end
