function genes_diff = find_genes_diff(res,genes_anno,genes_pred)
% function genes_diff = find_genes_diff(res,genes_anno,genes_pred)
%
% Find the genes which differ at the exon level.

genes_ME_idx = res.cds_exons.ME_gene_id;
assert(all(genes_ME_idx==[genes_anno(genes_ME_idx).id]));
genes_WE_idx = res.cds_exons.WE_gene_id;
assert(all(genes_WE_idx==[genes_pred(genes_WE_idx).id]));

genes_ME = genes_anno(genes_ME_idx);
genes_WE = genes_pred(genes_WE_idx);

genes_diff = genes_union(genes_ME,genes_WE);
