function genes_stats = get_gene_charcteristics(genes,genome_info) 
%  genes_stat = get_gene_charcteristics(genes)
  
  
  

genes_stats.num_genes = length(genes);
genes_stats.invalid = sum([genes.is_valid]==0);
genes_stats.num_cdsExons = zeros(1,length(genes));
genes_stats.length_cdsExons = -ones(1,length(genes).*200);
genes_stats.length_cdsIntrons = -ones(1,length(genes).*200);

genes_stats.length_cds = -ones(1,length(genes));
genes_stats.length_utr5 = -ones(1,length(genes));
genes_stats.length_utr3 = -ones(1,length(genes));
genes_stats.length_intergenic = zeros(1,length(genes));

for j=1:length(genes)
  if (mod(j,100)==0), 
    fprintf('%i/%i\r',j,length(genes))
  end
  gene = genes(j);
  cds_exons =  gene.cds_exons{1};
  
  genes_stats.num_cdsExons(j) = size(cds_exons,1); 
  genes_stats.length_cdsExons((j-1)*200+[1:size(cds_exons,1)]) = cds_exons(:,2)- cds_exons(:,1);
  genes_stats.length_cdsIntrons((j-1)*200+[1:size(cds_exons,1)-1]) = cds_exons(2:end,1)- cds_exons(1:end-1,2);
  genes_stats.length_cds(j) = sum(cds_exons(:,2)- cds_exons(:,1));
  
  if ~isempty(gene.tis)&~isempty(gene.tss)
    genes_stats.length_utr5(j) = abs(gene.tss(1)-gene.tis(1));
  end
  genes_stats.length_utr3(j) = abs(gene.cleave(1)-gene.cdsStop(1));
end

genes_stats.length_cdsExons(genes_stats.length_cdsExons==-1)=[];
genes_stats.length_cdsIntrons(genes_stats.length_cdsIntrons==-1)=[];


%%get intergenic distance
CHR = unique([genes.chr_num]);
STR = '+-';
num = 0;
fprintf('\ngetting intergenic distances\n')
numtot = 0;
chr_nums = [genes.chr_num];
strands = [genes.strand];
for c=CHR
  num=num+1;
  if (mod(num,100)==0), 
    fprintf('%i/%i\r',num,length(CHR))
  end
  for s=STR
    idx = find(chr_nums==c&strands==s);
    if s=='+'
      [starts,ii1] = sort([genes(idx).start]);
      stops = [genes(idx).stop];
      stops = stops(ii1);
      if length(starts)>1
        genes_stats.length_intergenic(numtot+[1:length(starts)-1]) = starts(2:end)-stops(1:end-1);
        numtot = numtot+length(starts)-1;
      end
    else
      [starts,ii1] = sort([genes(idx).stop]);
      stops = [genes(idx).start];
      stops = stops(ii1);
      if length(starts)>1
        genes_stats.length_intergenic(numtot+[1:length(starts)-1]) = stops(2:end)-starts(1:end-1);
        numtot = numtot+length(starts)-1;
      end
    end
  end
end
genes_stats.length_intergenic = genes_stats.length_intergenic(1:numtot );


fd=1;

CHR = genome_info.contig_names;
total_bp = 0;
for i=1:length(CHR)
  d=dir(genome_info.flat_fnames{i}) ;
  total_bp = total_bp + d(1).bytes;
end ;
fprintf(fd,'\n\n')

fprintf(fd,['No of contigs & Genome size & No of genes & No exons/gene & ' ...
            'Exon length & Intron length & ORF length \n'])

fprintf(fd,'%i & %.2f & %i & %.1f & %.1f & %.1f & %.1f  \n',...
        length(genome_info.contig_names),...
        total_bp/1e6,...
        genes_stats.num_genes,...
        median(genes_stats.num_cdsExons),...
        median(genes_stats.length_cdsExons),...
        median(genes_stats.length_cdsIntrons),...
        median(genes_stats.length_cds));


fprintf(fd,'%i & %.2f & %i & %.1f & %.1f & %.1f & %.1f  \n',...
        length(genome_info.contig_names),...
        total_bp/1e6,...
        genes_stats.num_genes,...
        mean(genes_stats.num_cdsExons),...
        mean(genes_stats.length_cdsExons),...
        mean(genes_stats.length_cdsIntrons),...
        mean(genes_stats.length_cds));
