function pred_genes = read_gene_predictions()

source = 'Genefinder'
  
addpath ../data/
addpath ../../splicing/utils/
addpath ../../splicing/splicegraphs/
addpath ../../splicing/splicegraphs/detect_altsplice/

genome_info = init_genome('genome.config') ;

annotation_fname = '/fml/ag-raetsch/share/databases/elegans_WS160/elegansWS160_CHROMOSOME.gff';
genes = parse_gene_pred_from_gff_file(annotation_fname,source)

% filter only genes with valid introns and other properties
[valid_genes,all_genes] = check_genes(genes, genome_info);

% build splicegraphs
genes = valid_genes;
build_splice_graph
infer_splice_graph
fprintf('Sorting exons...\n');
for i=1:length(genes)
  [dummy,exon_order] = sort(genes(i).splicegraph{1}(1,:),2,'ascend');
  genes(i).splicegraph{1} = genes(i).splicegraph{1}(:,exon_order);
  genes(i).splicegraph{2} = genes(i).splicegraph{2}(exon_order,exon_order);
end
valid_genes = alt_const(genes);

genes = all_genes;
build_splice_graph
infer_splice_graph
fprintf('Sorting exons...\n');
for i=1:length(genes)
  [dummy,exon_order] = sort(genes(i).splicegraph{1}(1,:),2,'ascend');
  genes(i).splicegraph{1} = genes(i).splicegraph{1}(:,exon_order);
  genes(i).splicegraph{2} = genes(i).splicegraph{2}(exon_order,exon_order);
end
all_genes = alt_const(genes);

res_file = ['/fml/ag-raetsch/share/projects/nGASP/gene_finders/' ...
            source '_pred_complete.mat'];
save(res_file, 'valid_genes', 'all_genes');

pred_genes = all_genes;
