function genes2 = map_genes_different_config(genes1,fn_config1,fn_config2,maps,field_names,backwards)

if nargin<5
  field_names = {'exons','cds_exons','utr5_exons','utr3_exons','tis','cdsStop','transacc','tss','cleave','polya'};
end

if nargin<6
  backwards=0;
end

genome_info1 = init_genome(fn_config1) ; 
genome_info2 = init_genome(fn_config2) ; 

CHR1 = genome_info1.contig_names;
CHR2 = genome_info2.contig_names;

% maps = read_map(fn_map,genome_info1,genome_info2);

genes_taken = [];
genes2(length(genes1)+1) = genes1(1);
genes2(length(genes1)+1) = [];
cnt_genes=0;

for i=1:length(CHR1);
  fprintf('chr %i(%i)\r',i,length(CHR1))
  map = maps(i);
  assert(all(map.chr_num1==i))
  if ~backwards
    idx1 = find([genes1.chr_num]==i);
    assert( all(strcmp({genes1(idx1).chr},CHR1{i})) );
    for j=1:length(map.start1)
      idx2 = find([genes1(idx1).start]>=map.start1(j)&[genes1(idx1).stop]<=map.stop1(j));
      assert(isempty(intersect(idx1(idx2),genes_taken)))
      offset = map.start2(j) -map.start1(j);
      
      for k=idx2
        cnt_genes=cnt_genes+1;
        genes2(cnt_genes) = genes1(idx1(k));
        genes2(cnt_genes).chr = map.chr2{j};
        genes2(cnt_genes).chr_num = map.chr_num2(j);
        genes2(cnt_genes).start = genes2(cnt_genes).start +offset ;
        genes2(cnt_genes).stop = genes2(cnt_genes).stop +offset ;
        assert(genes2(cnt_genes).start>0)
        assert(genes2(cnt_genes).stop>genes2(cnt_genes).start)
        genes2(cnt_genes) =  map_exons(genes2(cnt_genes),field_names,offset);
        if isfield(genes2(cnt_genes),'splicegraph')
          genes2(cnt_genes).splicegraph{1} =  genes2(cnt_genes).splicegraph{1} +offset;
        end
      end
      assert(isempty(intersect(idx1(idx2),genes_taken)))
      genes_taken = [genes_taken idx1(idx2)];
    end
  else
    % keyboard
    idx1 = find(ismember([genes1.chr_num],map.chr_num2));
    for j=idx1
      idx2 =  find(map.chr_num2==genes1(j).chr_num);
      assert(length(idx2)==1)
      assert(genes1(j).start>=map.start2(idx2)&genes1(j).stop<=map.stop2(idx2));
      offset = map.start1(idx2) -map.start2(idx2);
      cnt_genes=cnt_genes+1;
      
      genes2(cnt_genes) = genes1(j);
      genes2(cnt_genes).chr = map.chr1{idx2};
      genes2(cnt_genes).chr_num = map.chr_num1(idx2);
      genes2(cnt_genes).start = genes2(cnt_genes).start +offset ;
      genes2(cnt_genes).stop = genes2(cnt_genes).stop +offset ;
      assert(genes2(cnt_genes).start>0)
      assert(genes2(cnt_genes).stop>genes2(cnt_genes).start)
      genes2(cnt_genes) =  map_exons(genes2(cnt_genes),field_names,offset);
      if isfield(genes2(cnt_genes),'splicegraph')
        genes2(cnt_genes).splicegraph{1} =  genes2(cnt_genes).splicegraph{1} +offset;
      end
      assert(isempty(intersect(j,genes_taken)))
      genes_taken = [genes_taken j];
    end
  end
end
% keyboard
if ~isempty(setdiff([1:length(genes1)],genes_taken))
  warning('some genes not found')
end
genes2 = genes2(1:cnt_genes);

function genes = map_exons(genes,field_names,offset)
    
for i=1:length(field_names)
  if ~isfield(genes,field_names{i})
    continue
  end
  if iscell(genes.(field_names{i}))
    for j=1:length(genes.(field_names{i}))
      if ~isempty(genes.(field_names{i}){j})
        genes.(field_names{i}){j}(:,1:2) = genes.(field_names{i}){j}(:,1:2)+offset;
        assert(all(all(genes.(field_names{i}){j}(:,1:2)>=0)))
      end
    end
  else
    genes.(field_names{i}) = genes.(field_names{i})+offset;
    assert(all(genes.(field_names{i})(:)>=0))
  end
end