
  
%addpath /fml/ag-raetsch/share/software/matlab_tools/shogun
addpath ~/svn/projects/genefinding/lsl
addpath ~/svn/projects/genefinding/utils
addpath ~/svn/projects/genefinding/viz
addpath ~/svn/projects/genefinding/eval

PAR=[] ;
predictor_genome_config


unix(sprintf('mkdir -p %s/log_files', PAR.dir)) ;
unix(sprintf('mkdir -p %s/test_data', PAR.dir)) ;
unix(sprintf('mkdir -p %s/test_predictions/%s-%s', PAR.dir, PAR.user, PAR.dt)) ;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%% generate blocks
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if isfield(PAR, 'iteration')
  fn_train  = sprintf('%s_iteration%i.mat',PAR.fn_train,PAR.iteration)
else
  fn_train  = sprintf('%s_iteration10.mat',PAR.fn_train)
end
load(fn_train ,'TRAIN_PAR') ;


PAR.model = TRAIN_PAR.model;
PAR.use_annotation =0;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%% predict
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

PAR.RPROC.MEMREQ = 2500;
PAR.RPROC.options = [];
PAR.RPROC.options.arch = 64 ;
PAR.RPROC.options.express = 0 

PAR.cleave_offset = 7 ;
PAR.regenerate_seq = 1 ;

fdir = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/lsl/cat-1/data/' ;
fnames={'test_region_I+_2007-08-31corrected.mat', 'test_region_I-_2007-08-31corrected.mat', ...
        'test_region_II+_2007-08-31corrected.mat', 'test_region_II-_2007-08-31corrected.mat', ...
        'test_region_III+_2007-08-31corrected.mat', 'test_region_III-_2007-08-31corrected.mat', ...
        'test_region_IV+_2007-08-31corrected.mat', 'test_region_IV-_2007-08-31corrected.mat', ...
        'test_region_V+_2007-08-31corrected.mat', 'test_region_V-_2007-08-31corrected.mat', ...
        'test_region_X+_2007-08-31corrected.mat', 'test_region_X-_2007-08-31corrected.mat'} ;
mdir = '/fml/ag-raetsch/share/projects/genefinding/C_elegans/genome_data/' ;
mnames = {'gene_mask_I.mat', 'gene_mask_II.mat', 'gene_mask_III.mat', 'gene_mask_IV.mat', 'gene_mask_V.mat', 'gene_mask_X.mat'} ;

jobinfo = rproc_empty(0) ;
for i=1:length(fnames),
  i
  PAR.id = i ;
  PAR.fn_blocks = [fdir fnames{i}] ;
  PAR.fn_mask = [mdir mnames{ceil(i/2)}] ;
  PAR.fn_pred = sprintf('%s/test_predictions/%s-%s/pred_contig_corrected%i', PAR.dir, PAR.user, PAR.dt, PAR.id);
  PAR.fn_pred_cleave = [PAR.fn_pred sprintf('_cleave%1.2f.mat', PAR.cleave_offset)] ;
  if ~fexist(PAR.fn_pred_cleave),
    jobinfo(i) = rproc('pred_path_cleave_genome', PAR, 12000, [], 20*60) ;
    %addpath ~/shogun/trunk/src
    %pred_path_cleave_genome(PAR) ;
  end ;
end ;

return

num_genes = [];
for id=1:12,
  PAR.id=id ;
  PAR.cleave_offset=7 ;
  num_genes_contig(id)=0 ;
  for i=1:30,
    fn_pred = sprintf('%s/test_predictions/%s-%s/pred_contig_corrected%i_viterbi_block%i_cleave%1.2f.mat', PAR.dir, PAR.user, PAR.dt, PAR.id, i, PAR.cleave_offset);
    L=load(fn_pred);
    if ~all(all(all(L.pred.segments(:,1:2)~=0))), keyboard; end;
    %if length(L.pred.genes)<10, keyboard ; end ;
    num_genes(end+1) = length(L.pred.genes) ;
    num_genes_contig(id) = num_genes_contig(id)+length(L.pred.genes) ;
  end ; 
end ;
sum(num_genes)
