%addpath /fml/ag-raetsch/share/software/matlab_tools/shogun  

addpath ~/svn/projects/genefinding/lsl
addpath ~/svn/projects/genefinding/utils
addpath ~/svn/projects/genefinding/eval

load PAR_pac_loss_C=1_final_sol10_cor.mat


PAR.dir = ['/fml/ag-raetsch/share/projects/genefinding/P_pacificus/lsl/' PAR.exp_name ,'/'];

PAR.fn_blocks_pre = [PAR.dir '/data/genome_blocks.mat'] ;     

PAR.RPROC.MEMREQ = 4000;
PAR.RPROC.options = [];
PAR.RPROC.options.arch = 64 ;
PAR.RPROC.options.express = 0 ;
PAR.exm_per_batch = 1 ;

PAR.fn_init =  sprintf('%strain/%s-%s/init.mat',PAR.dir,PAR.user,PAR.dt);
PAR.fn_train = sprintf('%strain/%s-%s/train',PAR.dir,PAR.user,PAR.dt);
PAR.fn_log = sprintf('%slog_files/%s_%s_log_',PAR.dir,PAR.user,PAR.dt);


unix(sprintf('mkdir -p %strain/%s-%s', PAR.dir,PAR.user,PAR.dt)) ;
unix(sprintf('mkdir -p %spredictions/%s-%s', PAR.dir,PAR.user,PAR.dt)) ;

PAR=rmfield(PAR, 'fn_splits') ;

load(PAR.fn_blocks_pre) ;
blocks_pre = blocks ;

cleave_offset = 15 ;

PAR.submit=0 ;
jobinfo = rproc_empty(0) ;
num=0 ;
for i=400%length(blocks_pre):-1:1
  fprintf('%i\r', i) ;

  PAR.fn_blocks = sprintf('%s/data/genome_blocks_final_%i.mat', PAR.dir, i) ;
  %PAR.fn_pred = sprintf('%spredictions/%s-%s/pred_genome_%i',PAR.dir,PAR.user,PAR.dt, i);
  PAR.fn_pred = sprintf('%spredictions/%s-%s/tmp_pred_genome_%i_cleave=%1.1f', ...
                        PAR.dir, PAR.user, PAR.dt, i, cleave_offset);
  PAR.fn_pred_final = sprintf('%spredictions/%s-%s/tmp_pred_genome_%i_cleave=%1.1f_cleave%1.2f', ...
                              PAR.dir, PAR.user, PAR.dt, i, cleave_offset, cleave_offset);
  
  if ~fexist(PAR.fn_blocks),
    blocks_pre(i).gene_confirmed=zeros(1,1) ;
    blocks_pre(i).content.subset_id=1;
    blocks_pre(i).genestr = upper(blocks_pre(i).genestr) ;
    idx = find(blocks_pre(i).genestr~='A' & blocks_pre(i).genestr~='C' & ...
               blocks_pre(i).genestr~='G' & blocks_pre(i).genestr~='T') ;
    blocks_pre(i).genestr(idx) = 'A' ;
    block = blocks_pre(i) ;
    block.id = i ;
    [block.seq, block.pos] = gen_seq(blocks_pre(i), PAR.model);
    
    blocks=block ;
    save(PAR.fn_blocks, 'blocks', '-v7.3') ;
  end ;

  PAR.cleave_offset = cleave_offset ;
  if 1%~fexist([PAR.fn_pred_final '.mat']),
    i
    %jobinfo(end+1)=rproc('pred_path_cleave', PAR, 2000, [], 20*60) ;
    pred_path_cleave(PAR) ;
    num=num+1 ;
  end ;
end ;


num
