function res = check_example_fasta_file(fn_fasta, fn_trivial_regions, fn_config)
% res = check_example_fasta_file(fn_fasta, fn_trivial_regions)
% checks only one position out of thousand

load(fn_trivial_regions, 'trivial_regions')

%overwrite the config file since the dir has been moved
[trivial_regions.config] = deal(fn_config);

%trivial_regions = load_sequence(trivial_regions);
fd = fopen(fn_fasta, 'r');
offset = 199;
j = 0;
while ~feof(fd)
  j = j+1;
  line = fgetl(fd);
  XT = fgetl(fd);
  if mod(j,1000)==1, fprintf(1,'%i \r',j);
    line(line==',')='';
    elems = textscan(line,'> chr_num=%f strand=%s position=%f label=%f');
    chr_num = elems{1};
    strand = elems{2};
    position = elems{3};
    label = elems{4};
    strand_region_idx = findstr([trivial_regions.strand],strand{1});
    chr_region_idx = find([trivial_regions.chr_num] == chr_num);
    region = trivial_regions(intersect(strand_region_idx,chr_region_idx));
    region = load_sequence(region);
    assert(length(region)==1)
    true_pos = findstr(XT,region.seq)+offset;
    if strmatch(strand,'-')
       true_pos = length(region.seq)-true_pos+1;
    end
    assert(ismember(position,true_pos))
  end
end
res = 1;
 
