function genes = filter_unspliced_dna(genes)
% if there are any introns, remove all unspliced exons.

num_removed = 0;
for ix = 1:length(genes)
  % --- check for introns
  have_intron = 0;
  ix2 = 1;
  while ix2 <= length(genes(ix).exons)
    if size(genes(ix).exons{ix2},1) > 1
      have_intron = 1;
      break;
    end
    ix2 = ix2 + 1;
  end
  
  % --- if there are introns, remove unspliced exons
  if have_intron
    unspliced_list = [];
    for ix2 = 1:length(genes(ix).exons)
      if size(genes(ix).exons{ix2},1) == 1
	unspliced_list(end+1) = ix2;
      end
    end
    if ~isempty(unspliced_list)
      num_removed = num_removed + length(unspliced_list);
      genes(ix).transcripts(unspliced_list) = [];
      genes(ix).exons(unspliced_list) = [];
      genes(ix).exons_confirmed(unspliced_list) = [];
      genes(ix).strands(unspliced_list) = [];
      genes(ix).terminal_info(:,unspliced_list) = [];
    end
  end
end

fprintf(1,'Removed %d transcripts\n',num_removed);
