function gene_idx = split_genes(genes)
% gene_idx = split_genes(genes)

gene_idx=[] ;

rand('seed', 9873248923734) ;

% constitutive splicing

has_cDNA_idx = find([genes(:).has_cDNA] & ~[genes(:).is_alt] & [genes(:).is_valid]) ;
idx1 = randperm(length(has_cDNA_idx)) ;
only_EST_idx = find(~[genes(:).has_cDNA] & ~[genes(:).is_alt] & [genes(:).is_valid]) ;
idx2 = randperm(length(only_EST_idx)) ;

% training of splice sites & content sensors
gene_idx{1,1} = [only_EST_idx(idx2)] ;

% training of label sequence learning
gene_idx{2,1} = [has_cDNA_idx(idx1(1:floor(length(idx1)*0.4)))] ;

% validation of label sequence learning
gene_idx{3,1} = [has_cDNA_idx(idx1(floor(length(idx1)*0.4+1):floor(length(idx1)*0.6)))] ;

% test set for label sequence learning
gene_idx{4,1} = [has_cDNA_idx(idx1(floor(length(idx1)*0.60+1):end))] ;


% alternative splicing

has_cDNA_idx = find([genes(:).has_cDNA] & [genes(:).is_alt] & [genes(:).is_valid]) ;
idx1 = randperm(length(has_cDNA_idx)) ;
only_EST_idx = find(~[genes(:).has_cDNA] & [genes(:).is_alt] & [genes(:).is_valid]) ;
idx2 = randperm(length(only_EST_idx)) ;

% training of splice sites & content sensors
gene_idx{1,2} = [only_EST_idx(idx2)] ;

% training of label sequence learning
gene_idx{2,2} = [has_cDNA_idx(idx1(1:floor(length(idx1)*0.4)))] ;

% validation of label sequence learning
gene_idx{3,2} = [has_cDNA_idx(idx1(floor(length(idx1)*0.4+1):floor(length(idx1)*0.6)))] ;

% test set for label sequence learning
gene_idx{4,2} = [has_cDNA_idx(idx1(floor(length(idx1)*0.60+1):end))] ;

