#!/bin/tcsh

if ( -d ~/svn/projects/splicing/gff/bin )  set path=( ~/svn/projects/splicing/gff/bin $path)
if ( -d ~/svn/projects/splicing/gff/scripts )  set path=( ~/svn/projects/splicing/gff/scripts $path)

if ( -d ~/projects/splicing/gff/bin )  set path=( ~/projects/splicing/gff/bin $path)
if ( -d ~/projects/splicing/gff/scripts )  set path=( ~/projects/splicing/gff/scripts $path)

setenv BASEDIR    `list_files basedir $1`
setenv GENOMEDIR  "$BASEDIR/genome"

foreach i (`list_contigs flat__fasta $1`)
  #echo $i
  setenv j `echo $i| sed "s/__/ /g"`
  setenv fasta `echo $j| cut -f 2 -d " "` ;
  setenv flat  `echo $j| cut -f 1 -d " "` ;
  echo $flat  -- $fasta 
  cat $fasta | grep -v ">" | remove_newlines | tr "A-Z" "a-z" > $flat
end ;

list_contigs fasta $1 > $GENOMEDIR/contig_list
blat $GENOMEDIR/contig_list /tmp/bla.fa /tmp/bla.psl -makeOoc=$GENOMEDIR/11.ooc
blat -t=dnax -q=prot -tileSize=5 $GENOMEDIR/contig_list /tmp/bla.fa /tmp/bla.psl -makeOoc=$GENOMEDIR/5.ooc

rm -f /tmp/bla.fa /tmp/bla.psl
