#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include <ctype.h>

#include "common.h"
#include "genome.h"


int main(int argc, char**argv)
{
	FILE *out_file=stdout ;
	char * genome_config_fname=NULL ;
	char * organism ; 
	int i ;

	if (argc<2)
    {
		fprintf(stderr, "usage: %s organism  [<genome_config_fname]\n", argv[0]) ;
		exit(-1) ;
    } ;
	organism = argv[1] ;
	fprintf(stderr, "%s v0.1 (%s)\n", argv[0], organism) ;

	// genome config
	if (argc<3)
		genome_config_fname = "genome.config" ;
	else
		genome_config_fname = argv[2] ;
	if (init_genome(genome_config_fname)!=0)
	{
		fprintf(stderr, "genome initialization failed (%s)\n", genome_config_fname) ;
		exit(-1) ;
	}

	for (i=0; i<num_contigs; i++)
	{
		contig_files[i]=fopen(contig_fnames[i],"r") ;
		fseek(contig_files[i], 0, SEEK_END) ;
		char * cn = strdup(contig_names[i]) ;
		int j ;
		for (j=0; j<strlen(cn); j++)
			if (cn[j]==':')
				cn[j]='-' ;

		fprintf(out_file, ">%s:%s:%i:+:%li\n", organism, cn, 1, ftell(contig_files[i])) ;
		fseek(contig_files[i], 0, SEEK_SET) ;
		free(cn) ;
		
		while (!feof(contig_files[i]))
		{
			char buf[100] ;
			int cnt = fread(buf, sizeof(char), 50, contig_files[i]) ;
			buf[cnt]=0 ;
			{
				int q ;
				for (q=0; q<cnt; q++)
					buf[q] = toupper(buf[q]) ;
			}
			fprintf(out_file, "%s\n", buf) ;
		}
		fclose(contig_files[i]) ;
		contig_files[i] = NULL ;
	}

	cleanup_genome() ;

	return 0;
} 

