#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

char alph[5]="ACGTN" ;
int min_cdna_length = 50 ;

/* reverse complement a sequence */
char *reverse_complement(char*in)
{
  char *out=strdup(in) ;
  int i, len=strlen(in) ;
  for (i=0; i<len; i++)
    {
      switch (in[i])
	{
	case 'a': out[len-i-1]='t' ; break ;
	case 't': out[len-i-1]='a' ; break ;
	case 'g': out[len-i-1]='c' ; break ;
	case 'c': out[len-i-1]='g' ; break ;
	case 'n': out[len-i-1]='n' ; break ;
	case 'A': out[len-i-1]='T' ; break ;
	case 'T': out[len-i-1]='A' ; break ;
	case 'G': out[len-i-1]='C' ; break ;
	case 'C': out[len-i-1]='G' ; break ;
	case 'N': out[len-i-1]='N' ; break ;
	case '-': out[len-i-1]='-' ; break ;
	case 'M': out[len-i-1]='K' ; break ;
	case 'R': out[len-i-1]='Y' ; break ;
	case 'W': out[len-i-1]='S' ; break ;
	case 'S': out[len-i-1]='W' ; break ;
	case 'Y': out[len-i-1]='R' ; break ;
	case 'K': out[len-i-1]='M' ; break ;
	case 'V': out[len-i-1]='B' ; break ;
	case 'H': out[len-i-1]='D' ; break ;
	case 'D': out[len-i-1]='H' ; break ;
	case 'B': out[len-i-1]='V' ; break ;
	case 'm': out[len-i-1]='k' ; break ;
	case 'r': out[len-i-1]='y' ; break ;
	case 'w': out[len-i-1]='s' ; break ;
	case 's': out[len-i-1]='w' ; break ;
	case 'y': out[len-i-1]='r' ; break ;
	case 'k': out[len-i-1]='m' ; break ;
	case 'v': out[len-i-1]='b' ; break ;
	case 'h': out[len-i-1]='d' ; break ;
	case 'b': out[len-i-1]='v' ; break ;
	case 'x': out[len-i-1]='x' ; break ;
	case 'X': out[len-i-1]='X' ; break ;

	default:
	  fprintf(stderr,"wrong letter %c\n", in[i]) ;
	  exit(-1)  ;
	} ;
    } ;
  return out ;
} 

/* read a line from a file */
char *read_line(FILE*infile, char* line, size_t max_len) 
{
  int i,c ;

  i=0 ;
  while (!feof(infile))
    {
      c=fgetc(infile) ;
      if ((c==EOF) || (c==13) || (c==10))
	  break ;
      line[i]=c ;

      i++ ;
      if (i>max_len)
	{
	  fprintf(stderr, "line buffer not large enough\n") ;
	  exit(-1) ;
	} ;
    } ;
  line[i]=0 ;

  if (i==0)
    strcpy(line,"") ;
  return line ;
}

int main(int argc, char** argv)
{
	int max_line_len = 100000 ;
	char *line = (char*)malloc(sizeof(char)*max_line_len) ;
	int max_genestr_len = 10000000 ;
	char *genestr = (char*)malloc(sizeof(char)*max_genestr_len) ;
	int genestr_len=0 ;
	char last_header[1000] ;
	
	while (!feof(stdin))
	{
		char *ret = read_line(stdin, line, max_line_len) ;
		
		if ((strlen(ret)==0) || ((line[0]=='>') && (genestr_len!=0)))
		{
			int i;
			for (i=0; i<genestr_len; i++) 
			{
				if (genestr[i]=='a') genestr[i]=alph[0] ;
				if (genestr[i]=='c') genestr[i]=alph[1] ;
				if (genestr[i]=='g') genestr[i]=alph[2] ;
				if (genestr[i]=='t') genestr[i]=alph[3] ;
				if (genestr[i]=='n') genestr[i]=alph[4] ;
				if (genestr[i]=='A') genestr[i]=alph[0] ;
				if (genestr[i]=='C') genestr[i]=alph[1] ;
				if (genestr[i]=='G') genestr[i]=alph[2] ;
				if (genestr[i]=='T') genestr[i]=alph[3] ;
				if (genestr[i]=='N') genestr[i]=alph[4] ;
			}
			
			fprintf(stdout, ">rev_%s (reverse complemented)\n", &last_header[1]) ;
			//fprintf(stderr, "%s\n", last_header) ;
			genestr[genestr_len]=0 ;
			
			char * rev_genestr=reverse_complement(genestr) ;
						
			int k=0 ;
			for (i=0; i<strlen(rev_genestr); i+=60)
			{
				int j, len= strlen(rev_genestr) - i ;
				if (len>60) len=60 ;
				for (j=0; j<len; j++)
				{
					fputc(rev_genestr[i+j], stdout) ;
					k=k+1 ;
				}
				fprintf(stdout, "\n") ;
			} ;
			genestr_len=0 ;
			free(rev_genestr) ;
		} ;
//		if (strlen(ret)==0) break ;
		
		if (line[0]=='>')
			strcpy(last_header, line) ;
		if (line[0]!='>')
		{
			strcpy(&genestr[genestr_len], line) ;
			genestr_len+=strlen(line) ;
			assert(max_genestr_len>genestr_len) ;
		} ;
	} ;
	
	return 0 ;
}
