function [seqs,names]=read_fasta_file(fname, name_only)
% [seqs,names]=read_fasta_file(fname)
% 
% reads all entries in a fasta file

if nargin<2, name_only=0; end ; 

[s,nr_lines]=unix(sprintf('grep -c ">" %s', fname)) ;
nr_lines=str2num(nr_lines) 
if isempty(nr_lines),
  disp('problem with ">" in fa-files');
  keyboard
end

fd=fopen(fname,'r') ;
last=0 ;
cnt=0 ;
seqs={} ;
seqs{nr_lines}='' ;
names={} ;
names{nr_lines}='' ;
while ~last,
  [seq,name,last]=read_fasta(fd) ;
  if ~isempty(seq) | ~isempty(last) | last==0,
    if name_only,
      idx=find(name==' ') ;
      name=name(1:idx-1) ;
    end ;
    cnt=cnt+1 ;
    if mod(cnt,1000)==0, cnt, end ;
    seqs{cnt}=seq ;
    names{cnt}=name ;
  end ;
end ;
seqs=seqs(1:cnt) ;
names=names(1:cnt) ;

if isempty(seqs{end}) && isempty(names{end})
  seqs=seqs(1:cnt-1) ;
  names=names(1:cnt-1) ;
end ;

fclose(fd) ;
