function subset_fasta(filename, numhalves)
% function subset_fasta(filename, numhalves)
%
% Loads filename.fa and selects consecutive random subsets
% of half the size to write out. e.g.
% filename2.fa
% filename4.fa
% filename8.fa
% filename16.fa
% filename32.fa

  
[seqs,names]=read_fasta_file(sprintf('%s.fa',filename));

% create the random subsets
rand('state', 8)
numseq = length(seqs)
subidx = {};
idx = randperm(numseq);
numseq = round(numseq/2);
subidx{1} = idx(1:numseq);
for ix = 2:numhalves
  idx = subidx{ix-1}(randperm(numseq));
  numseq = round(numseq/2);
  subidx{ix} = idx(1:numseq);
end

% write the subsets of sequences to file
for ix = 1:numhalves
  curfile = sprintf('%s%d.fa',filename,2^ix)
  fid = fopen(curfile,'w');
  for ixs = subidx{ix}
    write_fasta_simple(fid, names{ixs}, seqs{ixs});
  end
  fclose(fid);
end
