function colmap=compute_colocation_map(genes1, genes2, genome_info)
% colmap=compute_colocation_map(genes1, genes2, genome_info)
  
  if ~isfield(genes1,'strand')
    for g=1:length(genes1)
      genes1(g).strand=genes1(g).strands(1);
    end
  end
  if ~isfield(genes2,'strand')
    for g=1:length(genes2)
      genes2(g).strand=genes2(g).strands(1);
    end
  end
  
  chr_maps = {} ;
  for i=1:length(genome_info.flat_fnames)
    d=dir(genome_info.flat_fnames{i}) ;
    chr_maps{1,i}=uint32(zeros(1,d(1).bytes)) ;
    chr_maps{2,i}=uint32(zeros(1,d(1).bytes)) ;
  end ;
  
  for i=1:length(genes1) ;
    % start=inf; stop=0 ;
    start = genes1(i).start ;
    stop = genes1(i).stop ;
    for j=1:length(genes1(i).exons)
      if start>min(genes1(i).exons{j}(:)), tmp=genes1(i).exons{j}(:,1:2) ; start=min(tmp(:)) ; end ;
      if stop<max(genes1(i).exons{j}(:)), tmp=genes1(i).exons{j}(:,1:2) ; stop=max(tmp(:)) ; end ;
    end ;
    if ~isinf(start) && stop~=0 ;
      genes1(i).start=start ;
      genes1(i).stop=stop ;
    end ;
  end

  for i=1:length(genes2) ;
    % start=inf; stop=0 ;
    start = genes2(i).start ;
     stop = genes2(i).stop ;
    for j=1:length(genes2(i).exons)
      if start>min(genes2(i).exons{j}(:)), tmp=genes2(i).exons{j}(:,1:2) ; start=min(tmp(:)) ; end ;
      if stop<max(genes2(i).exons{j}(:)), tmp=genes2(i).exons{j}(:,1:2) ; stop=max(tmp(:)) ; end ;
    end ;
    if ~isinf(start) & stop~=0,
      genes2(i).start=start ;
      genes2(i).stop=stop ;
    end ;
  end
  
  for i=1:length(genes1) ;
    if (mod(i,100)==0), fprintf(1,'%i\r',i);end;
    chr = find(ismember(upper(genome_info.contig_names),upper(genes1(i).chr))) ;
    gene_start = genes1(i).start ;
    gene_end = genes1(i).stop ;
    if genes1(i).strand=='+'
      chr_maps{1,chr}(gene_start:gene_end) = i ;
    else 
      chr_maps{2,chr}(gene_start:gene_end) = i ;
    end ;
  end ;
  fprintf('\n') ;
  
  colmap={} ;
  for i=1:length(genes2) ;
    colmap{i} = {} ;
    if (mod(i,100)==0), fprintf(1,'%i\r',i);end;
    chr = find(ismember(upper(genome_info.contig_names),upper(genes2(i).chr))) ;
    gene_start = genes2(i).start ;
    gene_end = genes2(i).stop ;
    if genes2(i).strand=='+'
      colmap{i} = unique(chr_maps{1,chr}(gene_start:gene_end)) ;
    else 
      colmap{i} = unique(chr_maps{2,chr}(gene_start:gene_end)) ;
    end ;
    colmap{i}(colmap{i}==0)=[] ;
    %if length(colmap{i})>1, keyboard; end ;
  end ;
  
